// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "bindings/modules/v8/ModuleBindingsInitializer.h"

#include "bindings/modules/v8/OriginTrialFeaturesForModules.h"
#include "bindings/modules/v8/serialization/SerializedScriptValueForModulesFactory.h"
#include "bindings/modules/v8/wasm/WasmResponseExtensions.h"
#include "platform/bindings/V8PerIsolateData.h"

namespace blink {

// initPartialInterfacesInModules is generated by
// generate_init_partial_interfaces.py.
void InitPartialInterfacesInModules();

void ModuleBindingsInitializer::Init() {
  RegisterInstallOriginTrialFeaturesForModules();
  InitPartialInterfacesInModules();
  SerializedScriptValueFactory::Initialize(
      new SerializedScriptValueForModulesFactory);
  WasmResponseExtensions::Initialize(V8PerIsolateData::MainThreadIsolate());
}

}  // namespace blink
