// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8AnimationEffectTiming.h"

#include "base/memory/scoped_refptr.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "core/dom/ExecutionContext.h"
#include "core/inspector/ConsoleMessage.h"
#include "platform/bindings/RuntimeCallStats.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/runtime_enabled_features.h"
#include "platform/wtf/GetPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8AnimationEffectTiming::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8AnimationEffectTiming::domTemplate,
    V8AnimationEffectTiming::Trace,
    V8AnimationEffectTiming::TraceWrappers,
    nullptr,
    "AnimationEffectTiming",
    &V8AnimationEffectTimingReadOnly::wrapperTypeInfo,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in AnimationEffectTiming.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& AnimationEffectTiming::wrapper_type_info_ = V8AnimationEffectTiming::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, AnimationEffectTiming>::value,
    "AnimationEffectTiming inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&AnimationEffectTiming::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "AnimationEffectTiming is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace AnimationEffectTimingV8Internal {

static void delayAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  V8SetReturnValue(info, impl->delay());
}

static void delayAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "AnimationEffectTiming", "delay");

  // Prepare the value to be set.
  double cppValue = NativeValueTraits<IDLDouble>::NativeValue(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.HadException())
    return;

  impl->setDelay(cppValue);
}

static void endDelayAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  V8SetReturnValue(info, impl->endDelay());
}

static void endDelayAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "AnimationEffectTiming", "endDelay");

  // Prepare the value to be set.
  double cppValue = NativeValueTraits<IDLDouble>::NativeValue(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.HadException())
    return;

  impl->setEndDelay(cppValue);
}

static void fillAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  V8SetReturnValueString(info, impl->fill(), info.GetIsolate());
}

static void fillAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setFill(cppValue);
}

static void iterationStartAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  V8SetReturnValue(info, impl->iterationStart());
}

static void iterationStartAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "AnimationEffectTiming", "iterationStart");

  // Prepare the value to be set.
  double cppValue = NativeValueTraits<IDLDouble>::NativeValue(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.HadException())
    return;

  impl->setIterationStart(cppValue, exceptionState);
}

static void iterationsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  V8SetReturnValue(info, impl->iterations());
}

static void iterationsAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "AnimationEffectTiming", "iterations");

  // Prepare the value to be set.
  double cppValue = NativeValueTraits<IDLUnrestrictedDouble>::NativeValue(info.GetIsolate(), v8Value, exceptionState);
  if (exceptionState.HadException())
    return;

  impl->setIterations(cppValue, exceptionState);
}

static void durationAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  UnrestrictedDoubleOrString result;
  impl->duration(result);

  V8SetReturnValue(info, result);
}

static void durationAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "AnimationEffectTiming", "duration");

  // Prepare the value to be set.
  UnrestrictedDoubleOrString cppValue;
  V8UnrestrictedDoubleOrString::ToImpl(info.GetIsolate(), v8Value, cppValue, UnionTypeConversionMode::kNotNullable, exceptionState);
  if (exceptionState.HadException())
    return;

  impl->setDuration(cppValue, exceptionState);
}

static void directionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  V8SetReturnValueString(info, impl->direction(), info.GetIsolate());
}

static void directionAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "AnimationEffectTiming", "direction");

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  // Type check per: http://heycam.github.io/webidl/#dfn-attribute-setter
  // Returns undefined without setting the value if the value is invalid.
  DummyExceptionStateForTesting dummyExceptionState;
  const char* validValues[] = {
      "normal",
      "reverse",
      "alternate",
      "alternate-reverse",
  };
  if (!IsValidEnum(cppValue, validValues, WTF_ARRAY_LENGTH(validValues), "PlaybackDirection", dummyExceptionState)) {
    ExecutionContext::ForCurrentRealm(info)->AddConsoleMessage(
        ConsoleMessage::Create(kJSMessageSource, kWarningMessageLevel,
                               dummyExceptionState.Message()));
    return;
  }

  impl->setDirection(cppValue);
}

static void easingAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  V8SetReturnValueString(info, impl->easing(), info.GetIsolate());
}

static void easingAttributeSetter(v8::Local<v8::Value> v8Value, const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Isolate* isolate = info.GetIsolate();
  ALLOW_UNUSED_LOCAL(isolate);

  v8::Local<v8::Object> holder = info.Holder();
  ALLOW_UNUSED_LOCAL(holder);

  AnimationEffectTiming* impl = V8AnimationEffectTiming::ToImpl(holder);

  ExceptionState exceptionState(isolate, ExceptionState::kSetterContext, "AnimationEffectTiming", "easing");

  // Prepare the value to be set.
  V8StringResource<> cppValue = v8Value;
  if (!cppValue.Prepare())
    return;

  impl->setEasing(cppValue, exceptionState);
}

} // namespace AnimationEffectTimingV8Internal

void V8AnimationEffectTiming::delayAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_delay_Getter");

  AnimationEffectTimingV8Internal::delayAttributeGetter(info);
}

void V8AnimationEffectTiming::delayAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_delay_Setter");

  v8::Local<v8::Value> v8Value = info[0];

  AnimationEffectTimingV8Internal::delayAttributeSetter(v8Value, info);
}

void V8AnimationEffectTiming::endDelayAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_endDelay_Getter");

  AnimationEffectTimingV8Internal::endDelayAttributeGetter(info);
}

void V8AnimationEffectTiming::endDelayAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_endDelay_Setter");

  v8::Local<v8::Value> v8Value = info[0];

  AnimationEffectTimingV8Internal::endDelayAttributeSetter(v8Value, info);
}

void V8AnimationEffectTiming::fillAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_fill_Getter");

  AnimationEffectTimingV8Internal::fillAttributeGetter(info);
}

void V8AnimationEffectTiming::fillAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_fill_Setter");

  v8::Local<v8::Value> v8Value = info[0];

  AnimationEffectTimingV8Internal::fillAttributeSetter(v8Value, info);
}

void V8AnimationEffectTiming::iterationStartAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_iterationStart_Getter");

  AnimationEffectTimingV8Internal::iterationStartAttributeGetter(info);
}

void V8AnimationEffectTiming::iterationStartAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_iterationStart_Setter");

  v8::Local<v8::Value> v8Value = info[0];

  AnimationEffectTimingV8Internal::iterationStartAttributeSetter(v8Value, info);
}

void V8AnimationEffectTiming::iterationsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_iterations_Getter");

  AnimationEffectTimingV8Internal::iterationsAttributeGetter(info);
}

void V8AnimationEffectTiming::iterationsAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_iterations_Setter");

  v8::Local<v8::Value> v8Value = info[0];

  AnimationEffectTimingV8Internal::iterationsAttributeSetter(v8Value, info);
}

void V8AnimationEffectTiming::durationAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_duration_Getter");

  AnimationEffectTimingV8Internal::durationAttributeGetter(info);
}

void V8AnimationEffectTiming::durationAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_duration_Setter");

  v8::Local<v8::Value> v8Value = info[0];

  AnimationEffectTimingV8Internal::durationAttributeSetter(v8Value, info);
}

void V8AnimationEffectTiming::directionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_direction_Getter");

  AnimationEffectTimingV8Internal::directionAttributeGetter(info);
}

void V8AnimationEffectTiming::directionAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_direction_Setter");

  v8::Local<v8::Value> v8Value = info[0];

  AnimationEffectTimingV8Internal::directionAttributeSetter(v8Value, info);
}

void V8AnimationEffectTiming::easingAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_easing_Getter");

  AnimationEffectTimingV8Internal::easingAttributeGetter(info);
}

void V8AnimationEffectTiming::easingAttributeSetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTiming_easing_Setter");

  v8::Local<v8::Value> v8Value = info[0];

  AnimationEffectTimingV8Internal::easingAttributeSetter(v8Value, info);
}

static const V8DOMConfiguration::AccessorConfiguration V8AnimationEffectTimingAccessors[] = {
    { "delay", V8AnimationEffectTiming::delayAttributeGetterCallback, V8AnimationEffectTiming::delayAttributeSetterCallback, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "endDelay", V8AnimationEffectTiming::endDelayAttributeGetterCallback, V8AnimationEffectTiming::endDelayAttributeSetterCallback, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "fill", V8AnimationEffectTiming::fillAttributeGetterCallback, V8AnimationEffectTiming::fillAttributeSetterCallback, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "iterationStart", V8AnimationEffectTiming::iterationStartAttributeGetterCallback, V8AnimationEffectTiming::iterationStartAttributeSetterCallback, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "iterations", V8AnimationEffectTiming::iterationsAttributeGetterCallback, V8AnimationEffectTiming::iterationsAttributeSetterCallback, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "duration", V8AnimationEffectTiming::durationAttributeGetterCallback, V8AnimationEffectTiming::durationAttributeSetterCallback, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "direction", V8AnimationEffectTiming::directionAttributeGetterCallback, V8AnimationEffectTiming::directionAttributeSetterCallback, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "easing", V8AnimationEffectTiming::easingAttributeGetterCallback, V8AnimationEffectTiming::easingAttributeSetterCallback, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::None), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static void installV8AnimationEffectTimingTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8AnimationEffectTiming::wrapperTypeInfo.interface_name, V8AnimationEffectTimingReadOnly::domTemplate(isolate, world), V8AnimationEffectTiming::internalFieldCount);

  if (!RuntimeEnabledFeatures::WebAnimationsAPIEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8AnimationEffectTimingAccessors, WTF_ARRAY_LENGTH(V8AnimationEffectTimingAccessors));

  // Custom signature

  V8AnimationEffectTiming::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8AnimationEffectTiming::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  if (!RuntimeEnabledFeatures::WebAnimationsAPIEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8AnimationEffectTiming::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8AnimationEffectTimingTemplate);
}

bool V8AnimationEffectTiming::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8AnimationEffectTiming::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

AnimationEffectTiming* V8AnimationEffectTiming::ToImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? ToImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

AnimationEffectTiming* NativeValueTraits<AnimationEffectTiming>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AnimationEffectTiming* nativeValue = V8AnimationEffectTiming::ToImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "AnimationEffectTiming"));
  }
  return nativeValue;
}

}  // namespace blink
