// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8AnimationEffectTimingReadOnly.h"

#include "base/memory/scoped_refptr.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "core/dom/ExecutionContext.h"
#include "core/inspector/ConsoleMessage.h"
#include "platform/bindings/RuntimeCallStats.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/runtime_enabled_features.h"
#include "platform/wtf/GetPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8AnimationEffectTimingReadOnly::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8AnimationEffectTimingReadOnly::domTemplate,
    V8AnimationEffectTimingReadOnly::Trace,
    V8AnimationEffectTimingReadOnly::TraceWrappers,
    nullptr,
    "AnimationEffectTimingReadOnly",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in AnimationEffectTimingReadOnly.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& AnimationEffectTimingReadOnly::wrapper_type_info_ = V8AnimationEffectTimingReadOnly::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, AnimationEffectTimingReadOnly>::value,
    "AnimationEffectTimingReadOnly inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&AnimationEffectTimingReadOnly::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "AnimationEffectTimingReadOnly is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace AnimationEffectTimingReadOnlyV8Internal {

static void delayAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTimingReadOnly* impl = V8AnimationEffectTimingReadOnly::ToImpl(holder);

  V8SetReturnValue(info, impl->delay());
}

static void endDelayAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTimingReadOnly* impl = V8AnimationEffectTimingReadOnly::ToImpl(holder);

  V8SetReturnValue(info, impl->endDelay());
}

static void fillAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTimingReadOnly* impl = V8AnimationEffectTimingReadOnly::ToImpl(holder);

  V8SetReturnValueString(info, impl->fill(), info.GetIsolate());
}

static void iterationStartAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTimingReadOnly* impl = V8AnimationEffectTimingReadOnly::ToImpl(holder);

  V8SetReturnValue(info, impl->iterationStart());
}

static void iterationsAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTimingReadOnly* impl = V8AnimationEffectTimingReadOnly::ToImpl(holder);

  V8SetReturnValue(info, impl->iterations());
}

static void durationAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTimingReadOnly* impl = V8AnimationEffectTimingReadOnly::ToImpl(holder);

  UnrestrictedDoubleOrString result;
  impl->duration(result);

  V8SetReturnValue(info, result);
}

static void directionAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTimingReadOnly* impl = V8AnimationEffectTimingReadOnly::ToImpl(holder);

  V8SetReturnValueString(info, impl->direction(), info.GetIsolate());
}

static void easingAttributeGetter(const v8::FunctionCallbackInfo<v8::Value>& info) {
  v8::Local<v8::Object> holder = info.Holder();

  AnimationEffectTimingReadOnly* impl = V8AnimationEffectTimingReadOnly::ToImpl(holder);

  V8SetReturnValueString(info, impl->easing(), info.GetIsolate());
}

} // namespace AnimationEffectTimingReadOnlyV8Internal

void V8AnimationEffectTimingReadOnly::delayAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTimingReadOnly_delay_Getter");

  AnimationEffectTimingReadOnlyV8Internal::delayAttributeGetter(info);
}

void V8AnimationEffectTimingReadOnly::endDelayAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTimingReadOnly_endDelay_Getter");

  AnimationEffectTimingReadOnlyV8Internal::endDelayAttributeGetter(info);
}

void V8AnimationEffectTimingReadOnly::fillAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTimingReadOnly_fill_Getter");

  AnimationEffectTimingReadOnlyV8Internal::fillAttributeGetter(info);
}

void V8AnimationEffectTimingReadOnly::iterationStartAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTimingReadOnly_iterationStart_Getter");

  AnimationEffectTimingReadOnlyV8Internal::iterationStartAttributeGetter(info);
}

void V8AnimationEffectTimingReadOnly::iterationsAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTimingReadOnly_iterations_Getter");

  AnimationEffectTimingReadOnlyV8Internal::iterationsAttributeGetter(info);
}

void V8AnimationEffectTimingReadOnly::durationAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTimingReadOnly_duration_Getter");

  AnimationEffectTimingReadOnlyV8Internal::durationAttributeGetter(info);
}

void V8AnimationEffectTimingReadOnly::directionAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTimingReadOnly_direction_Getter");

  AnimationEffectTimingReadOnlyV8Internal::directionAttributeGetter(info);
}

void V8AnimationEffectTimingReadOnly::easingAttributeGetterCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_AnimationEffectTimingReadOnly_easing_Getter");

  AnimationEffectTimingReadOnlyV8Internal::easingAttributeGetter(info);
}

static const V8DOMConfiguration::AccessorConfiguration V8AnimationEffectTimingReadOnlyAccessors[] = {
    { "delay", V8AnimationEffectTimingReadOnly::delayAttributeGetterCallback, nullptr, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "endDelay", V8AnimationEffectTimingReadOnly::endDelayAttributeGetterCallback, nullptr, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "fill", V8AnimationEffectTimingReadOnly::fillAttributeGetterCallback, nullptr, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "iterationStart", V8AnimationEffectTimingReadOnly::iterationStartAttributeGetterCallback, nullptr, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "iterations", V8AnimationEffectTimingReadOnly::iterationsAttributeGetterCallback, nullptr, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "duration", V8AnimationEffectTimingReadOnly::durationAttributeGetterCallback, nullptr, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "direction", V8AnimationEffectTimingReadOnly::directionAttributeGetterCallback, nullptr, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },

    { "easing", V8AnimationEffectTimingReadOnly::easingAttributeGetterCallback, nullptr, V8PrivateProperty::kNoCachedAccessor, static_cast<v8::PropertyAttribute>(v8::ReadOnly), V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kCheckHolder, V8DOMConfiguration::kAllWorlds },
};

static void installV8AnimationEffectTimingReadOnlyTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8AnimationEffectTimingReadOnly::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8AnimationEffectTimingReadOnly::internalFieldCount);

  if (!RuntimeEnabledFeatures::WebAnimationsAPIEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallAccessors(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8AnimationEffectTimingReadOnlyAccessors, WTF_ARRAY_LENGTH(V8AnimationEffectTimingReadOnlyAccessors));

  // Custom signature

  V8AnimationEffectTimingReadOnly::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8AnimationEffectTimingReadOnly::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  if (!RuntimeEnabledFeatures::WebAnimationsAPIEnabled()) {
    return;
  }

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8AnimationEffectTimingReadOnly::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8AnimationEffectTimingReadOnlyTemplate);
}

bool V8AnimationEffectTimingReadOnly::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8AnimationEffectTimingReadOnly::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

AnimationEffectTimingReadOnly* V8AnimationEffectTimingReadOnly::ToImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? ToImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

AnimationEffectTimingReadOnly* NativeValueTraits<AnimationEffectTimingReadOnly>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AnimationEffectTimingReadOnly* nativeValue = V8AnimationEffectTimingReadOnly::ToImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "AnimationEffectTimingReadOnly"));
  }
  return nativeValue;
}

}  // namespace blink
