// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8InputDeviceCapabilitiesInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8InputDeviceCapabilitiesInitKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "firesTouchEvents",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8InputDeviceCapabilitiesInit::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, InputDeviceCapabilitiesInit& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8InputDeviceCapabilitiesInitKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> firesTouchEventsValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&firesTouchEventsValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (firesTouchEventsValue.IsEmpty() || firesTouchEventsValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool firesTouchEventsCppValue = NativeValueTraits<IDLBoolean>::NativeValue(isolate, firesTouchEventsValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setFiresTouchEvents(firesTouchEventsCppValue);
  }
}

v8::Local<v8::Value> InputDeviceCapabilitiesInit::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8InputDeviceCapabilitiesInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8InputDeviceCapabilitiesInit(const InputDeviceCapabilitiesInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8InputDeviceCapabilitiesInitKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> firesTouchEventsValue;
  bool firesTouchEventsHasValueOrDefault = false;
  if (impl.hasFiresTouchEvents()) {
    firesTouchEventsValue = v8::Boolean::New(isolate, impl.firesTouchEvents());
    firesTouchEventsHasValueOrDefault = true;
  } else {
    firesTouchEventsValue = v8::Boolean::New(isolate, false);
    firesTouchEventsHasValueOrDefault = true;
  }
  if (firesTouchEventsHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), firesTouchEventsValue))) {
    return false;
  }

  return true;
}

InputDeviceCapabilitiesInit NativeValueTraits<InputDeviceCapabilitiesInit>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  InputDeviceCapabilitiesInit impl;
  V8InputDeviceCapabilitiesInit::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
