// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "composite_operation_or_composite_operation_sequence.h"

#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ToV8ForCore.h"

namespace blink {

CompositeOperationOrCompositeOperationSequence::CompositeOperationOrCompositeOperationSequence() : type_(SpecificType::kNone) {}

const String& CompositeOperationOrCompositeOperationSequence::GetAsCompositeOperation() const {
  DCHECK(IsCompositeOperation());
  return composite_operation_;
}

void CompositeOperationOrCompositeOperationSequence::SetCompositeOperation(const String& value) {
  DCHECK(IsNull());
  NonThrowableExceptionState exceptionState;
  const char* validValues[] = {
      "replace",
      "add",
      "accumulate",
  };
  if (!IsValidEnum(value, validValues, WTF_ARRAY_LENGTH(validValues), "CompositeOperation", exceptionState)) {
    NOTREACHED();
    return;
  }
  composite_operation_ = value;
  type_ = SpecificType::kCompositeOperation;
}

CompositeOperationOrCompositeOperationSequence CompositeOperationOrCompositeOperationSequence::FromCompositeOperation(const String& value) {
  CompositeOperationOrCompositeOperationSequence container;
  container.SetCompositeOperation(value);
  return container;
}

const Vector<String>& CompositeOperationOrCompositeOperationSequence::GetAsCompositeOperationSequence() const {
  DCHECK(IsCompositeOperationSequence());
  return composite_operation_sequence_;
}

void CompositeOperationOrCompositeOperationSequence::SetCompositeOperationSequence(const Vector<String>& value) {
  DCHECK(IsNull());
  NonThrowableExceptionState exceptionState;
  const char* validValues[] = {
      "replace",
      "add",
      "accumulate",
  };
  if (!IsValidEnum(value, validValues, WTF_ARRAY_LENGTH(validValues), "CompositeOperationSequence", exceptionState)) {
    NOTREACHED();
    return;
  }
  composite_operation_sequence_ = value;
  type_ = SpecificType::kCompositeOperationSequence;
}

CompositeOperationOrCompositeOperationSequence CompositeOperationOrCompositeOperationSequence::FromCompositeOperationSequence(const Vector<String>& value) {
  CompositeOperationOrCompositeOperationSequence container;
  container.SetCompositeOperationSequence(value);
  return container;
}

CompositeOperationOrCompositeOperationSequence::CompositeOperationOrCompositeOperationSequence(const CompositeOperationOrCompositeOperationSequence&) = default;
CompositeOperationOrCompositeOperationSequence::~CompositeOperationOrCompositeOperationSequence() = default;
CompositeOperationOrCompositeOperationSequence& CompositeOperationOrCompositeOperationSequence::operator=(const CompositeOperationOrCompositeOperationSequence&) = default;

void CompositeOperationOrCompositeOperationSequence::Trace(blink::Visitor* visitor) {
}

void V8CompositeOperationOrCompositeOperationSequence::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, CompositeOperationOrCompositeOperationSequence& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8Value))
    return;

  if (HasCallableIteratorSymbol(isolate, v8Value, exceptionState)) {
    Vector<String> cppValue = NativeValueTraits<IDLSequence<IDLString>>::NativeValue(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    const char* validValues[] = {
        "replace",
        "add",
        "accumulate",
    };
    if (!IsValidEnum(cppValue, validValues, WTF_ARRAY_LENGTH(validValues), "CompositeOperationSequence", exceptionState))
      return;
    impl.SetCompositeOperationSequence(cppValue);
    return;
  }

  {
    V8StringResource<> cppValue = v8Value;
    if (!cppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "replace",
        "add",
        "accumulate",
    };
    if (!IsValidEnum(cppValue, validValues, WTF_ARRAY_LENGTH(validValues), "CompositeOperation", exceptionState))
      return;
    impl.SetCompositeOperation(cppValue);
    return;
  }
}

v8::Local<v8::Value> ToV8(const CompositeOperationOrCompositeOperationSequence& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.type_) {
    case CompositeOperationOrCompositeOperationSequence::SpecificType::kNone:
      return v8::Null(isolate);
    case CompositeOperationOrCompositeOperationSequence::SpecificType::kCompositeOperation:
      return V8String(isolate, impl.GetAsCompositeOperation());
    case CompositeOperationOrCompositeOperationSequence::SpecificType::kCompositeOperationSequence:
      return ToV8(impl.GetAsCompositeOperationSequence(), creationContext, isolate);
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

CompositeOperationOrCompositeOperationSequence NativeValueTraits<CompositeOperationOrCompositeOperationSequence>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  CompositeOperationOrCompositeOperationSequence impl;
  V8CompositeOperationOrCompositeOperationSequence::ToImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exceptionState);
  return impl;
}

}  // namespace blink
