// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef CompositeOperationOrCompositeOperationSequence_h
#define CompositeOperationOrCompositeOperationSequence_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class CORE_EXPORT CompositeOperationOrCompositeOperationSequence final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  CompositeOperationOrCompositeOperationSequence();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsCompositeOperation() const { return type_ == SpecificType::kCompositeOperation; }
  const String& GetAsCompositeOperation() const;
  void SetCompositeOperation(const String&);
  static CompositeOperationOrCompositeOperationSequence FromCompositeOperation(const String&);

  bool IsCompositeOperationSequence() const { return type_ == SpecificType::kCompositeOperationSequence; }
  const Vector<String>& GetAsCompositeOperationSequence() const;
  void SetCompositeOperationSequence(const Vector<String>&);
  static CompositeOperationOrCompositeOperationSequence FromCompositeOperationSequence(const Vector<String>&);

  CompositeOperationOrCompositeOperationSequence(const CompositeOperationOrCompositeOperationSequence&);
  ~CompositeOperationOrCompositeOperationSequence();
  CompositeOperationOrCompositeOperationSequence& operator=(const CompositeOperationOrCompositeOperationSequence&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kCompositeOperation,
    kCompositeOperationSequence,
  };
  SpecificType type_;

  String composite_operation_;
  Vector<String> composite_operation_sequence_;

  friend CORE_EXPORT v8::Local<v8::Value> ToV8(const CompositeOperationOrCompositeOperationSequence&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8CompositeOperationOrCompositeOperationSequence final {
 public:
  CORE_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, CompositeOperationOrCompositeOperationSequence&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> ToV8(const CompositeOperationOrCompositeOperationSequence&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, CompositeOperationOrCompositeOperationSequence& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, CompositeOperationOrCompositeOperationSequence& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<CompositeOperationOrCompositeOperationSequence> : public NativeValueTraitsBase<CompositeOperationOrCompositeOperationSequence> {
  CORE_EXPORT static CompositeOperationOrCompositeOperationSequence NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  CORE_EXPORT static CompositeOperationOrCompositeOperationSequence NullValue() { return CompositeOperationOrCompositeOperationSequence(); }
};

template <>
struct V8TypeOf<CompositeOperationOrCompositeOperationSequence> {
  typedef V8CompositeOperationOrCompositeOperationSequence Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::CompositeOperationOrCompositeOperationSequence);

#endif  // CompositeOperationOrCompositeOperationSequence_h
