// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "css_style_value_or_css_style_value_sequence.h"

#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ToV8ForCore.h"
#include "bindings/core/v8/V8CSSStyleValue.h"

namespace blink {

CSSStyleValueOrCSSStyleValueSequence::CSSStyleValueOrCSSStyleValueSequence() : type_(SpecificType::kNone) {}

CSSStyleValue* CSSStyleValueOrCSSStyleValueSequence::GetAsCSSStyleValue() const {
  DCHECK(IsCSSStyleValue());
  return css_style_value_;
}

void CSSStyleValueOrCSSStyleValueSequence::SetCSSStyleValue(CSSStyleValue* value) {
  DCHECK(IsNull());
  css_style_value_ = value;
  type_ = SpecificType::kCSSStyleValue;
}

CSSStyleValueOrCSSStyleValueSequence CSSStyleValueOrCSSStyleValueSequence::FromCSSStyleValue(CSSStyleValue* value) {
  CSSStyleValueOrCSSStyleValueSequence container;
  container.SetCSSStyleValue(value);
  return container;
}

const HeapVector<Member<CSSStyleValue>>& CSSStyleValueOrCSSStyleValueSequence::GetAsCSSStyleValueSequence() const {
  DCHECK(IsCSSStyleValueSequence());
  return css_style_value_sequence_;
}

void CSSStyleValueOrCSSStyleValueSequence::SetCSSStyleValueSequence(const HeapVector<Member<CSSStyleValue>>& value) {
  DCHECK(IsNull());
  css_style_value_sequence_ = value;
  type_ = SpecificType::kCSSStyleValueSequence;
}

CSSStyleValueOrCSSStyleValueSequence CSSStyleValueOrCSSStyleValueSequence::FromCSSStyleValueSequence(const HeapVector<Member<CSSStyleValue>>& value) {
  CSSStyleValueOrCSSStyleValueSequence container;
  container.SetCSSStyleValueSequence(value);
  return container;
}

CSSStyleValueOrCSSStyleValueSequence::CSSStyleValueOrCSSStyleValueSequence(const CSSStyleValueOrCSSStyleValueSequence&) = default;
CSSStyleValueOrCSSStyleValueSequence::~CSSStyleValueOrCSSStyleValueSequence() = default;
CSSStyleValueOrCSSStyleValueSequence& CSSStyleValueOrCSSStyleValueSequence::operator=(const CSSStyleValueOrCSSStyleValueSequence&) = default;

void CSSStyleValueOrCSSStyleValueSequence::Trace(blink::Visitor* visitor) {
  visitor->Trace(css_style_value_);
  visitor->Trace(css_style_value_sequence_);
}

void V8CSSStyleValueOrCSSStyleValueSequence::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, CSSStyleValueOrCSSStyleValueSequence& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8Value))
    return;

  if (V8CSSStyleValue::hasInstance(v8Value, isolate)) {
    CSSStyleValue* cppValue = V8CSSStyleValue::ToImpl(v8::Local<v8::Object>::Cast(v8Value));
    impl.SetCSSStyleValue(cppValue);
    return;
  }

  if (HasCallableIteratorSymbol(isolate, v8Value, exceptionState)) {
    HeapVector<Member<CSSStyleValue>> cppValue = NativeValueTraits<IDLSequence<CSSStyleValue>>::NativeValue(isolate, v8Value, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.SetCSSStyleValueSequence(cppValue);
    return;
  }

  exceptionState.ThrowTypeError("The provided value is not of type '(CSSStyleValue or sequence<CSSStyleValue>)'");
}

v8::Local<v8::Value> ToV8(const CSSStyleValueOrCSSStyleValueSequence& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.type_) {
    case CSSStyleValueOrCSSStyleValueSequence::SpecificType::kNone:
      return v8::Null(isolate);
    case CSSStyleValueOrCSSStyleValueSequence::SpecificType::kCSSStyleValue:
      return ToV8(impl.GetAsCSSStyleValue(), creationContext, isolate);
    case CSSStyleValueOrCSSStyleValueSequence::SpecificType::kCSSStyleValueSequence:
      return ToV8(impl.GetAsCSSStyleValueSequence(), creationContext, isolate);
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

CSSStyleValueOrCSSStyleValueSequence NativeValueTraits<CSSStyleValueOrCSSStyleValueSequence>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  CSSStyleValueOrCSSStyleValueSequence impl;
  V8CSSStyleValueOrCSSStyleValueSequence::ToImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exceptionState);
  return impl;
}

}  // namespace blink
