// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef CSSStyleValueOrCSSStyleValueSequence_h
#define CSSStyleValueOrCSSStyleValueSequence_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class CSSStyleValue;

class CORE_EXPORT CSSStyleValueOrCSSStyleValueSequence final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  CSSStyleValueOrCSSStyleValueSequence();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsCSSStyleValue() const { return type_ == SpecificType::kCSSStyleValue; }
  CSSStyleValue* GetAsCSSStyleValue() const;
  void SetCSSStyleValue(CSSStyleValue*);
  static CSSStyleValueOrCSSStyleValueSequence FromCSSStyleValue(CSSStyleValue*);

  bool IsCSSStyleValueSequence() const { return type_ == SpecificType::kCSSStyleValueSequence; }
  const HeapVector<Member<CSSStyleValue>>& GetAsCSSStyleValueSequence() const;
  void SetCSSStyleValueSequence(const HeapVector<Member<CSSStyleValue>>&);
  static CSSStyleValueOrCSSStyleValueSequence FromCSSStyleValueSequence(const HeapVector<Member<CSSStyleValue>>&);

  CSSStyleValueOrCSSStyleValueSequence(const CSSStyleValueOrCSSStyleValueSequence&);
  ~CSSStyleValueOrCSSStyleValueSequence();
  CSSStyleValueOrCSSStyleValueSequence& operator=(const CSSStyleValueOrCSSStyleValueSequence&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kCSSStyleValue,
    kCSSStyleValueSequence,
  };
  SpecificType type_;

  Member<CSSStyleValue> css_style_value_;
  HeapVector<Member<CSSStyleValue>> css_style_value_sequence_;

  friend CORE_EXPORT v8::Local<v8::Value> ToV8(const CSSStyleValueOrCSSStyleValueSequence&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8CSSStyleValueOrCSSStyleValueSequence final {
 public:
  CORE_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, CSSStyleValueOrCSSStyleValueSequence&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> ToV8(const CSSStyleValueOrCSSStyleValueSequence&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, CSSStyleValueOrCSSStyleValueSequence& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, CSSStyleValueOrCSSStyleValueSequence& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<CSSStyleValueOrCSSStyleValueSequence> : public NativeValueTraitsBase<CSSStyleValueOrCSSStyleValueSequence> {
  CORE_EXPORT static CSSStyleValueOrCSSStyleValueSequence NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  CORE_EXPORT static CSSStyleValueOrCSSStyleValueSequence NullValue() { return CSSStyleValueOrCSSStyleValueSequence(); }
};

template <>
struct V8TypeOf<CSSStyleValueOrCSSStyleValueSequence> {
  typedef V8CSSStyleValueOrCSSStyleValueSequence Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::CSSStyleValueOrCSSStyleValueSequence);

#endif  // CSSStyleValueOrCSSStyleValueSequence_h
