// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef DoubleOrInternalEnum_h
#define DoubleOrInternalEnum_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class CORE_EXPORT DoubleOrInternalEnum final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  DoubleOrInternalEnum();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsDouble() const { return type_ == SpecificType::kDouble; }
  double GetAsDouble() const;
  void SetDouble(double);
  static DoubleOrInternalEnum FromDouble(double);

  bool IsInternalEnum() const { return type_ == SpecificType::kInternalEnum; }
  const String& GetAsInternalEnum() const;
  void SetInternalEnum(const String&);
  static DoubleOrInternalEnum FromInternalEnum(const String&);

  DoubleOrInternalEnum(const DoubleOrInternalEnum&);
  ~DoubleOrInternalEnum();
  DoubleOrInternalEnum& operator=(const DoubleOrInternalEnum&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kDouble,
    kInternalEnum,
  };
  SpecificType type_;

  double double_;
  String internal_enum_;

  friend CORE_EXPORT v8::Local<v8::Value> ToV8(const DoubleOrInternalEnum&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8DoubleOrInternalEnum final {
 public:
  CORE_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, DoubleOrInternalEnum&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> ToV8(const DoubleOrInternalEnum&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, DoubleOrInternalEnum& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, DoubleOrInternalEnum& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<DoubleOrInternalEnum> : public NativeValueTraitsBase<DoubleOrInternalEnum> {
  CORE_EXPORT static DoubleOrInternalEnum NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  CORE_EXPORT static DoubleOrInternalEnum NullValue() { return DoubleOrInternalEnum(); }
};

template <>
struct V8TypeOf<DoubleOrInternalEnum> {
  typedef V8DoubleOrInternalEnum Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::DoubleOrInternalEnum);

#endif  // DoubleOrInternalEnum_h
