// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef EventListenerOptionsOrBoolean_h
#define EventListenerOptionsOrBoolean_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "bindings/core/v8/V8EventListenerOptions.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class CORE_EXPORT EventListenerOptionsOrBoolean final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  EventListenerOptionsOrBoolean();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsBoolean() const { return type_ == SpecificType::kBoolean; }
  bool GetAsBoolean() const;
  void SetBoolean(bool);
  static EventListenerOptionsOrBoolean FromBoolean(bool);

  bool IsEventListenerOptions() const { return type_ == SpecificType::kEventListenerOptions; }
  const EventListenerOptions& GetAsEventListenerOptions() const;
  void SetEventListenerOptions(const EventListenerOptions&);
  static EventListenerOptionsOrBoolean FromEventListenerOptions(const EventListenerOptions&);

  EventListenerOptionsOrBoolean(const EventListenerOptionsOrBoolean&);
  ~EventListenerOptionsOrBoolean();
  EventListenerOptionsOrBoolean& operator=(const EventListenerOptionsOrBoolean&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kBoolean,
    kEventListenerOptions,
  };
  SpecificType type_;

  bool boolean_;
  EventListenerOptions event_listener_options_;

  friend CORE_EXPORT v8::Local<v8::Value> ToV8(const EventListenerOptionsOrBoolean&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8EventListenerOptionsOrBoolean final {
 public:
  CORE_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, EventListenerOptionsOrBoolean&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> ToV8(const EventListenerOptionsOrBoolean&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, EventListenerOptionsOrBoolean& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, EventListenerOptionsOrBoolean& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<EventListenerOptionsOrBoolean> : public NativeValueTraitsBase<EventListenerOptionsOrBoolean> {
  CORE_EXPORT static EventListenerOptionsOrBoolean NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  CORE_EXPORT static EventListenerOptionsOrBoolean NullValue() { return EventListenerOptionsOrBoolean(); }
};

template <>
struct V8TypeOf<EventListenerOptionsOrBoolean> {
  typedef V8EventListenerOptionsOrBoolean Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::EventListenerOptionsOrBoolean);

#endif  // EventListenerOptionsOrBoolean_h
