// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef HTMLOptionElementOrHTMLOptGroupElement_h
#define HTMLOptionElementOrHTMLOptGroupElement_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class HTMLOptGroupElement;
class HTMLOptionElement;

class CORE_EXPORT HTMLOptionElementOrHTMLOptGroupElement final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  HTMLOptionElementOrHTMLOptGroupElement();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsHTMLOptGroupElement() const { return type_ == SpecificType::kHTMLOptGroupElement; }
  HTMLOptGroupElement* GetAsHTMLOptGroupElement() const;
  void SetHTMLOptGroupElement(HTMLOptGroupElement*);
  static HTMLOptionElementOrHTMLOptGroupElement FromHTMLOptGroupElement(HTMLOptGroupElement*);

  bool IsHTMLOptionElement() const { return type_ == SpecificType::kHTMLOptionElement; }
  HTMLOptionElement* GetAsHTMLOptionElement() const;
  void SetHTMLOptionElement(HTMLOptionElement*);
  static HTMLOptionElementOrHTMLOptGroupElement FromHTMLOptionElement(HTMLOptionElement*);

  HTMLOptionElementOrHTMLOptGroupElement(const HTMLOptionElementOrHTMLOptGroupElement&);
  ~HTMLOptionElementOrHTMLOptGroupElement();
  HTMLOptionElementOrHTMLOptGroupElement& operator=(const HTMLOptionElementOrHTMLOptGroupElement&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kHTMLOptGroupElement,
    kHTMLOptionElement,
  };
  SpecificType type_;

  Member<HTMLOptGroupElement> html_opt_group_element_;
  Member<HTMLOptionElement> html_option_element_;

  friend CORE_EXPORT v8::Local<v8::Value> ToV8(const HTMLOptionElementOrHTMLOptGroupElement&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8HTMLOptionElementOrHTMLOptGroupElement final {
 public:
  CORE_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, HTMLOptionElementOrHTMLOptGroupElement&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> ToV8(const HTMLOptionElementOrHTMLOptGroupElement&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, HTMLOptionElementOrHTMLOptGroupElement& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, HTMLOptionElementOrHTMLOptGroupElement& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<HTMLOptionElementOrHTMLOptGroupElement> : public NativeValueTraitsBase<HTMLOptionElementOrHTMLOptGroupElement> {
  CORE_EXPORT static HTMLOptionElementOrHTMLOptGroupElement NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  CORE_EXPORT static HTMLOptionElementOrHTMLOptGroupElement NullValue() { return HTMLOptionElementOrHTMLOptGroupElement(); }
};

template <>
struct V8TypeOf<HTMLOptionElementOrHTMLOptGroupElement> {
  typedef V8HTMLOptionElementOrHTMLOptGroupElement Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::HTMLOptionElementOrHTMLOptGroupElement);

#endif  // HTMLOptionElementOrHTMLOptGroupElement_h
