// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef NodeListOrElement_h
#define NodeListOrElement_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class Element;
class NodeList;

class CORE_EXPORT NodeListOrElement final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  NodeListOrElement();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsElement() const { return type_ == SpecificType::kElement; }
  Element* GetAsElement() const;
  void SetElement(Element*);
  static NodeListOrElement FromElement(Element*);

  bool IsNodeList() const { return type_ == SpecificType::kNodeList; }
  NodeList* GetAsNodeList() const;
  void SetNodeList(NodeList*);
  static NodeListOrElement FromNodeList(NodeList*);

  NodeListOrElement(const NodeListOrElement&);
  ~NodeListOrElement();
  NodeListOrElement& operator=(const NodeListOrElement&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kElement,
    kNodeList,
  };
  SpecificType type_;

  Member<Element> element_;
  Member<NodeList> node_list_;

  friend CORE_EXPORT v8::Local<v8::Value> ToV8(const NodeListOrElement&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8NodeListOrElement final {
 public:
  CORE_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, NodeListOrElement&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> ToV8(const NodeListOrElement&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, NodeListOrElement& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, NodeListOrElement& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<NodeListOrElement> : public NativeValueTraitsBase<NodeListOrElement> {
  CORE_EXPORT static NodeListOrElement NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  CORE_EXPORT static NodeListOrElement NullValue() { return NodeListOrElement(); }
};

template <>
struct V8TypeOf<NodeListOrElement> {
  typedef V8NodeListOrElement Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::NodeListOrElement);

#endif  // NodeListOrElement_h
