// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef StringOrDictionary_h
#define StringOrDictionary_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class CORE_EXPORT StringOrDictionary final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  StringOrDictionary();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsDictionary() const { return type_ == SpecificType::kDictionary; }
  Dictionary GetAsDictionary() const;
  void SetDictionary(Dictionary);
  static StringOrDictionary FromDictionary(Dictionary);

  bool IsString() const { return type_ == SpecificType::kString; }
  const String& GetAsString() const;
  void SetString(const String&);
  static StringOrDictionary FromString(const String&);

  StringOrDictionary(const StringOrDictionary&);
  ~StringOrDictionary();
  StringOrDictionary& operator=(const StringOrDictionary&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kDictionary,
    kString,
  };
  SpecificType type_;

  Dictionary dictionary_;
  String string_;

  friend CORE_EXPORT v8::Local<v8::Value> ToV8(const StringOrDictionary&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8StringOrDictionary final {
 public:
  CORE_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, StringOrDictionary&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> ToV8(const StringOrDictionary&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrDictionary& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrDictionary& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<StringOrDictionary> : public NativeValueTraitsBase<StringOrDictionary> {
  CORE_EXPORT static StringOrDictionary NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  CORE_EXPORT static StringOrDictionary NullValue() { return StringOrDictionary(); }
};

template <>
struct V8TypeOf<StringOrDictionary> {
  typedef V8StringOrDictionary Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::StringOrDictionary);

#endif  // StringOrDictionary_h
