// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef StringOrTrustedHTML_h
#define StringOrTrustedHTML_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class TrustedHTML;

class CORE_EXPORT StringOrTrustedHTML final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  StringOrTrustedHTML();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsString() const { return type_ == SpecificType::kString; }
  const String& GetAsString() const;
  void SetString(const String&);
  static StringOrTrustedHTML FromString(const String&);

  bool IsTrustedHTML() const { return type_ == SpecificType::kTrustedHTML; }
  TrustedHTML* GetAsTrustedHTML() const;
  void SetTrustedHTML(TrustedHTML*);
  static StringOrTrustedHTML FromTrustedHTML(TrustedHTML*);

  StringOrTrustedHTML(const StringOrTrustedHTML&);
  ~StringOrTrustedHTML();
  StringOrTrustedHTML& operator=(const StringOrTrustedHTML&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kString,
    kTrustedHTML,
  };
  SpecificType type_;

  String string_;
  Member<TrustedHTML> trusted_html_;

  friend CORE_EXPORT v8::Local<v8::Value> ToV8(const StringOrTrustedHTML&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8StringOrTrustedHTML final {
 public:
  CORE_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, StringOrTrustedHTML&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> ToV8(const StringOrTrustedHTML&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrTrustedHTML& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrTrustedHTML& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<StringOrTrustedHTML> : public NativeValueTraitsBase<StringOrTrustedHTML> {
  CORE_EXPORT static StringOrTrustedHTML NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  CORE_EXPORT static StringOrTrustedHTML NullValue() { return StringOrTrustedHTML(); }
};

template <>
struct V8TypeOf<StringOrTrustedHTML> {
  typedef V8StringOrTrustedHTML Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::StringOrTrustedHTML);

#endif  // StringOrTrustedHTML_h
