// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef UnrestrictedDoubleOrKeyframeAnimationOptions_h
#define UnrestrictedDoubleOrKeyframeAnimationOptions_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "bindings/core/v8/V8KeyframeAnimationOptions.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class CORE_EXPORT UnrestrictedDoubleOrKeyframeAnimationOptions final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  UnrestrictedDoubleOrKeyframeAnimationOptions();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsKeyframeAnimationOptions() const { return type_ == SpecificType::kKeyframeAnimationOptions; }
  const KeyframeAnimationOptions& GetAsKeyframeAnimationOptions() const;
  void SetKeyframeAnimationOptions(const KeyframeAnimationOptions&);
  static UnrestrictedDoubleOrKeyframeAnimationOptions FromKeyframeAnimationOptions(const KeyframeAnimationOptions&);

  bool IsUnrestrictedDouble() const { return type_ == SpecificType::kUnrestrictedDouble; }
  double GetAsUnrestrictedDouble() const;
  void SetUnrestrictedDouble(double);
  static UnrestrictedDoubleOrKeyframeAnimationOptions FromUnrestrictedDouble(double);

  UnrestrictedDoubleOrKeyframeAnimationOptions(const UnrestrictedDoubleOrKeyframeAnimationOptions&);
  ~UnrestrictedDoubleOrKeyframeAnimationOptions();
  UnrestrictedDoubleOrKeyframeAnimationOptions& operator=(const UnrestrictedDoubleOrKeyframeAnimationOptions&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kKeyframeAnimationOptions,
    kUnrestrictedDouble,
  };
  SpecificType type_;

  KeyframeAnimationOptions keyframe_animation_options_;
  double unrestricted_double_;

  friend CORE_EXPORT v8::Local<v8::Value> ToV8(const UnrestrictedDoubleOrKeyframeAnimationOptions&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8UnrestrictedDoubleOrKeyframeAnimationOptions final {
 public:
  CORE_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, UnrestrictedDoubleOrKeyframeAnimationOptions&, UnionTypeConversionMode, ExceptionState&);
};

CORE_EXPORT v8::Local<v8::Value> ToV8(const UnrestrictedDoubleOrKeyframeAnimationOptions&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, UnrestrictedDoubleOrKeyframeAnimationOptions& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, UnrestrictedDoubleOrKeyframeAnimationOptions& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<UnrestrictedDoubleOrKeyframeAnimationOptions> : public NativeValueTraitsBase<UnrestrictedDoubleOrKeyframeAnimationOptions> {
  CORE_EXPORT static UnrestrictedDoubleOrKeyframeAnimationOptions NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  CORE_EXPORT static UnrestrictedDoubleOrKeyframeAnimationOptions NullValue() { return UnrestrictedDoubleOrKeyframeAnimationOptions(); }
};

template <>
struct V8TypeOf<UnrestrictedDoubleOrKeyframeAnimationOptions> {
  typedef V8UnrestrictedDoubleOrKeyframeAnimationOptions Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::UnrestrictedDoubleOrKeyframeAnimationOptions);

#endif  // UnrestrictedDoubleOrKeyframeAnimationOptions_h
