// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/OriginTrialFeaturesForModules.cpp.tmpl
// by the script generate_origin_trial_features.py.
// DO NOT MODIFY!

// clang-format off

#include "bindings/modules/v8/OriginTrialFeaturesForModules.h"

#include "bindings/core/v8/OriginTrialFeaturesForCore.h"
#include "bindings/core/v8/V8DedicatedWorkerGlobalScope.h"
#include "bindings/core/v8/V8Navigator.h"
#include "bindings/core/v8/V8SharedWorkerGlobalScope.h"
#include "bindings/core/v8/V8Window.h"
#include "bindings/modules/v8/V8AudioWorkletGlobalScope.h"
#include "bindings/modules/v8/V8BaseAudioContext.h"
#include "bindings/modules/v8/V8BudgetService.h"
#include "bindings/modules/v8/V8DedicatedWorkerGlobalScopePartial.h"
#include "bindings/modules/v8/V8Gamepad.h"
#include "bindings/modules/v8/V8GamepadButton.h"
#include "bindings/modules/v8/V8NavigatorPartial.h"
#include "bindings/modules/v8/V8ServiceWorkerGlobalScope.h"
#include "bindings/modules/v8/V8SharedWorkerGlobalScopePartial.h"
#include "bindings/modules/v8/V8WindowPartial.h"
#include "core/context_features/ContextFeatureSettings.h"
#include "core/dom/ExecutionContext.h"
#include "core/frame/Frame.h"
#include "core/origin_trials/origin_trials.h"
#include "platform/bindings/OriginTrialFeatures.h"
#include "platform/bindings/ScriptState.h"

namespace blink {

namespace {
InstallOriginTrialFeaturesFunction
    g_original_install_origin_trial_features_function = nullptr;
InstallPendingOriginTrialFeatureFunction
    g_original_install_pending_origin_trial_feature_function = nullptr;

void InstallOriginTrialFeaturesForModules(
    const WrapperTypeInfo* wrapper_type_info,
    const ScriptState* script_state,
    v8::Local<v8::Object> prototype_object,
    v8::Local<v8::Function> interface_object) {
  (*g_original_install_origin_trial_features_function)(
      wrapper_type_info, script_state, prototype_object, interface_object);

  ExecutionContext* execution_context = ExecutionContext::From(script_state);
  if (!execution_context)
    return;
  v8::Isolate* isolate = script_state->GetIsolate();
  const DOMWrapperWorld& world = script_state->World();
  // TODO(iclelland): Extract this common code out of OriginTrialFeaturesForCore
  // and OriginTrialFeaturesForModules into a block.
  if (wrapper_type_info == &V8AudioWorkletGlobalScope::wrapperTypeInfo) {
    v8::Local<v8::Object> instance_object =
        script_state->GetContext()->Global();
    if (OriginTrials::audioWorkletEnabled(execution_context)) {
      V8AudioWorkletGlobalScope::installAudioWorklet(
          isolate, world, instance_object, prototype_object, interface_object);
    }
  }
  if (wrapper_type_info == &V8BaseAudioContext::wrapperTypeInfo) {
    if (OriginTrials::audioWorkletEnabled(execution_context)) {
      V8BaseAudioContext::installAudioWorklet(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
  }
  if (wrapper_type_info == &V8BudgetService::wrapperTypeInfo) {
    if (OriginTrials::budgetQueryEnabled(execution_context)) {
      V8BudgetService::installBudgetQuery(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
  }
  if (wrapper_type_info == &V8DedicatedWorkerGlobalScope::wrapperTypeInfo) {
    v8::Local<v8::Object> instance_object =
        script_state->GetContext()->Global();
    if (OriginTrials::budgetQueryEnabled(execution_context)) {
      V8DedicatedWorkerGlobalScopePartial::installBudgetQuery(
          isolate, world, instance_object, prototype_object, interface_object);
    }
  }
  if (wrapper_type_info == &V8Gamepad::wrapperTypeInfo) {
    if (OriginTrials::gamepadExtensionsEnabled(execution_context)) {
      V8Gamepad::installGamepadExtensions(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
  }
  if (wrapper_type_info == &V8GamepadButton::wrapperTypeInfo) {
    if (OriginTrials::gamepadExtensionsEnabled(execution_context)) {
      V8GamepadButton::installGamepadExtensions(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
  }
  if (wrapper_type_info == &V8Navigator::wrapperTypeInfo) {
    if (OriginTrials::webVREnabled(execution_context)) {
      V8NavigatorPartial::installWebVR(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
    if (OriginTrials::mediaCapabilitiesEnabled(execution_context)) {
      V8NavigatorPartial::installMediaCapabilities(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
    if (OriginTrials::installedAppEnabled(execution_context)) {
      V8NavigatorPartial::installInstalledApp(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
  }
  if (wrapper_type_info == &V8ServiceWorkerGlobalScope::wrapperTypeInfo) {
    v8::Local<v8::Object> instance_object =
        script_state->GetContext()->Global();
    if (OriginTrials::budgetQueryEnabled(execution_context)) {
      V8ServiceWorkerGlobalScope::installBudgetQuery(
          isolate, world, instance_object, prototype_object, interface_object);
    }
  }
  if (wrapper_type_info == &V8SharedWorkerGlobalScope::wrapperTypeInfo) {
    v8::Local<v8::Object> instance_object =
        script_state->GetContext()->Global();
    if (OriginTrials::budgetQueryEnabled(execution_context)) {
      V8SharedWorkerGlobalScopePartial::installBudgetQuery(
          isolate, world, instance_object, prototype_object, interface_object);
    }
  }
  if (wrapper_type_info == &V8Window::wrapperTypeInfo) {
    v8::Local<v8::Object> instance_object =
        script_state->GetContext()->Global();
    if (OriginTrials::budgetQueryEnabled(execution_context)) {
      V8WindowPartial::installBudgetQuery(
          isolate, world, instance_object, prototype_object, interface_object);
    }
    if (OriginTrials::mediaCapabilitiesEnabled(execution_context)) {
      V8WindowPartial::installMediaCapabilities(
          isolate, world, instance_object, prototype_object, interface_object);
    }
    if (OriginTrials::webVREnabled(execution_context)) {
      V8WindowPartial::installWebVR(
          isolate, world, instance_object, prototype_object, interface_object);
    }
    if (OriginTrials::audioWorkletEnabled(execution_context)) {
      V8WindowPartial::installAudioWorklet(
          isolate, world, instance_object, prototype_object, interface_object);
    }
    if (OriginTrials::gamepadExtensionsEnabled(execution_context)) {
      V8WindowPartial::installGamepadExtensions(
          isolate, world, instance_object, prototype_object, interface_object);
    }
    if (OriginTrials::sensorEnabled(execution_context)) {
      V8WindowPartial::installSensor(
          isolate, world, instance_object, prototype_object, interface_object);
    }
  }
}

void InstallPendingOriginTrialFeatureForModules(
    const String& feature,
    const ScriptState* script_state) {
  (*g_original_install_pending_origin_trial_feature_function)(feature,
                                                             script_state);

  // TODO(iclelland): Extract this common code out of OriginTrialFeaturesForCore
  // and OriginTrialFeaturesForModules into a block.
  v8::Local<v8::Object> prototype_object;
  v8::Local<v8::Function> interface_object;
  v8::Isolate* isolate = script_state->GetIsolate();
  const DOMWrapperWorld& world = script_state->World();
  V8PerContextData* context_data = script_state->PerContextData();
  if (feature == OriginTrials::kAudioWorkletTrialName) {
    V8AudioWorkletGlobalScope::installAudioWorklet(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
    if (context_data->GetExistingConstructorAndPrototypeForType(
            &V8BaseAudioContext::wrapperTypeInfo, &prototype_object, &interface_object)) {
      V8BaseAudioContext::installAudioWorklet(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
    V8WindowPartial::installAudioWorklet(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
  }
  if (feature == OriginTrials::kBudgetQueryTrialName) {
    if (context_data->GetExistingConstructorAndPrototypeForType(
            &V8BudgetService::wrapperTypeInfo, &prototype_object, &interface_object)) {
      V8BudgetService::installBudgetQuery(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
    V8DedicatedWorkerGlobalScopePartial::installBudgetQuery(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
    V8WindowPartial::installBudgetQuery(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
    V8ServiceWorkerGlobalScope::installBudgetQuery(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
    V8SharedWorkerGlobalScopePartial::installBudgetQuery(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
  }
  if (feature == OriginTrials::kGamepadExtensionsTrialName) {
    if (context_data->GetExistingConstructorAndPrototypeForType(
            &V8Gamepad::wrapperTypeInfo, &prototype_object, &interface_object)) {
      V8Gamepad::installGamepadExtensions(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
    V8WindowPartial::installGamepadExtensions(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
    if (context_data->GetExistingConstructorAndPrototypeForType(
            &V8GamepadButton::wrapperTypeInfo, &prototype_object, &interface_object)) {
      V8GamepadButton::installGamepadExtensions(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
  }
  if (feature == OriginTrials::kInstalledAppTrialName) {
    if (context_data->GetExistingConstructorAndPrototypeForType(
            &V8Navigator::wrapperTypeInfo, &prototype_object, &interface_object)) {
      V8NavigatorPartial::installInstalledApp(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
  }
  if (feature == OriginTrials::kMediaCapabilitiesTrialName) {
    V8WindowPartial::installMediaCapabilities(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
    if (context_data->GetExistingConstructorAndPrototypeForType(
            &V8Navigator::wrapperTypeInfo, &prototype_object, &interface_object)) {
      V8NavigatorPartial::installMediaCapabilities(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
  }
  if (feature == OriginTrials::kSensorTrialName) {
    V8WindowPartial::installSensor(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
  }
  if (feature == OriginTrials::kWebVRTrialName) {
    V8WindowPartial::installWebVR(
        isolate, world, script_state->GetContext()->Global(),
        v8::Local<v8::Object>(), v8::Local<v8::Function>());
    if (context_data->GetExistingConstructorAndPrototypeForType(
            &V8Navigator::wrapperTypeInfo, &prototype_object, &interface_object)) {
      V8NavigatorPartial::installWebVR(
          isolate, world, v8::Local<v8::Object>(), prototype_object, interface_object);
    }
  }
}

}  // namespace

void RegisterInstallOriginTrialFeaturesForModules() {
  RegisterInstallOriginTrialFeaturesForCore();
  g_original_install_origin_trial_features_function =
      SetInstallOriginTrialFeaturesFunction(
          &InstallOriginTrialFeaturesForModules);
  g_original_install_pending_origin_trial_feature_function =
      SetInstallPendingOriginTrialFeatureFunction(
          &InstallPendingOriginTrialFeatureForModules);
}

}  // namespace blink
