// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8AudioTimestamp.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8AudioTimestampKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "contextTime",
    "performanceTime",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8AudioTimestamp::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, AudioTimestamp& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8AudioTimestampKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> contextTimeValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&contextTimeValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (contextTimeValue.IsEmpty() || contextTimeValue->IsUndefined()) {
    // Do nothing.
  } else {
    double contextTimeCppValue = NativeValueTraits<IDLDouble>::NativeValue(isolate, contextTimeValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setContextTime(contextTimeCppValue);
  }

  v8::Local<v8::Value> performanceTimeValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&performanceTimeValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (performanceTimeValue.IsEmpty() || performanceTimeValue->IsUndefined()) {
    // Do nothing.
  } else {
    double performanceTimeCppValue = NativeValueTraits<IDLDouble>::NativeValue(isolate, performanceTimeValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setPerformanceTime(performanceTimeCppValue);
  }
}

v8::Local<v8::Value> AudioTimestamp::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8AudioTimestamp(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8AudioTimestamp(const AudioTimestamp& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8AudioTimestampKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> contextTimeValue;
  bool contextTimeHasValueOrDefault = false;
  if (impl.hasContextTime()) {
    contextTimeValue = v8::Number::New(isolate, impl.contextTime());
    contextTimeHasValueOrDefault = true;
  }
  if (contextTimeHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), contextTimeValue))) {
    return false;
  }

  v8::Local<v8::Value> performanceTimeValue;
  bool performanceTimeHasValueOrDefault = false;
  if (impl.hasPerformanceTime()) {
    performanceTimeValue = v8::Number::New(isolate, impl.performanceTime());
    performanceTimeHasValueOrDefault = true;
  }
  if (performanceTimeHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), performanceTimeValue))) {
    return false;
  }

  return true;
}

AudioTimestamp NativeValueTraits<AudioTimestamp>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AudioTimestamp impl;
  V8AudioTimestamp::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
