// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8CanMakePaymentEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/modules/v8/V8ExtendableEventInit.h"
#include "bindings/modules/v8/V8PaymentDetailsModifier.h"
#include "bindings/modules/v8/V8PaymentMethodData.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8CanMakePaymentEventInitKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "methodData",
    "modifiers",
    "paymentRequestOrigin",
    "topLevelOrigin",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8CanMakePaymentEventInit::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, CanMakePaymentEventInit& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  V8ExtendableEventInit::ToImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.HadException())
    return;

  const v8::Eternal<v8::Name>* keys = eternalV8CanMakePaymentEventInitKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> methodDataValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&methodDataValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (methodDataValue.IsEmpty() || methodDataValue->IsUndefined()) {
    // Do nothing.
  } else {
    HeapVector<PaymentMethodData> methodDataCppValue = NativeValueTraits<IDLSequence<PaymentMethodData>>::NativeValue(isolate, methodDataValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setMethodData(methodDataCppValue);
  }

  v8::Local<v8::Value> modifiersValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&modifiersValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (modifiersValue.IsEmpty() || modifiersValue->IsUndefined()) {
    // Do nothing.
  } else {
    HeapVector<PaymentDetailsModifier> modifiersCppValue = NativeValueTraits<IDLSequence<PaymentDetailsModifier>>::NativeValue(isolate, modifiersValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setModifiers(modifiersCppValue);
  }

  v8::Local<v8::Value> paymentRequestOriginValue;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&paymentRequestOriginValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (paymentRequestOriginValue.IsEmpty() || paymentRequestOriginValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> paymentRequestOriginCppValue = NativeValueTraits<IDLUSVString>::NativeValue(isolate, paymentRequestOriginValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setPaymentRequestOrigin(paymentRequestOriginCppValue);
  }

  v8::Local<v8::Value> topLevelOriginValue;
  if (!v8Object->Get(context, keys[3].Get(isolate)).ToLocal(&topLevelOriginValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (topLevelOriginValue.IsEmpty() || topLevelOriginValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> topLevelOriginCppValue = NativeValueTraits<IDLUSVString>::NativeValue(isolate, topLevelOriginValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setTopLevelOrigin(topLevelOriginCppValue);
  }
}

v8::Local<v8::Value> CanMakePaymentEventInit::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8CanMakePaymentEventInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8CanMakePaymentEventInit(const CanMakePaymentEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8ExtendableEventInit(impl, dictionary, creationContext, isolate))
    return false;

  const v8::Eternal<v8::Name>* keys = eternalV8CanMakePaymentEventInitKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> methodDataValue;
  bool methodDataHasValueOrDefault = false;
  if (impl.hasMethodData()) {
    methodDataValue = ToV8(impl.methodData(), creationContext, isolate);
    methodDataHasValueOrDefault = true;
  }
  if (methodDataHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), methodDataValue))) {
    return false;
  }

  v8::Local<v8::Value> modifiersValue;
  bool modifiersHasValueOrDefault = false;
  if (impl.hasModifiers()) {
    modifiersValue = ToV8(impl.modifiers(), creationContext, isolate);
    modifiersHasValueOrDefault = true;
  }
  if (modifiersHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), modifiersValue))) {
    return false;
  }

  v8::Local<v8::Value> paymentRequestOriginValue;
  bool paymentRequestOriginHasValueOrDefault = false;
  if (impl.hasPaymentRequestOrigin()) {
    paymentRequestOriginValue = V8String(isolate, impl.paymentRequestOrigin());
    paymentRequestOriginHasValueOrDefault = true;
  }
  if (paymentRequestOriginHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), paymentRequestOriginValue))) {
    return false;
  }

  v8::Local<v8::Value> topLevelOriginValue;
  bool topLevelOriginHasValueOrDefault = false;
  if (impl.hasTopLevelOrigin()) {
    topLevelOriginValue = V8String(isolate, impl.topLevelOrigin());
    topLevelOriginHasValueOrDefault = true;
  }
  if (topLevelOriginHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[3].Get(isolate), topLevelOriginValue))) {
    return false;
  }

  return true;
}

CanMakePaymentEventInit NativeValueTraits<CanMakePaymentEventInit>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  CanMakePaymentEventInit impl;
  V8CanMakePaymentEventInit::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
