// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8CanvasRenderingContext2DSettings.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "platform/runtime_enabled_features.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8CanvasRenderingContext2DSettingsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "alpha",
    "colorSpace",
    "pixelFormat",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8CanvasRenderingContext2DSettings::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, CanvasRenderingContext2DSettings& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    // Do nothing.
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8CanvasRenderingContext2DSettingsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> alphaValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&alphaValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (alphaValue.IsEmpty() || alphaValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool alphaCppValue = NativeValueTraits<IDLBoolean>::NativeValue(isolate, alphaValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setAlpha(alphaCppValue);
  }

  if (RuntimeEnabledFeatures::ExperimentalCanvasFeaturesEnabled()) {
    v8::Local<v8::Value> colorSpaceValue;
    if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&colorSpaceValue)) {
      exceptionState.RethrowV8Exception(block.Exception());
      return;
    }
    if (colorSpaceValue.IsEmpty() || colorSpaceValue->IsUndefined()) {
      // Do nothing.
    } else {
      V8StringResource<> colorSpaceCppValue = colorSpaceValue;
      if (!colorSpaceCppValue.Prepare(exceptionState))
        return;
      const char* validValues[] = {
          "srgb",
          "rec2020",
          "p3",
      };
      if (!IsValidEnum(colorSpaceCppValue, validValues, WTF_ARRAY_LENGTH(validValues), "CanvasColorSpace", exceptionState))
        return;
      impl.setColorSpace(colorSpaceCppValue);
    }

    v8::Local<v8::Value> pixelFormatValue;
    if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&pixelFormatValue)) {
      exceptionState.RethrowV8Exception(block.Exception());
      return;
    }
    if (pixelFormatValue.IsEmpty() || pixelFormatValue->IsUndefined()) {
      // Do nothing.
    } else {
      V8StringResource<> pixelFormatCppValue = pixelFormatValue;
      if (!pixelFormatCppValue.Prepare(exceptionState))
        return;
      const char* validValues[] = {
          "8-8-8-8",
          "10-10-10-2",
          "12-12-12-12",
          "float16",
      };
      if (!IsValidEnum(pixelFormatCppValue, validValues, WTF_ARRAY_LENGTH(validValues), "CanvasPixelFormat", exceptionState))
        return;
      impl.setPixelFormat(pixelFormatCppValue);
    }
  }
}

v8::Local<v8::Value> CanvasRenderingContext2DSettings::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8CanvasRenderingContext2DSettings(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8CanvasRenderingContext2DSettings(const CanvasRenderingContext2DSettings& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8CanvasRenderingContext2DSettingsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> alphaValue;
  bool alphaHasValueOrDefault = false;
  if (impl.hasAlpha()) {
    alphaValue = v8::Boolean::New(isolate, impl.alpha());
    alphaHasValueOrDefault = true;
  } else {
    alphaValue = v8::Boolean::New(isolate, true);
    alphaHasValueOrDefault = true;
  }
  if (alphaHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), alphaValue))) {
    return false;
  }

  if (RuntimeEnabledFeatures::ExperimentalCanvasFeaturesEnabled()) {
    v8::Local<v8::Value> colorSpaceValue;
    bool colorSpaceHasValueOrDefault = false;
    if (impl.hasColorSpace()) {
      colorSpaceValue = V8String(isolate, impl.colorSpace());
      colorSpaceHasValueOrDefault = true;
    } else {
      colorSpaceValue = V8String(isolate, "srgb");
      colorSpaceHasValueOrDefault = true;
    }
    if (colorSpaceHasValueOrDefault &&
        !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), colorSpaceValue))) {
      return false;
    }

    v8::Local<v8::Value> pixelFormatValue;
    bool pixelFormatHasValueOrDefault = false;
    if (impl.hasPixelFormat()) {
      pixelFormatValue = V8String(isolate, impl.pixelFormat());
      pixelFormatHasValueOrDefault = true;
    } else {
      pixelFormatValue = V8String(isolate, "8-8-8-8");
      pixelFormatHasValueOrDefault = true;
    }
    if (pixelFormatHasValueOrDefault &&
        !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), pixelFormatValue))) {
      return false;
    }
  }

  return true;
}

CanvasRenderingContext2DSettings NativeValueTraits<CanvasRenderingContext2DSettings>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  CanvasRenderingContext2DSettings impl;
  V8CanvasRenderingContext2DSettings::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
