// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8LockOptions.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8LockOptionsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "ifAvailable",
    "mode",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8LockOptions::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, LockOptions& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8LockOptionsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> ifAvailableValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&ifAvailableValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (ifAvailableValue.IsEmpty() || ifAvailableValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool ifAvailableCppValue = NativeValueTraits<IDLBoolean>::NativeValue(isolate, ifAvailableValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setIfAvailable(ifAvailableCppValue);
  }

  v8::Local<v8::Value> modeValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&modeValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (modeValue.IsEmpty() || modeValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> modeCppValue = modeValue;
    if (!modeCppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "shared",
        "exclusive",
    };
    if (!IsValidEnum(modeCppValue, validValues, WTF_ARRAY_LENGTH(validValues), "LockMode", exceptionState))
      return;
    impl.setMode(modeCppValue);
  }
}

v8::Local<v8::Value> LockOptions::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8LockOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8LockOptions(const LockOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8LockOptionsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> ifAvailableValue;
  bool ifAvailableHasValueOrDefault = false;
  if (impl.hasIfAvailable()) {
    ifAvailableValue = v8::Boolean::New(isolate, impl.ifAvailable());
    ifAvailableHasValueOrDefault = true;
  } else {
    ifAvailableValue = v8::Boolean::New(isolate, false);
    ifAvailableHasValueOrDefault = true;
  }
  if (ifAvailableHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), ifAvailableValue))) {
    return false;
  }

  v8::Local<v8::Value> modeValue;
  bool modeHasValueOrDefault = false;
  if (impl.hasMode()) {
    modeValue = V8String(isolate, impl.mode());
    modeHasValueOrDefault = true;
  } else {
    modeValue = V8String(isolate, "exclusive");
    modeHasValueOrDefault = true;
  }
  if (modeHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), modeValue))) {
    return false;
  }

  return true;
}

LockOptions NativeValueTraits<LockOptions>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  LockOptions impl;
  V8LockOptions::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
