// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8MIDIConnectionEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/V8EventInit.h"
#include "bindings/modules/v8/V8MIDIPort.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8MIDIConnectionEventInitKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "port",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8MIDIConnectionEventInit::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, MIDIConnectionEventInit& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  V8EventInit::ToImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.HadException())
    return;

  const v8::Eternal<v8::Name>* keys = eternalV8MIDIConnectionEventInitKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> portValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&portValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (portValue.IsEmpty() || portValue->IsUndefined()) {
    // Do nothing.
  } else if (portValue->IsNull()) {
    impl.setPortToNull();
  } else {
    MIDIPort* portCppValue = V8MIDIPort::ToImplWithTypeCheck(isolate, portValue);
    if (!portCppValue) {
      exceptionState.ThrowTypeError("member port is not of type MIDIPort.");
      return;
    }
    impl.setPort(portCppValue);
  }
}

v8::Local<v8::Value> MIDIConnectionEventInit::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8MIDIConnectionEventInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8MIDIConnectionEventInit(const MIDIConnectionEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8EventInit(impl, dictionary, creationContext, isolate))
    return false;

  const v8::Eternal<v8::Name>* keys = eternalV8MIDIConnectionEventInitKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> portValue;
  bool portHasValueOrDefault = false;
  if (impl.hasPort()) {
    portValue = ToV8(impl.port(), creationContext, isolate);
    portHasValueOrDefault = true;
  } else {
    portValue = v8::Null(isolate);
    portHasValueOrDefault = true;
  }
  if (portHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), portValue))) {
    return false;
  }

  return true;
}

MIDIConnectionEventInit NativeValueTraits<MIDIConnectionEventInit>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  MIDIConnectionEventInit impl;
  V8MIDIConnectionEventInit::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
