// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8NotificationEventInit.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/modules/v8/V8ExtendableEventInit.h"
#include "bindings/modules/v8/V8Notification.h"
#include "platform/runtime_enabled_features.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8NotificationEventInitKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "action",
    "notification",
    "reply",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8NotificationEventInit::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, NotificationEventInit& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("Missing required member(s): notification.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  V8ExtendableEventInit::ToImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.HadException())
    return;

  const v8::Eternal<v8::Name>* keys = eternalV8NotificationEventInitKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> actionValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&actionValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (actionValue.IsEmpty() || actionValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> actionCppValue = actionValue;
    if (!actionCppValue.Prepare(exceptionState))
      return;
    impl.setAction(actionCppValue);
  }

  v8::Local<v8::Value> notificationValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&notificationValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (notificationValue.IsEmpty() || notificationValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member notification is undefined.");
    return;
  } else {
    Notification* notificationCppValue = V8Notification::ToImplWithTypeCheck(isolate, notificationValue);
    if (!notificationCppValue) {
      exceptionState.ThrowTypeError("member notification is not of type Notification.");
      return;
    }
    impl.setNotification(notificationCppValue);
  }

  if (RuntimeEnabledFeatures::NotificationInlineRepliesEnabled()) {
    v8::Local<v8::Value> replyValue;
    if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&replyValue)) {
      exceptionState.RethrowV8Exception(block.Exception());
      return;
    }
    if (replyValue.IsEmpty() || replyValue->IsUndefined()) {
      // Do nothing.
    } else if (replyValue->IsNull()) {
      impl.setReplyToNull();
    } else {
      V8StringResource<> replyCppValue = replyValue;
      if (!replyCppValue.Prepare(exceptionState))
        return;
      impl.setReply(replyCppValue);
    }
  }
}

v8::Local<v8::Value> NotificationEventInit::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8NotificationEventInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8NotificationEventInit(const NotificationEventInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8ExtendableEventInit(impl, dictionary, creationContext, isolate))
    return false;

  const v8::Eternal<v8::Name>* keys = eternalV8NotificationEventInitKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> actionValue;
  bool actionHasValueOrDefault = false;
  if (impl.hasAction()) {
    actionValue = V8String(isolate, impl.action());
    actionHasValueOrDefault = true;
  } else {
    actionValue = V8String(isolate, WTF::g_empty_string);
    actionHasValueOrDefault = true;
  }
  if (actionHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), actionValue))) {
    return false;
  }

  v8::Local<v8::Value> notificationValue;
  bool notificationHasValueOrDefault = false;
  if (impl.hasNotification()) {
    notificationValue = ToV8(impl.notification(), creationContext, isolate);
    notificationHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (notificationHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), notificationValue))) {
    return false;
  }

  if (RuntimeEnabledFeatures::NotificationInlineRepliesEnabled()) {
    v8::Local<v8::Value> replyValue;
    bool replyHasValueOrDefault = false;
    if (impl.hasReply()) {
      replyValue = V8String(isolate, impl.reply());
      replyHasValueOrDefault = true;
    } else {
      replyValue = V8String(isolate, WTF::g_empty_string);
      replyHasValueOrDefault = true;
    }
    if (replyHasValueOrDefault &&
        !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), replyValue))) {
      return false;
    }
  }

  return true;
}

NotificationEventInit NativeValueTraits<NotificationEventInit>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  NotificationEventInit impl;
  V8NotificationEventInit::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
