// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8PasswordCredentialData.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/modules/v8/V8CredentialData.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8PasswordCredentialDataKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "iconURL",
    "name",
    "password",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8PasswordCredentialData::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PasswordCredentialData& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("Missing required member(s): password.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  V8CredentialData::ToImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.HadException())
    return;

  const v8::Eternal<v8::Name>* keys = eternalV8PasswordCredentialDataKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> iconURLValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&iconURLValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (iconURLValue.IsEmpty() || iconURLValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> iconURLCppValue = NativeValueTraits<IDLUSVString>::NativeValue(isolate, iconURLValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setIconURL(iconURLCppValue);
  }

  v8::Local<v8::Value> nameValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&nameValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (nameValue.IsEmpty() || nameValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> nameCppValue = NativeValueTraits<IDLUSVString>::NativeValue(isolate, nameValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setName(nameCppValue);
  }

  v8::Local<v8::Value> passwordValue;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&passwordValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (passwordValue.IsEmpty() || passwordValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member password is undefined.");
    return;
  } else {
    V8StringResource<> passwordCppValue = NativeValueTraits<IDLUSVString>::NativeValue(isolate, passwordValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setPassword(passwordCppValue);
  }
}

v8::Local<v8::Value> PasswordCredentialData::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8PasswordCredentialData(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8PasswordCredentialData(const PasswordCredentialData& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8CredentialData(impl, dictionary, creationContext, isolate))
    return false;

  const v8::Eternal<v8::Name>* keys = eternalV8PasswordCredentialDataKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> iconURLValue;
  bool iconURLHasValueOrDefault = false;
  if (impl.hasIconURL()) {
    iconURLValue = V8String(isolate, impl.iconURL());
    iconURLHasValueOrDefault = true;
  }
  if (iconURLHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), iconURLValue))) {
    return false;
  }

  v8::Local<v8::Value> nameValue;
  bool nameHasValueOrDefault = false;
  if (impl.hasName()) {
    nameValue = V8String(isolate, impl.name());
    nameHasValueOrDefault = true;
  }
  if (nameHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), nameValue))) {
    return false;
  }

  v8::Local<v8::Value> passwordValue;
  bool passwordHasValueOrDefault = false;
  if (impl.hasPassword()) {
    passwordValue = V8String(isolate, impl.password());
    passwordHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (passwordHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), passwordValue))) {
    return false;
  }

  return true;
}

PasswordCredentialData NativeValueTraits<PasswordCredentialData>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  PasswordCredentialData impl;
  V8PasswordCredentialData::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
