// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8PaymentCurrencyAmount.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8PaymentCurrencyAmountKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "currency",
    "currencySystem",
    "value",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8PaymentCurrencyAmount::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PaymentCurrencyAmount& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("Missing required member(s): currency, value.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8PaymentCurrencyAmountKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> currencyValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&currencyValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (currencyValue.IsEmpty() || currencyValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member currency is undefined.");
    return;
  } else {
    V8StringResource<> currencyCppValue = currencyValue;
    if (!currencyCppValue.Prepare(exceptionState))
      return;
    impl.setCurrency(currencyCppValue);
  }

  v8::Local<v8::Value> currencySystemValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&currencySystemValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (currencySystemValue.IsEmpty() || currencySystemValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> currencySystemCppValue = currencySystemValue;
    if (!currencySystemCppValue.Prepare(exceptionState))
      return;
    impl.setCurrencySystem(currencySystemCppValue);
  }

  v8::Local<v8::Value> valueValue;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&valueValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (valueValue.IsEmpty() || valueValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member value is undefined.");
    return;
  } else {
    V8StringResource<> valueCppValue = valueValue;
    if (!valueCppValue.Prepare(exceptionState))
      return;
    impl.setValue(valueCppValue);
  }
}

v8::Local<v8::Value> PaymentCurrencyAmount::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8PaymentCurrencyAmount(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8PaymentCurrencyAmount(const PaymentCurrencyAmount& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8PaymentCurrencyAmountKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> currencyValue;
  bool currencyHasValueOrDefault = false;
  if (impl.hasCurrency()) {
    currencyValue = V8String(isolate, impl.currency());
    currencyHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (currencyHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), currencyValue))) {
    return false;
  }

  v8::Local<v8::Value> currencySystemValue;
  bool currencySystemHasValueOrDefault = false;
  if (impl.hasCurrencySystem()) {
    currencySystemValue = V8String(isolate, impl.currencySystem());
    currencySystemHasValueOrDefault = true;
  } else {
    currencySystemValue = V8String(isolate, "urn:iso:std:iso:4217");
    currencySystemHasValueOrDefault = true;
  }
  if (currencySystemHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), currencySystemValue))) {
    return false;
  }

  v8::Local<v8::Value> valueValue;
  bool valueHasValueOrDefault = false;
  if (impl.hasValue()) {
    valueValue = V8String(isolate, impl.value());
    valueHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (valueHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), valueValue))) {
    return false;
  }

  return true;
}

PaymentCurrencyAmount NativeValueTraits<PaymentCurrencyAmount>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  PaymentCurrencyAmount impl;
  V8PaymentCurrencyAmount::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
