// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8StereoPannerOptions.h"

#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/modules/v8/V8AudioNodeOptions.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8StereoPannerOptionsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "pan",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, WTF_ARRAY_LENGTH(kKeys));
}

void V8StereoPannerOptions::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, StereoPannerOptions& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  V8AudioNodeOptions::ToImpl(isolate, v8Value, impl, exceptionState);
  if (exceptionState.HadException())
    return;

  const v8::Eternal<v8::Name>* keys = eternalV8StereoPannerOptionsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> panValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&panValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (panValue.IsEmpty() || panValue->IsUndefined()) {
    // Do nothing.
  } else {
    float panCppValue = NativeValueTraits<IDLFloat>::NativeValue(isolate, panValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setPan(panCppValue);
  }
}

v8::Local<v8::Value> StereoPannerOptions::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8StereoPannerOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8StereoPannerOptions(const StereoPannerOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  if (!toV8AudioNodeOptions(impl, dictionary, creationContext, isolate))
    return false;

  const v8::Eternal<v8::Name>* keys = eternalV8StereoPannerOptionsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> panValue;
  bool panHasValueOrDefault = false;
  if (impl.hasPan()) {
    panValue = v8::Number::New(isolate, impl.pan());
    panHasValueOrDefault = true;
  } else {
    panValue = v8::Number::New(isolate, 0);
    panHasValueOrDefault = true;
  }
  if (panHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), panValue))) {
    return false;
  }

  return true;
}

StereoPannerOptions NativeValueTraits<StereoPannerOptions>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  StereoPannerOptions impl;
  V8StereoPannerOptions::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
