// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/interface.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "V8WebGLGetBufferSubDataAsync.h"

#include "base/memory/scoped_refptr.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/IDLTypes.h"
#include "bindings/core/v8/NativeValueTraitsImpl.h"
#include "bindings/core/v8/ScriptPromise.h"
#include "bindings/core/v8/V8ArrayBufferView.h"
#include "bindings/core/v8/V8DOMConfiguration.h"
#include "core/dom/ExecutionContext.h"
#include "core/typed_arrays/ArrayBufferViewHelpers.h"
#include "core/typed_arrays/FlexibleArrayBufferView.h"
#include "platform/bindings/RuntimeCallStats.h"
#include "platform/bindings/ScriptState.h"
#include "platform/bindings/V8ObjectConstructor.h"
#include "platform/wtf/GetPtr.h"

namespace blink {

// Suppress warning: global constructors, because struct WrapperTypeInfo is trivial
// and does not depend on another global objects.
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wglobal-constructors"
#endif
const WrapperTypeInfo V8WebGLGetBufferSubDataAsync::wrapperTypeInfo = {
    gin::kEmbedderBlink,
    V8WebGLGetBufferSubDataAsync::domTemplate,
    V8WebGLGetBufferSubDataAsync::Trace,
    V8WebGLGetBufferSubDataAsync::TraceWrappers,
    nullptr,
    "WebGLGetBufferSubDataAsync",
    nullptr,
    WrapperTypeInfo::kWrapperTypeObjectPrototype,
    WrapperTypeInfo::kObjectClassId,
    WrapperTypeInfo::kNotInheritFromActiveScriptWrappable,
};
#if defined(COMPONENT_BUILD) && defined(WIN32) && defined(__clang__)
#pragma clang diagnostic pop
#endif

// This static member must be declared by DEFINE_WRAPPERTYPEINFO in WebGLGetBufferSubDataAsync.h.
// For details, see the comment of DEFINE_WRAPPERTYPEINFO in
// platform/bindings/ScriptWrappable.h.
const WrapperTypeInfo& WebGLGetBufferSubDataAsync::wrapper_type_info_ = V8WebGLGetBufferSubDataAsync::wrapperTypeInfo;

// not [ActiveScriptWrappable]
static_assert(
    !std::is_base_of<ActiveScriptWrappableBase, WebGLGetBufferSubDataAsync>::value,
    "WebGLGetBufferSubDataAsync inherits from ActiveScriptWrappable<>, but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");
static_assert(
    std::is_same<decltype(&WebGLGetBufferSubDataAsync::HasPendingActivity),
                 decltype(&ScriptWrappable::HasPendingActivity)>::value,
    "WebGLGetBufferSubDataAsync is overriding hasPendingActivity(), but is not specifying "
    "[ActiveScriptWrappable] extended attribute in the IDL file.  "
    "Be consistent.");

namespace WebGLGetBufferSubDataAsyncV8Internal {

static void getBufferSubDataAsyncMethod(const v8::FunctionCallbackInfo<v8::Value>& info) {
  ExceptionState exceptionState(info.GetIsolate(), ExceptionState::kExecutionContext, "WebGLGetBufferSubDataAsync", "getBufferSubDataAsync");
  ExceptionToRejectPromiseScope rejectPromiseScope(info, exceptionState);

  // V8DOMConfiguration::kDoNotCheckHolder
  // Make sure that info.Holder() really points to an instance of the type.
  if (!V8WebGLGetBufferSubDataAsync::hasInstance(info.Holder(), info.GetIsolate())) {
    exceptionState.ThrowTypeError("Illegal invocation");
    return;
  }
  WebGLGetBufferSubDataAsync* impl = V8WebGLGetBufferSubDataAsync::ToImpl(info.Holder());

  ScriptState* scriptState = ScriptState::ForRelevantRealm(info);

  if (UNLIKELY(info.Length() < 3)) {
    exceptionState.ThrowTypeError(ExceptionMessages::NotEnoughArguments(3, info.Length()));
    return;
  }

  uint32_t target;
  int64_t srcByteOffset;
  NotShared<DOMArrayBufferView> dstData;
  uint32_t dstOffset;
  uint32_t length;
  target = NativeValueTraits<IDLUnsignedLong>::NativeValue(info.GetIsolate(), info[0], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  srcByteOffset = NativeValueTraits<IDLLongLong>::NativeValue(info.GetIsolate(), info[1], exceptionState, kNormalConversion);
  if (exceptionState.HadException())
    return;

  dstData = ToNotShared<NotShared<DOMArrayBufferView>>(info.GetIsolate(), info[2], exceptionState);
  if (exceptionState.HadException())
    return;
  if (!dstData) {
    exceptionState.ThrowTypeError("parameter 3 is not of type 'ArrayBufferView'.");
    return;
  }

  if (!info[3]->IsUndefined()) {
    dstOffset = NativeValueTraits<IDLUnsignedLong>::NativeValue(info.GetIsolate(), info[3], exceptionState, kNormalConversion);
    if (exceptionState.HadException())
      return;
  } else {
    dstOffset = 0u;
  }
  if (!info[4]->IsUndefined()) {
    length = NativeValueTraits<IDLUnsignedLong>::NativeValue(info.GetIsolate(), info[4], exceptionState, kNormalConversion);
    if (exceptionState.HadException())
      return;
  } else {
    length = 0u;
  }

  ScriptPromise result = impl->getBufferSubDataAsync(scriptState, target, srcByteOffset, dstData, dstOffset, length);
  V8SetReturnValue(info, result.V8Value());
}

} // namespace WebGLGetBufferSubDataAsyncV8Internal

void V8WebGLGetBufferSubDataAsync::getBufferSubDataAsyncMethodCallback(const v8::FunctionCallbackInfo<v8::Value>& info) {
  RUNTIME_CALL_TIMER_SCOPE_DISABLED_BY_DEFAULT(info.GetIsolate(), "Blink_WebGLGetBufferSubDataAsync_getBufferSubDataAsync");

  WebGLGetBufferSubDataAsyncV8Internal::getBufferSubDataAsyncMethod(info);
}

static const V8DOMConfiguration::MethodConfiguration V8WebGLGetBufferSubDataAsyncMethods[] = {
    {"getBufferSubDataAsync", V8WebGLGetBufferSubDataAsync::getBufferSubDataAsyncMethodCallback, 3, v8::None, V8DOMConfiguration::kOnPrototype, V8DOMConfiguration::kDoNotCheckHolder, V8DOMConfiguration::kDoNotCheckAccess, V8DOMConfiguration::kAllWorlds},
};

static void installV8WebGLGetBufferSubDataAsyncTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interfaceTemplate) {
  // Initialize the interface object's template.
  V8DOMConfiguration::InitializeDOMInterfaceTemplate(isolate, interfaceTemplate, V8WebGLGetBufferSubDataAsync::wrapperTypeInfo.interface_name, v8::Local<v8::FunctionTemplate>(), V8WebGLGetBufferSubDataAsync::internalFieldCount);

  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interfaceTemplate);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instanceTemplate = interfaceTemplate->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instanceTemplate);
  v8::Local<v8::ObjectTemplate> prototypeTemplate = interfaceTemplate->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototypeTemplate);

  // Register IDL constants, attributes and operations.
  V8DOMConfiguration::InstallMethods(
      isolate, world, instanceTemplate, prototypeTemplate, interfaceTemplate,
      signature, V8WebGLGetBufferSubDataAsyncMethods, WTF_ARRAY_LENGTH(V8WebGLGetBufferSubDataAsyncMethods));

  // Custom signature

  V8WebGLGetBufferSubDataAsync::InstallRuntimeEnabledFeaturesOnTemplate(
      isolate, world, interfaceTemplate);
}

void V8WebGLGetBufferSubDataAsync::InstallRuntimeEnabledFeaturesOnTemplate(
    v8::Isolate* isolate,
    const DOMWrapperWorld& world,
    v8::Local<v8::FunctionTemplate> interface_template) {
  v8::Local<v8::Signature> signature = v8::Signature::New(isolate, interface_template);
  ALLOW_UNUSED_LOCAL(signature);
  v8::Local<v8::ObjectTemplate> instance_template = interface_template->InstanceTemplate();
  ALLOW_UNUSED_LOCAL(instance_template);
  v8::Local<v8::ObjectTemplate> prototype_template = interface_template->PrototypeTemplate();
  ALLOW_UNUSED_LOCAL(prototype_template);

  // Register IDL constants, attributes and operations.

  // Custom signature
}

v8::Local<v8::FunctionTemplate> V8WebGLGetBufferSubDataAsync::domTemplate(v8::Isolate* isolate, const DOMWrapperWorld& world) {
  return V8DOMConfiguration::DomClassTemplate(isolate, world, const_cast<WrapperTypeInfo*>(&wrapperTypeInfo), installV8WebGLGetBufferSubDataAsyncTemplate);
}

bool V8WebGLGetBufferSubDataAsync::hasInstance(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->HasInstance(&wrapperTypeInfo, v8Value);
}

v8::Local<v8::Object> V8WebGLGetBufferSubDataAsync::findInstanceInPrototypeChain(v8::Local<v8::Value> v8Value, v8::Isolate* isolate) {
  return V8PerIsolateData::From(isolate)->FindInstanceInPrototypeChain(&wrapperTypeInfo, v8Value);
}

WebGLGetBufferSubDataAsync* V8WebGLGetBufferSubDataAsync::ToImplWithTypeCheck(v8::Isolate* isolate, v8::Local<v8::Value> value) {
  return hasInstance(value, isolate) ? ToImpl(v8::Local<v8::Object>::Cast(value)) : nullptr;
}

WebGLGetBufferSubDataAsync* NativeValueTraits<WebGLGetBufferSubDataAsync>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  WebGLGetBufferSubDataAsync* nativeValue = V8WebGLGetBufferSubDataAsync::ToImplWithTypeCheck(isolate, value);
  if (!nativeValue) {
    exceptionState.ThrowTypeError(ExceptionMessages::FailedToConvertJSValue(
        "WebGLGetBufferSubDataAsync"));
  }
  return nativeValue;
}

}  // namespace blink
