// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef ArrayBufferOrArrayBufferViewOrUSVString_h
#define ArrayBufferOrArrayBufferViewOrUSVString_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8ArrayBufferView.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "core/typed_arrays/ArrayBufferViewHelpers.h"
#include "core/typed_arrays/FlexibleArrayBufferView.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class DOMArrayBuffer;

class MODULES_EXPORT ArrayBufferOrArrayBufferViewOrUSVString final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  ArrayBufferOrArrayBufferViewOrUSVString();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsArrayBuffer() const { return type_ == SpecificType::kArrayBuffer; }
  DOMArrayBuffer* GetAsArrayBuffer() const;
  void SetArrayBuffer(DOMArrayBuffer*);
  static ArrayBufferOrArrayBufferViewOrUSVString FromArrayBuffer(DOMArrayBuffer*);

  bool IsArrayBufferView() const { return type_ == SpecificType::kArrayBufferView; }
  NotShared<DOMArrayBufferView> GetAsArrayBufferView() const;
  void SetArrayBufferView(NotShared<DOMArrayBufferView>);
  static ArrayBufferOrArrayBufferViewOrUSVString FromArrayBufferView(NotShared<DOMArrayBufferView>);

  bool IsUSVString() const { return type_ == SpecificType::kUSVString; }
  const String& GetAsUSVString() const;
  void SetUSVString(const String&);
  static ArrayBufferOrArrayBufferViewOrUSVString FromUSVString(const String&);

  ArrayBufferOrArrayBufferViewOrUSVString(const ArrayBufferOrArrayBufferViewOrUSVString&);
  ~ArrayBufferOrArrayBufferViewOrUSVString();
  ArrayBufferOrArrayBufferViewOrUSVString& operator=(const ArrayBufferOrArrayBufferViewOrUSVString&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kArrayBuffer,
    kArrayBufferView,
    kUSVString,
  };
  SpecificType type_;

  Member<DOMArrayBuffer> array_buffer_;
  Member<DOMArrayBufferView> array_buffer_view_;
  String usv_string_;

  friend MODULES_EXPORT v8::Local<v8::Value> ToV8(const ArrayBufferOrArrayBufferViewOrUSVString&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8ArrayBufferOrArrayBufferViewOrUSVString final {
 public:
  MODULES_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, ArrayBufferOrArrayBufferViewOrUSVString&, UnionTypeConversionMode, ExceptionState&);
};

MODULES_EXPORT v8::Local<v8::Value> ToV8(const ArrayBufferOrArrayBufferViewOrUSVString&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, ArrayBufferOrArrayBufferViewOrUSVString& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, ArrayBufferOrArrayBufferViewOrUSVString& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<ArrayBufferOrArrayBufferViewOrUSVString> : public NativeValueTraitsBase<ArrayBufferOrArrayBufferViewOrUSVString> {
  MODULES_EXPORT static ArrayBufferOrArrayBufferViewOrUSVString NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  MODULES_EXPORT static ArrayBufferOrArrayBufferViewOrUSVString NullValue() { return ArrayBufferOrArrayBufferViewOrUSVString(); }
};

template <>
struct V8TypeOf<ArrayBufferOrArrayBufferViewOrUSVString> {
  typedef V8ArrayBufferOrArrayBufferViewOrUSVString Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::ArrayBufferOrArrayBufferViewOrUSVString);

#endif  // ArrayBufferOrArrayBufferViewOrUSVString_h
