// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef AudioContextLatencyCategoryOrDouble_h
#define AudioContextLatencyCategoryOrDouble_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class MODULES_EXPORT AudioContextLatencyCategoryOrDouble final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  AudioContextLatencyCategoryOrDouble();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsAudioContextLatencyCategory() const { return type_ == SpecificType::kAudioContextLatencyCategory; }
  const String& GetAsAudioContextLatencyCategory() const;
  void SetAudioContextLatencyCategory(const String&);
  static AudioContextLatencyCategoryOrDouble FromAudioContextLatencyCategory(const String&);

  bool IsDouble() const { return type_ == SpecificType::kDouble; }
  double GetAsDouble() const;
  void SetDouble(double);
  static AudioContextLatencyCategoryOrDouble FromDouble(double);

  AudioContextLatencyCategoryOrDouble(const AudioContextLatencyCategoryOrDouble&);
  ~AudioContextLatencyCategoryOrDouble();
  AudioContextLatencyCategoryOrDouble& operator=(const AudioContextLatencyCategoryOrDouble&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kAudioContextLatencyCategory,
    kDouble,
  };
  SpecificType type_;

  String audio_context_latency_category_;
  double double_;

  friend MODULES_EXPORT v8::Local<v8::Value> ToV8(const AudioContextLatencyCategoryOrDouble&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8AudioContextLatencyCategoryOrDouble final {
 public:
  MODULES_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, AudioContextLatencyCategoryOrDouble&, UnionTypeConversionMode, ExceptionState&);
};

MODULES_EXPORT v8::Local<v8::Value> ToV8(const AudioContextLatencyCategoryOrDouble&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, AudioContextLatencyCategoryOrDouble& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, AudioContextLatencyCategoryOrDouble& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<AudioContextLatencyCategoryOrDouble> : public NativeValueTraitsBase<AudioContextLatencyCategoryOrDouble> {
  MODULES_EXPORT static AudioContextLatencyCategoryOrDouble NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  MODULES_EXPORT static AudioContextLatencyCategoryOrDouble NullValue() { return AudioContextLatencyCategoryOrDouble(); }
};

template <>
struct V8TypeOf<AudioContextLatencyCategoryOrDouble> {
  typedef V8AudioContextLatencyCategoryOrDouble Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::AudioContextLatencyCategoryOrDouble);

#endif  // AudioContextLatencyCategoryOrDouble_h
