// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef DOMExceptionOrOverconstrainedError_h
#define DOMExceptionOrOverconstrainedError_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class DOMException;
class OverconstrainedError;

class MODULES_EXPORT DOMExceptionOrOverconstrainedError final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  DOMExceptionOrOverconstrainedError();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsDOMException() const { return type_ == SpecificType::kDOMException; }
  DOMException* GetAsDOMException() const;
  void SetDOMException(DOMException*);
  static DOMExceptionOrOverconstrainedError FromDOMException(DOMException*);

  bool IsOverconstrainedError() const { return type_ == SpecificType::kOverconstrainedError; }
  OverconstrainedError* GetAsOverconstrainedError() const;
  void SetOverconstrainedError(OverconstrainedError*);
  static DOMExceptionOrOverconstrainedError FromOverconstrainedError(OverconstrainedError*);

  DOMExceptionOrOverconstrainedError(const DOMExceptionOrOverconstrainedError&);
  ~DOMExceptionOrOverconstrainedError();
  DOMExceptionOrOverconstrainedError& operator=(const DOMExceptionOrOverconstrainedError&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kDOMException,
    kOverconstrainedError,
  };
  SpecificType type_;

  Member<DOMException> dom_exception_;
  Member<OverconstrainedError> overconstrained_error_;

  friend MODULES_EXPORT v8::Local<v8::Value> ToV8(const DOMExceptionOrOverconstrainedError&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8DOMExceptionOrOverconstrainedError final {
 public:
  MODULES_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, DOMExceptionOrOverconstrainedError&, UnionTypeConversionMode, ExceptionState&);
};

MODULES_EXPORT v8::Local<v8::Value> ToV8(const DOMExceptionOrOverconstrainedError&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, DOMExceptionOrOverconstrainedError& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, DOMExceptionOrOverconstrainedError& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<DOMExceptionOrOverconstrainedError> : public NativeValueTraitsBase<DOMExceptionOrOverconstrainedError> {
  MODULES_EXPORT static DOMExceptionOrOverconstrainedError NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  MODULES_EXPORT static DOMExceptionOrOverconstrainedError NullValue() { return DOMExceptionOrOverconstrainedError(); }
};

template <>
struct V8TypeOf<DOMExceptionOrOverconstrainedError> {
  typedef V8DOMExceptionOrOverconstrainedError Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::DOMExceptionOrOverconstrainedError);

#endif  // DOMExceptionOrOverconstrainedError_h
