// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "password_credential_data_or_html_form_element.h"

#include "bindings/core/v8/ToV8ForCore.h"
#include "bindings/core/v8/V8HTMLFormElement.h"

namespace blink {

PasswordCredentialDataOrHTMLFormElement::PasswordCredentialDataOrHTMLFormElement() : type_(SpecificType::kNone) {}

HTMLFormElement* PasswordCredentialDataOrHTMLFormElement::GetAsHTMLFormElement() const {
  DCHECK(IsHTMLFormElement());
  return html_form_element_;
}

void PasswordCredentialDataOrHTMLFormElement::SetHTMLFormElement(HTMLFormElement* value) {
  DCHECK(IsNull());
  html_form_element_ = value;
  type_ = SpecificType::kHTMLFormElement;
}

PasswordCredentialDataOrHTMLFormElement PasswordCredentialDataOrHTMLFormElement::FromHTMLFormElement(HTMLFormElement* value) {
  PasswordCredentialDataOrHTMLFormElement container;
  container.SetHTMLFormElement(value);
  return container;
}

const PasswordCredentialData& PasswordCredentialDataOrHTMLFormElement::GetAsPasswordCredentialData() const {
  DCHECK(IsPasswordCredentialData());
  return password_credential_data_;
}

void PasswordCredentialDataOrHTMLFormElement::SetPasswordCredentialData(const PasswordCredentialData& value) {
  DCHECK(IsNull());
  password_credential_data_ = value;
  type_ = SpecificType::kPasswordCredentialData;
}

PasswordCredentialDataOrHTMLFormElement PasswordCredentialDataOrHTMLFormElement::FromPasswordCredentialData(const PasswordCredentialData& value) {
  PasswordCredentialDataOrHTMLFormElement container;
  container.SetPasswordCredentialData(value);
  return container;
}

PasswordCredentialDataOrHTMLFormElement::PasswordCredentialDataOrHTMLFormElement(const PasswordCredentialDataOrHTMLFormElement&) = default;
PasswordCredentialDataOrHTMLFormElement::~PasswordCredentialDataOrHTMLFormElement() = default;
PasswordCredentialDataOrHTMLFormElement& PasswordCredentialDataOrHTMLFormElement::operator=(const PasswordCredentialDataOrHTMLFormElement&) = default;

void PasswordCredentialDataOrHTMLFormElement::Trace(blink::Visitor* visitor) {
  visitor->Trace(html_form_element_);
  visitor->Trace(password_credential_data_);
}

void V8PasswordCredentialDataOrHTMLFormElement::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PasswordCredentialDataOrHTMLFormElement& impl, UnionTypeConversionMode conversionMode, ExceptionState& exceptionState) {
  if (v8Value.IsEmpty())
    return;

  if (conversionMode == UnionTypeConversionMode::kNullable && IsUndefinedOrNull(v8Value))
    return;

  if (IsUndefinedOrNull(v8Value)) {
    PasswordCredentialData cppValue;
    V8PasswordCredentialData::ToImpl(isolate, v8Value, cppValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.SetPasswordCredentialData(cppValue);
    return;
  }

  if (V8HTMLFormElement::hasInstance(v8Value, isolate)) {
    HTMLFormElement* cppValue = V8HTMLFormElement::ToImpl(v8::Local<v8::Object>::Cast(v8Value));
    impl.SetHTMLFormElement(cppValue);
    return;
  }

  if (v8Value->IsObject()) {
    PasswordCredentialData cppValue;
    V8PasswordCredentialData::ToImpl(isolate, v8Value, cppValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.SetPasswordCredentialData(cppValue);
    return;
  }

  exceptionState.ThrowTypeError("The provided value is not of type '(PasswordCredentialData or HTMLFormElement)'");
}

v8::Local<v8::Value> ToV8(const PasswordCredentialDataOrHTMLFormElement& impl, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  switch (impl.type_) {
    case PasswordCredentialDataOrHTMLFormElement::SpecificType::kNone:
      return v8::Null(isolate);
    case PasswordCredentialDataOrHTMLFormElement::SpecificType::kHTMLFormElement:
      return ToV8(impl.GetAsHTMLFormElement(), creationContext, isolate);
    case PasswordCredentialDataOrHTMLFormElement::SpecificType::kPasswordCredentialData:
      return ToV8(impl.GetAsPasswordCredentialData(), creationContext, isolate);
    default:
      NOTREACHED();
  }
  return v8::Local<v8::Value>();
}

PasswordCredentialDataOrHTMLFormElement NativeValueTraits<PasswordCredentialDataOrHTMLFormElement>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  PasswordCredentialDataOrHTMLFormElement impl;
  V8PasswordCredentialDataOrHTMLFormElement::ToImpl(isolate, value, impl, UnionTypeConversionMode::kNotNullable, exceptionState);
  return impl;
}

}  // namespace blink
