// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef PasswordCredentialDataOrHTMLFormElement_h
#define PasswordCredentialDataOrHTMLFormElement_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "bindings/modules/v8/V8PasswordCredentialData.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class HTMLFormElement;

class MODULES_EXPORT PasswordCredentialDataOrHTMLFormElement final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  PasswordCredentialDataOrHTMLFormElement();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsHTMLFormElement() const { return type_ == SpecificType::kHTMLFormElement; }
  HTMLFormElement* GetAsHTMLFormElement() const;
  void SetHTMLFormElement(HTMLFormElement*);
  static PasswordCredentialDataOrHTMLFormElement FromHTMLFormElement(HTMLFormElement*);

  bool IsPasswordCredentialData() const { return type_ == SpecificType::kPasswordCredentialData; }
  const PasswordCredentialData& GetAsPasswordCredentialData() const;
  void SetPasswordCredentialData(const PasswordCredentialData&);
  static PasswordCredentialDataOrHTMLFormElement FromPasswordCredentialData(const PasswordCredentialData&);

  PasswordCredentialDataOrHTMLFormElement(const PasswordCredentialDataOrHTMLFormElement&);
  ~PasswordCredentialDataOrHTMLFormElement();
  PasswordCredentialDataOrHTMLFormElement& operator=(const PasswordCredentialDataOrHTMLFormElement&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kHTMLFormElement,
    kPasswordCredentialData,
  };
  SpecificType type_;

  Member<HTMLFormElement> html_form_element_;
  PasswordCredentialData password_credential_data_;

  friend MODULES_EXPORT v8::Local<v8::Value> ToV8(const PasswordCredentialDataOrHTMLFormElement&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8PasswordCredentialDataOrHTMLFormElement final {
 public:
  MODULES_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, PasswordCredentialDataOrHTMLFormElement&, UnionTypeConversionMode, ExceptionState&);
};

MODULES_EXPORT v8::Local<v8::Value> ToV8(const PasswordCredentialDataOrHTMLFormElement&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, PasswordCredentialDataOrHTMLFormElement& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, PasswordCredentialDataOrHTMLFormElement& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<PasswordCredentialDataOrHTMLFormElement> : public NativeValueTraitsBase<PasswordCredentialDataOrHTMLFormElement> {
  MODULES_EXPORT static PasswordCredentialDataOrHTMLFormElement NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  MODULES_EXPORT static PasswordCredentialDataOrHTMLFormElement NullValue() { return PasswordCredentialDataOrHTMLFormElement(); }
};

template <>
struct V8TypeOf<PasswordCredentialDataOrHTMLFormElement> {
  typedef V8PasswordCredentialDataOrHTMLFormElement Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::PasswordCredentialDataOrHTMLFormElement);

#endif  // PasswordCredentialDataOrHTMLFormElement_h
