// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef StringOrArrayBufferOrNFCMessage_h
#define StringOrArrayBufferOrNFCMessage_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "bindings/modules/v8/V8NFCMessage.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class DOMArrayBuffer;

class MODULES_EXPORT StringOrArrayBufferOrNFCMessage final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  StringOrArrayBufferOrNFCMessage();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsArrayBuffer() const { return type_ == SpecificType::kArrayBuffer; }
  DOMArrayBuffer* GetAsArrayBuffer() const;
  void SetArrayBuffer(DOMArrayBuffer*);
  static StringOrArrayBufferOrNFCMessage FromArrayBuffer(DOMArrayBuffer*);

  bool IsNFCMessage() const { return type_ == SpecificType::kNFCMessage; }
  const NFCMessage& GetAsNFCMessage() const;
  void SetNFCMessage(const NFCMessage&);
  static StringOrArrayBufferOrNFCMessage FromNFCMessage(const NFCMessage&);

  bool IsString() const { return type_ == SpecificType::kString; }
  const String& GetAsString() const;
  void SetString(const String&);
  static StringOrArrayBufferOrNFCMessage FromString(const String&);

  StringOrArrayBufferOrNFCMessage(const StringOrArrayBufferOrNFCMessage&);
  ~StringOrArrayBufferOrNFCMessage();
  StringOrArrayBufferOrNFCMessage& operator=(const StringOrArrayBufferOrNFCMessage&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kArrayBuffer,
    kNFCMessage,
    kString,
  };
  SpecificType type_;

  Member<DOMArrayBuffer> array_buffer_;
  NFCMessage nfc_message_;
  String string_;

  friend MODULES_EXPORT v8::Local<v8::Value> ToV8(const StringOrArrayBufferOrNFCMessage&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8StringOrArrayBufferOrNFCMessage final {
 public:
  MODULES_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, StringOrArrayBufferOrNFCMessage&, UnionTypeConversionMode, ExceptionState&);
};

MODULES_EXPORT v8::Local<v8::Value> ToV8(const StringOrArrayBufferOrNFCMessage&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrArrayBufferOrNFCMessage& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrArrayBufferOrNFCMessage& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<StringOrArrayBufferOrNFCMessage> : public NativeValueTraitsBase<StringOrArrayBufferOrNFCMessage> {
  MODULES_EXPORT static StringOrArrayBufferOrNFCMessage NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  MODULES_EXPORT static StringOrArrayBufferOrNFCMessage NullValue() { return StringOrArrayBufferOrNFCMessage(); }
};

template <>
struct V8TypeOf<StringOrArrayBufferOrNFCMessage> {
  typedef V8StringOrArrayBufferOrNFCMessage Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::StringOrArrayBufferOrNFCMessage);

#endif  // StringOrArrayBufferOrNFCMessage_h
