// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/union_container.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef StringOrCanvasGradientOrCanvasPattern_h
#define StringOrCanvasGradientOrCanvasPattern_h

#include "bindings/core/v8/Dictionary.h"
#include "bindings/core/v8/ExceptionState.h"
#include "bindings/core/v8/NativeValueTraits.h"
#include "bindings/core/v8/Nullable.h"
#include "bindings/core/v8/V8BindingForCore.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class CanvasGradient;
class CanvasPattern;

class MODULES_EXPORT StringOrCanvasGradientOrCanvasPattern final {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  StringOrCanvasGradientOrCanvasPattern();
  bool IsNull() const { return type_ == SpecificType::kNone; }

  bool IsCanvasGradient() const { return type_ == SpecificType::kCanvasGradient; }
  CanvasGradient* GetAsCanvasGradient() const;
  void SetCanvasGradient(CanvasGradient*);
  static StringOrCanvasGradientOrCanvasPattern FromCanvasGradient(CanvasGradient*);

  bool IsCanvasPattern() const { return type_ == SpecificType::kCanvasPattern; }
  CanvasPattern* GetAsCanvasPattern() const;
  void SetCanvasPattern(CanvasPattern*);
  static StringOrCanvasGradientOrCanvasPattern FromCanvasPattern(CanvasPattern*);

  bool IsString() const { return type_ == SpecificType::kString; }
  const String& GetAsString() const;
  void SetString(const String&);
  static StringOrCanvasGradientOrCanvasPattern FromString(const String&);

  StringOrCanvasGradientOrCanvasPattern(const StringOrCanvasGradientOrCanvasPattern&);
  ~StringOrCanvasGradientOrCanvasPattern();
  StringOrCanvasGradientOrCanvasPattern& operator=(const StringOrCanvasGradientOrCanvasPattern&);
  void Trace(blink::Visitor*);

 private:
  enum class SpecificType {
    kNone,
    kCanvasGradient,
    kCanvasPattern,
    kString,
  };
  SpecificType type_;

  Member<CanvasGradient> canvas_gradient_;
  Member<CanvasPattern> canvas_pattern_;
  String string_;

  friend MODULES_EXPORT v8::Local<v8::Value> ToV8(const StringOrCanvasGradientOrCanvasPattern&, v8::Local<v8::Object>, v8::Isolate*);
};

class V8StringOrCanvasGradientOrCanvasPattern final {
 public:
  MODULES_EXPORT static void ToImpl(v8::Isolate*, v8::Local<v8::Value>, StringOrCanvasGradientOrCanvasPattern&, UnionTypeConversionMode, ExceptionState&);
};

MODULES_EXPORT v8::Local<v8::Value> ToV8(const StringOrCanvasGradientOrCanvasPattern&, v8::Local<v8::Object>, v8::Isolate*);

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrCanvasGradientOrCanvasPattern& impl) {
  V8SetReturnValue(callbackInfo, ToV8(impl, callbackInfo.Holder(), callbackInfo.GetIsolate()));
}

template <class CallbackInfo>
inline void V8SetReturnValue(const CallbackInfo& callbackInfo, StringOrCanvasGradientOrCanvasPattern& impl, v8::Local<v8::Object> creationContext) {
  V8SetReturnValue(callbackInfo, ToV8(impl, creationContext, callbackInfo.GetIsolate()));
}

template <>
struct NativeValueTraits<StringOrCanvasGradientOrCanvasPattern> : public NativeValueTraitsBase<StringOrCanvasGradientOrCanvasPattern> {
  MODULES_EXPORT static StringOrCanvasGradientOrCanvasPattern NativeValue(v8::Isolate*, v8::Local<v8::Value>, ExceptionState&);
  MODULES_EXPORT static StringOrCanvasGradientOrCanvasPattern NullValue() { return StringOrCanvasGradientOrCanvasPattern(); }
};

template <>
struct V8TypeOf<StringOrCanvasGradientOrCanvasPattern> {
  typedef V8StringOrCanvasGradientOrCanvasPattern Type;
};

}  // namespace blink

// We need to set canInitializeWithMemset=true because HeapVector supports
// items that can initialize with memset or have a vtable. It is safe to
// set canInitializeWithMemset=true for a union type object in practice.
// See https://codereview.chromium.org/1118993002/#msg5 for more details.
WTF_ALLOW_MOVE_AND_INIT_WITH_MEM_FUNCTIONS(blink::StringOrCanvasGradientOrCanvasPattern);

#endif  // StringOrCanvasGradientOrCanvasPattern_h
