// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef AnimationEffectTimingProperties_h
#define AnimationEffectTimingProperties_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "bindings/core/v8/unrestricted_double_or_string.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class CORE_EXPORT AnimationEffectTimingProperties : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  AnimationEffectTimingProperties();
  virtual ~AnimationEffectTimingProperties();
  AnimationEffectTimingProperties(const AnimationEffectTimingProperties&);
  AnimationEffectTimingProperties& operator=(const AnimationEffectTimingProperties&);

  bool hasDelay() const { return has_delay_; }
  double delay() const {
    DCHECK(has_delay_);
    return delay_;
  }
  inline void setDelay(double);

  bool hasDirection() const { return !direction_.IsNull(); }
  const String& direction() const {
    return direction_;
  }
  inline void setDirection(const String&);

  bool hasDuration() const { return !duration_.IsNull(); }
  const UnrestrictedDoubleOrString& duration() const {
    return duration_;
  }
  void setDuration(const UnrestrictedDoubleOrString&);

  bool hasEasing() const { return !easing_.IsNull(); }
  const String& easing() const {
    return easing_;
  }
  inline void setEasing(const String&);

  bool hasEndDelay() const { return has_end_delay_; }
  double endDelay() const {
    DCHECK(has_end_delay_);
    return end_delay_;
  }
  inline void setEndDelay(double);

  bool hasFill() const { return !fill_.IsNull(); }
  const String& fill() const {
    return fill_;
  }
  inline void setFill(const String&);

  bool hasIterationStart() const { return has_iteration_start_; }
  double iterationStart() const {
    DCHECK(has_iteration_start_);
    return iteration_start_;
  }
  inline void setIterationStart(double);

  bool hasIterations() const { return has_iterations_; }
  double iterations() const {
    DCHECK(has_iterations_);
    return iterations_;
  }
  inline void setIterations(double);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_delay_ = false;
  bool has_end_delay_ = false;
  bool has_iteration_start_ = false;
  bool has_iterations_ = false;

  double delay_;
  String direction_;
  UnrestrictedDoubleOrString duration_;
  String easing_;
  double end_delay_;
  String fill_;
  double iteration_start_;
  double iterations_;

  friend class V8AnimationEffectTimingProperties;
};

void AnimationEffectTimingProperties::setDelay(double value) {
  delay_ = value;
  has_delay_ = true;
}

void AnimationEffectTimingProperties::setDirection(const String& value) {
  direction_ = value;
}

void AnimationEffectTimingProperties::setEasing(const String& value) {
  easing_ = value;
}

void AnimationEffectTimingProperties::setEndDelay(double value) {
  end_delay_ = value;
  has_end_delay_ = true;
}

void AnimationEffectTimingProperties::setFill(const String& value) {
  fill_ = value;
}

void AnimationEffectTimingProperties::setIterationStart(double value) {
  iteration_start_ = value;
  has_iteration_start_ = true;
}

void AnimationEffectTimingProperties::setIterations(double value) {
  iterations_ = value;
  has_iterations_ = true;
}

}  // namespace blink

#endif  // AnimationEffectTimingProperties_h
