// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef BaseKeyframe_h
#define BaseKeyframe_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class CORE_EXPORT BaseKeyframe : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  BaseKeyframe();
  virtual ~BaseKeyframe();
  BaseKeyframe(const BaseKeyframe&);
  BaseKeyframe& operator=(const BaseKeyframe&);

  bool hasComposite() const { return !composite_.IsNull(); }
  const String& composite() const {
    return composite_;
  }
  inline void setComposite(const String&);

  bool hasEasing() const { return !easing_.IsNull(); }
  const String& easing() const {
    return easing_;
  }
  inline void setEasing(const String&);

  bool hasOffset() const { return has_offset_; }
  double offset() const {
    DCHECK(has_offset_);
    return offset_;
  }
  inline void setOffset(double);
  inline void setOffsetToNull();

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_offset_ = false;

  String composite_;
  String easing_;
  double offset_;

  friend class V8BaseKeyframe;
};

void BaseKeyframe::setComposite(const String& value) {
  composite_ = value;
}

void BaseKeyframe::setEasing(const String& value) {
  easing_ = value;
}

void BaseKeyframe::setOffset(double value) {
  offset_ = value;
  has_offset_ = true;
}
void BaseKeyframe::setOffsetToNull() {
  has_offset_ = false;
}

}  // namespace blink

#endif  // BaseKeyframe_h
