// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef FontFaceDescriptors_h
#define FontFaceDescriptors_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class CORE_EXPORT FontFaceDescriptors : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  FontFaceDescriptors();
  virtual ~FontFaceDescriptors();
  FontFaceDescriptors(const FontFaceDescriptors&);
  FontFaceDescriptors& operator=(const FontFaceDescriptors&);

  bool hasDisplay() const { return !display_.IsNull(); }
  const String& display() const {
    return display_;
  }
  inline void setDisplay(const String&);

  bool hasFeatureSettings() const { return !feature_settings_.IsNull(); }
  const String& featureSettings() const {
    return feature_settings_;
  }
  inline void setFeatureSettings(const String&);

  bool hasStretch() const { return !stretch_.IsNull(); }
  const String& stretch() const {
    return stretch_;
  }
  inline void setStretch(const String&);

  bool hasStyle() const { return !style_.IsNull(); }
  const String& style() const {
    return style_;
  }
  inline void setStyle(const String&);

  bool hasUnicodeRange() const { return !unicode_range_.IsNull(); }
  const String& unicodeRange() const {
    return unicode_range_;
  }
  inline void setUnicodeRange(const String&);

  bool hasVariant() const { return !variant_.IsNull(); }
  const String& variant() const {
    return variant_;
  }
  inline void setVariant(const String&);

  bool hasWeight() const { return !weight_.IsNull(); }
  const String& weight() const {
    return weight_;
  }
  inline void setWeight(const String&);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:

  String display_;
  String feature_settings_;
  String stretch_;
  String style_;
  String unicode_range_;
  String variant_;
  String weight_;

  friend class V8FontFaceDescriptors;
};

void FontFaceDescriptors::setDisplay(const String& value) {
  display_ = value;
}

void FontFaceDescriptors::setFeatureSettings(const String& value) {
  feature_settings_ = value;
}

void FontFaceDescriptors::setStretch(const String& value) {
  stretch_ = value;
}

void FontFaceDescriptors::setStyle(const String& value) {
  style_ = value;
}

void FontFaceDescriptors::setUnicodeRange(const String& value) {
  unicode_range_ = value;
}

void FontFaceDescriptors::setVariant(const String& value) {
  variant_ = value;
}

void FontFaceDescriptors::setWeight(const String& value) {
  weight_ = value;
}

}  // namespace blink

#endif  // FontFaceDescriptors_h
