// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSProperty.cpp.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5

// clang-format off

#include "core/css/properties/CSSProperty.h"

namespace blink {

const CSSProperty& GetCSSPropertyVariable() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyVariableInternal());
}
const CSSProperty& GetCSSPropertyAnimationDelay() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAnimationDelayInternal());
}
const CSSProperty& GetCSSPropertyAnimationDirection() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAnimationDirectionInternal());
}
const CSSProperty& GetCSSPropertyAnimationDuration() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAnimationDurationInternal());
}
const CSSProperty& GetCSSPropertyAnimationFillMode() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAnimationFillModeInternal());
}
const CSSProperty& GetCSSPropertyAnimationIterationCount() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAnimationIterationCountInternal());
}
const CSSProperty& GetCSSPropertyAnimationName() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAnimationNameInternal());
}
const CSSProperty& GetCSSPropertyAnimationPlayState() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAnimationPlayStateInternal());
}
const CSSProperty& GetCSSPropertyAnimationTimingFunction() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAnimationTimingFunctionInternal());
}
const CSSProperty& GetCSSPropertyTransitionDelay() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTransitionDelayInternal());
}
const CSSProperty& GetCSSPropertyTransitionDuration() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTransitionDurationInternal());
}
const CSSProperty& GetCSSPropertyTransitionProperty() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTransitionPropertyInternal());
}
const CSSProperty& GetCSSPropertyTransitionTimingFunction() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTransitionTimingFunctionInternal());
}
const CSSProperty& GetCSSPropertyColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColorInternal());
}
const CSSProperty& GetCSSPropertyDirection() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyDirectionInternal());
}
const CSSProperty& GetCSSPropertyFontFamily() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontFamilyInternal());
}
const CSSProperty& GetCSSPropertyFontFeatureSettings() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontFeatureSettingsInternal());
}
const CSSProperty& GetCSSPropertyFontKerning() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontKerningInternal());
}
const CSSProperty& GetCSSPropertyFontSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontSizeInternal());
}
const CSSProperty& GetCSSPropertyFontSizeAdjust() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontSizeAdjustInternal());
}
const CSSProperty& GetCSSPropertyFontStretch() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontStretchInternal());
}
const CSSProperty& GetCSSPropertyFontStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontStyleInternal());
}
const CSSProperty& GetCSSPropertyFontVariantCaps() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontVariantCapsInternal());
}
const CSSProperty& GetCSSPropertyFontVariantEastAsian() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontVariantEastAsianInternal());
}
const CSSProperty& GetCSSPropertyFontVariantLigatures() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontVariantLigaturesInternal());
}
const CSSProperty& GetCSSPropertyFontVariantNumeric() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontVariantNumericInternal());
}
const CSSProperty& GetCSSPropertyFontVariationSettings() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontVariationSettingsInternal());
}
const CSSProperty& GetCSSPropertyFontWeight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontWeightInternal());
}
const CSSProperty& GetCSSPropertyTextOrientation() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextOrientationInternal());
}
const CSSProperty& GetCSSPropertyTextRendering() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextRenderingInternal());
}
const CSSProperty& GetCSSPropertyWebkitFontSmoothing() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitFontSmoothingInternal());
}
const CSSProperty& GetCSSPropertyWebkitLocale() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitLocaleInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextOrientation() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextOrientationInternal());
}
const CSSProperty& GetCSSPropertyWebkitWritingMode() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitWritingModeInternal());
}
const CSSProperty& GetCSSPropertyWritingMode() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWritingModeInternal());
}
const CSSProperty& GetCSSPropertyZoom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyZoomInternal());
}
const CSSProperty& GetCSSPropertyAlignContent() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAlignContentInternal());
}
const CSSProperty& GetCSSPropertyAlignItems() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAlignItemsInternal());
}
const CSSProperty& GetCSSPropertyAlignSelf() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAlignSelfInternal());
}
const CSSProperty& GetCSSPropertyAlignmentBaseline() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAlignmentBaselineInternal());
}
const CSSProperty& GetCSSPropertyAll() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAllInternal());
}
const CSSProperty& GetCSSPropertyBackdropFilter() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackdropFilterInternal());
}
const CSSProperty& GetCSSPropertyBackfaceVisibility() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackfaceVisibilityInternal());
}
const CSSProperty& GetCSSPropertyBackgroundAttachment() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundAttachmentInternal());
}
const CSSProperty& GetCSSPropertyBackgroundBlendMode() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundBlendModeInternal());
}
const CSSProperty& GetCSSPropertyBackgroundClip() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundClipInternal());
}
const CSSProperty& GetCSSPropertyBackgroundColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundColorInternal());
}
const CSSProperty& GetCSSPropertyBackgroundImage() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundImageInternal());
}
const CSSProperty& GetCSSPropertyBackgroundOrigin() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundOriginInternal());
}
const CSSProperty& GetCSSPropertyBackgroundPositionX() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundPositionXInternal());
}
const CSSProperty& GetCSSPropertyBackgroundPositionY() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundPositionYInternal());
}
const CSSProperty& GetCSSPropertyBackgroundRepeatX() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundRepeatXInternal());
}
const CSSProperty& GetCSSPropertyBackgroundRepeatY() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundRepeatYInternal());
}
const CSSProperty& GetCSSPropertyBackgroundSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundSizeInternal());
}
const CSSProperty& GetCSSPropertyBaselineShift() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBaselineShiftInternal());
}
const CSSProperty& GetCSSPropertyBlockSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBlockSizeInternal());
}
const CSSProperty& GetCSSPropertyBorderBottomColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderBottomColorInternal());
}
const CSSProperty& GetCSSPropertyBorderBottomLeftRadius() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderBottomLeftRadiusInternal());
}
const CSSProperty& GetCSSPropertyBorderBottomRightRadius() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderBottomRightRadiusInternal());
}
const CSSProperty& GetCSSPropertyBorderBottomStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderBottomStyleInternal());
}
const CSSProperty& GetCSSPropertyBorderBottomWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderBottomWidthInternal());
}
const CSSProperty& GetCSSPropertyBorderCollapse() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderCollapseInternal());
}
const CSSProperty& GetCSSPropertyBorderImageOutset() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderImageOutsetInternal());
}
const CSSProperty& GetCSSPropertyBorderImageRepeat() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderImageRepeatInternal());
}
const CSSProperty& GetCSSPropertyBorderImageSlice() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderImageSliceInternal());
}
const CSSProperty& GetCSSPropertyBorderImageSource() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderImageSourceInternal());
}
const CSSProperty& GetCSSPropertyBorderImageWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderImageWidthInternal());
}
const CSSProperty& GetCSSPropertyBorderLeftColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderLeftColorInternal());
}
const CSSProperty& GetCSSPropertyBorderLeftStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderLeftStyleInternal());
}
const CSSProperty& GetCSSPropertyBorderLeftWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderLeftWidthInternal());
}
const CSSProperty& GetCSSPropertyBorderRightColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderRightColorInternal());
}
const CSSProperty& GetCSSPropertyBorderRightStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderRightStyleInternal());
}
const CSSProperty& GetCSSPropertyBorderRightWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderRightWidthInternal());
}
const CSSProperty& GetCSSPropertyBorderTopColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderTopColorInternal());
}
const CSSProperty& GetCSSPropertyBorderTopLeftRadius() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderTopLeftRadiusInternal());
}
const CSSProperty& GetCSSPropertyBorderTopRightRadius() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderTopRightRadiusInternal());
}
const CSSProperty& GetCSSPropertyBorderTopStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderTopStyleInternal());
}
const CSSProperty& GetCSSPropertyBorderTopWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderTopWidthInternal());
}
const CSSProperty& GetCSSPropertyBottom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBottomInternal());
}
const CSSProperty& GetCSSPropertyBoxShadow() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBoxShadowInternal());
}
const CSSProperty& GetCSSPropertyBoxSizing() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBoxSizingInternal());
}
const CSSProperty& GetCSSPropertyBreakAfter() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBreakAfterInternal());
}
const CSSProperty& GetCSSPropertyBreakBefore() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBreakBeforeInternal());
}
const CSSProperty& GetCSSPropertyBreakInside() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBreakInsideInternal());
}
const CSSProperty& GetCSSPropertyBufferedRendering() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBufferedRenderingInternal());
}
const CSSProperty& GetCSSPropertyCaptionSide() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyCaptionSideInternal());
}
const CSSProperty& GetCSSPropertyCaretColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyCaretColorInternal());
}
const CSSProperty& GetCSSPropertyClear() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyClearInternal());
}
const CSSProperty& GetCSSPropertyClip() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyClipInternal());
}
const CSSProperty& GetCSSPropertyClipPath() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyClipPathInternal());
}
const CSSProperty& GetCSSPropertyClipRule() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyClipRuleInternal());
}
const CSSProperty& GetCSSPropertyColorInterpolation() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColorInterpolationInternal());
}
const CSSProperty& GetCSSPropertyColorInterpolationFilters() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColorInterpolationFiltersInternal());
}
const CSSProperty& GetCSSPropertyColorRendering() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColorRenderingInternal());
}
const CSSProperty& GetCSSPropertyColumnCount() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnCountInternal());
}
const CSSProperty& GetCSSPropertyColumnFill() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnFillInternal());
}
const CSSProperty& GetCSSPropertyColumnGap() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnGapInternal());
}
const CSSProperty& GetCSSPropertyColumnRuleColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnRuleColorInternal());
}
const CSSProperty& GetCSSPropertyColumnRuleStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnRuleStyleInternal());
}
const CSSProperty& GetCSSPropertyColumnRuleWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnRuleWidthInternal());
}
const CSSProperty& GetCSSPropertyColumnSpan() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnSpanInternal());
}
const CSSProperty& GetCSSPropertyColumnWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnWidthInternal());
}
const CSSProperty& GetCSSPropertyContain() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyContainInternal());
}
const CSSProperty& GetCSSPropertyContent() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyContentInternal());
}
const CSSProperty& GetCSSPropertyCounterIncrement() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyCounterIncrementInternal());
}
const CSSProperty& GetCSSPropertyCounterReset() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyCounterResetInternal());
}
const CSSProperty& GetCSSPropertyCursor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyCursorInternal());
}
const CSSProperty& GetCSSPropertyCx() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyCxInternal());
}
const CSSProperty& GetCSSPropertyCy() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyCyInternal());
}
const CSSProperty& GetCSSPropertyD() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyDInternal());
}
const CSSProperty& GetCSSPropertyDisplay() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyDisplayInternal());
}
const CSSProperty& GetCSSPropertyDominantBaseline() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyDominantBaselineInternal());
}
const CSSProperty& GetCSSPropertyEmptyCells() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyEmptyCellsInternal());
}
const CSSProperty& GetCSSPropertyFill() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFillInternal());
}
const CSSProperty& GetCSSPropertyFillOpacity() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFillOpacityInternal());
}
const CSSProperty& GetCSSPropertyFillRule() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFillRuleInternal());
}
const CSSProperty& GetCSSPropertyFilter() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFilterInternal());
}
const CSSProperty& GetCSSPropertyFlexBasis() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFlexBasisInternal());
}
const CSSProperty& GetCSSPropertyFlexDirection() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFlexDirectionInternal());
}
const CSSProperty& GetCSSPropertyFlexGrow() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFlexGrowInternal());
}
const CSSProperty& GetCSSPropertyFlexShrink() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFlexShrinkInternal());
}
const CSSProperty& GetCSSPropertyFlexWrap() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFlexWrapInternal());
}
const CSSProperty& GetCSSPropertyFloat() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFloatInternal());
}
const CSSProperty& GetCSSPropertyFloodColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFloodColorInternal());
}
const CSSProperty& GetCSSPropertyFloodOpacity() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFloodOpacityInternal());
}
const CSSProperty& GetCSSPropertyFontDisplay() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontDisplayInternal());
}
const CSSProperty& GetCSSPropertyGridAutoColumns() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridAutoColumnsInternal());
}
const CSSProperty& GetCSSPropertyGridAutoFlow() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridAutoFlowInternal());
}
const CSSProperty& GetCSSPropertyGridAutoRows() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridAutoRowsInternal());
}
const CSSProperty& GetCSSPropertyGridColumnEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridColumnEndInternal());
}
const CSSProperty& GetCSSPropertyGridColumnGap() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridColumnGapInternal());
}
const CSSProperty& GetCSSPropertyGridColumnStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridColumnStartInternal());
}
const CSSProperty& GetCSSPropertyGridRowEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridRowEndInternal());
}
const CSSProperty& GetCSSPropertyGridRowGap() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridRowGapInternal());
}
const CSSProperty& GetCSSPropertyGridRowStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridRowStartInternal());
}
const CSSProperty& GetCSSPropertyGridTemplateAreas() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridTemplateAreasInternal());
}
const CSSProperty& GetCSSPropertyGridTemplateColumns() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridTemplateColumnsInternal());
}
const CSSProperty& GetCSSPropertyGridTemplateRows() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridTemplateRowsInternal());
}
const CSSProperty& GetCSSPropertyHeight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyHeightInternal());
}
const CSSProperty& GetCSSPropertyHyphens() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyHyphensInternal());
}
const CSSProperty& GetCSSPropertyImageOrientation() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyImageOrientationInternal());
}
const CSSProperty& GetCSSPropertyImageRendering() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyImageRenderingInternal());
}
const CSSProperty& GetCSSPropertyInlineSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyInlineSizeInternal());
}
const CSSProperty& GetCSSPropertyIsolation() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyIsolationInternal());
}
const CSSProperty& GetCSSPropertyJustifyContent() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyJustifyContentInternal());
}
const CSSProperty& GetCSSPropertyJustifyItems() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyJustifyItemsInternal());
}
const CSSProperty& GetCSSPropertyJustifySelf() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyJustifySelfInternal());
}
const CSSProperty& GetCSSPropertyLeft() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyLeftInternal());
}
const CSSProperty& GetCSSPropertyLetterSpacing() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyLetterSpacingInternal());
}
const CSSProperty& GetCSSPropertyLightingColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyLightingColorInternal());
}
const CSSProperty& GetCSSPropertyLineBreak() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyLineBreakInternal());
}
const CSSProperty& GetCSSPropertyLineHeight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyLineHeightInternal());
}
const CSSProperty& GetCSSPropertyLineHeightStep() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyLineHeightStepInternal());
}
const CSSProperty& GetCSSPropertyListStyleImage() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyListStyleImageInternal());
}
const CSSProperty& GetCSSPropertyListStylePosition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyListStylePositionInternal());
}
const CSSProperty& GetCSSPropertyListStyleType() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyListStyleTypeInternal());
}
const CSSProperty& GetCSSPropertyMarginBottom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMarginBottomInternal());
}
const CSSProperty& GetCSSPropertyMarginLeft() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMarginLeftInternal());
}
const CSSProperty& GetCSSPropertyMarginRight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMarginRightInternal());
}
const CSSProperty& GetCSSPropertyMarginTop() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMarginTopInternal());
}
const CSSProperty& GetCSSPropertyMarkerEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMarkerEndInternal());
}
const CSSProperty& GetCSSPropertyMarkerMid() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMarkerMidInternal());
}
const CSSProperty& GetCSSPropertyMarkerStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMarkerStartInternal());
}
const CSSProperty& GetCSSPropertyMask() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMaskInternal());
}
const CSSProperty& GetCSSPropertyMaskSourceType() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMaskSourceTypeInternal());
}
const CSSProperty& GetCSSPropertyMaskType() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMaskTypeInternal());
}
const CSSProperty& GetCSSPropertyMaxBlockSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMaxBlockSizeInternal());
}
const CSSProperty& GetCSSPropertyMaxHeight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMaxHeightInternal());
}
const CSSProperty& GetCSSPropertyMaxInlineSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMaxInlineSizeInternal());
}
const CSSProperty& GetCSSPropertyMaxWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMaxWidthInternal());
}
const CSSProperty& GetCSSPropertyMaxZoom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMaxZoomInternal());
}
const CSSProperty& GetCSSPropertyMinBlockSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMinBlockSizeInternal());
}
const CSSProperty& GetCSSPropertyMinHeight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMinHeightInternal());
}
const CSSProperty& GetCSSPropertyMinInlineSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMinInlineSizeInternal());
}
const CSSProperty& GetCSSPropertyMinWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMinWidthInternal());
}
const CSSProperty& GetCSSPropertyMinZoom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMinZoomInternal());
}
const CSSProperty& GetCSSPropertyMixBlendMode() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMixBlendModeInternal());
}
const CSSProperty& GetCSSPropertyObjectFit() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyObjectFitInternal());
}
const CSSProperty& GetCSSPropertyObjectPosition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyObjectPositionInternal());
}
const CSSProperty& GetCSSPropertyOffsetAnchor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOffsetAnchorInternal());
}
const CSSProperty& GetCSSPropertyOffsetDistance() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOffsetDistanceInternal());
}
const CSSProperty& GetCSSPropertyOffsetPath() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOffsetPathInternal());
}
const CSSProperty& GetCSSPropertyOffsetPosition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOffsetPositionInternal());
}
const CSSProperty& GetCSSPropertyOffsetRotate() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOffsetRotateInternal());
}
const CSSProperty& GetCSSPropertyOpacity() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOpacityInternal());
}
const CSSProperty& GetCSSPropertyOrder() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOrderInternal());
}
const CSSProperty& GetCSSPropertyOrientation() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOrientationInternal());
}
const CSSProperty& GetCSSPropertyOrphans() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOrphansInternal());
}
const CSSProperty& GetCSSPropertyOutlineColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOutlineColorInternal());
}
const CSSProperty& GetCSSPropertyOutlineOffset() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOutlineOffsetInternal());
}
const CSSProperty& GetCSSPropertyOutlineStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOutlineStyleInternal());
}
const CSSProperty& GetCSSPropertyOutlineWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOutlineWidthInternal());
}
const CSSProperty& GetCSSPropertyOverflowAnchor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOverflowAnchorInternal());
}
const CSSProperty& GetCSSPropertyOverflowWrap() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOverflowWrapInternal());
}
const CSSProperty& GetCSSPropertyOverflowX() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOverflowXInternal());
}
const CSSProperty& GetCSSPropertyOverflowY() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOverflowYInternal());
}
const CSSProperty& GetCSSPropertyOverscrollBehaviorX() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOverscrollBehaviorXInternal());
}
const CSSProperty& GetCSSPropertyOverscrollBehaviorY() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOverscrollBehaviorYInternal());
}
const CSSProperty& GetCSSPropertyPaddingBottom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPaddingBottomInternal());
}
const CSSProperty& GetCSSPropertyPaddingLeft() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPaddingLeftInternal());
}
const CSSProperty& GetCSSPropertyPaddingRight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPaddingRightInternal());
}
const CSSProperty& GetCSSPropertyPaddingTop() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPaddingTopInternal());
}
const CSSProperty& GetCSSPropertyPage() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPageInternal());
}
const CSSProperty& GetCSSPropertyPaintOrder() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPaintOrderInternal());
}
const CSSProperty& GetCSSPropertyPerspective() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPerspectiveInternal());
}
const CSSProperty& GetCSSPropertyPerspectiveOrigin() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPerspectiveOriginInternal());
}
const CSSProperty& GetCSSPropertyPointerEvents() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPointerEventsInternal());
}
const CSSProperty& GetCSSPropertyPosition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPositionInternal());
}
const CSSProperty& GetCSSPropertyQuotes() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyQuotesInternal());
}
const CSSProperty& GetCSSPropertyR() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyRInternal());
}
const CSSProperty& GetCSSPropertyResize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyResizeInternal());
}
const CSSProperty& GetCSSPropertyRight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyRightInternal());
}
const CSSProperty& GetCSSPropertyRotate() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyRotateInternal());
}
const CSSProperty& GetCSSPropertyRx() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyRxInternal());
}
const CSSProperty& GetCSSPropertyRy() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyRyInternal());
}
const CSSProperty& GetCSSPropertyScale() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScaleInternal());
}
const CSSProperty& GetCSSPropertyScrollBehavior() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollBehaviorInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginBlockEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginBlockEndInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginBlockStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginBlockStartInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginBottom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginBottomInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginInlineEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginInlineEndInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginInlineStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginInlineStartInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginLeft() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginLeftInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginRight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginRightInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginTop() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginTopInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingBlockEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingBlockEndInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingBlockStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingBlockStartInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingBottom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingBottomInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingInlineEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingInlineEndInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingInlineStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingInlineStartInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingLeft() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingLeftInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingRight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingRightInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingTop() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingTopInternal());
}
const CSSProperty& GetCSSPropertyScrollSnapAlign() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollSnapAlignInternal());
}
const CSSProperty& GetCSSPropertyScrollSnapStop() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollSnapStopInternal());
}
const CSSProperty& GetCSSPropertyScrollSnapType() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollSnapTypeInternal());
}
const CSSProperty& GetCSSPropertyShapeImageThreshold() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyShapeImageThresholdInternal());
}
const CSSProperty& GetCSSPropertyShapeMargin() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyShapeMarginInternal());
}
const CSSProperty& GetCSSPropertyShapeOutside() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyShapeOutsideInternal());
}
const CSSProperty& GetCSSPropertyShapeRendering() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyShapeRenderingInternal());
}
const CSSProperty& GetCSSPropertySize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertySizeInternal());
}
const CSSProperty& GetCSSPropertySpeak() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertySpeakInternal());
}
const CSSProperty& GetCSSPropertySrc() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertySrcInternal());
}
const CSSProperty& GetCSSPropertyStopColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStopColorInternal());
}
const CSSProperty& GetCSSPropertyStopOpacity() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStopOpacityInternal());
}
const CSSProperty& GetCSSPropertyStroke() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStrokeInternal());
}
const CSSProperty& GetCSSPropertyStrokeDasharray() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStrokeDasharrayInternal());
}
const CSSProperty& GetCSSPropertyStrokeDashoffset() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStrokeDashoffsetInternal());
}
const CSSProperty& GetCSSPropertyStrokeLinecap() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStrokeLinecapInternal());
}
const CSSProperty& GetCSSPropertyStrokeLinejoin() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStrokeLinejoinInternal());
}
const CSSProperty& GetCSSPropertyStrokeMiterlimit() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStrokeMiterlimitInternal());
}
const CSSProperty& GetCSSPropertyStrokeOpacity() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStrokeOpacityInternal());
}
const CSSProperty& GetCSSPropertyStrokeWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyStrokeWidthInternal());
}
const CSSProperty& GetCSSPropertyTabSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTabSizeInternal());
}
const CSSProperty& GetCSSPropertyTableLayout() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTableLayoutInternal());
}
const CSSProperty& GetCSSPropertyTextAlign() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextAlignInternal());
}
const CSSProperty& GetCSSPropertyTextAlignLast() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextAlignLastInternal());
}
const CSSProperty& GetCSSPropertyTextAnchor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextAnchorInternal());
}
const CSSProperty& GetCSSPropertyTextCombineUpright() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextCombineUprightInternal());
}
const CSSProperty& GetCSSPropertyTextDecorationColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextDecorationColorInternal());
}
const CSSProperty& GetCSSPropertyTextDecorationLine() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextDecorationLineInternal());
}
const CSSProperty& GetCSSPropertyTextDecorationSkipInk() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextDecorationSkipInkInternal());
}
const CSSProperty& GetCSSPropertyTextDecorationStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextDecorationStyleInternal());
}
const CSSProperty& GetCSSPropertyTextIndent() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextIndentInternal());
}
const CSSProperty& GetCSSPropertyTextJustify() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextJustifyInternal());
}
const CSSProperty& GetCSSPropertyTextOverflow() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextOverflowInternal());
}
const CSSProperty& GetCSSPropertyTextShadow() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextShadowInternal());
}
const CSSProperty& GetCSSPropertyTextSizeAdjust() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextSizeAdjustInternal());
}
const CSSProperty& GetCSSPropertyTextTransform() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextTransformInternal());
}
const CSSProperty& GetCSSPropertyTextUnderlinePosition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextUnderlinePositionInternal());
}
const CSSProperty& GetCSSPropertyTop() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTopInternal());
}
const CSSProperty& GetCSSPropertyTouchAction() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTouchActionInternal());
}
const CSSProperty& GetCSSPropertyTransform() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTransformInternal());
}
const CSSProperty& GetCSSPropertyTransformBox() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTransformBoxInternal());
}
const CSSProperty& GetCSSPropertyTransformOrigin() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTransformOriginInternal());
}
const CSSProperty& GetCSSPropertyTransformStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTransformStyleInternal());
}
const CSSProperty& GetCSSPropertyTranslate() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTranslateInternal());
}
const CSSProperty& GetCSSPropertyUnicodeBidi() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyUnicodeBidiInternal());
}
const CSSProperty& GetCSSPropertyUnicodeRange() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyUnicodeRangeInternal());
}
const CSSProperty& GetCSSPropertyUserSelect() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyUserSelectInternal());
}
const CSSProperty& GetCSSPropertyUserZoom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyUserZoomInternal());
}
const CSSProperty& GetCSSPropertyVectorEffect() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyVectorEffectInternal());
}
const CSSProperty& GetCSSPropertyVerticalAlign() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyVerticalAlignInternal());
}
const CSSProperty& GetCSSPropertyVisibility() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyVisibilityInternal());
}
const CSSProperty& GetCSSPropertyWebkitAppRegion() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitAppRegionInternal());
}
const CSSProperty& GetCSSPropertyWebkitAppearance() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitAppearanceInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderAfterColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderAfterColorInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderAfterStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderAfterStyleInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderAfterWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderAfterWidthInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderBeforeColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderBeforeColorInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderBeforeStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderBeforeStyleInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderBeforeWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderBeforeWidthInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderEndColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderEndColorInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderEndStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderEndStyleInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderEndWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderEndWidthInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderHorizontalSpacing() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderHorizontalSpacingInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderImage() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderImageInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderStartColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderStartColorInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderStartStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderStartStyleInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderStartWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderStartWidthInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderVerticalSpacing() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderVerticalSpacingInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxAlign() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxAlignInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxDecorationBreak() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxDecorationBreakInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxDirection() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxDirectionInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxFlex() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxFlexInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxFlexGroup() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxFlexGroupInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxLines() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxLinesInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxOrdinalGroup() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxOrdinalGroupInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxOrient() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxOrientInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxPack() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxPackInternal());
}
const CSSProperty& GetCSSPropertyWebkitBoxReflect() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBoxReflectInternal());
}
const CSSProperty& GetCSSPropertyWebkitFontSizeDelta() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitFontSizeDeltaInternal());
}
const CSSProperty& GetCSSPropertyWebkitHighlight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitHighlightInternal());
}
const CSSProperty& GetCSSPropertyWebkitHyphenateCharacter() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitHyphenateCharacterInternal());
}
const CSSProperty& GetCSSPropertyWebkitLineBreak() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitLineBreakInternal());
}
const CSSProperty& GetCSSPropertyWebkitLineClamp() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitLineClampInternal());
}
const CSSProperty& GetCSSPropertyWebkitLogicalHeight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitLogicalHeightInternal());
}
const CSSProperty& GetCSSPropertyWebkitLogicalWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitLogicalWidthInternal());
}
const CSSProperty& GetCSSPropertyWebkitMarginAfter() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMarginAfterInternal());
}
const CSSProperty& GetCSSPropertyWebkitMarginAfterCollapse() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMarginAfterCollapseInternal());
}
const CSSProperty& GetCSSPropertyWebkitMarginBefore() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMarginBeforeInternal());
}
const CSSProperty& GetCSSPropertyWebkitMarginBeforeCollapse() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMarginBeforeCollapseInternal());
}
const CSSProperty& GetCSSPropertyWebkitMarginBottomCollapse() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMarginBottomCollapseInternal());
}
const CSSProperty& GetCSSPropertyWebkitMarginEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMarginEndInternal());
}
const CSSProperty& GetCSSPropertyWebkitMarginStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMarginStartInternal());
}
const CSSProperty& GetCSSPropertyWebkitMarginTopCollapse() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMarginTopCollapseInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskBoxImageOutset() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskBoxImageOutsetInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskBoxImageRepeat() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskBoxImageRepeatInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskBoxImageSlice() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskBoxImageSliceInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskBoxImageSource() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskBoxImageSourceInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskBoxImageWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskBoxImageWidthInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskClip() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskClipInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskComposite() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskCompositeInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskImage() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskImageInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskOrigin() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskOriginInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskPositionX() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskPositionXInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskPositionY() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskPositionYInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskRepeatX() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskRepeatXInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskRepeatY() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskRepeatYInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskSize() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskSizeInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaxLogicalHeight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaxLogicalHeightInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaxLogicalWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaxLogicalWidthInternal());
}
const CSSProperty& GetCSSPropertyWebkitMinLogicalHeight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMinLogicalHeightInternal());
}
const CSSProperty& GetCSSPropertyWebkitMinLogicalWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMinLogicalWidthInternal());
}
const CSSProperty& GetCSSPropertyWebkitPaddingAfter() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitPaddingAfterInternal());
}
const CSSProperty& GetCSSPropertyWebkitPaddingBefore() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitPaddingBeforeInternal());
}
const CSSProperty& GetCSSPropertyWebkitPaddingEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitPaddingEndInternal());
}
const CSSProperty& GetCSSPropertyWebkitPaddingStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitPaddingStartInternal());
}
const CSSProperty& GetCSSPropertyWebkitPerspectiveOriginX() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitPerspectiveOriginXInternal());
}
const CSSProperty& GetCSSPropertyWebkitPerspectiveOriginY() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitPerspectiveOriginYInternal());
}
const CSSProperty& GetCSSPropertyWebkitPrintColorAdjust() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitPrintColorAdjustInternal());
}
const CSSProperty& GetCSSPropertyWebkitRtlOrdering() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitRtlOrderingInternal());
}
const CSSProperty& GetCSSPropertyWebkitRubyPosition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitRubyPositionInternal());
}
const CSSProperty& GetCSSPropertyWebkitTapHighlightColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTapHighlightColorInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextCombine() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextCombineInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextDecorationsInEffect() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextDecorationsInEffectInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextEmphasisColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextEmphasisColorInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextEmphasisPosition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextEmphasisPositionInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextEmphasisStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextEmphasisStyleInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextFillColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextFillColorInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextSecurity() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextSecurityInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextStrokeColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextStrokeColorInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextStrokeWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextStrokeWidthInternal());
}
const CSSProperty& GetCSSPropertyWebkitTransformOriginX() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTransformOriginXInternal());
}
const CSSProperty& GetCSSPropertyWebkitTransformOriginY() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTransformOriginYInternal());
}
const CSSProperty& GetCSSPropertyWebkitTransformOriginZ() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTransformOriginZInternal());
}
const CSSProperty& GetCSSPropertyWebkitUserDrag() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitUserDragInternal());
}
const CSSProperty& GetCSSPropertyWebkitUserModify() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitUserModifyInternal());
}
const CSSProperty& GetCSSPropertyWhiteSpace() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWhiteSpaceInternal());
}
const CSSProperty& GetCSSPropertyWidows() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWidowsInternal());
}
const CSSProperty& GetCSSPropertyWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWidthInternal());
}
const CSSProperty& GetCSSPropertyWillChange() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWillChangeInternal());
}
const CSSProperty& GetCSSPropertyWordBreak() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWordBreakInternal());
}
const CSSProperty& GetCSSPropertyWordSpacing() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWordSpacingInternal());
}
const CSSProperty& GetCSSPropertyWordWrap() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWordWrapInternal());
}
const CSSProperty& GetCSSPropertyX() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyXInternal());
}
const CSSProperty& GetCSSPropertyY() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyYInternal());
}
const CSSProperty& GetCSSPropertyZIndex() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyZIndexInternal());
}
const CSSProperty& GetCSSPropertyAnimation() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyAnimationInternal());
}
const CSSProperty& GetCSSPropertyBackground() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundInternal());
}
const CSSProperty& GetCSSPropertyBackgroundPosition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundPositionInternal());
}
const CSSProperty& GetCSSPropertyBackgroundRepeat() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBackgroundRepeatInternal());
}
const CSSProperty& GetCSSPropertyBorder() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderInternal());
}
const CSSProperty& GetCSSPropertyBorderBottom() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderBottomInternal());
}
const CSSProperty& GetCSSPropertyBorderColor() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderColorInternal());
}
const CSSProperty& GetCSSPropertyBorderImage() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderImageInternal());
}
const CSSProperty& GetCSSPropertyBorderLeft() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderLeftInternal());
}
const CSSProperty& GetCSSPropertyBorderRadius() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderRadiusInternal());
}
const CSSProperty& GetCSSPropertyBorderRight() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderRightInternal());
}
const CSSProperty& GetCSSPropertyBorderSpacing() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderSpacingInternal());
}
const CSSProperty& GetCSSPropertyBorderStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderStyleInternal());
}
const CSSProperty& GetCSSPropertyBorderTop() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderTopInternal());
}
const CSSProperty& GetCSSPropertyBorderWidth() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyBorderWidthInternal());
}
const CSSProperty& GetCSSPropertyColumnRule() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnRuleInternal());
}
const CSSProperty& GetCSSPropertyColumns() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyColumnsInternal());
}
const CSSProperty& GetCSSPropertyFlex() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFlexInternal());
}
const CSSProperty& GetCSSPropertyFlexFlow() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFlexFlowInternal());
}
const CSSProperty& GetCSSPropertyFont() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontInternal());
}
const CSSProperty& GetCSSPropertyFontVariant() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyFontVariantInternal());
}
const CSSProperty& GetCSSPropertyGrid() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridInternal());
}
const CSSProperty& GetCSSPropertyGridArea() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridAreaInternal());
}
const CSSProperty& GetCSSPropertyGridColumn() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridColumnInternal());
}
const CSSProperty& GetCSSPropertyGridGap() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridGapInternal());
}
const CSSProperty& GetCSSPropertyGridRow() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridRowInternal());
}
const CSSProperty& GetCSSPropertyGridTemplate() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyGridTemplateInternal());
}
const CSSProperty& GetCSSPropertyListStyle() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyListStyleInternal());
}
const CSSProperty& GetCSSPropertyMargin() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMarginInternal());
}
const CSSProperty& GetCSSPropertyMarker() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyMarkerInternal());
}
const CSSProperty& GetCSSPropertyOffset() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOffsetInternal());
}
const CSSProperty& GetCSSPropertyOutline() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOutlineInternal());
}
const CSSProperty& GetCSSPropertyOverflow() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOverflowInternal());
}
const CSSProperty& GetCSSPropertyOverscrollBehavior() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyOverscrollBehaviorInternal());
}
const CSSProperty& GetCSSPropertyPadding() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPaddingInternal());
}
const CSSProperty& GetCSSPropertyPageBreakAfter() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPageBreakAfterInternal());
}
const CSSProperty& GetCSSPropertyPageBreakBefore() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPageBreakBeforeInternal());
}
const CSSProperty& GetCSSPropertyPageBreakInside() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPageBreakInsideInternal());
}
const CSSProperty& GetCSSPropertyPlaceContent() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPlaceContentInternal());
}
const CSSProperty& GetCSSPropertyPlaceItems() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPlaceItemsInternal());
}
const CSSProperty& GetCSSPropertyPlaceSelf() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyPlaceSelfInternal());
}
const CSSProperty& GetCSSPropertyScrollMargin() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginBlock() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginBlockInternal());
}
const CSSProperty& GetCSSPropertyScrollMarginInline() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollMarginInlineInternal());
}
const CSSProperty& GetCSSPropertyScrollPadding() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingBlock() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingBlockInternal());
}
const CSSProperty& GetCSSPropertyScrollPaddingInline() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyScrollPaddingInlineInternal());
}
const CSSProperty& GetCSSPropertyTextDecoration() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTextDecorationInternal());
}
const CSSProperty& GetCSSPropertyTransition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyTransitionInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderAfter() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderAfterInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderBefore() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderBeforeInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderEnd() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderEndInternal());
}
const CSSProperty& GetCSSPropertyWebkitBorderStart() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitBorderStartInternal());
}
const CSSProperty& GetCSSPropertyWebkitColumnBreakAfter() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitColumnBreakAfterInternal());
}
const CSSProperty& GetCSSPropertyWebkitColumnBreakBefore() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitColumnBreakBeforeInternal());
}
const CSSProperty& GetCSSPropertyWebkitColumnBreakInside() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitColumnBreakInsideInternal());
}
const CSSProperty& GetCSSPropertyWebkitMarginCollapse() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMarginCollapseInternal());
}
const CSSProperty& GetCSSPropertyWebkitMask() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskBoxImage() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskBoxImageInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskPosition() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskPositionInternal());
}
const CSSProperty& GetCSSPropertyWebkitMaskRepeat() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitMaskRepeatInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextEmphasis() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextEmphasisInternal());
}
const CSSProperty& GetCSSPropertyWebkitTextStroke() {
  return ToCSSProperty(CSSUnresolvedProperty::GetCSSPropertyWebkitTextStrokeInternal());
}

const CSSProperty& CSSProperty::Get(CSSPropertyID id) {
  DCHECK_NE(id, CSSPropertyInvalid);
  DCHECK_LE(id, 441); // last property id
  return ToCSSProperty(CSSUnresolvedProperty::GetNonAliasProperty(id));
}

}  // namespace blink

