// Copyright 2017 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSUnresolvedProperty.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5

// clang-format off

#ifndef CSSUnresolvedProperty_h
#define CSSUnresolvedProperty_h

#include "core/CSSPropertyNames.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

// TODO(crbug.com/793288): audit and consider redesigning how aliases are
// handled once more of project Ribbon is done and all use of aliases can be
// found and (hopefully) constrained.
class CSSUnresolvedProperty {
 public:
  CORE_EXPORT static const CSSUnresolvedProperty& Get(CSSPropertyID);

  virtual bool IsResolvedProperty() const { return false; }
  virtual const char* GetPropertyName() const {
    NOTREACHED();
    return nullptr;
  }
  virtual const WTF::AtomicString& GetPropertyNameAtomicString() const {
    NOTREACHED();
    return g_empty_atom;
  }
  WTF::String GetPropertyNameString() const {
    // We share the StringImpl with the AtomicStrings.
    return GetPropertyNameAtomicString().GetString();
  }

  static const CSSUnresolvedProperty& GetCSSPropertyVariableInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAnimationDelayInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAnimationDirectionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAnimationDurationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAnimationFillModeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAnimationIterationCountInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAnimationNameInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAnimationPlayStateInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAnimationTimingFunctionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTransitionDelayInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTransitionDurationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTransitionPropertyInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTransitionTimingFunctionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyDirectionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontFamilyInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontFeatureSettingsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontKerningInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontSizeAdjustInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontStretchInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontVariantCapsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontVariantEastAsianInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontVariantLigaturesInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontVariantNumericInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontVariationSettingsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontWeightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextOrientationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextRenderingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitFontSmoothingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitLocaleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextOrientationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitWritingModeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWritingModeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyZoomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAlignContentInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAlignItemsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAlignSelfInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAlignmentBaselineInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAllInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackdropFilterInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackfaceVisibilityInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundAttachmentInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundBlendModeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundClipInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundImageInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundOriginInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundPositionXInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundPositionYInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundRepeatXInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundRepeatYInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBaselineShiftInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBlockSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderBottomColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderBottomLeftRadiusInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderBottomRightRadiusInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderBottomStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderBottomWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderCollapseInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderImageOutsetInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderImageRepeatInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderImageSliceInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderImageSourceInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderImageWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderLeftColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderLeftStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderLeftWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderRightColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderRightStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderRightWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderTopColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderTopLeftRadiusInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderTopRightRadiusInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderTopStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderTopWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBottomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBoxShadowInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBoxSizingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBreakAfterInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBreakBeforeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBreakInsideInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBufferedRenderingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyCaptionSideInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyCaretColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyClearInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyClipInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyClipPathInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyClipRuleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColorInterpolationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColorInterpolationFiltersInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColorRenderingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnCountInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnFillInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnGapInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnRuleColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnRuleStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnRuleWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnSpanInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyContainInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyContentInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyCounterIncrementInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyCounterResetInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyCursorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyCxInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyCyInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyDInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyDisplayInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyDominantBaselineInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyEmptyCellsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFillInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFillOpacityInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFillRuleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFilterInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFlexBasisInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFlexDirectionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFlexGrowInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFlexShrinkInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFlexWrapInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFloatInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFloodColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFloodOpacityInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontDisplayInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridAutoColumnsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridAutoFlowInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridAutoRowsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridColumnEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridColumnGapInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridColumnStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridRowEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridRowGapInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridRowStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridTemplateAreasInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridTemplateColumnsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridTemplateRowsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyHeightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyHyphensInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyImageOrientationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyImageRenderingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyInlineSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyIsolationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyJustifyContentInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyJustifyItemsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyJustifySelfInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyLeftInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyLetterSpacingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyLightingColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyLineBreakInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyLineHeightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyLineHeightStepInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyListStyleImageInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyListStylePositionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyListStyleTypeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMarginBottomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMarginLeftInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMarginRightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMarginTopInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMarkerEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMarkerMidInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMarkerStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMaskInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMaskSourceTypeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMaskTypeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMaxBlockSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMaxHeightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMaxInlineSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMaxWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMaxZoomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMinBlockSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMinHeightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMinInlineSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMinWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMinZoomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMixBlendModeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyObjectFitInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyObjectPositionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOffsetAnchorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOffsetDistanceInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOffsetPathInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOffsetPositionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOffsetRotateInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOpacityInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOrderInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOrientationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOrphansInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOutlineColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOutlineOffsetInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOutlineStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOutlineWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOverflowAnchorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOverflowWrapInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOverflowXInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOverflowYInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOverscrollBehaviorXInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOverscrollBehaviorYInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPaddingBottomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPaddingLeftInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPaddingRightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPaddingTopInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPageInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPaintOrderInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPerspectiveInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPerspectiveOriginInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPointerEventsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPositionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyQuotesInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyRInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyResizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyRightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyRotateInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyRxInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyRyInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScaleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollBehaviorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginBlockEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginBlockStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginBottomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginInlineEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginInlineStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginLeftInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginRightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginTopInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingBlockEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingBlockStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingBottomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingInlineEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingInlineStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingLeftInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingRightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingTopInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollSnapAlignInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollSnapStopInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollSnapTypeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyShapeImageThresholdInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyShapeMarginInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyShapeOutsideInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyShapeRenderingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertySizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertySpeakInternal();
  static const CSSUnresolvedProperty& GetCSSPropertySrcInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStopColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStopOpacityInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStrokeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStrokeDasharrayInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStrokeDashoffsetInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStrokeLinecapInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStrokeLinejoinInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStrokeMiterlimitInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStrokeOpacityInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyStrokeWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTabSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTableLayoutInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextAlignInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextAlignLastInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextAnchorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextCombineUprightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextDecorationColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextDecorationLineInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextDecorationSkipInkInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextDecorationStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextIndentInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextJustifyInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextOverflowInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextShadowInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextSizeAdjustInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextTransformInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextUnderlinePositionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTopInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTouchActionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTransformInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTransformBoxInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTransformOriginInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTransformStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTranslateInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyUnicodeBidiInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyUnicodeRangeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyUserSelectInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyUserZoomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyVectorEffectInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyVerticalAlignInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyVisibilityInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitAppRegionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitAppearanceInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderAfterColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderAfterStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderAfterWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderBeforeColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderBeforeStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderBeforeWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderEndColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderEndStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderEndWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderHorizontalSpacingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderImageInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderStartColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderStartStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderStartWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderVerticalSpacingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxAlignInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxDecorationBreakInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxDirectionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxFlexInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxFlexGroupInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxLinesInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxOrdinalGroupInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxOrientInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxPackInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBoxReflectInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitFontSizeDeltaInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitHighlightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitHyphenateCharacterInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitLineBreakInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitLineClampInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitLogicalHeightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitLogicalWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMarginAfterInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMarginAfterCollapseInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMarginBeforeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMarginBeforeCollapseInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMarginBottomCollapseInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMarginEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMarginStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMarginTopCollapseInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskBoxImageOutsetInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskBoxImageRepeatInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskBoxImageSliceInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskBoxImageSourceInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskBoxImageWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskClipInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskCompositeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskImageInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskOriginInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskPositionXInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskPositionYInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskRepeatXInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskRepeatYInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskSizeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaxLogicalHeightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaxLogicalWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMinLogicalHeightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMinLogicalWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitPaddingAfterInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitPaddingBeforeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitPaddingEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitPaddingStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitPerspectiveOriginXInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitPerspectiveOriginYInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitPrintColorAdjustInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitRtlOrderingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitRubyPositionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTapHighlightColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextCombineInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextDecorationsInEffectInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextEmphasisColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextEmphasisPositionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextEmphasisStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextFillColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextSecurityInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextStrokeColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextStrokeWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTransformOriginXInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTransformOriginYInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTransformOriginZInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitUserDragInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitUserModifyInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWhiteSpaceInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWidowsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWillChangeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWordBreakInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWordSpacingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWordWrapInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyXInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyYInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyZIndexInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyAnimationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundPositionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBackgroundRepeatInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderBottomInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderColorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderImageInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderLeftInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderRadiusInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderRightInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderSpacingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderTopInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyBorderWidthInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnRuleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyColumnsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFlexInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFlexFlowInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyFontVariantInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridAreaInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridColumnInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridGapInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridRowInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyGridTemplateInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyListStyleInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMarginInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyMarkerInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOffsetInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOutlineInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOverflowInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyOverscrollBehaviorInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPaddingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPageBreakAfterInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPageBreakBeforeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPageBreakInsideInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPlaceContentInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPlaceItemsInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyPlaceSelfInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginBlockInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollMarginInlineInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingBlockInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyScrollPaddingInlineInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTextDecorationInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyTransitionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderAfterInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderBeforeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderEndInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitBorderStartInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitColumnBreakAfterInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitColumnBreakBeforeInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitColumnBreakInsideInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMarginCollapseInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskBoxImageInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskPositionInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitMaskRepeatInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextEmphasisInternal();
  static const CSSUnresolvedProperty& GetCSSPropertyWebkitTextStrokeInternal();

  CORE_EXPORT static const CSSUnresolvedProperty* GetAliasProperty(CSSPropertyID);

 protected:
  constexpr CSSUnresolvedProperty() {}
  static const CSSUnresolvedProperty& GetNonAliasProperty(CSSPropertyID);
};

}  // namespace blink

#endif  // CSSUnresolvedProperty_h
