// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_All_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_All_h

#include "core/css/properties/Longhand.h"

namespace blink {
namespace CSSLonghand {

// Implements the 'all' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class All final : public Longhand {
 public:
  constexpr All() : Longhand() {}
  const char* GetPropertyName() const override { return "all\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("all\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("all\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyAll; }
  bool IsAffectedByAll() const override { return false; }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_All_h
