// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_BackgroundRepeatY_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_BackgroundRepeatY_h

#include "core/css/CSSIdentifierValue.h"
#include "core/css/CSSPrimitiveValueMappings.h"
#include "core/css/CSSValueList.h"
#include "core/css/properties/Longhand.h"
#include "core/css/resolver/StyleResolverState.h"
#include "core/style/ComputedStyle.h"

namespace blink {
namespace CSSLonghand {

// Implements the 'background-repeat-y' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class BackgroundRepeatY final : public Longhand {
 public:
  constexpr BackgroundRepeatY() : Longhand() {}
  const char* GetPropertyName() const override { return "background-repeat-y\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("background-repeat-y\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("backgroundRepeatY\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyBackgroundRepeatY; }

  // Style builder functions
  void ApplyInitial(StyleResolverState& state) const override;
  void ApplyInherit(StyleResolverState& state) const override;
  void ApplyValue(StyleResolverState& state, const CSSValue& value) const override;
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_BackgroundRepeatY_h
