// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_ColumnWidth_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_ColumnWidth_h

#include "core/css/CSSPrimitiveValueMappings.h"
#include "core/css/CSSPrimitiveValueMappings.h"
#include "core/css/properties/Longhand.h"
#include "core/css/resolver/StyleBuilderConverter.h"
#include "core/css/resolver/StyleResolverState.h"
#include "core/style/ComputedStyle.h"

namespace blink {
namespace CSSLonghand {

// Implements the 'column-width' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class ColumnWidth final : public Longhand {
 public:
  constexpr ColumnWidth() : Longhand() {}
  const char* GetPropertyName() const override { return "column-width\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("column-width\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("columnWidth\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyColumnWidth; }
  const CSSValue* ParseSingleValue(CSSParserTokenRange&, const CSSParserContext&, const CSSParserLocalContext&) const override;
  const CSSValue* CSSValueFromComputedStyleInternal(const ComputedStyle&, const SVGComputedStyle&, const LayoutObject*, Node*, bool allow_visited_style) const override;
  bool IsInterpolable() const override { return true; }

  // Style builder functions
  void ApplyInitial(StyleResolverState& state) const override {
    state.Style()->SetHasAutoColumnWidth();
  }
  void ApplyInherit(StyleResolverState& state) const override {
    if (state.ParentStyle()->HasAutoColumnWidth())
      state.Style()->SetHasAutoColumnWidth();
    else
      state.Style()->SetColumnWidth(state.ParentStyle()->ColumnWidth());
  }
  void ApplyValue(StyleResolverState& state, const CSSValue& value) const override {
    if (value.IsIdentifierValue() &&
        ToCSSIdentifierValue(value).GetValueID() == CSSValueAuto)
      state.Style()->SetHasAutoColumnWidth();
    else
      state.Style()->SetColumnWidth(StyleBuilderConverter::ConvertComputedLength<float>(state, value));
  }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_ColumnWidth_h
