// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_FontDisplay_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_FontDisplay_h

#include "core/css/properties/Longhand.h"

namespace blink {
namespace CSSLonghand {

// Implements the 'font-display' CSS descriptor
// See src/third_party/WebKit/Source/core/css/properties/README.md
class FontDisplay final : public Longhand {
 public:
  constexpr FontDisplay() : Longhand() {}
  const char* GetPropertyName() const override { return "font-display\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("font-display\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("fontDisplay\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyFontDisplay; }
  bool IsDescriptor() const override { return true; }
  bool IsProperty() const override { return false; }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_FontDisplay_h
