// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_FontKerning_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_FontKerning_h

#include "core/css/CSSIdentifierValue.h"
#include "core/css/CSSPrimitiveValueMappings.h"
#include "core/css/properties/Longhand.h"
#include "core/css/resolver/FontBuilder.h"
#include "core/css/resolver/StyleResolverState.h"

namespace blink {
namespace CSSLonghand {

// Implements the 'font-kerning' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class FontKerning final : public Longhand {
 public:
  constexpr FontKerning() : Longhand() {}
  const char* GetPropertyName() const override { return "font-kerning\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("font-kerning\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("fontKerning\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyFontKerning; }
  const CSSValue* CSSValueFromComputedStyleInternal(const ComputedStyle&, const SVGComputedStyle&, const LayoutObject*, Node*, bool allow_visited_style) const override;
  bool IsInherited() const override { return true; }

  // Style builder functions
  void ApplyInitial(StyleResolverState& state) const override {
    state.GetFontBuilder().SetKerning(FontBuilder::InitialKerning());
  }
  void ApplyInherit(StyleResolverState& state) const override {
    state.GetFontBuilder().SetKerning(state.ParentFontDescription().GetKerning());
  }
  void ApplyValue(StyleResolverState& state, const CSSValue& value) const override {
    state.GetFontBuilder().SetKerning(ToCSSIdentifierValue(value).ConvertTo<blink::FontDescription::Kerning>());
  }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_FontKerning_h
