// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_ScrollPaddingInlineEnd_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_ScrollPaddingInlineEnd_h

#include "core/StylePropertyShorthand.h"
#include "core/css/properties/Longhand.h"
#include "platform/runtime_enabled_features.h"

namespace blink {
namespace CSSLonghand {

// Implements the 'scroll-padding-inline-end' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class ScrollPaddingInlineEnd final : public Longhand {
 public:
  constexpr ScrollPaddingInlineEnd() : Longhand() {}
  const char* GetPropertyName() const override { return "scroll-padding-inline-end\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("scroll-padding-inline-end\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("scrollPaddingInlineEnd\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyScrollPaddingInlineEnd; }
  const CSSValue* ParseSingleValue(CSSParserTokenRange&, const CSSParserContext&, const CSSParserLocalContext&) const override;
  bool SupportsPercentage() const override { return true; }
  bool IsEnabled() const override {
    return RuntimeEnabledFeatures::CSSScrollSnapPointsEnabled();
  }
  const CSSValue* CSSValueFromComputedStyleInternal(
      const ComputedStyle& ,
      const SVGComputedStyle&,
      const LayoutObject*,
      Node*,
      bool allow_visited_style) const override {
    // Directional properties are resolved by resolveDirectionAwareProperty()
    // before calling CSSValueFromComputedStyleInternal.
    NOTREACHED();
    return nullptr;
  }
  const CSSProperty& ResolveDirectionAwareProperty(
      TextDirection direction,
      blink::WritingMode writing_mode) const override {
    return ResolveEndToPhysicalProperty(
      direction,
      writing_mode,
      scrollPaddingShorthand());
  }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_ScrollPaddingInlineEnd_h
