// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitBoxFlex_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitBoxFlex_h

#include "core/css/CSSPrimitiveValue.h"
#include "core/css/CSSPrimitiveValueMappings.h"
#include "core/css/CSSPrimitiveValueMappings.h"
#include "core/css/properties/Longhand.h"
#include "core/css/resolver/StyleResolverState.h"
#include "core/style/ComputedStyle.h"

namespace blink {
namespace CSSLonghand {

// Implements the '-webkit-box-flex' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class WebkitBoxFlex final : public Longhand {
 public:
  constexpr WebkitBoxFlex() : Longhand() {}
  const char* GetPropertyName() const override { return "-webkit-box-flex\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("-webkit-box-flex\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("webkitBoxFlex\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyWebkitBoxFlex; }
  const CSSValue* ParseSingleValue(CSSParserTokenRange&, const CSSParserContext&, const CSSParserLocalContext&) const override;
  const CSSValue* CSSValueFromComputedStyleInternal(const ComputedStyle&, const SVGComputedStyle&, const LayoutObject*, Node*, bool allow_visited_style) const override;

  // Style builder functions
  void ApplyInitial(StyleResolverState& state) const override {
    state.Style()->SetBoxFlex(ComputedStyleInitialValues::InitialBoxFlex());
  }
  void ApplyInherit(StyleResolverState& state) const override {
    state.Style()->SetBoxFlex(state.ParentStyle()->BoxFlex());
  }
  void ApplyValue(StyleResolverState& state, const CSSValue& value) const override {
    state.Style()->SetBoxFlex(ToCSSPrimitiveValue(value).ConvertTo<float>());
  }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitBoxFlex_h
