// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitLogicalHeight_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitLogicalHeight_h

#include "core/StylePropertyShorthand.h"
#include "core/css/properties/Longhand.h"

namespace blink {
namespace CSSLonghand {

// Implements the '-webkit-logical-height' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class WebkitLogicalHeight final : public Longhand {
 public:
  constexpr WebkitLogicalHeight() : Longhand() {}
  const char* GetPropertyName() const override { return "-webkit-logical-height\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("-webkit-logical-height\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("webkitLogicalHeight\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyWebkitLogicalHeight; }
  const CSSValue* ParseSingleValue(CSSParserTokenRange&, const CSSParserContext&, const CSSParserLocalContext&) const override;
  const CSSValue* CSSValueFromComputedStyleInternal(
      const ComputedStyle& ,
      const SVGComputedStyle&,
      const LayoutObject*,
      Node*,
      bool allow_visited_style) const override {
    // Directional properties are resolved by resolveDirectionAwareProperty()
    // before calling CSSValueFromComputedStyleInternal.
    NOTREACHED();
    return nullptr;
  }
  const CSSProperty& ResolveDirectionAwareProperty(
      TextDirection direction,
      blink::WritingMode writing_mode) const override {
    if (IsHorizontalWritingMode(writing_mode))
      return GetCSSPropertyHeight();
    return GetCSSPropertyWidth();
  }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitLogicalHeight_h
