// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitMarginBeforeCollapse_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitMarginBeforeCollapse_h

#include "core/css/CSSIdentifierValue.h"
#include "core/css/CSSPrimitiveValueMappings.h"
#include "core/css/properties/Longhand.h"
#include "core/css/resolver/StyleResolverState.h"
#include "core/style/ComputedStyle.h"

namespace blink {
namespace CSSLonghand {

// Implements the '-webkit-margin-before-collapse' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class WebkitMarginBeforeCollapse final : public Longhand {
 public:
  constexpr WebkitMarginBeforeCollapse() : Longhand() {}
  const char* GetPropertyName() const override { return "-webkit-margin-before-collapse\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("-webkit-margin-before-collapse\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("webkitMarginBeforeCollapse\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyWebkitMarginBeforeCollapse; }
  const CSSValue* CSSValueFromComputedStyleInternal(const ComputedStyle&, const SVGComputedStyle&, const LayoutObject*, Node*, bool allow_visited_style) const override;

  // Style builder functions
  void ApplyInitial(StyleResolverState& state) const override {
    state.Style()->SetMarginBeforeCollapse(ComputedStyleInitialValues::InitialMarginBeforeCollapse());
  }
  void ApplyInherit(StyleResolverState& state) const override {
    state.Style()->SetMarginBeforeCollapse(state.ParentStyle()->MarginBeforeCollapse());
  }
  void ApplyValue(StyleResolverState& state, const CSSValue& value) const override {
    state.Style()->SetMarginBeforeCollapse(ToCSSIdentifierValue(value).ConvertTo<blink::EMarginCollapse>());
  }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitMarginBeforeCollapse_h
