// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitTextStrokeColor_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitTextStrokeColor_h

#include "core/css/properties/Longhand.h"

namespace blink {
namespace CSSLonghand {

// Implements the '-webkit-text-stroke-color' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class WebkitTextStrokeColor final : public Longhand {
 public:
  constexpr WebkitTextStrokeColor() : Longhand() {}
  const char* GetPropertyName() const override { return "-webkit-text-stroke-color\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("-webkit-text-stroke-color\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("webkitTextStrokeColor\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyWebkitTextStrokeColor; }
  const CSSValue* ParseSingleValue(CSSParserTokenRange&, const CSSParserContext&, const CSSParserLocalContext&) const override;
  const CSSValue* CSSValueFromComputedStyleInternal(const ComputedStyle&, const SVGComputedStyle&, const LayoutObject*, Node*, bool allow_visited_style) const override;
  const blink::Color ColorIncludingFallback(bool, const ComputedStyle&) const override;
  bool IsInterpolable() const override { return true; }
  bool IsInherited() const override { return true; }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_LONGHAND_WebkitTextStrokeColor_h
