// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_SHORTHAND_Marker_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_SHORTHAND_Marker_h

#include "core/css/properties/Shorthand.h"

namespace blink {
namespace CSSShorthand {

// Implements the 'marker' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class Marker final : public Shorthand {
 public:
  constexpr Marker() : Shorthand() {}
  const char* GetPropertyName() const override { return "marker\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("marker\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("marker\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyMarker; }
  bool ParseShorthand(bool, CSSParserTokenRange&, const CSSParserContext&, const CSSParserLocalContext&, HeapVector<CSSPropertyValue, 256>&) const override;
};

}  // namespace CSSShorthand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_SHORTHAND_Marker_h
