// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/CSSPropertySubclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/css/properties/CSSPropertyMethods.json5


#ifndef GEN_BLINK_CORE_CSS_PROPERTIES_SHORTHAND_ScrollMarginInline_h
#define GEN_BLINK_CORE_CSS_PROPERTIES_SHORTHAND_ScrollMarginInline_h

#include "core/css/properties/Shorthand.h"
#include "platform/runtime_enabled_features.h"

namespace blink {
namespace CSSShorthand {

// Implements the 'scroll-margin-inline' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class ScrollMarginInline final : public Shorthand {
 public:
  constexpr ScrollMarginInline() : Shorthand() {}
  const char* GetPropertyName() const override { return "scroll-margin-inline\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("scroll-margin-inline\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("scrollMarginInline\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyScrollMarginInline; }
  bool ParseShorthand(bool, CSSParserTokenRange&, const CSSParserContext&, const CSSParserLocalContext&, HeapVector<CSSPropertyValue, 256>&) const override;
  const CSSValue* CSSValueFromComputedStyleInternal(const ComputedStyle&, const SVGComputedStyle&, const LayoutObject*, Node*, bool allow_visited_style) const override;
  bool IsEnabled() const override {
    return RuntimeEnabledFeatures::CSSScrollSnapPointsEnabled();
  }
};

}  // namespace CSSShorthand
}  // namespace blink

#endif  // GEN_BLINK_CORE_CSS_PROPERTIES_SHORTHAND_ScrollMarginInline_h
