// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef AnimationEventInit_h
#define AnimationEventInit_h

#include "core/CoreExport.h"
#include "core/dom/events/EventInit.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class CORE_EXPORT AnimationEventInit : public EventInit {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  AnimationEventInit();
  virtual ~AnimationEventInit();
  AnimationEventInit(const AnimationEventInit&);
  AnimationEventInit& operator=(const AnimationEventInit&);

  bool hasAnimationName() const { return !animation_name_.IsNull(); }
  const String& animationName() const {
    return animation_name_;
  }
  inline void setAnimationName(const String&);

  bool hasElapsedTime() const { return has_elapsed_time_; }
  double elapsedTime() const {
    DCHECK(has_elapsed_time_);
    return elapsed_time_;
  }
  inline void setElapsedTime(double);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_elapsed_time_ = false;

  String animation_name_;
  double elapsed_time_;

  friend class V8AnimationEventInit;
};

void AnimationEventInit::setAnimationName(const String& value) {
  animation_name_ = value;
}

void AnimationEventInit::setElapsedTime(double value) {
  elapsed_time_ = value;
  has_elapsed_time_ = true;
}

}  // namespace blink

#endif  // AnimationEventInit_h
