// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef InputEventInit_h
#define InputEventInit_h

#include "core/CoreExport.h"
#include "core/events/UIEventInit.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class StaticRange;
class DataTransfer;

class CORE_EXPORT InputEventInit : public UIEventInit {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  InputEventInit();
  virtual ~InputEventInit();
  InputEventInit(const InputEventInit&);
  InputEventInit& operator=(const InputEventInit&);

  bool hasData() const { return !data_.IsNull(); }
  const String& data() const {
    return data_;
  }
  inline void setData(const String&);
  inline void setDataToNull();

  bool hasDataTransfer() const { return data_transfer_; }
  DataTransfer* dataTransfer() const {
    return data_transfer_;
  }
  inline void setDataTransfer(DataTransfer*);
  inline void setDataTransferToNull();

  bool hasInputType() const { return !input_type_.IsNull(); }
  const String& inputType() const {
    return input_type_;
  }
  inline void setInputType(const String&);

  bool hasIsComposing() const { return has_is_composing_; }
  bool isComposing() const {
    DCHECK(has_is_composing_);
    return is_composing_;
  }
  inline void setIsComposing(bool);

  bool hasTargetRanges() const { return has_target_ranges_; }
  const HeapVector<Member<StaticRange>>& targetRanges() const {
    DCHECK(has_target_ranges_);
    return target_ranges_;
  }
  void setTargetRanges(const HeapVector<Member<StaticRange>>&);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_is_composing_ = false;
  bool has_target_ranges_ = false;

  String data_;
  Member<DataTransfer> data_transfer_;
  String input_type_;
  bool is_composing_;
  HeapVector<Member<StaticRange>> target_ranges_;

  friend class V8InputEventInit;
};

void InputEventInit::setData(const String& value) {
  data_ = value;
}
void InputEventInit::setDataToNull() {
  data_ = String();
}

void InputEventInit::setDataTransfer(DataTransfer* value) {
  data_transfer_ = value;
}
void InputEventInit::setDataTransferToNull() {
  data_transfer_ = Member<DataTransfer>();
}

void InputEventInit::setInputType(const String& value) {
  input_type_ = value;
}

void InputEventInit::setIsComposing(bool value) {
  is_composing_ = value;
  has_is_composing_ = true;
}

}  // namespace blink

#endif  // InputEventInit_h
