// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef MouseEventInit_h
#define MouseEventInit_h

#include "core/CoreExport.h"
#include "core/dom/events/EventModifierInit.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class EventTarget;

class CORE_EXPORT MouseEventInit : public EventModifierInit {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  MouseEventInit();
  virtual ~MouseEventInit();
  MouseEventInit(const MouseEventInit&);
  MouseEventInit& operator=(const MouseEventInit&);

  bool hasButton() const { return has_button_; }
  int16_t button() const {
    DCHECK(has_button_);
    return button_;
  }
  inline void setButton(int16_t);

  bool hasButtons() const { return has_buttons_; }
  uint16_t buttons() const {
    DCHECK(has_buttons_);
    return buttons_;
  }
  inline void setButtons(uint16_t);

  bool hasClientX() const { return has_clientx_; }
  double clientX() const {
    DCHECK(has_clientx_);
    return clientx_;
  }
  inline void setClientX(double);

  bool hasClientY() const { return has_clienty_; }
  double clientY() const {
    DCHECK(has_clienty_);
    return clienty_;
  }
  inline void setClientY(double);

  bool hasMovementX() const { return has_movementx_; }
  int32_t movementX() const {
    DCHECK(has_movementx_);
    return movementx_;
  }
  inline void setMovementX(int32_t);

  bool hasMovementY() const { return has_movementy_; }
  int32_t movementY() const {
    DCHECK(has_movementy_);
    return movementy_;
  }
  inline void setMovementY(int32_t);

  bool hasRegion() const { return !region_.IsNull(); }
  const String& region() const {
    return region_;
  }
  inline void setRegion(const String&);
  inline void setRegionToNull();

  bool hasRelatedTarget() const { return related_target_; }
  EventTarget* relatedTarget() const {
    return related_target_;
  }
  inline void setRelatedTarget(EventTarget*);
  inline void setRelatedTargetToNull();

  bool hasScreenX() const { return has_screenx_; }
  double screenX() const {
    DCHECK(has_screenx_);
    return screenx_;
  }
  inline void setScreenX(double);

  bool hasScreenY() const { return has_screeny_; }
  double screenY() const {
    DCHECK(has_screeny_);
    return screeny_;
  }
  inline void setScreenY(double);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_button_ = false;
  bool has_buttons_ = false;
  bool has_clientx_ = false;
  bool has_clienty_ = false;
  bool has_movementx_ = false;
  bool has_movementy_ = false;
  bool has_screenx_ = false;
  bool has_screeny_ = false;

  int16_t button_;
  uint16_t buttons_;
  double clientx_;
  double clienty_;
  int32_t movementx_;
  int32_t movementy_;
  String region_;
  Member<EventTarget> related_target_;
  double screenx_;
  double screeny_;

  friend class V8MouseEventInit;
};

void MouseEventInit::setButton(int16_t value) {
  button_ = value;
  has_button_ = true;
}

void MouseEventInit::setButtons(uint16_t value) {
  buttons_ = value;
  has_buttons_ = true;
}

void MouseEventInit::setClientX(double value) {
  clientx_ = value;
  has_clientx_ = true;
}

void MouseEventInit::setClientY(double value) {
  clienty_ = value;
  has_clienty_ = true;
}

void MouseEventInit::setMovementX(int32_t value) {
  movementx_ = value;
  has_movementx_ = true;
}

void MouseEventInit::setMovementY(int32_t value) {
  movementy_ = value;
  has_movementy_ = true;
}

void MouseEventInit::setRegion(const String& value) {
  region_ = value;
}
void MouseEventInit::setRegionToNull() {
  region_ = String();
}

void MouseEventInit::setRelatedTarget(EventTarget* value) {
  related_target_ = value;
}
void MouseEventInit::setRelatedTargetToNull() {
  related_target_ = Member<EventTarget>();
}

void MouseEventInit::setScreenX(double value) {
  screenx_ = value;
  has_screenx_ = true;
}

void MouseEventInit::setScreenY(double value) {
  screeny_ = value;
  has_screeny_ = true;
}

}  // namespace blink

#endif  // MouseEventInit_h
