// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef TransitionEventInit_h
#define TransitionEventInit_h

#include "core/CoreExport.h"
#include "core/dom/events/EventInit.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class CORE_EXPORT TransitionEventInit : public EventInit {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  TransitionEventInit();
  virtual ~TransitionEventInit();
  TransitionEventInit(const TransitionEventInit&);
  TransitionEventInit& operator=(const TransitionEventInit&);

  bool hasElapsedTime() const { return has_elapsed_time_; }
  double elapsedTime() const {
    DCHECK(has_elapsed_time_);
    return elapsed_time_;
  }
  inline void setElapsedTime(double);

  bool hasPropertyName() const { return !property_name_.IsNull(); }
  const String& propertyName() const {
    return property_name_;
  }
  inline void setPropertyName(const String&);

  bool hasPseudoElement() const { return !pseudo_element_.IsNull(); }
  const String& pseudoElement() const {
    return pseudo_element_;
  }
  inline void setPseudoElement(const String&);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_elapsed_time_ = false;

  double elapsed_time_;
  String property_name_;
  String pseudo_element_;

  friend class V8TransitionEventInit;
};

void TransitionEventInit::setElapsedTime(double value) {
  elapsed_time_ = value;
  has_elapsed_time_ = true;
}

void TransitionEventInit::setPropertyName(const String& value) {
  property_name_ = value;
}

void TransitionEventInit::setPseudoElement(const String& value) {
  pseudo_element_ = value;
}

}  // namespace blink

#endif  // TransitionEventInit_h
