// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef WheelEventInit_h
#define WheelEventInit_h

#include "core/CoreExport.h"
#include "core/events/MouseEventInit.h"
#include "platform/heap/Handle.h"

namespace blink {

class CORE_EXPORT WheelEventInit : public MouseEventInit {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  WheelEventInit();
  virtual ~WheelEventInit();
  WheelEventInit(const WheelEventInit&);
  WheelEventInit& operator=(const WheelEventInit&);

  bool hasDeltaMode() const { return has_delta_mode_; }
  uint32_t deltaMode() const {
    DCHECK(has_delta_mode_);
    return delta_mode_;
  }
  inline void setDeltaMode(uint32_t);

  bool hasDeltaX() const { return has_deltax_; }
  double deltaX() const {
    DCHECK(has_deltax_);
    return deltax_;
  }
  inline void setDeltaX(double);

  bool hasDeltaY() const { return has_deltay_; }
  double deltaY() const {
    DCHECK(has_deltay_);
    return deltay_;
  }
  inline void setDeltaY(double);

  bool hasDeltaZ() const { return has_deltaz_; }
  double deltaZ() const {
    DCHECK(has_deltaz_);
    return deltaz_;
  }
  inline void setDeltaZ(double);

  bool hasWheelDeltaX() const { return has_wheel_delta_x_; }
  int32_t wheelDeltaX() const {
    DCHECK(has_wheel_delta_x_);
    return wheel_delta_x_;
  }
  inline void setWheelDeltaX(int32_t);

  bool hasWheelDeltaY() const { return has_wheel_delta_y_; }
  int32_t wheelDeltaY() const {
    DCHECK(has_wheel_delta_y_);
    return wheel_delta_y_;
  }
  inline void setWheelDeltaY(int32_t);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_delta_mode_ = false;
  bool has_deltax_ = false;
  bool has_deltay_ = false;
  bool has_deltaz_ = false;
  bool has_wheel_delta_x_ = false;
  bool has_wheel_delta_y_ = false;

  uint32_t delta_mode_;
  double deltax_;
  double deltay_;
  double deltaz_;
  int32_t wheel_delta_x_;
  int32_t wheel_delta_y_;

  friend class V8WheelEventInit;
};

void WheelEventInit::setDeltaMode(uint32_t value) {
  delta_mode_ = value;
  has_delta_mode_ = true;
}

void WheelEventInit::setDeltaX(double value) {
  deltax_ = value;
  has_deltax_ = true;
}

void WheelEventInit::setDeltaY(double value) {
  deltay_ = value;
  has_deltay_ = true;
}

void WheelEventInit::setDeltaZ(double value) {
  deltaz_ = value;
  has_deltaz_ = true;
}

void WheelEventInit::setWheelDeltaX(int32_t value) {
  wheel_delta_x_ = value;
  has_wheel_delta_x_ = true;
}

void WheelEventInit::setWheelDeltaY(int32_t value) {
  wheel_delta_y_ = value;
  has_wheel_delta_y_ = true;
}

}  // namespace blink

#endif  // WheelEventInit_h
