// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef CanvasContextCreationAttributes_h
#define CanvasContextCreationAttributes_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class CORE_EXPORT CanvasContextCreationAttributes : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  CanvasContextCreationAttributes();
  virtual ~CanvasContextCreationAttributes();
  CanvasContextCreationAttributes(const CanvasContextCreationAttributes&);
  CanvasContextCreationAttributes& operator=(const CanvasContextCreationAttributes&);

  bool hasAlpha() const { return has_alpha_; }
  bool alpha() const {
    DCHECK(has_alpha_);
    return alpha_;
  }
  inline void setAlpha(bool);

  bool hasAntialias() const { return has_antialias_; }
  bool antialias() const {
    DCHECK(has_antialias_);
    return antialias_;
  }
  inline void setAntialias(bool);

  bool hasColorSpace() const { return !color_space_.IsNull(); }
  const String& colorSpace() const {
    return color_space_;
  }
  inline void setColorSpace(const String&);

  bool hasDepth() const { return has_depth_; }
  bool depth() const {
    DCHECK(has_depth_);
    return depth_;
  }
  inline void setDepth(bool);

  bool hasFailIfMajorPerformanceCaveat() const { return has_fail_if_major_performance_caveat_; }
  bool failIfMajorPerformanceCaveat() const {
    DCHECK(has_fail_if_major_performance_caveat_);
    return fail_if_major_performance_caveat_;
  }
  inline void setFailIfMajorPerformanceCaveat(bool);

  bool hasLowLatency() const { return has_low_latency_; }
  bool lowLatency() const {
    DCHECK(has_low_latency_);
    return low_latency_;
  }
  inline void setLowLatency(bool);

  bool hasPixelFormat() const { return !pixel_format_.IsNull(); }
  const String& pixelFormat() const {
    return pixel_format_;
  }
  inline void setPixelFormat(const String&);

  bool hasPremultipliedAlpha() const { return has_premultiplied_alpha_; }
  bool premultipliedAlpha() const {
    DCHECK(has_premultiplied_alpha_);
    return premultiplied_alpha_;
  }
  inline void setPremultipliedAlpha(bool);

  bool hasPreserveDrawingBuffer() const { return has_preserve_drawing_buffer_; }
  bool preserveDrawingBuffer() const {
    DCHECK(has_preserve_drawing_buffer_);
    return preserve_drawing_buffer_;
  }
  inline void setPreserveDrawingBuffer(bool);

  bool hasStencil() const { return has_stencil_; }
  bool stencil() const {
    DCHECK(has_stencil_);
    return stencil_;
  }
  inline void setStencil(bool);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_alpha_ = false;
  bool has_antialias_ = false;
  bool has_depth_ = false;
  bool has_fail_if_major_performance_caveat_ = false;
  bool has_low_latency_ = false;
  bool has_premultiplied_alpha_ = false;
  bool has_preserve_drawing_buffer_ = false;
  bool has_stencil_ = false;

  bool alpha_;
  bool antialias_;
  String color_space_;
  bool depth_;
  bool fail_if_major_performance_caveat_;
  bool low_latency_;
  String pixel_format_;
  bool premultiplied_alpha_;
  bool preserve_drawing_buffer_;
  bool stencil_;

  friend class V8CanvasContextCreationAttributes;
};

void CanvasContextCreationAttributes::setAlpha(bool value) {
  alpha_ = value;
  has_alpha_ = true;
}

void CanvasContextCreationAttributes::setAntialias(bool value) {
  antialias_ = value;
  has_antialias_ = true;
}

void CanvasContextCreationAttributes::setColorSpace(const String& value) {
  color_space_ = value;
}

void CanvasContextCreationAttributes::setDepth(bool value) {
  depth_ = value;
  has_depth_ = true;
}

void CanvasContextCreationAttributes::setFailIfMajorPerformanceCaveat(bool value) {
  fail_if_major_performance_caveat_ = value;
  has_fail_if_major_performance_caveat_ = true;
}

void CanvasContextCreationAttributes::setLowLatency(bool value) {
  low_latency_ = value;
  has_low_latency_ = true;
}

void CanvasContextCreationAttributes::setPixelFormat(const String& value) {
  pixel_format_ = value;
}

void CanvasContextCreationAttributes::setPremultipliedAlpha(bool value) {
  premultiplied_alpha_ = value;
  has_premultiplied_alpha_ = true;
}

void CanvasContextCreationAttributes::setPreserveDrawingBuffer(bool value) {
  preserve_drawing_buffer_ = value;
  has_preserve_drawing_buffer_ = true;
}

void CanvasContextCreationAttributes::setStencil(bool value) {
  stencil_ = value;
  has_stencil_ = true;
}

}  // namespace blink

#endif  // CanvasContextCreationAttributes_h
