// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/element_factory.cc.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/html/HTMLAttributeNames.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/html/HTMLTagNames.json5


#include "core/html_element_factory.h"

#include "core/html_names.h"
#include "core/html/HTMLAnchorElement.h"
#include "core/html/HTMLAreaElement.h"
#include "core/html/HTMLBDIElement.h"
#include "core/html/HTMLBRElement.h"
#include "core/html/HTMLBaseElement.h"
#include "core/html/HTMLBodyElement.h"
#include "core/html/HTMLContentElement.h"
#include "core/html/HTMLDListElement.h"
#include "core/html/HTMLDataElement.h"
#include "core/html/HTMLDetailsElement.h"
#include "core/html/HTMLDialogElement.h"
#include "core/html/HTMLDirectoryElement.h"
#include "core/html/HTMLDivElement.h"
#include "core/html/HTMLElement.h"
#include "core/html/HTMLEmbedElement.h"
#include "core/html/HTMLFontElement.h"
#include "core/html/HTMLFrameElement.h"
#include "core/html/HTMLFrameSetElement.h"
#include "core/html/HTMLHRElement.h"
#include "core/html/HTMLHeadElement.h"
#include "core/html/HTMLHeadingElement.h"
#include "core/html/HTMLHtmlElement.h"
#include "core/html/HTMLIFrameElement.h"
#include "core/html/HTMLImageElement.h"
#include "core/html/HTMLLIElement.h"
#include "core/html/HTMLLinkElement.h"
#include "core/html/HTMLMapElement.h"
#include "core/html/HTMLMarqueeElement.h"
#include "core/html/HTMLMenuElement.h"
#include "core/html/HTMLMetaElement.h"
#include "core/html/HTMLMeterElement.h"
#include "core/html/HTMLModElement.h"
#include "core/html/HTMLNoEmbedElement.h"
#include "core/html/HTMLNoScriptElement.h"
#include "core/html/HTMLOListElement.h"
#include "core/html/HTMLObjectElement.h"
#include "core/html/HTMLParagraphElement.h"
#include "core/html/HTMLParamElement.h"
#include "core/html/HTMLPictureElement.h"
#include "core/html/HTMLPreElement.h"
#include "core/html/HTMLProgressElement.h"
#include "core/html/HTMLQuoteElement.h"
#include "core/html/HTMLRTElement.h"
#include "core/html/HTMLRubyElement.h"
#include "core/html/HTMLScriptElement.h"
#include "core/html/HTMLShadowElement.h"
#include "core/html/HTMLSlotElement.h"
#include "core/html/HTMLSourceElement.h"
#include "core/html/HTMLSpanElement.h"
#include "core/html/HTMLStyleElement.h"
#include "core/html/HTMLSummaryElement.h"
#include "core/html/HTMLTableCaptionElement.h"
#include "core/html/HTMLTableCellElement.h"
#include "core/html/HTMLTableColElement.h"
#include "core/html/HTMLTableElement.h"
#include "core/html/HTMLTableRowElement.h"
#include "core/html/HTMLTableSectionElement.h"
#include "core/html/HTMLTemplateElement.h"
#include "core/html/HTMLTimeElement.h"
#include "core/html/HTMLTitleElement.h"
#include "core/html/HTMLUListElement.h"
#include "core/html/HTMLUnknownElement.h"
#include "core/html/HTMLWBRElement.h"
#include "core/html/canvas/HTMLCanvasElement.h"
#include "core/html/forms/HTMLButtonElement.h"
#include "core/html/forms/HTMLDataListElement.h"
#include "core/html/forms/HTMLFieldSetElement.h"
#include "core/html/forms/HTMLFormElement.h"
#include "core/html/forms/HTMLInputElement.h"
#include "core/html/forms/HTMLLabelElement.h"
#include "core/html/forms/HTMLLegendElement.h"
#include "core/html/forms/HTMLOptGroupElement.h"
#include "core/html/forms/HTMLOptionElement.h"
#include "core/html/forms/HTMLOutputElement.h"
#include "core/html/forms/HTMLSelectElement.h"
#include "core/html/forms/HTMLTextAreaElement.h"
#include "core/html/media/HTMLAudioElement.h"
#include "core/html/media/HTMLVideoElement.h"
#include "core/html/track/HTMLTrackElement.h"
#include "core/html/HTMLUnknownElement.h"
#include "core/html/custom/CustomElement.h"
#include "core/html/custom/V0CustomElement.h"
#include "core/html/custom/V0CustomElementRegistrationContext.h"
#include "core/dom/Document.h"
#include "core/frame/Settings.h"
#include "platform/runtime_enabled_features.h"
#include "platform/wtf/HashMap.h"

namespace blink {

typedef HTMLElement* (*HTMLConstructorFunction)(
    Document&,
    CreateElementFlags);

typedef HashMap<AtomicString, HTMLConstructorFunction> HTMLFunctionMap;

static HTMLFunctionMap* g_HTML_constructors = 0;

static HTMLElement* HTMLabbrConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::abbrTag, document);
}
static HTMLElement* HTMLacronymConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::acronymTag, document);
}
static HTMLElement* HTMLaddressConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::addressTag, document);
}
static HTMLElement* HTMLarticleConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::articleTag, document);
}
static HTMLElement* HTMLasideConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::asideTag, document);
}
static HTMLElement* HTMLbConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::bTag, document);
}
static HTMLElement* HTMLbasefontConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::basefontTag, document);
}
static HTMLElement* HTMLbdoConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::bdoTag, document);
}
static HTMLElement* HTMLbigConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::bigTag, document);
}
static HTMLElement* HTMLcenterConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::centerTag, document);
}
static HTMLElement* HTMLciteConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::citeTag, document);
}
static HTMLElement* HTMLcodeConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::codeTag, document);
}
static HTMLElement* HTMLddConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::ddTag, document);
}
static HTMLElement* HTMLdfnConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::dfnTag, document);
}
static HTMLElement* HTMLdtConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::dtTag, document);
}
static HTMLElement* HTMLemConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::emTag, document);
}
static HTMLElement* HTMLfigcaptionConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::figcaptionTag, document);
}
static HTMLElement* HTMLfigureConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::figureTag, document);
}
static HTMLElement* HTMLfooterConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::footerTag, document);
}
static HTMLElement* HTMLheaderConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::headerTag, document);
}
static HTMLElement* HTMLhgroupConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::hgroupTag, document);
}
static HTMLElement* HTMLiConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::iTag, document);
}
static HTMLElement* HTMLkbdConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::kbdTag, document);
}
static HTMLElement* HTMLlayerConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::layerTag, document);
}
static HTMLElement* HTMLmainConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::mainTag, document);
}
static HTMLElement* HTMLmarkConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::markTag, document);
}
static HTMLElement* HTMLnavConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::navTag, document);
}
static HTMLElement* HTMLnobrConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::nobrTag, document);
}
static HTMLElement* HTMLnoframesConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::noframesTag, document);
}
static HTMLElement* HTMLnolayerConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::nolayerTag, document);
}
static HTMLElement* HTMLplaintextConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::plaintextTag, document);
}
static HTMLElement* HTMLrbConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::rbTag, document);
}
static HTMLElement* HTMLrpConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::rpTag, document);
}
static HTMLElement* HTMLrtcConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::rtcTag, document);
}
static HTMLElement* HTMLsConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::sTag, document);
}
static HTMLElement* HTMLsampConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::sampTag, document);
}
static HTMLElement* HTMLsectionConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::sectionTag, document);
}
static HTMLElement* HTMLsmallConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::smallTag, document);
}
static HTMLElement* HTMLstrikeConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::strikeTag, document);
}
static HTMLElement* HTMLstrongConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::strongTag, document);
}
static HTMLElement* HTMLsubConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::subTag, document);
}
static HTMLElement* HTMLsupConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::supTag, document);
}
static HTMLElement* HTMLttConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::ttTag, document);
}
static HTMLElement* HTMLuConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::uTag, document);
}
static HTMLElement* HTMLvarConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLElement::Create(HTMLNames::varTag, document);
}
static HTMLElement* HTMLaConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLAnchorElement::Create(document);
}
static HTMLElement* HTMLareaConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLAreaElement::Create(document);
}
static HTMLElement* HTMLaudioConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLAudioElement::Create(document);
}
static HTMLElement* HTMLbrConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLBRElement::Create(document);
}
static HTMLElement* HTMLbaseConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLBaseElement::Create(document);
}
static HTMLElement* HTMLbodyConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLBodyElement::Create(document);
}
static HTMLElement* HTMLbuttonConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLButtonElement::Create(document);
}
static HTMLElement* HTMLcanvasConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLCanvasElement::Create(document);
}
static HTMLElement* HTMLcontentConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLContentElement::Create(document);
}
static HTMLElement* HTMLdlConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLDListElement::Create(document);
}
static HTMLElement* HTMLdataConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLDataElement::Create(document);
}
static HTMLElement* HTMLdatalistConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLDataListElement::Create(document);
}
static HTMLElement* HTMLdetailsConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLDetailsElement::Create(document);
}
static HTMLElement* HTMLdialogConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLDialogElement::Create(document);
}
static HTMLElement* HTMLdirConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLDirectoryElement::Create(document);
}
static HTMLElement* HTMLdivConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLDivElement::Create(document);
}
static HTMLElement* HTMLfieldsetConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLFieldSetElement::Create(document);
}
static HTMLElement* HTMLfontConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLFontElement::Create(document);
}
static HTMLElement* HTMLformConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLFormElement::Create(document);
}
static HTMLElement* HTMLframeConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLFrameElement::Create(document);
}
static HTMLElement* HTMLframesetConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLFrameSetElement::Create(document);
}
static HTMLElement* HTMLhrConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLHRElement::Create(document);
}
static HTMLElement* HTMLheadConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLHeadElement::Create(document);
}
static HTMLElement* HTMLh1Constructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLHeadingElement::Create(HTMLNames::h1Tag, document);
}
static HTMLElement* HTMLh2Constructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLHeadingElement::Create(HTMLNames::h2Tag, document);
}
static HTMLElement* HTMLh3Constructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLHeadingElement::Create(HTMLNames::h3Tag, document);
}
static HTMLElement* HTMLh4Constructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLHeadingElement::Create(HTMLNames::h4Tag, document);
}
static HTMLElement* HTMLh5Constructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLHeadingElement::Create(HTMLNames::h5Tag, document);
}
static HTMLElement* HTMLh6Constructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLHeadingElement::Create(HTMLNames::h6Tag, document);
}
static HTMLElement* HTMLhtmlConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLHtmlElement::Create(document);
}
static HTMLElement* HTMLiframeConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLIFrameElement::Create(document);
}
static HTMLElement* HTMLliConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLLIElement::Create(document);
}
static HTMLElement* HTMLlabelConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLLabelElement::Create(document);
}
static HTMLElement* HTMLlegendConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLLegendElement::Create(document);
}
static HTMLElement* HTMLmapConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLMapElement::Create(document);
}
static HTMLElement* HTMLmarqueeConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLMarqueeElement::Create(document);
}
static HTMLElement* HTMLmenuConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLMenuElement::Create(document);
}
static HTMLElement* HTMLmetaConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLMetaElement::Create(document);
}
static HTMLElement* HTMLmeterConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLMeterElement::Create(document);
}
static HTMLElement* HTMLdelConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLModElement::Create(HTMLNames::delTag, document);
}
static HTMLElement* HTMLinsConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLModElement::Create(HTMLNames::insTag, document);
}
static HTMLElement* HTMLolConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLOListElement::Create(document);
}
static HTMLElement* HTMLoptgroupConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLOptGroupElement::Create(document);
}
static HTMLElement* HTMLoptionConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLOptionElement::Create(document);
}
static HTMLElement* HTMLoutputConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLOutputElement::Create(document);
}
static HTMLElement* HTMLpConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLParagraphElement::Create(document);
}
static HTMLElement* HTMLparamConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLParamElement::Create(document);
}
static HTMLElement* HTMLpictureConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLPictureElement::Create(document);
}
static HTMLElement* HTMLpreConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLPreElement::Create(HTMLNames::preTag, document);
}
static HTMLElement* HTMLlistingConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLPreElement::Create(HTMLNames::listingTag, document);
}
static HTMLElement* HTMLxmpConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLPreElement::Create(HTMLNames::xmpTag, document);
}
static HTMLElement* HTMLprogressConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLProgressElement::Create(document);
}
static HTMLElement* HTMLblockquoteConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLQuoteElement::Create(HTMLNames::blockquoteTag, document);
}
static HTMLElement* HTMLqConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLQuoteElement::Create(HTMLNames::qTag, document);
}
static HTMLElement* HTMLselectConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLSelectElement::Create(document);
}
static HTMLElement* HTMLshadowConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLShadowElement::Create(document);
}
static HTMLElement* HTMLslotConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLSlotElement::Create(document);
}
static HTMLElement* HTMLsourceConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLSourceElement::Create(document);
}
static HTMLElement* HTMLspanConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLSpanElement::Create(document);
}
static HTMLElement* HTMLcaptionConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableCaptionElement::Create(document);
}
static HTMLElement* HTMLtdConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableCellElement::Create(HTMLNames::tdTag, document);
}
static HTMLElement* HTMLthConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableCellElement::Create(HTMLNames::thTag, document);
}
static HTMLElement* HTMLcolConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableColElement::Create(HTMLNames::colTag, document);
}
static HTMLElement* HTMLcolgroupConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableColElement::Create(HTMLNames::colgroupTag, document);
}
static HTMLElement* HTMLtableConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableElement::Create(document);
}
static HTMLElement* HTMLtrConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableRowElement::Create(document);
}
static HTMLElement* HTMLtbodyConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableSectionElement::Create(HTMLNames::tbodyTag, document);
}
static HTMLElement* HTMLtfootConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableSectionElement::Create(HTMLNames::tfootTag, document);
}
static HTMLElement* HTMLtheadConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTableSectionElement::Create(HTMLNames::theadTag, document);
}
static HTMLElement* HTMLtemplateConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTemplateElement::Create(document);
}
static HTMLElement* HTMLtextareaConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTextAreaElement::Create(document);
}
static HTMLElement* HTMLtimeConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTimeElement::Create(document);
}
static HTMLElement* HTMLtitleConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTitleElement::Create(document);
}
static HTMLElement* HTMLtrackConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLTrackElement::Create(document);
}
static HTMLElement* HTMLulConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLUListElement::Create(document);
}
static HTMLElement* HTMLappletConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLUnknownElement::Create(HTMLNames::appletTag, document);
}
static HTMLElement* HTMLbgsoundConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLUnknownElement::Create(HTMLNames::bgsoundTag, document);
}
static HTMLElement* HTMLcommandConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLUnknownElement::Create(HTMLNames::commandTag, document);
}
static HTMLElement* HTMLimageConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLUnknownElement::Create(HTMLNames::imageTag, document);
}
static HTMLElement* HTMLkeygenConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLUnknownElement::Create(HTMLNames::keygenTag, document);
}
static HTMLElement* HTMLvideoConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLVideoElement::Create(document);
}
static HTMLElement* HTMLembedConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLEmbedElement::Create(document, flags & kCreatedByParser);
}
static HTMLElement* HTMLimgConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLImageElement::Create(document, flags & kCreatedByParser);
}
static HTMLElement* HTMLinputConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLInputElement::Create(document, flags & kCreatedByParser);
}
static HTMLElement* HTMLlinkConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLLinkElement::Create(document, flags & kCreatedByParser);
}
static HTMLElement* HTMLobjectConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLObjectElement::Create(document, flags & kCreatedByParser);
}
static HTMLElement* HTMLscriptConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLScriptElement::Create(document, flags & kCreatedByParser);
}
static HTMLElement* HTMLstyleConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLStyleElement::Create(document, flags & kCreatedByParser);
}
static HTMLElement* HTMLbdiConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLBDIElement::Create(document);
}
static HTMLElement* HTMLnoembedConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLNoEmbedElement::Create(document);
}
static HTMLElement* HTMLnoscriptConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLNoScriptElement::Create(document);
}
static HTMLElement* HTMLrtConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLRTElement::Create(document);
}
static HTMLElement* HTMLrubyConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLRubyElement::Create(document);
}
static HTMLElement* HTMLsummaryConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLSummaryElement::Create(document);
}
static HTMLElement* HTMLwbrConstructor(
    Document& document,
    CreateElementFlags flags) {
  return HTMLWBRElement::Create(document);
}

struct CreateHTMLFunctionMapData {
  const QualifiedName& tag;
  HTMLConstructorFunction func;
};

static void createHTMLFunctionMap() {
  DCHECK(!g_HTML_constructors);
  g_HTML_constructors = new HTMLFunctionMap;
  // Empty array initializer lists are illegal [dcl.init.aggr] and will not
  // compile in MSVC. If tags list is empty, add check to skip this.
  static const CreateHTMLFunctionMapData data[] = {
    { HTMLNames::abbrTag, HTMLabbrConstructor },
    { HTMLNames::acronymTag, HTMLacronymConstructor },
    { HTMLNames::addressTag, HTMLaddressConstructor },
    { HTMLNames::articleTag, HTMLarticleConstructor },
    { HTMLNames::asideTag, HTMLasideConstructor },
    { HTMLNames::bTag, HTMLbConstructor },
    { HTMLNames::basefontTag, HTMLbasefontConstructor },
    { HTMLNames::bdoTag, HTMLbdoConstructor },
    { HTMLNames::bigTag, HTMLbigConstructor },
    { HTMLNames::centerTag, HTMLcenterConstructor },
    { HTMLNames::citeTag, HTMLciteConstructor },
    { HTMLNames::codeTag, HTMLcodeConstructor },
    { HTMLNames::ddTag, HTMLddConstructor },
    { HTMLNames::dfnTag, HTMLdfnConstructor },
    { HTMLNames::dtTag, HTMLdtConstructor },
    { HTMLNames::emTag, HTMLemConstructor },
    { HTMLNames::figcaptionTag, HTMLfigcaptionConstructor },
    { HTMLNames::figureTag, HTMLfigureConstructor },
    { HTMLNames::footerTag, HTMLfooterConstructor },
    { HTMLNames::headerTag, HTMLheaderConstructor },
    { HTMLNames::hgroupTag, HTMLhgroupConstructor },
    { HTMLNames::iTag, HTMLiConstructor },
    { HTMLNames::kbdTag, HTMLkbdConstructor },
    { HTMLNames::layerTag, HTMLlayerConstructor },
    { HTMLNames::mainTag, HTMLmainConstructor },
    { HTMLNames::markTag, HTMLmarkConstructor },
    { HTMLNames::navTag, HTMLnavConstructor },
    { HTMLNames::nobrTag, HTMLnobrConstructor },
    { HTMLNames::noframesTag, HTMLnoframesConstructor },
    { HTMLNames::nolayerTag, HTMLnolayerConstructor },
    { HTMLNames::plaintextTag, HTMLplaintextConstructor },
    { HTMLNames::rbTag, HTMLrbConstructor },
    { HTMLNames::rpTag, HTMLrpConstructor },
    { HTMLNames::rtcTag, HTMLrtcConstructor },
    { HTMLNames::sTag, HTMLsConstructor },
    { HTMLNames::sampTag, HTMLsampConstructor },
    { HTMLNames::sectionTag, HTMLsectionConstructor },
    { HTMLNames::smallTag, HTMLsmallConstructor },
    { HTMLNames::strikeTag, HTMLstrikeConstructor },
    { HTMLNames::strongTag, HTMLstrongConstructor },
    { HTMLNames::subTag, HTMLsubConstructor },
    { HTMLNames::supTag, HTMLsupConstructor },
    { HTMLNames::ttTag, HTMLttConstructor },
    { HTMLNames::uTag, HTMLuConstructor },
    { HTMLNames::varTag, HTMLvarConstructor },
    { HTMLNames::aTag, HTMLaConstructor },
    { HTMLNames::areaTag, HTMLareaConstructor },
    { HTMLNames::audioTag, HTMLaudioConstructor },
    { HTMLNames::brTag, HTMLbrConstructor },
    { HTMLNames::baseTag, HTMLbaseConstructor },
    { HTMLNames::bodyTag, HTMLbodyConstructor },
    { HTMLNames::buttonTag, HTMLbuttonConstructor },
    { HTMLNames::canvasTag, HTMLcanvasConstructor },
    { HTMLNames::contentTag, HTMLcontentConstructor },
    { HTMLNames::dlTag, HTMLdlConstructor },
    { HTMLNames::dataTag, HTMLdataConstructor },
    { HTMLNames::datalistTag, HTMLdatalistConstructor },
    { HTMLNames::detailsTag, HTMLdetailsConstructor },
    { HTMLNames::dialogTag, HTMLdialogConstructor },
    { HTMLNames::dirTag, HTMLdirConstructor },
    { HTMLNames::divTag, HTMLdivConstructor },
    { HTMLNames::fieldsetTag, HTMLfieldsetConstructor },
    { HTMLNames::fontTag, HTMLfontConstructor },
    { HTMLNames::formTag, HTMLformConstructor },
    { HTMLNames::frameTag, HTMLframeConstructor },
    { HTMLNames::framesetTag, HTMLframesetConstructor },
    { HTMLNames::hrTag, HTMLhrConstructor },
    { HTMLNames::headTag, HTMLheadConstructor },
    { HTMLNames::h1Tag, HTMLh1Constructor },
    { HTMLNames::h2Tag, HTMLh2Constructor },
    { HTMLNames::h3Tag, HTMLh3Constructor },
    { HTMLNames::h4Tag, HTMLh4Constructor },
    { HTMLNames::h5Tag, HTMLh5Constructor },
    { HTMLNames::h6Tag, HTMLh6Constructor },
    { HTMLNames::htmlTag, HTMLhtmlConstructor },
    { HTMLNames::iframeTag, HTMLiframeConstructor },
    { HTMLNames::liTag, HTMLliConstructor },
    { HTMLNames::labelTag, HTMLlabelConstructor },
    { HTMLNames::legendTag, HTMLlegendConstructor },
    { HTMLNames::mapTag, HTMLmapConstructor },
    { HTMLNames::marqueeTag, HTMLmarqueeConstructor },
    { HTMLNames::menuTag, HTMLmenuConstructor },
    { HTMLNames::metaTag, HTMLmetaConstructor },
    { HTMLNames::meterTag, HTMLmeterConstructor },
    { HTMLNames::delTag, HTMLdelConstructor },
    { HTMLNames::insTag, HTMLinsConstructor },
    { HTMLNames::olTag, HTMLolConstructor },
    { HTMLNames::optgroupTag, HTMLoptgroupConstructor },
    { HTMLNames::optionTag, HTMLoptionConstructor },
    { HTMLNames::outputTag, HTMLoutputConstructor },
    { HTMLNames::pTag, HTMLpConstructor },
    { HTMLNames::paramTag, HTMLparamConstructor },
    { HTMLNames::pictureTag, HTMLpictureConstructor },
    { HTMLNames::preTag, HTMLpreConstructor },
    { HTMLNames::listingTag, HTMLlistingConstructor },
    { HTMLNames::xmpTag, HTMLxmpConstructor },
    { HTMLNames::progressTag, HTMLprogressConstructor },
    { HTMLNames::blockquoteTag, HTMLblockquoteConstructor },
    { HTMLNames::qTag, HTMLqConstructor },
    { HTMLNames::selectTag, HTMLselectConstructor },
    { HTMLNames::shadowTag, HTMLshadowConstructor },
    { HTMLNames::slotTag, HTMLslotConstructor },
    { HTMLNames::sourceTag, HTMLsourceConstructor },
    { HTMLNames::spanTag, HTMLspanConstructor },
    { HTMLNames::captionTag, HTMLcaptionConstructor },
    { HTMLNames::tdTag, HTMLtdConstructor },
    { HTMLNames::thTag, HTMLthConstructor },
    { HTMLNames::colTag, HTMLcolConstructor },
    { HTMLNames::colgroupTag, HTMLcolgroupConstructor },
    { HTMLNames::tableTag, HTMLtableConstructor },
    { HTMLNames::trTag, HTMLtrConstructor },
    { HTMLNames::tbodyTag, HTMLtbodyConstructor },
    { HTMLNames::tfootTag, HTMLtfootConstructor },
    { HTMLNames::theadTag, HTMLtheadConstructor },
    { HTMLNames::templateTag, HTMLtemplateConstructor },
    { HTMLNames::textareaTag, HTMLtextareaConstructor },
    { HTMLNames::timeTag, HTMLtimeConstructor },
    { HTMLNames::titleTag, HTMLtitleConstructor },
    { HTMLNames::trackTag, HTMLtrackConstructor },
    { HTMLNames::ulTag, HTMLulConstructor },
    { HTMLNames::appletTag, HTMLappletConstructor },
    { HTMLNames::bgsoundTag, HTMLbgsoundConstructor },
    { HTMLNames::commandTag, HTMLcommandConstructor },
    { HTMLNames::imageTag, HTMLimageConstructor },
    { HTMLNames::keygenTag, HTMLkeygenConstructor },
    { HTMLNames::videoTag, HTMLvideoConstructor },
    { HTMLNames::embedTag, HTMLembedConstructor },
    { HTMLNames::imgTag, HTMLimgConstructor },
    { HTMLNames::inputTag, HTMLinputConstructor },
    { HTMLNames::linkTag, HTMLlinkConstructor },
    { HTMLNames::objectTag, HTMLobjectConstructor },
    { HTMLNames::scriptTag, HTMLscriptConstructor },
    { HTMLNames::styleTag, HTMLstyleConstructor },
    { HTMLNames::bdiTag, HTMLbdiConstructor },
    { HTMLNames::noembedTag, HTMLnoembedConstructor },
    { HTMLNames::noscriptTag, HTMLnoscriptConstructor },
    { HTMLNames::rtTag, HTMLrtConstructor },
    { HTMLNames::rubyTag, HTMLrubyConstructor },
    { HTMLNames::summaryTag, HTMLsummaryConstructor },
    { HTMLNames::wbrTag, HTMLwbrConstructor },
  };
  for (size_t i = 0; i < WTF_ARRAY_LENGTH(data); i++)
    g_HTML_constructors->Set(data[i].tag.LocalName(), data[i].func);
}

HTMLElement* HTMLElementFactory::createHTMLElement(
    const AtomicString& localName,
    Document& document,
    CreateElementFlags flags) {
  if (!g_HTML_constructors)
    createHTMLFunctionMap();
  if (HTMLConstructorFunction function = g_HTML_constructors->at(localName))
    return function(document, flags);

  // createElement handles custom element creation itself in order to
  // transmit exceptions.
  // TODO(dominicc): When the HTML parser can pass an error
  // reporting ExceptionState, and "v0" custom elements have been
  // removed, consolidate custom element creation into one place.
  if (flags != kCreatedByCreateElement && CustomElement::ShouldCreateCustomElement(localName)) {
    QualifiedName tagName(g_null_atom, localName, HTMLNames::xhtmlNamespaceURI);
    if (flags & kAsynchronousCustomElements)
      return CustomElement::CreateCustomElementAsync(document, tagName);
    return CustomElement::CreateCustomElementSync(document, tagName);
  }

  if (document.RegistrationContext() &&
      V0CustomElement::IsValidName(localName)) {
    Element* element = document.RegistrationContext()->CreateCustomTagElement(
        document, QualifiedName(g_null_atom, localName, HTMLNames::xhtmlNamespaceURI));
    SECURITY_DCHECK(element->IsHTMLElement());
    return ToHTMLElement(element);
  }

  return HTMLUnknownElement::Create(QualifiedName(g_null_atom, localName, HTMLNames::xhtmlNamespaceURI), document);
}

} // namespace blink
