// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef TouchInit_h
#define TouchInit_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class EventTarget;

class CORE_EXPORT TouchInit : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  TouchInit();
  virtual ~TouchInit();
  TouchInit(const TouchInit&);
  TouchInit& operator=(const TouchInit&);

  bool hasClientX() const { return has_clientx_; }
  double clientX() const {
    DCHECK(has_clientx_);
    return clientx_;
  }
  inline void setClientX(double);

  bool hasClientY() const { return has_clienty_; }
  double clientY() const {
    DCHECK(has_clienty_);
    return clienty_;
  }
  inline void setClientY(double);

  bool hasForce() const { return has_force_; }
  float force() const {
    DCHECK(has_force_);
    return force_;
  }
  inline void setForce(float);

  bool hasIdentifier() const { return has_identifier_; }
  int32_t identifier() const {
    DCHECK(has_identifier_);
    return identifier_;
  }
  inline void setIdentifier(int32_t);

  bool hasPageX() const { return has_pagex_; }
  double pageX() const {
    DCHECK(has_pagex_);
    return pagex_;
  }
  inline void setPageX(double);

  bool hasPageY() const { return has_pagey_; }
  double pageY() const {
    DCHECK(has_pagey_);
    return pagey_;
  }
  inline void setPageY(double);

  bool hasRadiusX() const { return has_radiusx_; }
  float radiusX() const {
    DCHECK(has_radiusx_);
    return radiusx_;
  }
  inline void setRadiusX(float);

  bool hasRadiusY() const { return has_radiusy_; }
  float radiusY() const {
    DCHECK(has_radiusy_);
    return radiusy_;
  }
  inline void setRadiusY(float);

  bool hasRegion() const { return !region_.IsNull(); }
  const String& region() const {
    return region_;
  }
  inline void setRegion(const String&);
  inline void setRegionToNull();

  bool hasRotationAngle() const { return has_rotation_angle_; }
  float rotationAngle() const {
    DCHECK(has_rotation_angle_);
    return rotation_angle_;
  }
  inline void setRotationAngle(float);

  bool hasScreenX() const { return has_screenx_; }
  double screenX() const {
    DCHECK(has_screenx_);
    return screenx_;
  }
  inline void setScreenX(double);

  bool hasScreenY() const { return has_screeny_; }
  double screenY() const {
    DCHECK(has_screeny_);
    return screeny_;
  }
  inline void setScreenY(double);

  bool hasTarget() const { return target_; }
  EventTarget* target() const {
    return target_;
  }
  inline void setTarget(EventTarget*);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_clientx_ = false;
  bool has_clienty_ = false;
  bool has_force_ = false;
  bool has_identifier_ = false;
  bool has_pagex_ = false;
  bool has_pagey_ = false;
  bool has_radiusx_ = false;
  bool has_radiusy_ = false;
  bool has_rotation_angle_ = false;
  bool has_screenx_ = false;
  bool has_screeny_ = false;

  double clientx_;
  double clienty_;
  float force_;
  int32_t identifier_;
  double pagex_;
  double pagey_;
  float radiusx_;
  float radiusy_;
  String region_;
  float rotation_angle_;
  double screenx_;
  double screeny_;
  Member<EventTarget> target_;

  friend class V8TouchInit;
};

void TouchInit::setClientX(double value) {
  clientx_ = value;
  has_clientx_ = true;
}

void TouchInit::setClientY(double value) {
  clienty_ = value;
  has_clienty_ = true;
}

void TouchInit::setForce(float value) {
  force_ = value;
  has_force_ = true;
}

void TouchInit::setIdentifier(int32_t value) {
  identifier_ = value;
  has_identifier_ = true;
}

void TouchInit::setPageX(double value) {
  pagex_ = value;
  has_pagex_ = true;
}

void TouchInit::setPageY(double value) {
  pagey_ = value;
  has_pagey_ = true;
}

void TouchInit::setRadiusX(float value) {
  radiusx_ = value;
  has_radiusx_ = true;
}

void TouchInit::setRadiusY(float value) {
  radiusy_ = value;
  has_radiusy_ = true;
}

void TouchInit::setRegion(const String& value) {
  region_ = value;
}
void TouchInit::setRegionToNull() {
  region_ = String();
}

void TouchInit::setRotationAngle(float value) {
  rotation_angle_ = value;
  has_rotation_angle_ = true;
}

void TouchInit::setScreenX(double value) {
  screenx_ = value;
  has_screenx_ = true;
}

void TouchInit::setScreenY(double value) {
  screeny_ = value;
  has_screeny_ = true;
}

void TouchInit::setTarget(EventTarget* value) {
  target_ = value;
}

}  // namespace blink

#endif  // TouchInit_h
