// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef IntersectionObserverInit_h
#define IntersectionObserverInit_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "bindings/core/v8/double_or_double_sequence.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/Vector.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class Element;

class CORE_EXPORT IntersectionObserverInit : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  IntersectionObserverInit();
  virtual ~IntersectionObserverInit();
  IntersectionObserverInit(const IntersectionObserverInit&);
  IntersectionObserverInit& operator=(const IntersectionObserverInit&);

  bool hasRoot() const { return root_; }
  Element* root() const {
    return root_;
  }
  inline void setRoot(Element*);
  inline void setRootToNull();

  bool hasRootMargin() const { return !root_margin_.IsNull(); }
  const String& rootMargin() const {
    return root_margin_;
  }
  inline void setRootMargin(const String&);

  bool hasThreshold() const { return !threshold_.IsNull(); }
  const DoubleOrDoubleSequence& threshold() const {
    return threshold_;
  }
  void setThreshold(const DoubleOrDoubleSequence&);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:

  Member<Element> root_;
  String root_margin_;
  DoubleOrDoubleSequence threshold_;

  friend class V8IntersectionObserverInit;
};

void IntersectionObserverInit::setRoot(Element* value) {
  root_ = value;
}
void IntersectionObserverInit::setRootToNull() {
  root_ = Member<Element>();
}

void IntersectionObserverInit::setRootMargin(const String& value) {
  root_margin_ = value;
}

}  // namespace blink

#endif  // IntersectionObserverInit_h
