// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef ScrollStateInit_h
#define ScrollStateInit_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "core/CoreExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class CORE_EXPORT ScrollStateInit : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  ScrollStateInit();
  virtual ~ScrollStateInit();
  ScrollStateInit(const ScrollStateInit&);
  ScrollStateInit& operator=(const ScrollStateInit&);

  bool hasDeltaGranularity() const { return has_delta_granularity_; }
  double deltaGranularity() const {
    DCHECK(has_delta_granularity_);
    return delta_granularity_;
  }
  inline void setDeltaGranularity(double);

  bool hasDeltaX() const { return has_deltax_; }
  double deltaX() const {
    DCHECK(has_deltax_);
    return deltax_;
  }
  inline void setDeltaX(double);

  bool hasDeltaXHint() const { return has_deltax_hint_; }
  double deltaXHint() const {
    DCHECK(has_deltax_hint_);
    return deltax_hint_;
  }
  inline void setDeltaXHint(double);

  bool hasDeltaY() const { return has_deltay_; }
  double deltaY() const {
    DCHECK(has_deltay_);
    return deltay_;
  }
  inline void setDeltaY(double);

  bool hasDeltaYHint() const { return has_deltay_hint_; }
  double deltaYHint() const {
    DCHECK(has_deltay_hint_);
    return deltay_hint_;
  }
  inline void setDeltaYHint(double);

  bool hasFromUserInput() const { return has_from_user_input_; }
  bool fromUserInput() const {
    DCHECK(has_from_user_input_);
    return from_user_input_;
  }
  inline void setFromUserInput(bool);

  bool hasIsBeginning() const { return has_is_beginning_; }
  bool isBeginning() const {
    DCHECK(has_is_beginning_);
    return is_beginning_;
  }
  inline void setIsBeginning(bool);

  bool hasIsDirectManipulation() const { return has_is_direct_manipulation_; }
  bool isDirectManipulation() const {
    DCHECK(has_is_direct_manipulation_);
    return is_direct_manipulation_;
  }
  inline void setIsDirectManipulation(bool);

  bool hasIsEnding() const { return has_is_ending_; }
  bool isEnding() const {
    DCHECK(has_is_ending_);
    return is_ending_;
  }
  inline void setIsEnding(bool);

  bool hasIsInInertialPhase() const { return has_is_in_inertial_phase_; }
  bool isInInertialPhase() const {
    DCHECK(has_is_in_inertial_phase_);
    return is_in_inertial_phase_;
  }
  inline void setIsInInertialPhase(bool);

  bool hasPositionX() const { return has_positionx_; }
  int32_t positionX() const {
    DCHECK(has_positionx_);
    return positionx_;
  }
  inline void setPositionX(int32_t);

  bool hasPositionY() const { return has_positiony_; }
  int32_t positionY() const {
    DCHECK(has_positiony_);
    return positiony_;
  }
  inline void setPositionY(int32_t);

  bool hasShouldPropagate() const { return has_should_propagate_; }
  bool shouldPropagate() const {
    DCHECK(has_should_propagate_);
    return should_propagate_;
  }
  inline void setShouldPropagate(bool);

  bool hasVelocityX() const { return has_velocityx_; }
  double velocityX() const {
    DCHECK(has_velocityx_);
    return velocityx_;
  }
  inline void setVelocityX(double);

  bool hasVelocityY() const { return has_velocityy_; }
  double velocityY() const {
    DCHECK(has_velocityy_);
    return velocityy_;
  }
  inline void setVelocityY(double);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_delta_granularity_ = false;
  bool has_deltax_ = false;
  bool has_deltax_hint_ = false;
  bool has_deltay_ = false;
  bool has_deltay_hint_ = false;
  bool has_from_user_input_ = false;
  bool has_is_beginning_ = false;
  bool has_is_direct_manipulation_ = false;
  bool has_is_ending_ = false;
  bool has_is_in_inertial_phase_ = false;
  bool has_positionx_ = false;
  bool has_positiony_ = false;
  bool has_should_propagate_ = false;
  bool has_velocityx_ = false;
  bool has_velocityy_ = false;

  double delta_granularity_;
  double deltax_;
  double deltax_hint_;
  double deltay_;
  double deltay_hint_;
  bool from_user_input_;
  bool is_beginning_;
  bool is_direct_manipulation_;
  bool is_ending_;
  bool is_in_inertial_phase_;
  int32_t positionx_;
  int32_t positiony_;
  bool should_propagate_;
  double velocityx_;
  double velocityy_;

  friend class V8ScrollStateInit;
};

void ScrollStateInit::setDeltaGranularity(double value) {
  delta_granularity_ = value;
  has_delta_granularity_ = true;
}

void ScrollStateInit::setDeltaX(double value) {
  deltax_ = value;
  has_deltax_ = true;
}

void ScrollStateInit::setDeltaXHint(double value) {
  deltax_hint_ = value;
  has_deltax_hint_ = true;
}

void ScrollStateInit::setDeltaY(double value) {
  deltay_ = value;
  has_deltay_ = true;
}

void ScrollStateInit::setDeltaYHint(double value) {
  deltay_hint_ = value;
  has_deltay_hint_ = true;
}

void ScrollStateInit::setFromUserInput(bool value) {
  from_user_input_ = value;
  has_from_user_input_ = true;
}

void ScrollStateInit::setIsBeginning(bool value) {
  is_beginning_ = value;
  has_is_beginning_ = true;
}

void ScrollStateInit::setIsDirectManipulation(bool value) {
  is_direct_manipulation_ = value;
  has_is_direct_manipulation_ = true;
}

void ScrollStateInit::setIsEnding(bool value) {
  is_ending_ = value;
  has_is_ending_ = true;
}

void ScrollStateInit::setIsInInertialPhase(bool value) {
  is_in_inertial_phase_ = value;
  has_is_in_inertial_phase_ = true;
}

void ScrollStateInit::setPositionX(int32_t value) {
  positionx_ = value;
  has_positionx_ = true;
}

void ScrollStateInit::setPositionY(int32_t value) {
  positiony_ = value;
  has_positiony_ = true;
}

void ScrollStateInit::setShouldPropagate(bool value) {
  should_propagate_ = value;
  has_should_propagate_ = true;
}

void ScrollStateInit::setVelocityX(double value) {
  velocityx_ = value;
  has_velocityx_ = true;
}

void ScrollStateInit::setVelocityY(double value) {
  velocityy_ = value;
  has_velocityy_ = true;
}

}  // namespace blink

#endif  // ScrollStateInit_h
