// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/element_factory.cc.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/svg/SVGAttributeNames.json5
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/svg/SVGTagNames.json5


#include "core/svg_element_factory.h"

#include "core/svg_names.h"
#include "core/svg/SVGAElement.h"
#include "core/svg/SVGAnimateElement.h"
#include "core/svg/SVGAnimateMotionElement.h"
#include "core/svg/SVGAnimateTransformElement.h"
#include "core/svg/SVGCircleElement.h"
#include "core/svg/SVGClipPathElement.h"
#include "core/svg/SVGDefsElement.h"
#include "core/svg/SVGDescElement.h"
#include "core/svg/SVGDiscardElement.h"
#include "core/svg/SVGEllipseElement.h"
#include "core/svg/SVGFEBlendElement.h"
#include "core/svg/SVGFEColorMatrixElement.h"
#include "core/svg/SVGFEComponentTransferElement.h"
#include "core/svg/SVGFECompositeElement.h"
#include "core/svg/SVGFEConvolveMatrixElement.h"
#include "core/svg/SVGFEDiffuseLightingElement.h"
#include "core/svg/SVGFEDisplacementMapElement.h"
#include "core/svg/SVGFEDistantLightElement.h"
#include "core/svg/SVGFEDropShadowElement.h"
#include "core/svg/SVGFEFloodElement.h"
#include "core/svg/SVGFEFuncAElement.h"
#include "core/svg/SVGFEFuncBElement.h"
#include "core/svg/SVGFEFuncGElement.h"
#include "core/svg/SVGFEFuncRElement.h"
#include "core/svg/SVGFEGaussianBlurElement.h"
#include "core/svg/SVGFEImageElement.h"
#include "core/svg/SVGFEMergeElement.h"
#include "core/svg/SVGFEMergeNodeElement.h"
#include "core/svg/SVGFEMorphologyElement.h"
#include "core/svg/SVGFEOffsetElement.h"
#include "core/svg/SVGFEPointLightElement.h"
#include "core/svg/SVGFESpecularLightingElement.h"
#include "core/svg/SVGFESpotLightElement.h"
#include "core/svg/SVGFETileElement.h"
#include "core/svg/SVGFETurbulenceElement.h"
#include "core/svg/SVGFilterElement.h"
#include "core/svg/SVGForeignObjectElement.h"
#include "core/svg/SVGGElement.h"
#include "core/svg/SVGImageElement.h"
#include "core/svg/SVGLineElement.h"
#include "core/svg/SVGLinearGradientElement.h"
#include "core/svg/SVGMPathElement.h"
#include "core/svg/SVGMarkerElement.h"
#include "core/svg/SVGMaskElement.h"
#include "core/svg/SVGMetadataElement.h"
#include "core/svg/SVGPathElement.h"
#include "core/svg/SVGPatternElement.h"
#include "core/svg/SVGPolygonElement.h"
#include "core/svg/SVGPolylineElement.h"
#include "core/svg/SVGRadialGradientElement.h"
#include "core/svg/SVGRectElement.h"
#include "core/svg/SVGSVGElement.h"
#include "core/svg/SVGScriptElement.h"
#include "core/svg/SVGSetElement.h"
#include "core/svg/SVGStopElement.h"
#include "core/svg/SVGStyleElement.h"
#include "core/svg/SVGSwitchElement.h"
#include "core/svg/SVGSymbolElement.h"
#include "core/svg/SVGTSpanElement.h"
#include "core/svg/SVGTextElement.h"
#include "core/svg/SVGTextPathElement.h"
#include "core/svg/SVGTitleElement.h"
#include "core/svg/SVGUnknownElement.h"
#include "core/svg/SVGUseElement.h"
#include "core/svg/SVGViewElement.h"
#include "core/svg/SVGUnknownElement.h"
#include "core/html/custom/V0CustomElement.h"
#include "core/html/custom/V0CustomElementRegistrationContext.h"
#include "core/dom/Document.h"
#include "core/frame/Settings.h"
#include "platform/runtime_enabled_features.h"
#include "platform/wtf/HashMap.h"

namespace blink {

typedef SVGElement* (*SVGConstructorFunction)(
    Document&,
    CreateElementFlags);

typedef HashMap<AtomicString, SVGConstructorFunction> SVGFunctionMap;

static SVGFunctionMap* g_SVG_constructors = 0;

static SVGElement* SVGaConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGAElement::Create(document);
}
static SVGElement* SVGanimateConstructor(
    Document& document,
    CreateElementFlags flags) {
  if (!RuntimeEnabledFeatures::SMILEnabled())
    return SVGUnknownElement::Create(SVGNames::animateTag, document);
  return SVGAnimateElement::Create(document);
}
static SVGElement* SVGanimateMotionConstructor(
    Document& document,
    CreateElementFlags flags) {
  if (!RuntimeEnabledFeatures::SMILEnabled())
    return SVGUnknownElement::Create(SVGNames::animateMotionTag, document);
  return SVGAnimateMotionElement::Create(document);
}
static SVGElement* SVGanimateTransformConstructor(
    Document& document,
    CreateElementFlags flags) {
  if (!RuntimeEnabledFeatures::SMILEnabled())
    return SVGUnknownElement::Create(SVGNames::animateTransformTag, document);
  return SVGAnimateTransformElement::Create(document);
}
static SVGElement* SVGcircleConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGCircleElement::Create(document);
}
static SVGElement* SVGclipPathConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGClipPathElement::Create(document);
}
static SVGElement* SVGdefsConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGDefsElement::Create(document);
}
static SVGElement* SVGdescConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGDescElement::Create(document);
}
static SVGElement* SVGdiscardConstructor(
    Document& document,
    CreateElementFlags flags) {
  if (!RuntimeEnabledFeatures::SMILEnabled())
    return SVGUnknownElement::Create(SVGNames::discardTag, document);
  return SVGDiscardElement::Create(document);
}
static SVGElement* SVGellipseConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGEllipseElement::Create(document);
}
static SVGElement* SVGfeBlendConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEBlendElement::Create(document);
}
static SVGElement* SVGfeColorMatrixConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEColorMatrixElement::Create(document);
}
static SVGElement* SVGfeComponentTransferConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEComponentTransferElement::Create(document);
}
static SVGElement* SVGfeCompositeConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFECompositeElement::Create(document);
}
static SVGElement* SVGfeConvolveMatrixConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEConvolveMatrixElement::Create(document);
}
static SVGElement* SVGfeDiffuseLightingConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEDiffuseLightingElement::Create(document);
}
static SVGElement* SVGfeDisplacementMapConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEDisplacementMapElement::Create(document);
}
static SVGElement* SVGfeDistantLightConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEDistantLightElement::Create(document);
}
static SVGElement* SVGfeDropShadowConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEDropShadowElement::Create(document);
}
static SVGElement* SVGfeFloodConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEFloodElement::Create(document);
}
static SVGElement* SVGfeFuncAConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEFuncAElement::Create(document);
}
static SVGElement* SVGfeFuncBConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEFuncBElement::Create(document);
}
static SVGElement* SVGfeFuncGConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEFuncGElement::Create(document);
}
static SVGElement* SVGfeFuncRConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEFuncRElement::Create(document);
}
static SVGElement* SVGfeGaussianBlurConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEGaussianBlurElement::Create(document);
}
static SVGElement* SVGfeImageConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEImageElement::Create(document);
}
static SVGElement* SVGfeMergeConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEMergeElement::Create(document);
}
static SVGElement* SVGfeMergeNodeConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEMergeNodeElement::Create(document);
}
static SVGElement* SVGfeMorphologyConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEMorphologyElement::Create(document);
}
static SVGElement* SVGfeOffsetConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEOffsetElement::Create(document);
}
static SVGElement* SVGfePointLightConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFEPointLightElement::Create(document);
}
static SVGElement* SVGfeSpecularLightingConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFESpecularLightingElement::Create(document);
}
static SVGElement* SVGfeSpotLightConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFESpotLightElement::Create(document);
}
static SVGElement* SVGfeTileConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFETileElement::Create(document);
}
static SVGElement* SVGfeTurbulenceConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFETurbulenceElement::Create(document);
}
static SVGElement* SVGfilterConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGFilterElement::Create(document);
}
static SVGElement* SVGforeignObjectConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGForeignObjectElement::Create(document);
}
static SVGElement* SVGgConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGGElement::Create(document);
}
static SVGElement* SVGimageConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGImageElement::Create(document);
}
static SVGElement* SVGlineConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGLineElement::Create(document);
}
static SVGElement* SVGlinearGradientConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGLinearGradientElement::Create(document);
}
static SVGElement* SVGmpathConstructor(
    Document& document,
    CreateElementFlags flags) {
  if (!RuntimeEnabledFeatures::SMILEnabled())
    return SVGUnknownElement::Create(SVGNames::mpathTag, document);
  return SVGMPathElement::Create(document);
}
static SVGElement* SVGmarkerConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGMarkerElement::Create(document);
}
static SVGElement* SVGmaskConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGMaskElement::Create(document);
}
static SVGElement* SVGmetadataConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGMetadataElement::Create(document);
}
static SVGElement* SVGpathConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGPathElement::Create(document);
}
static SVGElement* SVGpatternConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGPatternElement::Create(document);
}
static SVGElement* SVGpolygonConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGPolygonElement::Create(document);
}
static SVGElement* SVGpolylineConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGPolylineElement::Create(document);
}
static SVGElement* SVGradialGradientConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGRadialGradientElement::Create(document);
}
static SVGElement* SVGrectConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGRectElement::Create(document);
}
static SVGElement* SVGsvgConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGSVGElement::Create(document);
}
static SVGElement* SVGsetConstructor(
    Document& document,
    CreateElementFlags flags) {
  if (!RuntimeEnabledFeatures::SMILEnabled())
    return SVGUnknownElement::Create(SVGNames::setTag, document);
  return SVGSetElement::Create(document);
}
static SVGElement* SVGstopConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGStopElement::Create(document);
}
static SVGElement* SVGswitchConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGSwitchElement::Create(document);
}
static SVGElement* SVGsymbolConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGSymbolElement::Create(document);
}
static SVGElement* SVGtspanConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGTSpanElement::Create(document);
}
static SVGElement* SVGtextConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGTextElement::Create(document);
}
static SVGElement* SVGtextPathConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGTextPathElement::Create(document);
}
static SVGElement* SVGtitleConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGTitleElement::Create(document);
}
static SVGElement* SVGuseConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGUseElement::Create(document);
}
static SVGElement* SVGviewConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGViewElement::Create(document);
}
static SVGElement* SVGscriptConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGScriptElement::Create(document, flags & kCreatedByParser);
}
static SVGElement* SVGstyleConstructor(
    Document& document,
    CreateElementFlags flags) {
  return SVGStyleElement::Create(document, flags & kCreatedByParser);
}

struct CreateSVGFunctionMapData {
  const QualifiedName& tag;
  SVGConstructorFunction func;
};

static void createSVGFunctionMap() {
  DCHECK(!g_SVG_constructors);
  g_SVG_constructors = new SVGFunctionMap;
  // Empty array initializer lists are illegal [dcl.init.aggr] and will not
  // compile in MSVC. If tags list is empty, add check to skip this.
  static const CreateSVGFunctionMapData data[] = {
    { SVGNames::aTag, SVGaConstructor },
    { SVGNames::animateTag, SVGanimateConstructor },
    { SVGNames::animateMotionTag, SVGanimateMotionConstructor },
    { SVGNames::animateTransformTag, SVGanimateTransformConstructor },
    { SVGNames::circleTag, SVGcircleConstructor },
    { SVGNames::clipPathTag, SVGclipPathConstructor },
    { SVGNames::defsTag, SVGdefsConstructor },
    { SVGNames::descTag, SVGdescConstructor },
    { SVGNames::discardTag, SVGdiscardConstructor },
    { SVGNames::ellipseTag, SVGellipseConstructor },
    { SVGNames::feBlendTag, SVGfeBlendConstructor },
    { SVGNames::feColorMatrixTag, SVGfeColorMatrixConstructor },
    { SVGNames::feComponentTransferTag, SVGfeComponentTransferConstructor },
    { SVGNames::feCompositeTag, SVGfeCompositeConstructor },
    { SVGNames::feConvolveMatrixTag, SVGfeConvolveMatrixConstructor },
    { SVGNames::feDiffuseLightingTag, SVGfeDiffuseLightingConstructor },
    { SVGNames::feDisplacementMapTag, SVGfeDisplacementMapConstructor },
    { SVGNames::feDistantLightTag, SVGfeDistantLightConstructor },
    { SVGNames::feDropShadowTag, SVGfeDropShadowConstructor },
    { SVGNames::feFloodTag, SVGfeFloodConstructor },
    { SVGNames::feFuncATag, SVGfeFuncAConstructor },
    { SVGNames::feFuncBTag, SVGfeFuncBConstructor },
    { SVGNames::feFuncGTag, SVGfeFuncGConstructor },
    { SVGNames::feFuncRTag, SVGfeFuncRConstructor },
    { SVGNames::feGaussianBlurTag, SVGfeGaussianBlurConstructor },
    { SVGNames::feImageTag, SVGfeImageConstructor },
    { SVGNames::feMergeTag, SVGfeMergeConstructor },
    { SVGNames::feMergeNodeTag, SVGfeMergeNodeConstructor },
    { SVGNames::feMorphologyTag, SVGfeMorphologyConstructor },
    { SVGNames::feOffsetTag, SVGfeOffsetConstructor },
    { SVGNames::fePointLightTag, SVGfePointLightConstructor },
    { SVGNames::feSpecularLightingTag, SVGfeSpecularLightingConstructor },
    { SVGNames::feSpotLightTag, SVGfeSpotLightConstructor },
    { SVGNames::feTileTag, SVGfeTileConstructor },
    { SVGNames::feTurbulenceTag, SVGfeTurbulenceConstructor },
    { SVGNames::filterTag, SVGfilterConstructor },
    { SVGNames::foreignObjectTag, SVGforeignObjectConstructor },
    { SVGNames::gTag, SVGgConstructor },
    { SVGNames::imageTag, SVGimageConstructor },
    { SVGNames::lineTag, SVGlineConstructor },
    { SVGNames::linearGradientTag, SVGlinearGradientConstructor },
    { SVGNames::mpathTag, SVGmpathConstructor },
    { SVGNames::markerTag, SVGmarkerConstructor },
    { SVGNames::maskTag, SVGmaskConstructor },
    { SVGNames::metadataTag, SVGmetadataConstructor },
    { SVGNames::pathTag, SVGpathConstructor },
    { SVGNames::patternTag, SVGpatternConstructor },
    { SVGNames::polygonTag, SVGpolygonConstructor },
    { SVGNames::polylineTag, SVGpolylineConstructor },
    { SVGNames::radialGradientTag, SVGradialGradientConstructor },
    { SVGNames::rectTag, SVGrectConstructor },
    { SVGNames::svgTag, SVGsvgConstructor },
    { SVGNames::setTag, SVGsetConstructor },
    { SVGNames::stopTag, SVGstopConstructor },
    { SVGNames::switchTag, SVGswitchConstructor },
    { SVGNames::symbolTag, SVGsymbolConstructor },
    { SVGNames::tspanTag, SVGtspanConstructor },
    { SVGNames::textTag, SVGtextConstructor },
    { SVGNames::textPathTag, SVGtextPathConstructor },
    { SVGNames::titleTag, SVGtitleConstructor },
    { SVGNames::useTag, SVGuseConstructor },
    { SVGNames::viewTag, SVGviewConstructor },
    { SVGNames::scriptTag, SVGscriptConstructor },
    { SVGNames::styleTag, SVGstyleConstructor },
  };
  for (size_t i = 0; i < WTF_ARRAY_LENGTH(data); i++)
    g_SVG_constructors->Set(data[i].tag.LocalName(), data[i].func);
}

SVGElement* SVGElementFactory::createSVGElement(
    const AtomicString& localName,
    Document& document,
    CreateElementFlags flags) {
  if (!g_SVG_constructors)
    createSVGFunctionMap();
  if (SVGConstructorFunction function = g_SVG_constructors->at(localName))
    return function(document, flags);


  if (document.RegistrationContext() &&
      V0CustomElement::IsValidName(localName)) {
    Element* element = document.RegistrationContext()->CreateCustomTagElement(
        document, QualifiedName(g_null_atom, localName, SVGNames::svgNamespaceURI));
    SECURITY_DCHECK(element->IsSVGElement());
    return ToSVGElement(element);
  }

  return SVGUnknownElement::Create(QualifiedName(g_null_atom, localName, SVGNames::svgNamespaceURI), document);
}

} // namespace blink
