// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/make_qualified_names.cc.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/WebKit/Source/core/xml/xmlattrs.json5


#include "xml_names.h"

#include "platform/wtf/StaticConstructors.h"
#include "platform/wtf/StdLibExtras.h"
#include <memory>

namespace blink {
namespace XMLNames {

using namespace blink;

DEFINE_GLOBAL(AtomicString, xmlNamespaceURI);

// Attributes

void* AttrStorage[XMLAttrsCount * ((sizeof(QualifiedName) + sizeof(void *) - 1) / sizeof(void *))];

const QualifiedName& langAttr = reinterpret_cast<QualifiedName*>(&AttrStorage)[0];
const QualifiedName& spaceAttr = reinterpret_cast<QualifiedName*>(&AttrStorage)[1];

std::unique_ptr<const QualifiedName*[]> getXMLAttrs() {
  auto attrs = std::make_unique<const QualifiedName*[]>(XMLAttrsCount);
  for (size_t i = 0; i < XMLAttrsCount; i++)
    attrs[i] = reinterpret_cast<QualifiedName*>(&AttrStorage) + i;
  return attrs;
}


void init() {
  struct NameEntry {
    const char* name;
    unsigned hash;
    unsigned char length;
    unsigned char isTag;
    unsigned char isAttr;
  };

  // Use placement new to initialize the globals.
  AtomicString xmlNS("http://www.w3.org/XML/1998/namespace");

  // Namespace
  new ((void*)&xmlNamespaceURI) AtomicString(xmlNS);
  static const NameEntry kNames[] = {
    { "lang", 3702417, 4, 0, 1 },
    { "space", 531440, 5, 0, 1 },
  };

  size_t attr_i = 0;
  for (size_t i = 0; i < WTF_ARRAY_LENGTH(kNames); i++) {
    StringImpl* stringImpl = StringImpl::CreateStatic(kNames[i].name, kNames[i].length, kNames[i].hash);
    void* address = reinterpret_cast<QualifiedName*>(&AttrStorage) + attr_i;
    QualifiedName::CreateStatic(address, stringImpl, xmlNS);
    attr_i++;
  }
  DCHECK_EQ(attr_i, XMLAttrsCount);
}

} // XML
} // namespace blink
