// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef RequestDeviceOptions_h
#define RequestDeviceOptions_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "bindings/modules/v8/string_or_unsigned_long.h"
#include "modules/ModulesExport.h"
#include "modules/bluetooth/BluetoothLEScanFilterInit.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/Vector.h"

namespace blink {

class MODULES_EXPORT RequestDeviceOptions : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  RequestDeviceOptions();
  virtual ~RequestDeviceOptions();
  RequestDeviceOptions(const RequestDeviceOptions&);
  RequestDeviceOptions& operator=(const RequestDeviceOptions&);

  bool hasAcceptAllDevices() const { return has_accept_all_devices_; }
  bool acceptAllDevices() const {
    DCHECK(has_accept_all_devices_);
    return accept_all_devices_;
  }
  inline void setAcceptAllDevices(bool);

  bool hasFilters() const { return has_filters_; }
  const HeapVector<BluetoothLEScanFilterInit>& filters() const {
    DCHECK(has_filters_);
    return filters_;
  }
  void setFilters(const HeapVector<BluetoothLEScanFilterInit>&);

  bool hasOptionalServices() const { return has_optional_services_; }
  const HeapVector<StringOrUnsignedLong>& optionalServices() const {
    DCHECK(has_optional_services_);
    return optional_services_;
  }
  void setOptionalServices(const HeapVector<StringOrUnsignedLong>&);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_accept_all_devices_ = false;
  bool has_filters_ = false;
  bool has_optional_services_ = false;

  bool accept_all_devices_;
  HeapVector<BluetoothLEScanFilterInit> filters_;
  HeapVector<StringOrUnsignedLong> optional_services_;

  friend class V8RequestDeviceOptions;
};

void RequestDeviceOptions::setAcceptAllDevices(bool value) {
  accept_all_devices_ = value;
  has_accept_all_devices_ = true;
}

}  // namespace blink

#endif  // RequestDeviceOptions_h
