// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef MakePublicKeyCredentialOptions_h
#define MakePublicKeyCredentialOptions_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "bindings/core/v8/array_buffer_or_array_buffer_view.h"
#include "core/typed_arrays/ArrayBufferViewHelpers.h"
#include "core/typed_arrays/DOMArrayBuffer.h"
#include "core/typed_arrays/DOMTypedArray.h"
#include "modules/ModulesExport.h"
#include "modules/credentialmanager/AuthenticatorSelectionCriteria.h"
#include "modules/credentialmanager/PublicKeyCredentialDescriptor.h"
#include "modules/credentialmanager/PublicKeyCredentialParameters.h"
#include "modules/credentialmanager/PublicKeyCredentialRpEntity.h"
#include "modules/credentialmanager/PublicKeyCredentialUserEntity.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/Vector.h"

namespace blink {

class MODULES_EXPORT MakePublicKeyCredentialOptions : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  MakePublicKeyCredentialOptions();
  virtual ~MakePublicKeyCredentialOptions();
  MakePublicKeyCredentialOptions(const MakePublicKeyCredentialOptions&);
  MakePublicKeyCredentialOptions& operator=(const MakePublicKeyCredentialOptions&);

  bool hasAuthenticatorSelection() const { return has_authenticator_selection_; }
  const AuthenticatorSelectionCriteria& authenticatorSelection() const {
    DCHECK(has_authenticator_selection_);
    return authenticator_selection_;
  }
  void setAuthenticatorSelection(const AuthenticatorSelectionCriteria&);

  bool hasChallenge() const { return !challenge_.IsNull(); }
  const ArrayBufferOrArrayBufferView& challenge() const {
    return challenge_;
  }
  void setChallenge(const ArrayBufferOrArrayBufferView&);

  bool hasExcludeCredentials() const { return has_exclude_credentials_; }
  const HeapVector<PublicKeyCredentialDescriptor>& excludeCredentials() const {
    DCHECK(has_exclude_credentials_);
    return exclude_credentials_;
  }
  void setExcludeCredentials(const HeapVector<PublicKeyCredentialDescriptor>&);

  bool hasPubKeyCredParams() const { return has_pub_key_cred_params_; }
  const HeapVector<PublicKeyCredentialParameters>& pubKeyCredParams() const {
    DCHECK(has_pub_key_cred_params_);
    return pub_key_cred_params_;
  }
  void setPubKeyCredParams(const HeapVector<PublicKeyCredentialParameters>&);

  bool hasRp() const { return has_rp_; }
  const PublicKeyCredentialRpEntity& rp() const {
    DCHECK(has_rp_);
    return rp_;
  }
  void setRp(const PublicKeyCredentialRpEntity&);

  bool hasTimeout() const { return has_timeout_; }
  uint32_t timeout() const {
    DCHECK(has_timeout_);
    return timeout_;
  }
  inline void setTimeout(uint32_t);

  bool hasUser() const { return has_user_; }
  const PublicKeyCredentialUserEntity& user() const {
    DCHECK(has_user_);
    return user_;
  }
  void setUser(const PublicKeyCredentialUserEntity&);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_authenticator_selection_ = false;
  bool has_exclude_credentials_ = false;
  bool has_pub_key_cred_params_ = false;
  bool has_rp_ = false;
  bool has_timeout_ = false;
  bool has_user_ = false;

  AuthenticatorSelectionCriteria authenticator_selection_;
  ArrayBufferOrArrayBufferView challenge_;
  HeapVector<PublicKeyCredentialDescriptor> exclude_credentials_;
  HeapVector<PublicKeyCredentialParameters> pub_key_cred_params_;
  PublicKeyCredentialRpEntity rp_;
  uint32_t timeout_;
  PublicKeyCredentialUserEntity user_;

  friend class V8MakePublicKeyCredentialOptions;
};

void MakePublicKeyCredentialOptions::setTimeout(uint32_t value) {
  timeout_ = value;
  has_timeout_ = true;
}

}  // namespace blink

#endif  // MakePublicKeyCredentialOptions_h
