// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef PublicKeyCredentialRequestOptions_h
#define PublicKeyCredentialRequestOptions_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "bindings/core/v8/array_buffer_or_array_buffer_view.h"
#include "core/typed_arrays/ArrayBufferViewHelpers.h"
#include "core/typed_arrays/DOMArrayBuffer.h"
#include "core/typed_arrays/DOMTypedArray.h"
#include "modules/ModulesExport.h"
#include "modules/credentialmanager/PublicKeyCredentialDescriptor.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/Vector.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class MODULES_EXPORT PublicKeyCredentialRequestOptions : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  PublicKeyCredentialRequestOptions();
  virtual ~PublicKeyCredentialRequestOptions();
  PublicKeyCredentialRequestOptions(const PublicKeyCredentialRequestOptions&);
  PublicKeyCredentialRequestOptions& operator=(const PublicKeyCredentialRequestOptions&);

  bool hasAllowCredentials() const { return has_allow_credentials_; }
  const HeapVector<PublicKeyCredentialDescriptor>& allowCredentials() const {
    DCHECK(has_allow_credentials_);
    return allow_credentials_;
  }
  void setAllowCredentials(const HeapVector<PublicKeyCredentialDescriptor>&);

  bool hasChallenge() const { return !challenge_.IsNull(); }
  const ArrayBufferOrArrayBufferView& challenge() const {
    return challenge_;
  }
  void setChallenge(const ArrayBufferOrArrayBufferView&);

  bool hasRpId() const { return !rp_id_.IsNull(); }
  const String& rpId() const {
    return rp_id_;
  }
  inline void setRpId(const String&);

  bool hasTimeout() const { return has_timeout_; }
  uint32_t timeout() const {
    DCHECK(has_timeout_);
    return timeout_;
  }
  inline void setTimeout(uint32_t);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_allow_credentials_ = false;
  bool has_timeout_ = false;

  HeapVector<PublicKeyCredentialDescriptor> allow_credentials_;
  ArrayBufferOrArrayBufferView challenge_;
  String rp_id_;
  uint32_t timeout_;

  friend class V8PublicKeyCredentialRequestOptions;
};

void PublicKeyCredentialRequestOptions::setRpId(const String& value) {
  rp_id_ = value;
}

void PublicKeyCredentialRequestOptions::setTimeout(uint32_t value) {
  timeout_ = value;
  has_timeout_ = true;
}

}  // namespace blink

#endif  // PublicKeyCredentialRequestOptions_h
