// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef MediaKeySystemConfiguration_h
#define MediaKeySystemConfiguration_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "modules/ModulesExport.h"
#include "modules/encryptedmedia/MediaKeySystemMediaCapability.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/Vector.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class MODULES_EXPORT MediaKeySystemConfiguration : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  MediaKeySystemConfiguration();
  virtual ~MediaKeySystemConfiguration();
  MediaKeySystemConfiguration(const MediaKeySystemConfiguration&);
  MediaKeySystemConfiguration& operator=(const MediaKeySystemConfiguration&);

  bool hasAudioCapabilities() const { return has_audio_capabilities_; }
  const HeapVector<MediaKeySystemMediaCapability>& audioCapabilities() const {
    DCHECK(has_audio_capabilities_);
    return audio_capabilities_;
  }
  void setAudioCapabilities(const HeapVector<MediaKeySystemMediaCapability>&);

  bool hasDistinctiveIdentifier() const { return !distinctive_identifier_.IsNull(); }
  const String& distinctiveIdentifier() const {
    return distinctive_identifier_;
  }
  inline void setDistinctiveIdentifier(const String&);

  bool hasInitDataTypes() const { return has_init_data_types_; }
  const Vector<String>& initDataTypes() const {
    DCHECK(has_init_data_types_);
    return init_data_types_;
  }
  void setInitDataTypes(const Vector<String>&);

  bool hasLabel() const { return !label_.IsNull(); }
  const String& label() const {
    return label_;
  }
  inline void setLabel(const String&);

  bool hasPersistentState() const { return !persistent_state_.IsNull(); }
  const String& persistentState() const {
    return persistent_state_;
  }
  inline void setPersistentState(const String&);

  bool hasSessionTypes() const { return has_session_types_; }
  const Vector<String>& sessionTypes() const {
    DCHECK(has_session_types_);
    return session_types_;
  }
  void setSessionTypes(const Vector<String>&);

  bool hasVideoCapabilities() const { return has_video_capabilities_; }
  const HeapVector<MediaKeySystemMediaCapability>& videoCapabilities() const {
    DCHECK(has_video_capabilities_);
    return video_capabilities_;
  }
  void setVideoCapabilities(const HeapVector<MediaKeySystemMediaCapability>&);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_audio_capabilities_ = false;
  bool has_init_data_types_ = false;
  bool has_session_types_ = false;
  bool has_video_capabilities_ = false;

  HeapVector<MediaKeySystemMediaCapability> audio_capabilities_;
  String distinctive_identifier_;
  Vector<String> init_data_types_;
  String label_;
  String persistent_state_;
  Vector<String> session_types_;
  HeapVector<MediaKeySystemMediaCapability> video_capabilities_;

  friend class V8MediaKeySystemConfiguration;
};

void MediaKeySystemConfiguration::setDistinctiveIdentifier(const String& value) {
  distinctive_identifier_ = value;
}

void MediaKeySystemConfiguration::setLabel(const String& value) {
  label_ = value;
}

void MediaKeySystemConfiguration::setPersistentState(const String& value) {
  persistent_state_ = value;
}

}  // namespace blink

#endif  // MediaKeySystemConfiguration_h
