// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/EventFactory.cpp.tmpl
// and input files:
//   gen/blink/event_modules_names.json5


#include "modules/EventModulesFactory.h"

#include "core/frame/Deprecation.h"
#include "modules/app_banner/BeforeInstallPromptEvent.h"
#include "modules/background_fetch/BackgroundFetchClickEvent.h"
#include "modules/background_fetch/BackgroundFetchEvent.h"
#include "modules/background_fetch/BackgroundFetchFailEvent.h"
#include "modules/background_fetch/BackgroundFetchedEvent.h"
#include "modules/background_sync/SyncEvent.h"
#include "modules/device_orientation/DeviceMotionEvent.h"
#include "modules/device_orientation/DeviceOrientationEvent.h"
#include "modules/encryptedmedia/MediaEncryptedEvent.h"
#include "modules/encryptedmedia/MediaKeyMessageEvent.h"
#include "modules/gamepad/GamepadEvent.h"
#include "modules/indexeddb/IDBVersionChangeEvent.h"
#include "modules/mediarecorder/BlobEvent.h"
#include "modules/mediastream/MediaStreamEvent.h"
#include "modules/mediastream/MediaStreamTrackEvent.h"
#include "modules/notifications/NotificationEvent.h"
#include "modules/payments/AbortPaymentEvent.h"
#include "modules/payments/CanMakePaymentEvent.h"
#include "modules/payments/PaymentRequestEvent.h"
#include "modules/payments/PaymentRequestUpdateEvent.h"
#include "modules/peerconnection/RTCDTMFToneChangeEvent.h"
#include "modules/peerconnection/RTCDataChannelEvent.h"
#include "modules/peerconnection/RTCPeerConnectionIceEvent.h"
#include "modules/presentation/PresentationConnectionAvailableEvent.h"
#include "modules/presentation/PresentationConnectionCloseEvent.h"
#include "modules/push_messaging/PushEvent.h"
#include "modules/sensor/SensorErrorEvent.h"
#include "modules/serviceworkers/ExtendableEvent.h"
#include "modules/serviceworkers/ExtendableMessageEvent.h"
#include "modules/serviceworkers/FetchEvent.h"
#include "modules/serviceworkers/InstallEvent.h"
#include "modules/speech/SpeechRecognitionError.h"
#include "modules/speech/SpeechRecognitionEvent.h"
#include "modules/speech/SpeechSynthesisEvent.h"
#include "modules/storage/StorageEvent.h"
#include "modules/vr/VRDisplayEvent.h"
#include "modules/webaudio/AudioProcessingEvent.h"
#include "modules/webaudio/OfflineAudioCompletionEvent.h"
#include "modules/webgl/WebGLContextEvent.h"
#include "modules/webmidi/MIDIConnectionEvent.h"
#include "modules/webmidi/MIDIMessageEvent.h"
#include "modules/websockets/CloseEvent.h"
#include "modules/xr/XRSessionEvent.h"
#include "platform/runtime_enabled_features.h"

namespace blink {

Event* EventModulesFactory::Create(ExecutionContext* executionContext, const String& type) {
  if (DeprecatedEqualIgnoringCase(type, "DeviceMotionEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventDeviceMotionEvent);
    return DeviceMotionEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "DeviceOrientationEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventDeviceOrientationEvent);
    return DeviceOrientationEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "IDBVersionChangeEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventIDBVersionChangeEvent);
    return IDBVersionChangeEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "StorageEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventStorageEvent);
    return StorageEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "WebGLContextEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventWebGLContextEvent);
    return WebGLContextEvent::Create();
  }
  if (DeprecatedEqualIgnoringCase(type, "CloseEvent")) {
    UseCounter::Count(executionContext, WebFeature::kDocumentCreateEventCloseEvent);
    return CloseEvent::Create();
  }
  return nullptr;
}

} // namespace blink
