// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef AudioConfiguration_h
#define AudioConfiguration_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class MODULES_EXPORT AudioConfiguration : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  AudioConfiguration();
  virtual ~AudioConfiguration();
  AudioConfiguration(const AudioConfiguration&);
  AudioConfiguration& operator=(const AudioConfiguration&);

  bool hasBitrate() const { return has_bitrate_; }
  uint32_t bitrate() const {
    DCHECK(has_bitrate_);
    return bitrate_;
  }
  inline void setBitrate(uint32_t);

  bool hasChannels() const { return !channels_.IsNull(); }
  const String& channels() const {
    return channels_;
  }
  inline void setChannels(const String&);

  bool hasContentType() const { return !content_type_.IsNull(); }
  const String& contentType() const {
    return content_type_;
  }
  inline void setContentType(const String&);

  bool hasSamplerate() const { return has_samplerate_; }
  uint32_t samplerate() const {
    DCHECK(has_samplerate_);
    return samplerate_;
  }
  inline void setSamplerate(uint32_t);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_bitrate_ = false;
  bool has_samplerate_ = false;

  uint32_t bitrate_;
  String channels_;
  String content_type_;
  uint32_t samplerate_;

  friend class V8AudioConfiguration;
};

void AudioConfiguration::setBitrate(uint32_t value) {
  bitrate_ = value;
  has_bitrate_ = true;
}

void AudioConfiguration::setChannels(const String& value) {
  channels_ = value;
}

void AudioConfiguration::setContentType(const String& value) {
  content_type_ = value;
}

void AudioConfiguration::setSamplerate(uint32_t value) {
  samplerate_ = value;
  has_samplerate_ = true;
}

}  // namespace blink

#endif  // AudioConfiguration_h
