// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef MediaTrackCapabilities_h
#define MediaTrackCapabilities_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/Vector.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class MediaSettingsRange;

class MODULES_EXPORT MediaTrackCapabilities : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  MediaTrackCapabilities();
  virtual ~MediaTrackCapabilities();
  MediaTrackCapabilities(const MediaTrackCapabilities&);
  MediaTrackCapabilities& operator=(const MediaTrackCapabilities&);

  bool hasBrightness() const { return brightness_; }
  MediaSettingsRange* brightness() const {
    return brightness_;
  }
  inline void setBrightness(MediaSettingsRange*);

  bool hasColorTemperature() const { return color_temperature_; }
  MediaSettingsRange* colorTemperature() const {
    return color_temperature_;
  }
  inline void setColorTemperature(MediaSettingsRange*);

  bool hasContrast() const { return contrast_; }
  MediaSettingsRange* contrast() const {
    return contrast_;
  }
  inline void setContrast(MediaSettingsRange*);

  bool hasExposureCompensation() const { return exposure_compensation_; }
  MediaSettingsRange* exposureCompensation() const {
    return exposure_compensation_;
  }
  inline void setExposureCompensation(MediaSettingsRange*);

  bool hasExposureMode() const { return has_exposure_mode_; }
  const Vector<String>& exposureMode() const {
    DCHECK(has_exposure_mode_);
    return exposure_mode_;
  }
  void setExposureMode(const Vector<String>&);

  bool hasFocusMode() const { return has_focus_mode_; }
  const Vector<String>& focusMode() const {
    DCHECK(has_focus_mode_);
    return focus_mode_;
  }
  void setFocusMode(const Vector<String>&);

  bool hasIso() const { return iso_; }
  MediaSettingsRange* iso() const {
    return iso_;
  }
  inline void setIso(MediaSettingsRange*);

  bool hasSaturation() const { return saturation_; }
  MediaSettingsRange* saturation() const {
    return saturation_;
  }
  inline void setSaturation(MediaSettingsRange*);

  bool hasSharpness() const { return sharpness_; }
  MediaSettingsRange* sharpness() const {
    return sharpness_;
  }
  inline void setSharpness(MediaSettingsRange*);

  bool hasTorch() const { return has_torch_; }
  bool torch() const {
    DCHECK(has_torch_);
    return torch_;
  }
  inline void setTorch(bool);

  bool hasWhiteBalanceMode() const { return has_white_balance_mode_; }
  const Vector<String>& whiteBalanceMode() const {
    DCHECK(has_white_balance_mode_);
    return white_balance_mode_;
  }
  void setWhiteBalanceMode(const Vector<String>&);

  bool hasZoom() const { return zoom_; }
  MediaSettingsRange* zoom() const {
    return zoom_;
  }
  inline void setZoom(MediaSettingsRange*);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_exposure_mode_ = false;
  bool has_focus_mode_ = false;
  bool has_torch_ = false;
  bool has_white_balance_mode_ = false;

  Member<MediaSettingsRange> brightness_;
  Member<MediaSettingsRange> color_temperature_;
  Member<MediaSettingsRange> contrast_;
  Member<MediaSettingsRange> exposure_compensation_;
  Vector<String> exposure_mode_;
  Vector<String> focus_mode_;
  Member<MediaSettingsRange> iso_;
  Member<MediaSettingsRange> saturation_;
  Member<MediaSettingsRange> sharpness_;
  bool torch_;
  Vector<String> white_balance_mode_;
  Member<MediaSettingsRange> zoom_;

  friend class V8MediaTrackCapabilities;
};

void MediaTrackCapabilities::setBrightness(MediaSettingsRange* value) {
  brightness_ = value;
}

void MediaTrackCapabilities::setColorTemperature(MediaSettingsRange* value) {
  color_temperature_ = value;
}

void MediaTrackCapabilities::setContrast(MediaSettingsRange* value) {
  contrast_ = value;
}

void MediaTrackCapabilities::setExposureCompensation(MediaSettingsRange* value) {
  exposure_compensation_ = value;
}

void MediaTrackCapabilities::setIso(MediaSettingsRange* value) {
  iso_ = value;
}

void MediaTrackCapabilities::setSaturation(MediaSettingsRange* value) {
  saturation_ = value;
}

void MediaTrackCapabilities::setSharpness(MediaSettingsRange* value) {
  sharpness_ = value;
}

void MediaTrackCapabilities::setTorch(bool value) {
  torch_ = value;
  has_torch_ = true;
}

void MediaTrackCapabilities::setZoom(MediaSettingsRange* value) {
  zoom_ = value;
}

}  // namespace blink

#endif  // MediaTrackCapabilities_h
