// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef PaymentInstrument_h
#define PaymentInstrument_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "bindings/core/v8/ScriptValue.h"
#include "modules/ModulesExport.h"
#include "modules/payments/ImageObject.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/Vector.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class MODULES_EXPORT PaymentInstrument : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  PaymentInstrument();
  virtual ~PaymentInstrument();
  PaymentInstrument(const PaymentInstrument&);
  PaymentInstrument& operator=(const PaymentInstrument&);

  bool hasCapabilities() const { return !(capabilities_.IsEmpty() || capabilities_.IsNull() || capabilities_.IsUndefined()); }
  ScriptValue capabilities() const {
    return capabilities_;
  }
  void setCapabilities(ScriptValue);

  bool hasEnabledMethods() const { return has_enabled_methods_; }
  const Vector<String>& enabledMethods() const {
    DCHECK(has_enabled_methods_);
    return enabled_methods_;
  }
  void setEnabledMethods(const Vector<String>&);

  bool hasIcons() const { return has_icons_; }
  const HeapVector<ImageObject>& icons() const {
    DCHECK(has_icons_);
    return icons_;
  }
  void setIcons(const HeapVector<ImageObject>&);

  bool hasName() const { return !name_.IsNull(); }
  const String& name() const {
    return name_;
  }
  inline void setName(const String&);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_enabled_methods_ = false;
  bool has_icons_ = false;

  ScriptValue capabilities_;
  Vector<String> enabled_methods_;
  HeapVector<ImageObject> icons_;
  String name_;

  friend class V8PaymentInstrument;
};

void PaymentInstrument::setName(const String& value) {
  name_ = value;
}

}  // namespace blink

#endif  // PaymentInstrument_h
