// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef RTCIceCandidateInit_h
#define RTCIceCandidateInit_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class MODULES_EXPORT RTCIceCandidateInit : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  RTCIceCandidateInit();
  virtual ~RTCIceCandidateInit();
  RTCIceCandidateInit(const RTCIceCandidateInit&);
  RTCIceCandidateInit& operator=(const RTCIceCandidateInit&);

  bool hasCandidate() const { return !candidate_.IsNull(); }
  const String& candidate() const {
    return candidate_;
  }
  inline void setCandidate(const String&);

  bool hasSdpMid() const { return !sdp_mid_.IsNull(); }
  const String& sdpMid() const {
    return sdp_mid_;
  }
  inline void setSdpMid(const String&);

  bool hasSdpMLineIndex() const { return has_sdpm_line_index_; }
  uint16_t sdpMLineIndex() const {
    DCHECK(has_sdpm_line_index_);
    return sdpm_line_index_;
  }
  inline void setSdpMLineIndex(uint16_t);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_sdpm_line_index_ = false;

  String candidate_;
  String sdp_mid_;
  uint16_t sdpm_line_index_;

  friend class V8RTCIceCandidateInit;
};

void RTCIceCandidateInit::setCandidate(const String& value) {
  candidate_ = value;
}

void RTCIceCandidateInit::setSdpMid(const String& value) {
  sdp_mid_ = value;
}

void RTCIceCandidateInit::setSdpMLineIndex(uint16_t value) {
  sdpm_line_index_ = value;
  has_sdpm_line_index_ = true;
}

}  // namespace blink

#endif  // RTCIceCandidateInit_h
