// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef RTCOfferOptions_h
#define RTCOfferOptions_h

#include "modules/ModulesExport.h"
#include "modules/peerconnection/RTCOfferAnswerOptions.h"
#include "platform/heap/Handle.h"

namespace blink {

class MODULES_EXPORT RTCOfferOptions : public RTCOfferAnswerOptions {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  RTCOfferOptions();
  virtual ~RTCOfferOptions();
  RTCOfferOptions(const RTCOfferOptions&);
  RTCOfferOptions& operator=(const RTCOfferOptions&);

  bool hasIceRestart() const { return has_ice_restart_; }
  bool iceRestart() const {
    DCHECK(has_ice_restart_);
    return ice_restart_;
  }
  inline void setIceRestart(bool);

  bool hasOfferToReceiveAudio() const { return has_offer_to_receive_audio_; }
  int32_t offerToReceiveAudio() const {
    DCHECK(has_offer_to_receive_audio_);
    return offer_to_receive_audio_;
  }
  inline void setOfferToReceiveAudio(int32_t);

  bool hasOfferToReceiveVideo() const { return has_offer_to_receive_video_; }
  int32_t offerToReceiveVideo() const {
    DCHECK(has_offer_to_receive_video_);
    return offer_to_receive_video_;
  }
  inline void setOfferToReceiveVideo(int32_t);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_ice_restart_ = false;
  bool has_offer_to_receive_audio_ = false;
  bool has_offer_to_receive_video_ = false;

  bool ice_restart_;
  int32_t offer_to_receive_audio_;
  int32_t offer_to_receive_video_;

  friend class V8RTCOfferOptions;
};

void RTCOfferOptions::setIceRestart(bool value) {
  ice_restart_ = value;
  has_ice_restart_ = true;
}

void RTCOfferOptions::setOfferToReceiveAudio(int32_t value) {
  offer_to_receive_audio_ = value;
  has_offer_to_receive_audio_ = true;
}

void RTCOfferOptions::setOfferToReceiveVideo(int32_t value) {
  offer_to_receive_video_ = value;
  has_offer_to_receive_video_ = true;
}

}  // namespace blink

#endif  // RTCOfferOptions_h
