// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef VRLayerInit_h
#define VRLayerInit_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "bindings/modules/v8/html_canvas_element_or_offscreen_canvas.h"
#include "core/html/canvas/HTMLCanvasElement.h"
#include "core/offscreencanvas/OffscreenCanvas.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/Vector.h"

namespace blink {

class MODULES_EXPORT VRLayerInit : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  VRLayerInit();
  virtual ~VRLayerInit();
  VRLayerInit(const VRLayerInit&);
  VRLayerInit& operator=(const VRLayerInit&);

  bool hasLeftBounds() const { return has_left_bounds_; }
  const Vector<float>& leftBounds() const {
    DCHECK(has_left_bounds_);
    return left_bounds_;
  }
  void setLeftBounds(const Vector<float>&);

  bool hasRightBounds() const { return has_right_bounds_; }
  const Vector<float>& rightBounds() const {
    DCHECK(has_right_bounds_);
    return right_bounds_;
  }
  void setRightBounds(const Vector<float>&);

  bool hasSource() const { return !source_.IsNull(); }
  const HTMLCanvasElementOrOffscreenCanvas& source() const {
    return source_;
  }
  void setSource(const HTMLCanvasElementOrOffscreenCanvas&);
  void setSourceToNull();

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_left_bounds_ = false;
  bool has_right_bounds_ = false;

  Vector<float> left_bounds_;
  Vector<float> right_bounds_;
  HTMLCanvasElementOrOffscreenCanvas source_;

  friend class V8VRLayerInit;
};

}  // namespace blink

#endif  // VRLayerInit_h
