// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef AnalyserOptions_h
#define AnalyserOptions_h

#include "modules/ModulesExport.h"
#include "modules/webaudio/AudioNodeOptions.h"
#include "platform/heap/Handle.h"

namespace blink {

class MODULES_EXPORT AnalyserOptions : public AudioNodeOptions {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  AnalyserOptions();
  virtual ~AnalyserOptions();
  AnalyserOptions(const AnalyserOptions&);
  AnalyserOptions& operator=(const AnalyserOptions&);

  bool hasFftSize() const { return has_fft_size_; }
  uint32_t fftSize() const {
    DCHECK(has_fft_size_);
    return fft_size_;
  }
  inline void setFftSize(uint32_t);

  bool hasMaxDecibels() const { return has_max_decibels_; }
  float maxDecibels() const {
    DCHECK(has_max_decibels_);
    return max_decibels_;
  }
  inline void setMaxDecibels(float);

  bool hasMinDecibels() const { return has_min_decibels_; }
  float minDecibels() const {
    DCHECK(has_min_decibels_);
    return min_decibels_;
  }
  inline void setMinDecibels(float);

  bool hasSmoothingTimeConstant() const { return has_smoothing_time_constant_; }
  float smoothingTimeConstant() const {
    DCHECK(has_smoothing_time_constant_);
    return smoothing_time_constant_;
  }
  inline void setSmoothingTimeConstant(float);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_fft_size_ = false;
  bool has_max_decibels_ = false;
  bool has_min_decibels_ = false;
  bool has_smoothing_time_constant_ = false;

  uint32_t fft_size_;
  float max_decibels_;
  float min_decibels_;
  float smoothing_time_constant_;

  friend class V8AnalyserOptions;
};

void AnalyserOptions::setFftSize(uint32_t value) {
  fft_size_ = value;
  has_fft_size_ = true;
}

void AnalyserOptions::setMaxDecibels(float value) {
  max_decibels_ = value;
  has_max_decibels_ = true;
}

void AnalyserOptions::setMinDecibels(float value) {
  min_decibels_ = value;
  has_min_decibels_ = true;
}

void AnalyserOptions::setSmoothingTimeConstant(float value) {
  smoothing_time_constant_ = value;
  has_smoothing_time_constant_ = true;
}

}  // namespace blink

#endif  // AnalyserOptions_h
