// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef AudioBufferSourceOptions_h
#define AudioBufferSourceOptions_h

#include "bindings/core/v8/IDLDictionaryBase.h"
#include "modules/ModulesExport.h"
#include "platform/heap/Handle.h"

namespace blink {

class AudioBuffer;

class MODULES_EXPORT AudioBufferSourceOptions : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  AudioBufferSourceOptions();
  virtual ~AudioBufferSourceOptions();
  AudioBufferSourceOptions(const AudioBufferSourceOptions&);
  AudioBufferSourceOptions& operator=(const AudioBufferSourceOptions&);

  bool hasBuffer() const { return buffer_; }
  AudioBuffer* buffer() const {
    return buffer_;
  }
  inline void setBuffer(AudioBuffer*);
  inline void setBufferToNull();

  bool hasDetune() const { return has_detune_; }
  float detune() const {
    DCHECK(has_detune_);
    return detune_;
  }
  inline void setDetune(float);

  bool hasLoop() const { return has_loop_; }
  bool loop() const {
    DCHECK(has_loop_);
    return loop_;
  }
  inline void setLoop(bool);

  bool hasLoopEnd() const { return has_loop_end_; }
  double loopEnd() const {
    DCHECK(has_loop_end_);
    return loop_end_;
  }
  inline void setLoopEnd(double);

  bool hasLoopStart() const { return has_loop_start_; }
  double loopStart() const {
    DCHECK(has_loop_start_);
    return loop_start_;
  }
  inline void setLoopStart(double);

  bool hasPlaybackRate() const { return has_playback_rate_; }
  float playbackRate() const {
    DCHECK(has_playback_rate_);
    return playback_rate_;
  }
  inline void setPlaybackRate(float);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_detune_ = false;
  bool has_loop_ = false;
  bool has_loop_end_ = false;
  bool has_loop_start_ = false;
  bool has_playback_rate_ = false;

  Member<AudioBuffer> buffer_;
  float detune_;
  bool loop_;
  double loop_end_;
  double loop_start_;
  float playback_rate_;

  friend class V8AudioBufferSourceOptions;
};

void AudioBufferSourceOptions::setBuffer(AudioBuffer* value) {
  buffer_ = value;
}
void AudioBufferSourceOptions::setBufferToNull() {
  buffer_ = Member<AudioBuffer>();
}

void AudioBufferSourceOptions::setDetune(float value) {
  detune_ = value;
  has_detune_ = true;
}

void AudioBufferSourceOptions::setLoop(bool value) {
  loop_ = value;
  has_loop_ = true;
}

void AudioBufferSourceOptions::setLoopEnd(double value) {
  loop_end_ = value;
  has_loop_end_ = true;
}

void AudioBufferSourceOptions::setLoopStart(double value) {
  loop_start_ = value;
  has_loop_start_ = true;
}

void AudioBufferSourceOptions::setPlaybackRate(float value) {
  playback_rate_ = value;
  has_playback_rate_ = true;
}

}  // namespace blink

#endif  // AudioBufferSourceOptions_h
