// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/WebKit/Source/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef PannerOptions_h
#define PannerOptions_h

#include "modules/ModulesExport.h"
#include "modules/webaudio/AudioNodeOptions.h"
#include "platform/heap/Handle.h"
#include "platform/wtf/text/WTFString.h"

namespace blink {

class MODULES_EXPORT PannerOptions : public AudioNodeOptions {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  PannerOptions();
  virtual ~PannerOptions();
  PannerOptions(const PannerOptions&);
  PannerOptions& operator=(const PannerOptions&);

  bool hasConeInnerAngle() const { return has_cone_inner_angle_; }
  double coneInnerAngle() const {
    DCHECK(has_cone_inner_angle_);
    return cone_inner_angle_;
  }
  inline void setConeInnerAngle(double);

  bool hasConeOuterAngle() const { return has_cone_outer_angle_; }
  double coneOuterAngle() const {
    DCHECK(has_cone_outer_angle_);
    return cone_outer_angle_;
  }
  inline void setConeOuterAngle(double);

  bool hasConeOuterGain() const { return has_cone_outer_gain_; }
  double coneOuterGain() const {
    DCHECK(has_cone_outer_gain_);
    return cone_outer_gain_;
  }
  inline void setConeOuterGain(double);

  bool hasDistanceModel() const { return !distance_model_.IsNull(); }
  const String& distanceModel() const {
    return distance_model_;
  }
  inline void setDistanceModel(const String&);

  bool hasMaxDistance() const { return has_max_distance_; }
  double maxDistance() const {
    DCHECK(has_max_distance_);
    return max_distance_;
  }
  inline void setMaxDistance(double);

  bool hasOrientationX() const { return has_orientationx_; }
  float orientationX() const {
    DCHECK(has_orientationx_);
    return orientationx_;
  }
  inline void setOrientationX(float);

  bool hasOrientationY() const { return has_orientationy_; }
  float orientationY() const {
    DCHECK(has_orientationy_);
    return orientationy_;
  }
  inline void setOrientationY(float);

  bool hasOrientationZ() const { return has_orientationz_; }
  float orientationZ() const {
    DCHECK(has_orientationz_);
    return orientationz_;
  }
  inline void setOrientationZ(float);

  bool hasPanningModel() const { return !panning_model_.IsNull(); }
  const String& panningModel() const {
    return panning_model_;
  }
  inline void setPanningModel(const String&);

  bool hasPositionX() const { return has_positionx_; }
  float positionX() const {
    DCHECK(has_positionx_);
    return positionx_;
  }
  inline void setPositionX(float);

  bool hasPositionY() const { return has_positiony_; }
  float positionY() const {
    DCHECK(has_positiony_);
    return positiony_;
  }
  inline void setPositionY(float);

  bool hasPositionZ() const { return has_positionz_; }
  float positionZ() const {
    DCHECK(has_positionz_);
    return positionz_;
  }
  inline void setPositionZ(float);

  bool hasRefDistance() const { return has_ref_distance_; }
  double refDistance() const {
    DCHECK(has_ref_distance_);
    return ref_distance_;
  }
  inline void setRefDistance(double);

  bool hasRolloffFactor() const { return has_rolloff_factor_; }
  double rolloffFactor() const {
    DCHECK(has_rolloff_factor_);
    return rolloff_factor_;
  }
  inline void setRolloffFactor(double);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  virtual void Trace(blink::Visitor*);

 private:
  bool has_cone_inner_angle_ = false;
  bool has_cone_outer_angle_ = false;
  bool has_cone_outer_gain_ = false;
  bool has_max_distance_ = false;
  bool has_orientationx_ = false;
  bool has_orientationy_ = false;
  bool has_orientationz_ = false;
  bool has_positionx_ = false;
  bool has_positiony_ = false;
  bool has_positionz_ = false;
  bool has_ref_distance_ = false;
  bool has_rolloff_factor_ = false;

  double cone_inner_angle_;
  double cone_outer_angle_;
  double cone_outer_gain_;
  String distance_model_;
  double max_distance_;
  float orientationx_;
  float orientationy_;
  float orientationz_;
  String panning_model_;
  float positionx_;
  float positiony_;
  float positionz_;
  double ref_distance_;
  double rolloff_factor_;

  friend class V8PannerOptions;
};

void PannerOptions::setConeInnerAngle(double value) {
  cone_inner_angle_ = value;
  has_cone_inner_angle_ = true;
}

void PannerOptions::setConeOuterAngle(double value) {
  cone_outer_angle_ = value;
  has_cone_outer_angle_ = true;
}

void PannerOptions::setConeOuterGain(double value) {
  cone_outer_gain_ = value;
  has_cone_outer_gain_ = true;
}

void PannerOptions::setDistanceModel(const String& value) {
  distance_model_ = value;
}

void PannerOptions::setMaxDistance(double value) {
  max_distance_ = value;
  has_max_distance_ = true;
}

void PannerOptions::setOrientationX(float value) {
  orientationx_ = value;
  has_orientationx_ = true;
}

void PannerOptions::setOrientationY(float value) {
  orientationy_ = value;
  has_orientationy_ = true;
}

void PannerOptions::setOrientationZ(float value) {
  orientationz_ = value;
  has_orientationz_ = true;
}

void PannerOptions::setPanningModel(const String& value) {
  panning_model_ = value;
}

void PannerOptions::setPositionX(float value) {
  positionx_ = value;
  has_positionx_ = true;
}

void PannerOptions::setPositionY(float value) {
  positiony_ = value;
  has_positiony_ = true;
}

void PannerOptions::setPositionZ(float value) {
  positionz_ = value;
  has_positionz_ = true;
}

void PannerOptions::setRefDistance(double value) {
  ref_distance_ = value;
  has_ref_distance_ = true;
}

void PannerOptions::setRolloffFactor(double value) {
  rolloff_factor_ = value;
  has_rolloff_factor_ = true;
}

}  // namespace blink

#endif  // PannerOptions_h
