// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_PRINTING_SERVICE_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_SHARED_INTERNAL_H_
#define COMPONENTS_PRINTING_SERVICE_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace printing {
namespace mojom {
namespace internal {

struct PdfCompositor_Status_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
// The 650042251 value is based on sha256(salt + "PdfCompositor1").
constexpr uint32_t kPdfCompositor_CompositePdf_Name = 650042251;
class  PdfCompositor_CompositePdf_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_CompositePdf_Params_Data));
      new (data()) PdfCompositor_CompositePdf_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_CompositePdf_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_CompositePdf_Params_Data>(index_);
    }
    PdfCompositor_CompositePdf_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data sk_handle;
  uint8_t padfinal_[4];

 private:
  PdfCompositor_CompositePdf_Params_Data();
  ~PdfCompositor_CompositePdf_Params_Data() = delete;
};
static_assert(sizeof(PdfCompositor_CompositePdf_Params_Data) == 16,
              "Bad sizeof(PdfCompositor_CompositePdf_Params_Data)");
class  PdfCompositor_CompositePdf_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PdfCompositor_CompositePdf_ResponseParams_Data));
      new (data()) PdfCompositor_CompositePdf_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PdfCompositor_CompositePdf_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PdfCompositor_CompositePdf_ResponseParams_Data>(index_);
    }
    PdfCompositor_CompositePdf_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  mojo::internal::Handle_Data pdf_handle;

 private:
  PdfCompositor_CompositePdf_ResponseParams_Data();
  ~PdfCompositor_CompositePdf_ResponseParams_Data() = delete;
};
static_assert(sizeof(PdfCompositor_CompositePdf_ResponseParams_Data) == 16,
              "Bad sizeof(PdfCompositor_CompositePdf_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace printing

#endif  // COMPONENTS_PRINTING_SERVICE_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_SHARED_INTERNAL_H_