// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_PRINTING_SERVICE_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_SHARED_H_
#define COMPONENTS_PRINTING_SERVICE_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "components/printing/service/public/interfaces/pdf_compositor.mojom-shared-internal.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace printing {
namespace mojom {


}  // namespace mojom
}  // namespace printing

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace printing {
namespace mojom {

enum class PdfCompositor_Status : int32_t {
  SUCCESS,
  HANDLE_MAP_ERROR,
  CONTENT_FORMAT_ERROR,
  COMPOSTING_FAILURE,
};

inline std::ostream& operator<<(std::ostream& os, PdfCompositor_Status value) {
  switch(value) {
    case PdfCompositor_Status::SUCCESS:
      return os << "PdfCompositor_Status::SUCCESS";
    case PdfCompositor_Status::HANDLE_MAP_ERROR:
      return os << "PdfCompositor_Status::HANDLE_MAP_ERROR";
    case PdfCompositor_Status::CONTENT_FORMAT_ERROR:
      return os << "PdfCompositor_Status::CONTENT_FORMAT_ERROR";
    case PdfCompositor_Status::COMPOSTING_FAILURE:
      return os << "PdfCompositor_Status::COMPOSTING_FAILURE";
    default:
      return os << "Unknown PdfCompositor_Status value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(PdfCompositor_Status value) {
  return internal::PdfCompositor_Status_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class PdfCompositorInterfaceBase {};

using PdfCompositorPtrDataView =
    mojo::InterfacePtrDataView<PdfCompositorInterfaceBase>;
using PdfCompositorRequestDataView =
    mojo::InterfaceRequestDataView<PdfCompositorInterfaceBase>;
using PdfCompositorAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PdfCompositorInterfaceBase>;
using PdfCompositorAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PdfCompositorInterfaceBase>;
class PdfCompositor_CompositePdf_ParamsDataView {
 public:
  PdfCompositor_CompositePdf_ParamsDataView() {}

  PdfCompositor_CompositePdf_ParamsDataView(
      internal::PdfCompositor_CompositePdf_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  mojo::ScopedSharedBufferHandle TakeSkHandle() {
    mojo::ScopedSharedBufferHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedSharedBufferHandle>(
            &data_->sk_handle, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::PdfCompositor_CompositePdf_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PdfCompositor_CompositePdf_ResponseParamsDataView {
 public:
  PdfCompositor_CompositePdf_ResponseParamsDataView() {}

  PdfCompositor_CompositePdf_ResponseParamsDataView(
      internal::PdfCompositor_CompositePdf_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::printing::mojom::PdfCompositor_Status>(
        data_value, output);
  }

  PdfCompositor_Status status() const {
    return static_cast<PdfCompositor_Status>(data_->status);
  }
  mojo::ScopedSharedBufferHandle TakePdfHandle() {
    mojo::ScopedSharedBufferHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedSharedBufferHandle>(
            &data_->pdf_handle, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::PdfCompositor_CompositePdf_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace printing

namespace std {

template <>
struct hash<::printing::mojom::PdfCompositor_Status>
    : public mojo::internal::EnumHashImpl<::printing::mojom::PdfCompositor_Status> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::printing::mojom::PdfCompositor_Status, ::printing::mojom::PdfCompositor_Status> {
  static ::printing::mojom::PdfCompositor_Status ToMojom(::printing::mojom::PdfCompositor_Status input) { return input; }
  static bool FromMojom(::printing::mojom::PdfCompositor_Status input, ::printing::mojom::PdfCompositor_Status* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::printing::mojom::PdfCompositor_Status, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::printing::mojom::PdfCompositor_Status, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::printing::mojom::PdfCompositor_Status>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace printing {
namespace mojom {






}  // namespace mojom
}  // namespace printing

#endif  // COMPONENTS_PRINTING_SERVICE_PUBLIC_INTERFACES_PDF_COMPOSITOR_MOJOM_SHARED_H_
