// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "components/printing/service/public/interfaces/pdf_compositor.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace printing {
namespace mojom {
const char kServiceName[] = "pdf_compositor";
const char PdfCompositor::Name_[] = "printing::mojom::PdfCompositor";

class PdfCompositor_CompositePdf_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PdfCompositor_CompositePdf_ForwardToCallback(
      PdfCompositor::CompositePdfCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PdfCompositor::CompositePdfCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(PdfCompositor_CompositePdf_ForwardToCallback);
};

PdfCompositorProxy::PdfCompositorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PdfCompositorProxy::CompositePdf(
    mojo::ScopedSharedBufferHandle in_sk_handle, CompositePdfCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "printing::mojom::PdfCompositor::CompositePdf");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPdfCompositor_CompositePdf_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::printing::mojom::internal::PdfCompositor_CompositePdf_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_sk_handle, &params->sk_handle, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->sk_handle),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid sk_handle in PdfCompositor.CompositePdf request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PdfCompositor_CompositePdf_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class PdfCompositor_CompositePdf_ProxyToResponder {
 public:
  static PdfCompositor::CompositePdfCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<PdfCompositor_CompositePdf_ProxyToResponder> proxy(
        new PdfCompositor_CompositePdf_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&PdfCompositor_CompositePdf_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~PdfCompositor_CompositePdf_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  PdfCompositor_CompositePdf_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PdfCompositor::CompositePdfCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      PdfCompositor::Status in_status, mojo::ScopedSharedBufferHandle in_pdf_handle);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(PdfCompositor_CompositePdf_ProxyToResponder);
};

bool PdfCompositor_CompositePdf_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "printing::mojom::PdfCompositor::CompositePdfCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::PdfCompositor_CompositePdf_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PdfCompositor_CompositePdf_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  PdfCompositor::Status p_status{};
  mojo::ScopedSharedBufferHandle p_pdf_handle{};
  PdfCompositor_CompositePdf_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  p_pdf_handle = input_data_view.TakePdfHandle();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "PdfCompositor::CompositePdf response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_pdf_handle));
  return true;
}

void PdfCompositor_CompositePdf_ProxyToResponder::Run(
    PdfCompositor::Status in_status, mojo::ScopedSharedBufferHandle in_pdf_handle) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPdfCompositor_CompositePdf_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::printing::mojom::internal::PdfCompositor_CompositePdf_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::printing::mojom::PdfCompositor_Status>(
      in_status, &params->status);
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_pdf_handle, &params->pdf_handle, &serialization_context);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)printing::mojom::PdfCompositor::CompositePdfCallback",
               "message", message.name());
#endif
  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool PdfCompositorStubDispatch::Accept(
    PdfCompositor* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kPdfCompositor_CompositePdf_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)printing::mojom::PdfCompositor::CompositePdf",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

// static
bool PdfCompositorStubDispatch::AcceptWithResponder(
    PdfCompositor* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kPdfCompositor_CompositePdf_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)printing::mojom::PdfCompositor::CompositePdf",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::PdfCompositor_CompositePdf_Params_Data* params =
          reinterpret_cast<
              internal::PdfCompositor_CompositePdf_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      mojo::ScopedSharedBufferHandle p_sk_handle{};
      PdfCompositor_CompositePdf_ParamsDataView input_data_view(params, &serialization_context);
      
      p_sk_handle = input_data_view.TakeSkHandle();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "PdfCompositor::CompositePdf deserializer");
        return false;
      }
      PdfCompositor::CompositePdfCallback callback =
          PdfCompositor_CompositePdf_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->CompositePdf(
std::move(p_sk_handle), std::move(callback));
      return true;
    }
  }
  return false;
}

bool PdfCompositorRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "PdfCompositor RequestValidator");

  switch (message->header()->name) {
    case internal::kPdfCompositor_CompositePdf_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::PdfCompositor_CompositePdf_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool PdfCompositorResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "PdfCompositor ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kPdfCompositor_CompositePdf_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::PdfCompositor_CompositePdf_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
void PdfCompositorInterceptorForTesting::CompositePdf(mojo::ScopedSharedBufferHandle sk_handle, CompositePdfCallback callback) {
  GetForwardingInterface()->CompositePdf(std::move(sk_handle), std::move(callback));
}
PdfCompositorAsyncWaiter::PdfCompositorAsyncWaiter(
    PdfCompositor* proxy) : proxy_(proxy) {}

PdfCompositorAsyncWaiter::~PdfCompositorAsyncWaiter() = default;

void PdfCompositorAsyncWaiter::CompositePdf(
    mojo::ScopedSharedBufferHandle sk_handle, PdfCompositor::Status* out_status, mojo::ScopedSharedBufferHandle* out_pdf_handle) {
  base::RunLoop loop;
  proxy_->CompositePdf(std::move(sk_handle),
      base::Bind(
          [](base::RunLoop* loop,
             PdfCompositor::Status* out_status
,
             mojo::ScopedSharedBufferHandle* out_pdf_handle
,
             PdfCompositor::Status status,
             mojo::ScopedSharedBufferHandle pdf_handle) {*out_status = std::move(status);*out_pdf_handle = std::move(pdf_handle);
            loop->Quit();
          },
          &loop,
          out_status,
          out_pdf_handle));
  loop.Run();
}

}  // namespace mojom
}  // namespace printing

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif