// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_CHILD_CONTROL_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_CHILD_CONTROL_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "content/common/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 481783602 value is based on sha256(salt + "ChildControl1").
constexpr uint32_t kChildControl_ProcessShutdown_Name = 481783602;
class MOJOM_SHARED_CONTENT_EXPORT ChildControl_ProcessShutdown_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ChildControl_ProcessShutdown_Params_Data));
      new (data()) ChildControl_ProcessShutdown_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ChildControl_ProcessShutdown_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ChildControl_ProcessShutdown_Params_Data>(index_);
    }
    ChildControl_ProcessShutdown_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ChildControl_ProcessShutdown_Params_Data();
  ~ChildControl_ProcessShutdown_Params_Data() = delete;
};
static_assert(sizeof(ChildControl_ProcessShutdown_Params_Data) == 8,
              "Bad sizeof(ChildControl_ProcessShutdown_Params_Data)");
// The 1450498364 value is based on sha256(salt + "ChildControl2").
constexpr uint32_t kChildControl_SetIPCLoggingEnabled_Name = 1450498364;
class MOJOM_SHARED_CONTENT_EXPORT ChildControl_SetIPCLoggingEnabled_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ChildControl_SetIPCLoggingEnabled_Params_Data));
      new (data()) ChildControl_SetIPCLoggingEnabled_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ChildControl_SetIPCLoggingEnabled_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ChildControl_SetIPCLoggingEnabled_Params_Data>(index_);
    }
    ChildControl_SetIPCLoggingEnabled_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t on : 1;
  uint8_t padfinal_[7];

 private:
  ChildControl_SetIPCLoggingEnabled_Params_Data();
  ~ChildControl_SetIPCLoggingEnabled_Params_Data() = delete;
};
static_assert(sizeof(ChildControl_SetIPCLoggingEnabled_Params_Data) == 16,
              "Bad sizeof(ChildControl_SetIPCLoggingEnabled_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_CHILD_CONTROL_MOJOM_SHARED_INTERNAL_H_