// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_FILE_UTILITIES_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_FILE_UTILITIES_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/file_info.mojom-shared-internal.h"
#include "mojo/common/file_path.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "content/common/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1895995 value is based on sha256(salt + "FileUtilitiesHost1").
constexpr uint32_t kFileUtilitiesHost_GetFileInfo_Name = 1895995;
class MOJOM_SHARED_CONTENT_EXPORT FileUtilitiesHost_GetFileInfo_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileUtilitiesHost_GetFileInfo_Params_Data));
      new (data()) FileUtilitiesHost_GetFileInfo_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileUtilitiesHost_GetFileInfo_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileUtilitiesHost_GetFileInfo_Params_Data>(index_);
    }
    FileUtilitiesHost_GetFileInfo_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::FilePath_Data> path;

 private:
  FileUtilitiesHost_GetFileInfo_Params_Data();
  ~FileUtilitiesHost_GetFileInfo_Params_Data() = delete;
};
static_assert(sizeof(FileUtilitiesHost_GetFileInfo_Params_Data) == 16,
              "Bad sizeof(FileUtilitiesHost_GetFileInfo_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT FileUtilitiesHost_GetFileInfo_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileUtilitiesHost_GetFileInfo_ResponseParams_Data));
      new (data()) FileUtilitiesHost_GetFileInfo_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileUtilitiesHost_GetFileInfo_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileUtilitiesHost_GetFileInfo_ResponseParams_Data>(index_);
    }
    FileUtilitiesHost_GetFileInfo_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::FileInfo_Data> result;

 private:
  FileUtilitiesHost_GetFileInfo_ResponseParams_Data();
  ~FileUtilitiesHost_GetFileInfo_ResponseParams_Data() = delete;
};
static_assert(sizeof(FileUtilitiesHost_GetFileInfo_ResponseParams_Data) == 16,
              "Bad sizeof(FileUtilitiesHost_GetFileInfo_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_FILE_UTILITIES_MOJOM_SHARED_INTERNAL_H_