// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_MEDIA_RENDERER_AUDIO_OUTPUT_STREAM_FACTORY_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_MEDIA_RENDERER_AUDIO_OUTPUT_STREAM_FACTORY_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "media/mojo/interfaces/audio_output_stream.mojom-shared-internal.h"
#include "media/mojo/interfaces/audio_parameters.mojom-shared-internal.h"
#include "media/mojo/interfaces/media_types.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "content/common/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 2063543837 value is based on sha256(salt + "RendererAudioOutputStreamFactory1").
constexpr uint32_t kRendererAudioOutputStreamFactory_RequestDeviceAuthorization_Name = 2063543837;
class MOJOM_SHARED_CONTENT_EXPORT RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data));
      new (data()) RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data>(index_);
    }
    RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data stream_provider_request;
  int32_t session_id;
  mojo::internal::Pointer<mojo::internal::String_Data> device_id;

 private:
  RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data();
  ~RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data() = delete;
};
static_assert(sizeof(RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data) == 24,
              "Bad sizeof(RendererAudioOutputStreamFactory_RequestDeviceAuthorization_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data));
      new (data()) RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data>(index_);
    }
    RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t state;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::media::mojom::internal::AudioParameters_Data> output_params;
  mojo::internal::Pointer<mojo::internal::String_Data> matched_device_id;

 private:
  RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data();
  ~RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data() = delete;
};
static_assert(sizeof(RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data) == 32,
              "Bad sizeof(RendererAudioOutputStreamFactory_RequestDeviceAuthorization_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_MEDIA_RENDERER_AUDIO_OUTPUT_STREAM_FACTORY_MOJOM_SHARED_INTERNAL_H_