// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_SERVICE_WORKER_SERVICE_WORKER_CONTAINER_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_SERVICE_WORKER_SERVICE_WORKER_CONTAINER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "content/common/service_worker/controller_service_worker.mojom-shared-internal.h"
#include "mojo/common/string16.mojom-shared-internal.h"
#include "third_party/WebKit/common/service_worker/service_worker_error_type.mojom-shared-internal.h"
#include "third_party/WebKit/common/service_worker/service_worker_object.mojom-shared-internal.h"
#include "third_party/WebKit/common/service_worker/service_worker_registration.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/web_feature.mojom-shared-internal.h"
#include "url/mojo/url.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "content/common/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1972510619 value is based on sha256(salt + "ServiceWorkerContainerHost1").
constexpr uint32_t kServiceWorkerContainerHost_Register_Name = 1972510619;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_Register_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_Register_Params_Data));
      new (data()) ServiceWorkerContainerHost_Register_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_Register_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_Register_Params_Data>(index_);
    }
    ServiceWorkerContainerHost_Register_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> script_url;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerRegistrationOptions_Data> options;

 private:
  ServiceWorkerContainerHost_Register_Params_Data();
  ~ServiceWorkerContainerHost_Register_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_Register_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerContainerHost_Register_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_Register_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_Register_ResponseParams_Data));
      new (data()) ServiceWorkerContainerHost_Register_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_Register_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_Register_ResponseParams_Data>(index_);
    }
    ServiceWorkerContainerHost_Register_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> error_msg;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerRegistrationObjectInfo_Data> registration;

 private:
  ServiceWorkerContainerHost_Register_ResponseParams_Data();
  ~ServiceWorkerContainerHost_Register_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_Register_ResponseParams_Data) == 32,
              "Bad sizeof(ServiceWorkerContainerHost_Register_ResponseParams_Data)");
// The 750145875 value is based on sha256(salt + "ServiceWorkerContainerHost2").
constexpr uint32_t kServiceWorkerContainerHost_GetRegistration_Name = 750145875;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_GetRegistration_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_GetRegistration_Params_Data));
      new (data()) ServiceWorkerContainerHost_GetRegistration_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_GetRegistration_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_GetRegistration_Params_Data>(index_);
    }
    ServiceWorkerContainerHost_GetRegistration_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> client_url;

 private:
  ServiceWorkerContainerHost_GetRegistration_Params_Data();
  ~ServiceWorkerContainerHost_GetRegistration_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_GetRegistration_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerContainerHost_GetRegistration_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data));
      new (data()) ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data>(index_);
    }
    ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> error_msg;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerRegistrationObjectInfo_Data> registration;

 private:
  ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data();
  ~ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data) == 32,
              "Bad sizeof(ServiceWorkerContainerHost_GetRegistration_ResponseParams_Data)");
// The 438862042 value is based on sha256(salt + "ServiceWorkerContainerHost3").
constexpr uint32_t kServiceWorkerContainerHost_GetRegistrations_Name = 438862042;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_GetRegistrations_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_GetRegistrations_Params_Data));
      new (data()) ServiceWorkerContainerHost_GetRegistrations_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_GetRegistrations_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_GetRegistrations_Params_Data>(index_);
    }
    ServiceWorkerContainerHost_GetRegistrations_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorkerContainerHost_GetRegistrations_Params_Data();
  ~ServiceWorkerContainerHost_GetRegistrations_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_GetRegistrations_Params_Data) == 8,
              "Bad sizeof(ServiceWorkerContainerHost_GetRegistrations_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data));
      new (data()) ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data>(index_);
    }
    ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> error_msg;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerRegistrationObjectInfo_Data>>> infos;

 private:
  ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data();
  ~ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data) == 32,
              "Bad sizeof(ServiceWorkerContainerHost_GetRegistrations_ResponseParams_Data)");
// The 1058552856 value is based on sha256(salt + "ServiceWorkerContainerHost4").
constexpr uint32_t kServiceWorkerContainerHost_GetRegistrationForReady_Name = 1058552856;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data));
      new (data()) ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data>(index_);
    }
    ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data();
  ~ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data) == 8,
              "Bad sizeof(ServiceWorkerContainerHost_GetRegistrationForReady_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data));
      new (data()) ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data>(index_);
    }
    ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerRegistrationObjectInfo_Data> registration;

 private:
  ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data();
  ~ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorkerContainerHost_GetRegistrationForReady_ResponseParams_Data)");
// The 2018472074 value is based on sha256(salt + "ServiceWorkerContainerHost5").
constexpr uint32_t kServiceWorkerContainerHost_GetControllerServiceWorker_Name = 2018472074;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data));
      new (data()) ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data>(index_);
    }
    ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data controller;
  uint8_t padfinal_[4];

 private:
  ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data();
  ~ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerContainerHost_GetControllerServiceWorker_Params_Data)");
// The 843728428 value is based on sha256(salt + "ServiceWorkerContainerHost6").
constexpr uint32_t kServiceWorkerContainerHost_CloneForWorker_Name = 843728428;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainerHost_CloneForWorker_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainerHost_CloneForWorker_Params_Data));
      new (data()) ServiceWorkerContainerHost_CloneForWorker_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainerHost_CloneForWorker_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainerHost_CloneForWorker_Params_Data>(index_);
    }
    ServiceWorkerContainerHost_CloneForWorker_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data container_host_for_worker;
  uint8_t padfinal_[4];

 private:
  ServiceWorkerContainerHost_CloneForWorker_Params_Data();
  ~ServiceWorkerContainerHost_CloneForWorker_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainerHost_CloneForWorker_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerContainerHost_CloneForWorker_Params_Data)");
// The 1529019232 value is based on sha256(salt + "ServiceWorkerContainer1").
constexpr uint32_t kServiceWorkerContainer_SetController_Name = 1529019232;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainer_SetController_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainer_SetController_Params_Data));
      new (data()) ServiceWorkerContainer_SetController_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainer_SetController_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainer_SetController_Params_Data>(index_);
    }
    ServiceWorkerContainer_SetController_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::content::mojom::internal::ControllerServiceWorkerInfo_Data> controller_info;
  mojo::internal::Pointer<mojo::internal::Array_Data<int32_t>> used_features;
  uint8_t should_notify_controllerchange : 1;
  uint8_t padfinal_[7];

 private:
  ServiceWorkerContainer_SetController_Params_Data();
  ~ServiceWorkerContainer_SetController_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainer_SetController_Params_Data) == 32,
              "Bad sizeof(ServiceWorkerContainer_SetController_Params_Data)");
// The 27472857 value is based on sha256(salt + "ServiceWorkerContainer2").
constexpr uint32_t kServiceWorkerContainer_PostMessageToClient_Name = 27472857;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainer_PostMessageToClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainer_PostMessageToClient_Params_Data));
      new (data()) ServiceWorkerContainer_PostMessageToClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainer_PostMessageToClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainer_PostMessageToClient_Params_Data>(index_);
    }
    ServiceWorkerContainer_PostMessageToClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerObjectInfo_Data> source;
  mojo::internal::Pointer<::mojo::common::mojom::internal::String16_Data> message;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Handle_Data>> message_ports;

 private:
  ServiceWorkerContainer_PostMessageToClient_Params_Data();
  ~ServiceWorkerContainer_PostMessageToClient_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainer_PostMessageToClient_Params_Data) == 32,
              "Bad sizeof(ServiceWorkerContainer_PostMessageToClient_Params_Data)");
// The 1458129329 value is based on sha256(salt + "ServiceWorkerContainer3").
constexpr uint32_t kServiceWorkerContainer_CountFeature_Name = 1458129329;
class MOJOM_SHARED_CONTENT_EXPORT ServiceWorkerContainer_CountFeature_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerContainer_CountFeature_Params_Data));
      new (data()) ServiceWorkerContainer_CountFeature_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerContainer_CountFeature_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerContainer_CountFeature_Params_Data>(index_);
    }
    ServiceWorkerContainer_CountFeature_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t feature;
  uint8_t padfinal_[4];

 private:
  ServiceWorkerContainer_CountFeature_Params_Data();
  ~ServiceWorkerContainer_CountFeature_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerContainer_CountFeature_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerContainer_CountFeature_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_SERVICE_WORKER_SERVICE_WORKER_CONTAINER_MOJOM_SHARED_INTERNAL_H_