// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_SENSORS_PUBLIC_INTERFACES_MOTION_MOJOM_SHARED_INTERNAL_H_
#define DEVICE_SENSORS_PUBLIC_INTERFACES_MOTION_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1865835387 value is based on sha256(salt + "MotionSensor1").
constexpr uint32_t kMotionSensor_StartPolling_Name = 1865835387;
class  MotionSensor_StartPolling_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MotionSensor_StartPolling_Params_Data));
      new (data()) MotionSensor_StartPolling_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MotionSensor_StartPolling_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MotionSensor_StartPolling_Params_Data>(index_);
    }
    MotionSensor_StartPolling_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MotionSensor_StartPolling_Params_Data();
  ~MotionSensor_StartPolling_Params_Data() = delete;
};
static_assert(sizeof(MotionSensor_StartPolling_Params_Data) == 8,
              "Bad sizeof(MotionSensor_StartPolling_Params_Data)");
class  MotionSensor_StartPolling_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MotionSensor_StartPolling_ResponseParams_Data));
      new (data()) MotionSensor_StartPolling_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MotionSensor_StartPolling_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MotionSensor_StartPolling_ResponseParams_Data>(index_);
    }
    MotionSensor_StartPolling_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data memory_handle;
  uint8_t padfinal_[4];

 private:
  MotionSensor_StartPolling_ResponseParams_Data();
  ~MotionSensor_StartPolling_ResponseParams_Data() = delete;
};
static_assert(sizeof(MotionSensor_StartPolling_ResponseParams_Data) == 16,
              "Bad sizeof(MotionSensor_StartPolling_ResponseParams_Data)");
// The 1292020748 value is based on sha256(salt + "MotionSensor2").
constexpr uint32_t kMotionSensor_StopPolling_Name = 1292020748;
class  MotionSensor_StopPolling_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MotionSensor_StopPolling_Params_Data));
      new (data()) MotionSensor_StopPolling_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MotionSensor_StopPolling_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MotionSensor_StopPolling_Params_Data>(index_);
    }
    MotionSensor_StopPolling_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MotionSensor_StopPolling_Params_Data();
  ~MotionSensor_StopPolling_Params_Data() = delete;
};
static_assert(sizeof(MotionSensor_StopPolling_Params_Data) == 8,
              "Bad sizeof(MotionSensor_StopPolling_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // DEVICE_SENSORS_PUBLIC_INTERFACES_MOTION_MOJOM_SHARED_INTERNAL_H_