// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_SENSORS_PUBLIC_INTERFACES_ORIENTATION_MOJOM_SHARED_INTERNAL_H_
#define DEVICE_SENSORS_PUBLIC_INTERFACES_ORIENTATION_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1045897639 value is based on sha256(salt + "OrientationAbsoluteSensor1").
constexpr uint32_t kOrientationAbsoluteSensor_StartPolling_Name = 1045897639;
class  OrientationAbsoluteSensor_StartPolling_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OrientationAbsoluteSensor_StartPolling_Params_Data));
      new (data()) OrientationAbsoluteSensor_StartPolling_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OrientationAbsoluteSensor_StartPolling_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OrientationAbsoluteSensor_StartPolling_Params_Data>(index_);
    }
    OrientationAbsoluteSensor_StartPolling_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  OrientationAbsoluteSensor_StartPolling_Params_Data();
  ~OrientationAbsoluteSensor_StartPolling_Params_Data() = delete;
};
static_assert(sizeof(OrientationAbsoluteSensor_StartPolling_Params_Data) == 8,
              "Bad sizeof(OrientationAbsoluteSensor_StartPolling_Params_Data)");
class  OrientationAbsoluteSensor_StartPolling_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OrientationAbsoluteSensor_StartPolling_ResponseParams_Data));
      new (data()) OrientationAbsoluteSensor_StartPolling_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OrientationAbsoluteSensor_StartPolling_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OrientationAbsoluteSensor_StartPolling_ResponseParams_Data>(index_);
    }
    OrientationAbsoluteSensor_StartPolling_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data memory_handle;
  uint8_t padfinal_[4];

 private:
  OrientationAbsoluteSensor_StartPolling_ResponseParams_Data();
  ~OrientationAbsoluteSensor_StartPolling_ResponseParams_Data() = delete;
};
static_assert(sizeof(OrientationAbsoluteSensor_StartPolling_ResponseParams_Data) == 16,
              "Bad sizeof(OrientationAbsoluteSensor_StartPolling_ResponseParams_Data)");
// The 1576184340 value is based on sha256(salt + "OrientationAbsoluteSensor2").
constexpr uint32_t kOrientationAbsoluteSensor_StopPolling_Name = 1576184340;
class  OrientationAbsoluteSensor_StopPolling_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OrientationAbsoluteSensor_StopPolling_Params_Data));
      new (data()) OrientationAbsoluteSensor_StopPolling_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OrientationAbsoluteSensor_StopPolling_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OrientationAbsoluteSensor_StopPolling_Params_Data>(index_);
    }
    OrientationAbsoluteSensor_StopPolling_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  OrientationAbsoluteSensor_StopPolling_Params_Data();
  ~OrientationAbsoluteSensor_StopPolling_Params_Data() = delete;
};
static_assert(sizeof(OrientationAbsoluteSensor_StopPolling_Params_Data) == 8,
              "Bad sizeof(OrientationAbsoluteSensor_StopPolling_Params_Data)");
// The 863600106 value is based on sha256(salt + "OrientationSensor1").
constexpr uint32_t kOrientationSensor_StartPolling_Name = 863600106;
class  OrientationSensor_StartPolling_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OrientationSensor_StartPolling_Params_Data));
      new (data()) OrientationSensor_StartPolling_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OrientationSensor_StartPolling_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OrientationSensor_StartPolling_Params_Data>(index_);
    }
    OrientationSensor_StartPolling_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  OrientationSensor_StartPolling_Params_Data();
  ~OrientationSensor_StartPolling_Params_Data() = delete;
};
static_assert(sizeof(OrientationSensor_StartPolling_Params_Data) == 8,
              "Bad sizeof(OrientationSensor_StartPolling_Params_Data)");
class  OrientationSensor_StartPolling_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OrientationSensor_StartPolling_ResponseParams_Data));
      new (data()) OrientationSensor_StartPolling_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OrientationSensor_StartPolling_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OrientationSensor_StartPolling_ResponseParams_Data>(index_);
    }
    OrientationSensor_StartPolling_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data memory_handle;
  uint8_t padfinal_[4];

 private:
  OrientationSensor_StartPolling_ResponseParams_Data();
  ~OrientationSensor_StartPolling_ResponseParams_Data() = delete;
};
static_assert(sizeof(OrientationSensor_StartPolling_ResponseParams_Data) == 16,
              "Bad sizeof(OrientationSensor_StartPolling_ResponseParams_Data)");
// The 391776302 value is based on sha256(salt + "OrientationSensor2").
constexpr uint32_t kOrientationSensor_StopPolling_Name = 391776302;
class  OrientationSensor_StopPolling_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OrientationSensor_StopPolling_Params_Data));
      new (data()) OrientationSensor_StopPolling_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OrientationSensor_StopPolling_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OrientationSensor_StopPolling_Params_Data>(index_);
    }
    OrientationSensor_StopPolling_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  OrientationSensor_StopPolling_Params_Data();
  ~OrientationSensor_StopPolling_Params_Data() = delete;
};
static_assert(sizeof(OrientationSensor_StopPolling_Params_Data) == 8,
              "Bad sizeof(OrientationSensor_StopPolling_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // DEVICE_SENSORS_PUBLIC_INTERFACES_ORIENTATION_MOJOM_SHARED_INTERNAL_H_