// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "device/sensors/public/interfaces/orientation.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace device {
namespace mojom {
const char OrientationAbsoluteSensor::Name_[] = "device::mojom::OrientationAbsoluteSensor";

class OrientationAbsoluteSensor_StartPolling_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  OrientationAbsoluteSensor_StartPolling_ForwardToCallback(
      OrientationAbsoluteSensor::StartPollingCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  OrientationAbsoluteSensor::StartPollingCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(OrientationAbsoluteSensor_StartPolling_ForwardToCallback);
};

OrientationAbsoluteSensorProxy::OrientationAbsoluteSensorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void OrientationAbsoluteSensorProxy::StartPolling(
    StartPollingCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "device::mojom::OrientationAbsoluteSensor::StartPolling");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kOrientationAbsoluteSensor_StartPolling_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::device::mojom::internal::OrientationAbsoluteSensor_StartPolling_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new OrientationAbsoluteSensor_StartPolling_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void OrientationAbsoluteSensorProxy::StopPolling(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "device::mojom::OrientationAbsoluteSensor::StopPolling");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kOrientationAbsoluteSensor_StopPolling_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::device::mojom::internal::OrientationAbsoluteSensor_StopPolling_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class OrientationAbsoluteSensor_StartPolling_ProxyToResponder {
 public:
  static OrientationAbsoluteSensor::StartPollingCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<OrientationAbsoluteSensor_StartPolling_ProxyToResponder> proxy(
        new OrientationAbsoluteSensor_StartPolling_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&OrientationAbsoluteSensor_StartPolling_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~OrientationAbsoluteSensor_StartPolling_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  OrientationAbsoluteSensor_StartPolling_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "OrientationAbsoluteSensor::StartPollingCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      mojo::ScopedSharedBufferHandle in_memory_handle);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(OrientationAbsoluteSensor_StartPolling_ProxyToResponder);
};

bool OrientationAbsoluteSensor_StartPolling_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "device::mojom::OrientationAbsoluteSensor::StartPollingCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::OrientationAbsoluteSensor_StartPolling_ResponseParams_Data* params =
      reinterpret_cast<
          internal::OrientationAbsoluteSensor_StartPolling_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  mojo::ScopedSharedBufferHandle p_memory_handle{};
  OrientationAbsoluteSensor_StartPolling_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_memory_handle = input_data_view.TakeMemoryHandle();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "OrientationAbsoluteSensor::StartPolling response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_memory_handle));
  return true;
}

void OrientationAbsoluteSensor_StartPolling_ProxyToResponder::Run(
    mojo::ScopedSharedBufferHandle in_memory_handle) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kOrientationAbsoluteSensor_StartPolling_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::device::mojom::internal::OrientationAbsoluteSensor_StartPolling_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_memory_handle, &params->memory_handle, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->memory_handle),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid memory_handle in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationAbsoluteSensor::StartPollingCallback",
               "message", message.name());
#endif
  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool OrientationAbsoluteSensorStubDispatch::Accept(
    OrientationAbsoluteSensor* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kOrientationAbsoluteSensor_StartPolling_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationAbsoluteSensor::StartPolling",
               "message", message->name());
#endif
      break;
    }
    case internal::kOrientationAbsoluteSensor_StopPolling_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationAbsoluteSensor::StopPolling",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::OrientationAbsoluteSensor_StopPolling_Params_Data* params =
          reinterpret_cast<internal::OrientationAbsoluteSensor_StopPolling_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      OrientationAbsoluteSensor_StopPolling_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OrientationAbsoluteSensor::StopPolling deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StopPolling();
      return true;
    }
  }
  return false;
}

// static
bool OrientationAbsoluteSensorStubDispatch::AcceptWithResponder(
    OrientationAbsoluteSensor* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kOrientationAbsoluteSensor_StartPolling_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationAbsoluteSensor::StartPolling",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::OrientationAbsoluteSensor_StartPolling_Params_Data* params =
          reinterpret_cast<
              internal::OrientationAbsoluteSensor_StartPolling_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      OrientationAbsoluteSensor_StartPolling_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OrientationAbsoluteSensor::StartPolling deserializer");
        return false;
      }
      OrientationAbsoluteSensor::StartPollingCallback callback =
          OrientationAbsoluteSensor_StartPolling_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StartPolling(std::move(callback));
      return true;
    }
    case internal::kOrientationAbsoluteSensor_StopPolling_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationAbsoluteSensor::StopPolling",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool OrientationAbsoluteSensorRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OrientationAbsoluteSensor RequestValidator");

  switch (message->header()->name) {
    case internal::kOrientationAbsoluteSensor_StartPolling_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OrientationAbsoluteSensor_StartPolling_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kOrientationAbsoluteSensor_StopPolling_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OrientationAbsoluteSensor_StopPolling_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool OrientationAbsoluteSensorResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OrientationAbsoluteSensor ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kOrientationAbsoluteSensor_StartPolling_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::OrientationAbsoluteSensor_StartPolling_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
void OrientationAbsoluteSensorInterceptorForTesting::StartPolling(StartPollingCallback callback) {
  GetForwardingInterface()->StartPolling(std::move(callback));
}
void OrientationAbsoluteSensorInterceptorForTesting::StopPolling() {
  GetForwardingInterface()->StopPolling();
}
OrientationAbsoluteSensorAsyncWaiter::OrientationAbsoluteSensorAsyncWaiter(
    OrientationAbsoluteSensor* proxy) : proxy_(proxy) {}

OrientationAbsoluteSensorAsyncWaiter::~OrientationAbsoluteSensorAsyncWaiter() = default;

void OrientationAbsoluteSensorAsyncWaiter::StartPolling(
    mojo::ScopedSharedBufferHandle* out_memory_handle) {
  base::RunLoop loop;
  proxy_->StartPolling(
      base::Bind(
          [](base::RunLoop* loop,
             mojo::ScopedSharedBufferHandle* out_memory_handle
,
             mojo::ScopedSharedBufferHandle memory_handle) {*out_memory_handle = std::move(memory_handle);
            loop->Quit();
          },
          &loop,
          out_memory_handle));
  loop.Run();
}

const char OrientationSensor::Name_[] = "device::mojom::OrientationSensor";

class OrientationSensor_StartPolling_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  OrientationSensor_StartPolling_ForwardToCallback(
      OrientationSensor::StartPollingCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  OrientationSensor::StartPollingCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(OrientationSensor_StartPolling_ForwardToCallback);
};

OrientationSensorProxy::OrientationSensorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void OrientationSensorProxy::StartPolling(
    StartPollingCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "device::mojom::OrientationSensor::StartPolling");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kOrientationSensor_StartPolling_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::device::mojom::internal::OrientationSensor_StartPolling_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  std::unique_ptr<mojo::MessageReceiver> responder(
      new OrientationSensor_StartPolling_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void OrientationSensorProxy::StopPolling(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "device::mojom::OrientationSensor::StopPolling");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kOrientationSensor_StopPolling_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::device::mojom::internal::OrientationSensor_StopPolling_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class OrientationSensor_StartPolling_ProxyToResponder {
 public:
  static OrientationSensor::StartPollingCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<OrientationSensor_StartPolling_ProxyToResponder> proxy(
        new OrientationSensor_StartPolling_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::Bind(&OrientationSensor_StartPolling_ProxyToResponder::Run,
                      base::Passed(&proxy));
  }

  ~OrientationSensor_StartPolling_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  OrientationSensor_StartPolling_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "OrientationSensor::StartPollingCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      mojo::ScopedSharedBufferHandle in_memory_handle);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(OrientationSensor_StartPolling_ProxyToResponder);
};

bool OrientationSensor_StartPolling_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "device::mojom::OrientationSensor::StartPollingCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::OrientationSensor_StartPolling_ResponseParams_Data* params =
      reinterpret_cast<
          internal::OrientationSensor_StartPolling_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  mojo::ScopedSharedBufferHandle p_memory_handle{};
  OrientationSensor_StartPolling_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  p_memory_handle = input_data_view.TakeMemoryHandle();
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "OrientationSensor::StartPolling response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_memory_handle));
  return true;
}

void OrientationSensor_StartPolling_ProxyToResponder::Run(
    mojo::ScopedSharedBufferHandle in_memory_handle) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kOrientationSensor_StartPolling_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::device::mojom::internal::OrientationSensor_StartPolling_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_memory_handle, &params->memory_handle, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->memory_handle),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid memory_handle in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationSensor::StartPollingCallback",
               "message", message.name());
#endif
  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool OrientationSensorStubDispatch::Accept(
    OrientationSensor* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kOrientationSensor_StartPolling_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationSensor::StartPolling",
               "message", message->name());
#endif
      break;
    }
    case internal::kOrientationSensor_StopPolling_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationSensor::StopPolling",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::OrientationSensor_StopPolling_Params_Data* params =
          reinterpret_cast<internal::OrientationSensor_StopPolling_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      OrientationSensor_StopPolling_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OrientationSensor::StopPolling deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StopPolling();
      return true;
    }
  }
  return false;
}

// static
bool OrientationSensorStubDispatch::AcceptWithResponder(
    OrientationSensor* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kOrientationSensor_StartPolling_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationSensor::StartPolling",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::OrientationSensor_StartPolling_Params_Data* params =
          reinterpret_cast<
              internal::OrientationSensor_StartPolling_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      OrientationSensor_StartPolling_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "OrientationSensor::StartPolling deserializer");
        return false;
      }
      OrientationSensor::StartPollingCallback callback =
          OrientationSensor_StartPolling_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StartPolling(std::move(callback));
      return true;
    }
    case internal::kOrientationSensor_StopPolling_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)device::mojom::OrientationSensor::StopPolling",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool OrientationSensorRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OrientationSensor RequestValidator");

  switch (message->header()->name) {
    case internal::kOrientationSensor_StartPolling_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OrientationSensor_StartPolling_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kOrientationSensor_StopPolling_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::OrientationSensor_StopPolling_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool OrientationSensorResponseValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "OrientationSensor ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kOrientationSensor_StartPolling_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::OrientationSensor_StartPolling_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
void OrientationSensorInterceptorForTesting::StartPolling(StartPollingCallback callback) {
  GetForwardingInterface()->StartPolling(std::move(callback));
}
void OrientationSensorInterceptorForTesting::StopPolling() {
  GetForwardingInterface()->StopPolling();
}
OrientationSensorAsyncWaiter::OrientationSensorAsyncWaiter(
    OrientationSensor* proxy) : proxy_(proxy) {}

OrientationSensorAsyncWaiter::~OrientationSensorAsyncWaiter() = default;

void OrientationSensorAsyncWaiter::StartPolling(
    mojo::ScopedSharedBufferHandle* out_memory_handle) {
  base::RunLoop loop;
  proxy_->StartPolling(
      base::Bind(
          [](base::RunLoop* loop,
             mojo::ScopedSharedBufferHandle* out_memory_handle
,
             mojo::ScopedSharedBufferHandle memory_handle) {*out_memory_handle = std::move(memory_handle);
            loop->Quit();
          },
          &loop,
          out_memory_handle));
  loop.Run();
}

}  // namespace mojom
}  // namespace device

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif