// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef DEVICE_VR_VR_SERVICE_MOJOM_H_
#define DEVICE_VR_VR_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_features.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "device/vr/vr_service.mojom-shared.h"
#include "mojo/common/time.mojom.h"
#include "gpu/ipc/common/mailbox_holder.mojom.h"
#include "gpu/ipc/common/sync_token.mojom.h"
#include "ui/gfx/geometry/mojo/geometry.mojom.h"
#include "ui/gfx/mojo/gpu_fence_handle.mojom.h"
#include <string>
#include <vector>


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "device/vr/mojo_bindings_export.h"


namespace device {
namespace mojom {
class VRService;
using VRServicePtr = mojo::InterfacePtr<VRService>;
using VRServicePtrInfo = mojo::InterfacePtrInfo<VRService>;
using ThreadSafeVRServicePtr =
    mojo::ThreadSafeInterfacePtr<VRService>;
using VRServiceRequest = mojo::InterfaceRequest<VRService>;
using VRServiceAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRService>;
using ThreadSafeVRServiceAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRService>;
using VRServiceAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRService>;
using VRServiceAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRService>;

class VRServiceClient;
using VRServiceClientPtr = mojo::InterfacePtr<VRServiceClient>;
using VRServiceClientPtrInfo = mojo::InterfacePtrInfo<VRServiceClient>;
using ThreadSafeVRServiceClientPtr =
    mojo::ThreadSafeInterfacePtr<VRServiceClient>;
using VRServiceClientRequest = mojo::InterfaceRequest<VRServiceClient>;
using VRServiceClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRServiceClient>;
using ThreadSafeVRServiceClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRServiceClient>;
using VRServiceClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRServiceClient>;
using VRServiceClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRServiceClient>;

class VRSubmitFrameClient;
using VRSubmitFrameClientPtr = mojo::InterfacePtr<VRSubmitFrameClient>;
using VRSubmitFrameClientPtrInfo = mojo::InterfacePtrInfo<VRSubmitFrameClient>;
using ThreadSafeVRSubmitFrameClientPtr =
    mojo::ThreadSafeInterfacePtr<VRSubmitFrameClient>;
using VRSubmitFrameClientRequest = mojo::InterfaceRequest<VRSubmitFrameClient>;
using VRSubmitFrameClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRSubmitFrameClient>;
using ThreadSafeVRSubmitFrameClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRSubmitFrameClient>;
using VRSubmitFrameClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRSubmitFrameClient>;
using VRSubmitFrameClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRSubmitFrameClient>;

class VRDisplayHost;
using VRDisplayHostPtr = mojo::InterfacePtr<VRDisplayHost>;
using VRDisplayHostPtrInfo = mojo::InterfacePtrInfo<VRDisplayHost>;
using ThreadSafeVRDisplayHostPtr =
    mojo::ThreadSafeInterfacePtr<VRDisplayHost>;
using VRDisplayHostRequest = mojo::InterfaceRequest<VRDisplayHost>;
using VRDisplayHostAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRDisplayHost>;
using ThreadSafeVRDisplayHostAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRDisplayHost>;
using VRDisplayHostAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRDisplayHost>;
using VRDisplayHostAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRDisplayHost>;

class VRMagicWindowProvider;
using VRMagicWindowProviderPtr = mojo::InterfacePtr<VRMagicWindowProvider>;
using VRMagicWindowProviderPtrInfo = mojo::InterfacePtrInfo<VRMagicWindowProvider>;
using ThreadSafeVRMagicWindowProviderPtr =
    mojo::ThreadSafeInterfacePtr<VRMagicWindowProvider>;
using VRMagicWindowProviderRequest = mojo::InterfaceRequest<VRMagicWindowProvider>;
using VRMagicWindowProviderAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRMagicWindowProvider>;
using ThreadSafeVRMagicWindowProviderAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRMagicWindowProvider>;
using VRMagicWindowProviderAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRMagicWindowProvider>;
using VRMagicWindowProviderAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRMagicWindowProvider>;

class VRPresentationProvider;
using VRPresentationProviderPtr = mojo::InterfacePtr<VRPresentationProvider>;
using VRPresentationProviderPtrInfo = mojo::InterfacePtrInfo<VRPresentationProvider>;
using ThreadSafeVRPresentationProviderPtr =
    mojo::ThreadSafeInterfacePtr<VRPresentationProvider>;
using VRPresentationProviderRequest = mojo::InterfaceRequest<VRPresentationProvider>;
using VRPresentationProviderAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRPresentationProvider>;
using ThreadSafeVRPresentationProviderAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRPresentationProvider>;
using VRPresentationProviderAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRPresentationProvider>;
using VRPresentationProviderAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRPresentationProvider>;

class VRDisplayClient;
using VRDisplayClientPtr = mojo::InterfacePtr<VRDisplayClient>;
using VRDisplayClientPtrInfo = mojo::InterfacePtrInfo<VRDisplayClient>;
using ThreadSafeVRDisplayClientPtr =
    mojo::ThreadSafeInterfacePtr<VRDisplayClient>;
using VRDisplayClientRequest = mojo::InterfaceRequest<VRDisplayClient>;
using VRDisplayClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<VRDisplayClient>;
using ThreadSafeVRDisplayClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<VRDisplayClient>;
using VRDisplayClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<VRDisplayClient>;
using VRDisplayClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<VRDisplayClient>;

class VRFieldOfView;
using VRFieldOfViewPtr = mojo::InlinedStructPtr<VRFieldOfView>;

class VRPose;
using VRPosePtr = mojo::StructPtr<VRPose>;

class VRDisplayCapabilities;
using VRDisplayCapabilitiesPtr = mojo::InlinedStructPtr<VRDisplayCapabilities>;

class VREyeParameters;
using VREyeParametersPtr = mojo::StructPtr<VREyeParameters>;

class VRStageParameters;
using VRStageParametersPtr = mojo::StructPtr<VRStageParameters>;

class VRDisplayInfo;
using VRDisplayInfoPtr = mojo::StructPtr<VRDisplayInfo>;

class VRRequestPresentOptions;
using VRRequestPresentOptionsPtr = mojo::InlinedStructPtr<VRRequestPresentOptions>;

class VRDisplayFrameTransportOptions;
using VRDisplayFrameTransportOptionsPtr = mojo::InlinedStructPtr<VRDisplayFrameTransportOptions>;


class VRServiceProxy;

template <typename ImplRefTraits>
class VRServiceStub;

class VRServiceRequestValidator;
class VRServiceResponseValidator;

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRService
    : public VRServiceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRServiceStub<ImplRefTraits>;

  using RequestValidator_ = VRServiceRequestValidator;
  using ResponseValidator_ = VRServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kSetClientMinVersion = 0,
    kSetListeningForActivateMinVersion = 0,
  };
  virtual ~VRService() {}


  using SetClientCallback = base::OnceCallback<void()>;
  virtual void SetClient(VRServiceClientPtr client, SetClientCallback callback) = 0;

  virtual void SetListeningForActivate(bool listening) = 0;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceInterceptorForTesting : public VRService {
  virtual VRService* GetForwardingInterface() = 0;
  void SetClient(VRServiceClientPtr client, SetClientCallback callback) override;
  void SetListeningForActivate(bool listening) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceAsyncWaiter {
 public:
  explicit VRServiceAsyncWaiter(VRService* proxy);
  ~VRServiceAsyncWaiter();
  void SetClient(
      VRServiceClientPtr client);

 private:
  VRService* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VRServiceAsyncWaiter);
};

class VRServiceClientProxy;

template <typename ImplRefTraits>
class VRServiceClientStub;

class VRServiceClientRequestValidator;

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceClient
    : public VRServiceClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRServiceClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRServiceClientStub<ImplRefTraits>;

  using RequestValidator_ = VRServiceClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnDisplayConnectedMinVersion = 0,
  };
  virtual ~VRServiceClient() {}

  virtual void OnDisplayConnected(VRMagicWindowProviderPtr magic_window_provider, VRDisplayHostPtr display, VRDisplayClientRequest request, VRDisplayInfoPtr display_info) = 0;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceClientInterceptorForTesting : public VRServiceClient {
  virtual VRServiceClient* GetForwardingInterface() = 0;
  void OnDisplayConnected(VRMagicWindowProviderPtr magic_window_provider, VRDisplayHostPtr display, VRDisplayClientRequest request, VRDisplayInfoPtr display_info) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceClientAsyncWaiter {
 public:
  explicit VRServiceClientAsyncWaiter(VRServiceClient* proxy);
  ~VRServiceClientAsyncWaiter();

 private:
  VRServiceClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VRServiceClientAsyncWaiter);
};

class VRSubmitFrameClientProxy;

template <typename ImplRefTraits>
class VRSubmitFrameClientStub;

class VRSubmitFrameClientRequestValidator;

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRSubmitFrameClient
    : public VRSubmitFrameClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRSubmitFrameClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRSubmitFrameClientStub<ImplRefTraits>;

  using RequestValidator_ = VRSubmitFrameClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnSubmitFrameTransferredMinVersion = 0,
    kOnSubmitFrameRenderedMinVersion = 0,
    kOnSubmitFrameGpuFenceMinVersion = 0,
  };
  virtual ~VRSubmitFrameClient() {}

  virtual void OnSubmitFrameTransferred(bool success) = 0;

  virtual void OnSubmitFrameRendered() = 0;

  virtual void OnSubmitFrameGpuFence(const ::gfx::GpuFenceHandle& gpu_fence_handle) = 0;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRSubmitFrameClientInterceptorForTesting : public VRSubmitFrameClient {
  virtual VRSubmitFrameClient* GetForwardingInterface() = 0;
  void OnSubmitFrameTransferred(bool success) override;
  void OnSubmitFrameRendered() override;
  void OnSubmitFrameGpuFence(const ::gfx::GpuFenceHandle& gpu_fence_handle) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRSubmitFrameClientAsyncWaiter {
 public:
  explicit VRSubmitFrameClientAsyncWaiter(VRSubmitFrameClient* proxy);
  ~VRSubmitFrameClientAsyncWaiter();

 private:
  VRSubmitFrameClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VRSubmitFrameClientAsyncWaiter);
};

class VRDisplayHostProxy;

template <typename ImplRefTraits>
class VRDisplayHostStub;

class VRDisplayHostRequestValidator;
class VRDisplayHostResponseValidator;

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayHost
    : public VRDisplayHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRDisplayHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRDisplayHostStub<ImplRefTraits>;

  using RequestValidator_ = VRDisplayHostRequestValidator;
  using ResponseValidator_ = VRDisplayHostResponseValidator;
  enum MethodMinVersions : uint32_t {
    kRequestPresentMinVersion = 0,
    kExitPresentMinVersion = 0,
  };
  virtual ~VRDisplayHost() {}


  using RequestPresentCallback = base::OnceCallback<void(bool, VRDisplayFrameTransportOptionsPtr)>;
  virtual void RequestPresent(VRSubmitFrameClientPtr client, VRPresentationProviderRequest request, VRRequestPresentOptionsPtr options, RequestPresentCallback callback) = 0;

  virtual void ExitPresent() = 0;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayHostInterceptorForTesting : public VRDisplayHost {
  virtual VRDisplayHost* GetForwardingInterface() = 0;
  void RequestPresent(VRSubmitFrameClientPtr client, VRPresentationProviderRequest request, VRRequestPresentOptionsPtr options, RequestPresentCallback callback) override;
  void ExitPresent() override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayHostAsyncWaiter {
 public:
  explicit VRDisplayHostAsyncWaiter(VRDisplayHost* proxy);
  ~VRDisplayHostAsyncWaiter();
  void RequestPresent(
      VRSubmitFrameClientPtr client, VRPresentationProviderRequest request, VRRequestPresentOptionsPtr options, bool* out_success, VRDisplayFrameTransportOptionsPtr* out_transport_options);

 private:
  VRDisplayHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VRDisplayHostAsyncWaiter);
};

class VRMagicWindowProviderProxy;

template <typename ImplRefTraits>
class VRMagicWindowProviderStub;

class VRMagicWindowProviderRequestValidator;
class VRMagicWindowProviderResponseValidator;

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRMagicWindowProvider
    : public VRMagicWindowProviderInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRMagicWindowProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRMagicWindowProviderStub<ImplRefTraits>;

  using RequestValidator_ = VRMagicWindowProviderRequestValidator;
  using ResponseValidator_ = VRMagicWindowProviderResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetPoseMinVersion = 0,
  };
  virtual ~VRMagicWindowProvider() {}


  using GetPoseCallback = base::OnceCallback<void(VRPosePtr)>;
  virtual void GetPose(GetPoseCallback callback) = 0;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRMagicWindowProviderInterceptorForTesting : public VRMagicWindowProvider {
  virtual VRMagicWindowProvider* GetForwardingInterface() = 0;
  void GetPose(GetPoseCallback callback) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRMagicWindowProviderAsyncWaiter {
 public:
  explicit VRMagicWindowProviderAsyncWaiter(VRMagicWindowProvider* proxy);
  ~VRMagicWindowProviderAsyncWaiter();
  void GetPose(
      VRPosePtr* out_pose);

 private:
  VRMagicWindowProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VRMagicWindowProviderAsyncWaiter);
};

class VRPresentationProviderProxy;

template <typename ImplRefTraits>
class VRPresentationProviderStub;

class VRPresentationProviderRequestValidator;
class VRPresentationProviderResponseValidator;

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRPresentationProvider
    : public VRPresentationProviderInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRPresentationProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRPresentationProviderStub<ImplRefTraits>;

  using RequestValidator_ = VRPresentationProviderRequestValidator;
  using ResponseValidator_ = VRPresentationProviderResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetVSyncMinVersion = 0,
    kUpdateLayerBoundsMinVersion = 0,
    kSubmitFrameMinVersion = 0,
    kSubmitFrameWithTextureHandleMinVersion = 0,
  };
  using VSyncStatus = VRPresentationProvider_VSyncStatus;
  virtual ~VRPresentationProvider() {}


  using GetVSyncCallback = base::OnceCallback<void(VRPosePtr, base::TimeDelta, int16_t, VRPresentationProvider::VSyncStatus)>;
  virtual void GetVSync(GetVSyncCallback callback) = 0;

  virtual void UpdateLayerBounds(int16_t frame_id, const gfx::RectF& left_bounds, const gfx::RectF& right_bounds, const gfx::Size& source_size) = 0;

  virtual void SubmitFrame(int16_t frame_id, const ::gpu::MailboxHolder& mailbox_holder, base::TimeDelta time_waited) = 0;

  virtual void SubmitFrameWithTextureHandle(int16_t frameId, mojo::ScopedHandle texture) = 0;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRPresentationProviderInterceptorForTesting : public VRPresentationProvider {
  virtual VRPresentationProvider* GetForwardingInterface() = 0;
  void GetVSync(GetVSyncCallback callback) override;
  void UpdateLayerBounds(int16_t frame_id, const gfx::RectF& left_bounds, const gfx::RectF& right_bounds, const gfx::Size& source_size) override;
  void SubmitFrame(int16_t frame_id, const ::gpu::MailboxHolder& mailbox_holder, base::TimeDelta time_waited) override;
  void SubmitFrameWithTextureHandle(int16_t frameId, mojo::ScopedHandle texture) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRPresentationProviderAsyncWaiter {
 public:
  explicit VRPresentationProviderAsyncWaiter(VRPresentationProvider* proxy);
  ~VRPresentationProviderAsyncWaiter();
  void GetVSync(
      VRPosePtr* out_pose, base::TimeDelta* out_time, int16_t* out_frame_id, VRPresentationProvider::VSyncStatus* out_status);

 private:
  VRPresentationProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VRPresentationProviderAsyncWaiter);
};

class VRDisplayClientProxy;

template <typename ImplRefTraits>
class VRDisplayClientStub;

class VRDisplayClientRequestValidator;
class VRDisplayClientResponseValidator;

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayClient
    : public VRDisplayClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = VRDisplayClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = VRDisplayClientStub<ImplRefTraits>;

  using RequestValidator_ = VRDisplayClientRequestValidator;
  using ResponseValidator_ = VRDisplayClientResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOnChangedMinVersion = 0,
    kOnExitPresentMinVersion = 0,
    kOnBlurMinVersion = 0,
    kOnFocusMinVersion = 0,
    kOnActivateMinVersion = 0,
    kOnDeactivateMinVersion = 0,
  };
  virtual ~VRDisplayClient() {}

  virtual void OnChanged(VRDisplayInfoPtr display) = 0;

  virtual void OnExitPresent() = 0;

  virtual void OnBlur() = 0;

  virtual void OnFocus() = 0;


  using OnActivateCallback = base::OnceCallback<void(bool)>;
  virtual void OnActivate(VRDisplayEventReason reason, OnActivateCallback callback) = 0;

  virtual void OnDeactivate(VRDisplayEventReason reason) = 0;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayClientInterceptorForTesting : public VRDisplayClient {
  virtual VRDisplayClient* GetForwardingInterface() = 0;
  void OnChanged(VRDisplayInfoPtr display) override;
  void OnExitPresent() override;
  void OnBlur() override;
  void OnFocus() override;
  void OnActivate(VRDisplayEventReason reason, OnActivateCallback callback) override;
  void OnDeactivate(VRDisplayEventReason reason) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayClientAsyncWaiter {
 public:
  explicit VRDisplayClientAsyncWaiter(VRDisplayClient* proxy);
  ~VRDisplayClientAsyncWaiter();
  void OnActivate(
      VRDisplayEventReason reason, bool* out_will_not_present);

 private:
  VRDisplayClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(VRDisplayClientAsyncWaiter);
};

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceProxy
    : public VRService {
 public:
  explicit VRServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  void SetClient(VRServiceClientPtr client, SetClientCallback callback) final;
  void SetListeningForActivate(bool listening) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceClientProxy
    : public VRServiceClient {
 public:
  explicit VRServiceClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnDisplayConnected(VRMagicWindowProviderPtr magic_window_provider, VRDisplayHostPtr display, VRDisplayClientRequest request, VRDisplayInfoPtr display_info) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRSubmitFrameClientProxy
    : public VRSubmitFrameClient {
 public:
  explicit VRSubmitFrameClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnSubmitFrameTransferred(bool success) final;
  void OnSubmitFrameRendered() final;
  void OnSubmitFrameGpuFence(const ::gfx::GpuFenceHandle& gpu_fence_handle) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayHostProxy
    : public VRDisplayHost {
 public:
  explicit VRDisplayHostProxy(mojo::MessageReceiverWithResponder* receiver);
  void RequestPresent(VRSubmitFrameClientPtr client, VRPresentationProviderRequest request, VRRequestPresentOptionsPtr options, RequestPresentCallback callback) final;
  void ExitPresent() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRMagicWindowProviderProxy
    : public VRMagicWindowProvider {
 public:
  explicit VRMagicWindowProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  void GetPose(GetPoseCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRPresentationProviderProxy
    : public VRPresentationProvider {
 public:
  explicit VRPresentationProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  void GetVSync(GetVSyncCallback callback) final;
  void UpdateLayerBounds(int16_t frame_id, const gfx::RectF& left_bounds, const gfx::RectF& right_bounds, const gfx::Size& source_size) final;
  void SubmitFrame(int16_t frame_id, const ::gpu::MailboxHolder& mailbox_holder, base::TimeDelta time_waited) final;
  void SubmitFrameWithTextureHandle(int16_t frameId, mojo::ScopedHandle texture) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayClientProxy
    : public VRDisplayClient {
 public:
  explicit VRDisplayClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnChanged(VRDisplayInfoPtr display) final;
  void OnExitPresent() final;
  void OnBlur() final;
  void OnFocus() final;
  void OnActivate(VRDisplayEventReason reason, OnActivateCallback callback) final;
  void OnDeactivate(VRDisplayEventReason reason) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceStubDispatch {
 public:
  static bool Accept(VRService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRService>>
class VRServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRServiceStub() {}
  ~VRServiceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceClientStubDispatch {
 public:
  static bool Accept(VRServiceClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRServiceClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRServiceClient>>
class VRServiceClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRServiceClientStub() {}
  ~VRServiceClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRServiceClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRServiceClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRSubmitFrameClientStubDispatch {
 public:
  static bool Accept(VRSubmitFrameClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRSubmitFrameClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRSubmitFrameClient>>
class VRSubmitFrameClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRSubmitFrameClientStub() {}
  ~VRSubmitFrameClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRSubmitFrameClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRSubmitFrameClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayHostStubDispatch {
 public:
  static bool Accept(VRDisplayHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRDisplayHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRDisplayHost>>
class VRDisplayHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRDisplayHostStub() {}
  ~VRDisplayHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRDisplayHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRDisplayHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRMagicWindowProviderStubDispatch {
 public:
  static bool Accept(VRMagicWindowProvider* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRMagicWindowProvider* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRMagicWindowProvider>>
class VRMagicWindowProviderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRMagicWindowProviderStub() {}
  ~VRMagicWindowProviderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRMagicWindowProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRMagicWindowProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRPresentationProviderStubDispatch {
 public:
  static bool Accept(VRPresentationProvider* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRPresentationProvider* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRPresentationProvider>>
class VRPresentationProviderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRPresentationProviderStub() {}
  ~VRPresentationProviderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRPresentationProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRPresentationProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayClientStubDispatch {
 public:
  static bool Accept(VRDisplayClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VRDisplayClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VRDisplayClient>>
class VRDisplayClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VRDisplayClientStub() {}
  ~VRDisplayClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRDisplayClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VRDisplayClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRSubmitFrameClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRMagicWindowProviderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRPresentationProviderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayHostResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRMagicWindowProviderResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRPresentationProviderResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayClientResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};


class DEVICE_VR_MOJO_BINDINGS_EXPORT VRFieldOfView {
 public:
  using DataView = VRFieldOfViewDataView;
  using Data_ = internal::VRFieldOfView_Data;

  template <typename... Args>
  static VRFieldOfViewPtr New(Args&&... args) {
    return VRFieldOfViewPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRFieldOfViewPtr From(const U& u) {
    return mojo::TypeConverter<VRFieldOfViewPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRFieldOfView>::Convert(*this);
  }


  VRFieldOfView();

  VRFieldOfView(
      float upDegrees,
      float downDegrees,
      float leftDegrees,
      float rightDegrees);

  ~VRFieldOfView();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRFieldOfViewPtr>
  VRFieldOfViewPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRFieldOfView>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VRFieldOfView::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VRFieldOfView::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VRFieldOfView_UnserializedMessageContext<
            UserType, VRFieldOfView::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VRFieldOfView::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VRFieldOfView::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VRFieldOfView_UnserializedMessageContext<
            UserType, VRFieldOfView::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VRFieldOfView::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  float upDegrees;
  float downDegrees;
  float leftDegrees;
  float rightDegrees;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};



class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayCapabilities {
 public:
  using DataView = VRDisplayCapabilitiesDataView;
  using Data_ = internal::VRDisplayCapabilities_Data;

  template <typename... Args>
  static VRDisplayCapabilitiesPtr New(Args&&... args) {
    return VRDisplayCapabilitiesPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRDisplayCapabilitiesPtr From(const U& u) {
    return mojo::TypeConverter<VRDisplayCapabilitiesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRDisplayCapabilities>::Convert(*this);
  }


  VRDisplayCapabilities();

  VRDisplayCapabilities(
      bool hasPosition,
      bool hasExternalDisplay,
      bool canPresent);

  ~VRDisplayCapabilities();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRDisplayCapabilitiesPtr>
  VRDisplayCapabilitiesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRDisplayCapabilities>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VRDisplayCapabilities::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VRDisplayCapabilities::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VRDisplayCapabilities_UnserializedMessageContext<
            UserType, VRDisplayCapabilities::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VRDisplayCapabilities::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VRDisplayCapabilities::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VRDisplayCapabilities_UnserializedMessageContext<
            UserType, VRDisplayCapabilities::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VRDisplayCapabilities::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  bool hasPosition;
  bool hasExternalDisplay;
  bool canPresent;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};





class DEVICE_VR_MOJO_BINDINGS_EXPORT VRRequestPresentOptions {
 public:
  using DataView = VRRequestPresentOptionsDataView;
  using Data_ = internal::VRRequestPresentOptions_Data;

  template <typename... Args>
  static VRRequestPresentOptionsPtr New(Args&&... args) {
    return VRRequestPresentOptionsPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRRequestPresentOptionsPtr From(const U& u) {
    return mojo::TypeConverter<VRRequestPresentOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRRequestPresentOptions>::Convert(*this);
  }


  VRRequestPresentOptions();

  explicit VRRequestPresentOptions(
      bool preserve_drawing_buffer);

  ~VRRequestPresentOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRRequestPresentOptionsPtr>
  VRRequestPresentOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRRequestPresentOptions>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VRRequestPresentOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VRRequestPresentOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VRRequestPresentOptions_UnserializedMessageContext<
            UserType, VRRequestPresentOptions::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VRRequestPresentOptions::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VRRequestPresentOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VRRequestPresentOptions_UnserializedMessageContext<
            UserType, VRRequestPresentOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VRRequestPresentOptions::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  bool preserve_drawing_buffer;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};


class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayFrameTransportOptions {
 public:
  using DataView = VRDisplayFrameTransportOptionsDataView;
  using Data_ = internal::VRDisplayFrameTransportOptions_Data;

  template <typename... Args>
  static VRDisplayFrameTransportOptionsPtr New(Args&&... args) {
    return VRDisplayFrameTransportOptionsPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRDisplayFrameTransportOptionsPtr From(const U& u) {
    return mojo::TypeConverter<VRDisplayFrameTransportOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRDisplayFrameTransportOptions>::Convert(*this);
  }


  VRDisplayFrameTransportOptions();

  VRDisplayFrameTransportOptions(
      VRDisplayFrameTransportMethod transport_method,
      bool wait_for_transfer_notification,
      bool wait_for_render_notification,
      bool wait_for_gpu_fence);

  ~VRDisplayFrameTransportOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRDisplayFrameTransportOptionsPtr>
  VRDisplayFrameTransportOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRDisplayFrameTransportOptions>::value>::type* = nullptr>
  bool Equals(const T& other) const;
  size_t Hash(size_t seed) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VRDisplayFrameTransportOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VRDisplayFrameTransportOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VRDisplayFrameTransportOptions_UnserializedMessageContext<
            UserType, VRDisplayFrameTransportOptions::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VRDisplayFrameTransportOptions::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VRDisplayFrameTransportOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VRDisplayFrameTransportOptions_UnserializedMessageContext<
            UserType, VRDisplayFrameTransportOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VRDisplayFrameTransportOptions::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  VRDisplayFrameTransportMethod transport_method;
  bool wait_for_transfer_notification;
  bool wait_for_render_notification;
  bool wait_for_gpu_fence;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};





class DEVICE_VR_MOJO_BINDINGS_EXPORT VRPose {
 public:
  using DataView = VRPoseDataView;
  using Data_ = internal::VRPose_Data;

  template <typename... Args>
  static VRPosePtr New(Args&&... args) {
    return VRPosePtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRPosePtr From(const U& u) {
    return mojo::TypeConverter<VRPosePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRPose>::Convert(*this);
  }


  VRPose();

  VRPose(
      const base::Optional<std::vector<float>>& orientation,
      const base::Optional<std::vector<float>>& position,
      const base::Optional<std::vector<float>>& angularVelocity,
      const base::Optional<std::vector<float>>& linearVelocity,
      const base::Optional<std::vector<float>>& angularAcceleration,
      const base::Optional<std::vector<float>>& linearAcceleration);

  ~VRPose();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRPosePtr>
  VRPosePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRPose>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VRPose::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VRPose::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VRPose_UnserializedMessageContext<
            UserType, VRPose::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VRPose::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VRPose::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VRPose_UnserializedMessageContext<
            UserType, VRPose::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VRPose::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  base::Optional<std::vector<float>> orientation;
  base::Optional<std::vector<float>> position;
  base::Optional<std::vector<float>> angularVelocity;
  base::Optional<std::vector<float>> linearVelocity;
  base::Optional<std::vector<float>> angularAcceleration;
  base::Optional<std::vector<float>> linearAcceleration;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};



class DEVICE_VR_MOJO_BINDINGS_EXPORT VREyeParameters {
 public:
  using DataView = VREyeParametersDataView;
  using Data_ = internal::VREyeParameters_Data;

  template <typename... Args>
  static VREyeParametersPtr New(Args&&... args) {
    return VREyeParametersPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VREyeParametersPtr From(const U& u) {
    return mojo::TypeConverter<VREyeParametersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VREyeParameters>::Convert(*this);
  }


  VREyeParameters();

  VREyeParameters(
      VRFieldOfViewPtr fieldOfView,
      const std::vector<float>& offset,
      uint32_t renderWidth,
      uint32_t renderHeight);

  ~VREyeParameters();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VREyeParametersPtr>
  VREyeParametersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VREyeParameters>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VREyeParameters::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VREyeParameters::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VREyeParameters_UnserializedMessageContext<
            UserType, VREyeParameters::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VREyeParameters::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VREyeParameters::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VREyeParameters_UnserializedMessageContext<
            UserType, VREyeParameters::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VREyeParameters::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  VRFieldOfViewPtr fieldOfView;
  std::vector<float> offset;
  uint32_t renderWidth;
  uint32_t renderHeight;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(VREyeParameters);
};


class DEVICE_VR_MOJO_BINDINGS_EXPORT VRStageParameters {
 public:
  using DataView = VRStageParametersDataView;
  using Data_ = internal::VRStageParameters_Data;

  template <typename... Args>
  static VRStageParametersPtr New(Args&&... args) {
    return VRStageParametersPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRStageParametersPtr From(const U& u) {
    return mojo::TypeConverter<VRStageParametersPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRStageParameters>::Convert(*this);
  }


  VRStageParameters();

  VRStageParameters(
      const std::vector<float>& standingTransform,
      float sizeX,
      float sizeZ);

  ~VRStageParameters();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRStageParametersPtr>
  VRStageParametersPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRStageParameters>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VRStageParameters::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VRStageParameters::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VRStageParameters_UnserializedMessageContext<
            UserType, VRStageParameters::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VRStageParameters::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VRStageParameters::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VRStageParameters_UnserializedMessageContext<
            UserType, VRStageParameters::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VRStageParameters::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  std::vector<float> standingTransform;
  float sizeX;
  float sizeZ;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};


class DEVICE_VR_MOJO_BINDINGS_EXPORT VRDisplayInfo {
 public:
  using DataView = VRDisplayInfoDataView;
  using Data_ = internal::VRDisplayInfo_Data;

  template <typename... Args>
  static VRDisplayInfoPtr New(Args&&... args) {
    return VRDisplayInfoPtr(
        base::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static VRDisplayInfoPtr From(const U& u) {
    return mojo::TypeConverter<VRDisplayInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VRDisplayInfo>::Convert(*this);
  }


  VRDisplayInfo();

  VRDisplayInfo(
      uint32_t index,
      const std::string& displayName,
      VRDisplayCapabilitiesPtr capabilities,
      VRStageParametersPtr stageParameters,
      VREyeParametersPtr leftEye,
      VREyeParametersPtr rightEye);

  ~VRDisplayInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VRDisplayInfoPtr>
  VRDisplayInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, VRDisplayInfo>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        VRDisplayInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VRDisplayInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VRDisplayInfo_UnserializedMessageContext<
            UserType, VRDisplayInfo::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<VRDisplayInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VRDisplayInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VRDisplayInfo_UnserializedMessageContext<
            UserType, VRDisplayInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VRDisplayInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  uint32_t index;
  std::string displayName;
  VRDisplayCapabilitiesPtr capabilities;
  VRStageParametersPtr stageParameters;
  VREyeParametersPtr leftEye;
  VREyeParametersPtr rightEye;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(VRDisplayInfo);
};



template <typename StructPtrType>
VRFieldOfViewPtr VRFieldOfView::Clone() const {
  return New(
      mojo::Clone(upDegrees),
      mojo::Clone(downDegrees),
      mojo::Clone(leftDegrees),
      mojo::Clone(rightDegrees)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRFieldOfView>::value>::type*>
bool VRFieldOfView::Equals(const T& other) const {
  if (!mojo::Equals(this->upDegrees, other.upDegrees))
    return false;
  if (!mojo::Equals(this->downDegrees, other.downDegrees))
    return false;
  if (!mojo::Equals(this->leftDegrees, other.leftDegrees))
    return false;
  if (!mojo::Equals(this->rightDegrees, other.rightDegrees))
    return false;
  return true;
}
template <typename StructPtrType>
VRPosePtr VRPose::Clone() const {
  return New(
      mojo::Clone(orientation),
      mojo::Clone(position),
      mojo::Clone(angularVelocity),
      mojo::Clone(linearVelocity),
      mojo::Clone(angularAcceleration),
      mojo::Clone(linearAcceleration)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRPose>::value>::type*>
bool VRPose::Equals(const T& other) const {
  if (!mojo::Equals(this->orientation, other.orientation))
    return false;
  if (!mojo::Equals(this->position, other.position))
    return false;
  if (!mojo::Equals(this->angularVelocity, other.angularVelocity))
    return false;
  if (!mojo::Equals(this->linearVelocity, other.linearVelocity))
    return false;
  if (!mojo::Equals(this->angularAcceleration, other.angularAcceleration))
    return false;
  if (!mojo::Equals(this->linearAcceleration, other.linearAcceleration))
    return false;
  return true;
}
template <typename StructPtrType>
VRDisplayCapabilitiesPtr VRDisplayCapabilities::Clone() const {
  return New(
      mojo::Clone(hasPosition),
      mojo::Clone(hasExternalDisplay),
      mojo::Clone(canPresent)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRDisplayCapabilities>::value>::type*>
bool VRDisplayCapabilities::Equals(const T& other) const {
  if (!mojo::Equals(this->hasPosition, other.hasPosition))
    return false;
  if (!mojo::Equals(this->hasExternalDisplay, other.hasExternalDisplay))
    return false;
  if (!mojo::Equals(this->canPresent, other.canPresent))
    return false;
  return true;
}
template <typename StructPtrType>
VREyeParametersPtr VREyeParameters::Clone() const {
  return New(
      mojo::Clone(fieldOfView),
      mojo::Clone(offset),
      mojo::Clone(renderWidth),
      mojo::Clone(renderHeight)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VREyeParameters>::value>::type*>
bool VREyeParameters::Equals(const T& other) const {
  if (!mojo::Equals(this->fieldOfView, other.fieldOfView))
    return false;
  if (!mojo::Equals(this->offset, other.offset))
    return false;
  if (!mojo::Equals(this->renderWidth, other.renderWidth))
    return false;
  if (!mojo::Equals(this->renderHeight, other.renderHeight))
    return false;
  return true;
}
template <typename StructPtrType>
VRStageParametersPtr VRStageParameters::Clone() const {
  return New(
      mojo::Clone(standingTransform),
      mojo::Clone(sizeX),
      mojo::Clone(sizeZ)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRStageParameters>::value>::type*>
bool VRStageParameters::Equals(const T& other) const {
  if (!mojo::Equals(this->standingTransform, other.standingTransform))
    return false;
  if (!mojo::Equals(this->sizeX, other.sizeX))
    return false;
  if (!mojo::Equals(this->sizeZ, other.sizeZ))
    return false;
  return true;
}
template <typename StructPtrType>
VRDisplayInfoPtr VRDisplayInfo::Clone() const {
  return New(
      mojo::Clone(index),
      mojo::Clone(displayName),
      mojo::Clone(capabilities),
      mojo::Clone(stageParameters),
      mojo::Clone(leftEye),
      mojo::Clone(rightEye)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRDisplayInfo>::value>::type*>
bool VRDisplayInfo::Equals(const T& other) const {
  if (!mojo::Equals(this->index, other.index))
    return false;
  if (!mojo::Equals(this->displayName, other.displayName))
    return false;
  if (!mojo::Equals(this->capabilities, other.capabilities))
    return false;
  if (!mojo::Equals(this->stageParameters, other.stageParameters))
    return false;
  if (!mojo::Equals(this->leftEye, other.leftEye))
    return false;
  if (!mojo::Equals(this->rightEye, other.rightEye))
    return false;
  return true;
}
template <typename StructPtrType>
VRRequestPresentOptionsPtr VRRequestPresentOptions::Clone() const {
  return New(
      mojo::Clone(preserve_drawing_buffer)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRRequestPresentOptions>::value>::type*>
bool VRRequestPresentOptions::Equals(const T& other) const {
  if (!mojo::Equals(this->preserve_drawing_buffer, other.preserve_drawing_buffer))
    return false;
  return true;
}
template <typename StructPtrType>
VRDisplayFrameTransportOptionsPtr VRDisplayFrameTransportOptions::Clone() const {
  return New(
      mojo::Clone(transport_method),
      mojo::Clone(wait_for_transfer_notification),
      mojo::Clone(wait_for_render_notification),
      mojo::Clone(wait_for_gpu_fence)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, VRDisplayFrameTransportOptions>::value>::type*>
bool VRDisplayFrameTransportOptions::Equals(const T& other) const {
  if (!mojo::Equals(this->transport_method, other.transport_method))
    return false;
  if (!mojo::Equals(this->wait_for_transfer_notification, other.wait_for_transfer_notification))
    return false;
  if (!mojo::Equals(this->wait_for_render_notification, other.wait_for_render_notification))
    return false;
  if (!mojo::Equals(this->wait_for_gpu_fence, other.wait_for_gpu_fence))
    return false;
  return true;
}


}  // namespace mojom
}  // namespace device

namespace mojo {


template <>
struct DEVICE_VR_MOJO_BINDINGS_EXPORT StructTraits<::device::mojom::VRFieldOfView::DataView,
                                         ::device::mojom::VRFieldOfViewPtr> {
  static bool IsNull(const ::device::mojom::VRFieldOfViewPtr& input) { return !input; }
  static void SetToNull(::device::mojom::VRFieldOfViewPtr* output) { output->reset(); }

  static decltype(::device::mojom::VRFieldOfView::upDegrees) upDegrees(
      const ::device::mojom::VRFieldOfViewPtr& input) {
    return input->upDegrees;
  }

  static decltype(::device::mojom::VRFieldOfView::downDegrees) downDegrees(
      const ::device::mojom::VRFieldOfViewPtr& input) {
    return input->downDegrees;
  }

  static decltype(::device::mojom::VRFieldOfView::leftDegrees) leftDegrees(
      const ::device::mojom::VRFieldOfViewPtr& input) {
    return input->leftDegrees;
  }

  static decltype(::device::mojom::VRFieldOfView::rightDegrees) rightDegrees(
      const ::device::mojom::VRFieldOfViewPtr& input) {
    return input->rightDegrees;
  }

  static bool Read(::device::mojom::VRFieldOfView::DataView input, ::device::mojom::VRFieldOfViewPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_EXPORT StructTraits<::device::mojom::VRPose::DataView,
                                         ::device::mojom::VRPosePtr> {
  static bool IsNull(const ::device::mojom::VRPosePtr& input) { return !input; }
  static void SetToNull(::device::mojom::VRPosePtr* output) { output->reset(); }

  static const decltype(::device::mojom::VRPose::orientation)& orientation(
      const ::device::mojom::VRPosePtr& input) {
    return input->orientation;
  }

  static const decltype(::device::mojom::VRPose::position)& position(
      const ::device::mojom::VRPosePtr& input) {
    return input->position;
  }

  static const decltype(::device::mojom::VRPose::angularVelocity)& angularVelocity(
      const ::device::mojom::VRPosePtr& input) {
    return input->angularVelocity;
  }

  static const decltype(::device::mojom::VRPose::linearVelocity)& linearVelocity(
      const ::device::mojom::VRPosePtr& input) {
    return input->linearVelocity;
  }

  static const decltype(::device::mojom::VRPose::angularAcceleration)& angularAcceleration(
      const ::device::mojom::VRPosePtr& input) {
    return input->angularAcceleration;
  }

  static const decltype(::device::mojom::VRPose::linearAcceleration)& linearAcceleration(
      const ::device::mojom::VRPosePtr& input) {
    return input->linearAcceleration;
  }

  static bool Read(::device::mojom::VRPose::DataView input, ::device::mojom::VRPosePtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_EXPORT StructTraits<::device::mojom::VRDisplayCapabilities::DataView,
                                         ::device::mojom::VRDisplayCapabilitiesPtr> {
  static bool IsNull(const ::device::mojom::VRDisplayCapabilitiesPtr& input) { return !input; }
  static void SetToNull(::device::mojom::VRDisplayCapabilitiesPtr* output) { output->reset(); }

  static decltype(::device::mojom::VRDisplayCapabilities::hasPosition) hasPosition(
      const ::device::mojom::VRDisplayCapabilitiesPtr& input) {
    return input->hasPosition;
  }

  static decltype(::device::mojom::VRDisplayCapabilities::hasExternalDisplay) hasExternalDisplay(
      const ::device::mojom::VRDisplayCapabilitiesPtr& input) {
    return input->hasExternalDisplay;
  }

  static decltype(::device::mojom::VRDisplayCapabilities::canPresent) canPresent(
      const ::device::mojom::VRDisplayCapabilitiesPtr& input) {
    return input->canPresent;
  }

  static bool Read(::device::mojom::VRDisplayCapabilities::DataView input, ::device::mojom::VRDisplayCapabilitiesPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_EXPORT StructTraits<::device::mojom::VREyeParameters::DataView,
                                         ::device::mojom::VREyeParametersPtr> {
  static bool IsNull(const ::device::mojom::VREyeParametersPtr& input) { return !input; }
  static void SetToNull(::device::mojom::VREyeParametersPtr* output) { output->reset(); }

  static const decltype(::device::mojom::VREyeParameters::fieldOfView)& fieldOfView(
      const ::device::mojom::VREyeParametersPtr& input) {
    return input->fieldOfView;
  }

  static const decltype(::device::mojom::VREyeParameters::offset)& offset(
      const ::device::mojom::VREyeParametersPtr& input) {
    return input->offset;
  }

  static decltype(::device::mojom::VREyeParameters::renderWidth) renderWidth(
      const ::device::mojom::VREyeParametersPtr& input) {
    return input->renderWidth;
  }

  static decltype(::device::mojom::VREyeParameters::renderHeight) renderHeight(
      const ::device::mojom::VREyeParametersPtr& input) {
    return input->renderHeight;
  }

  static bool Read(::device::mojom::VREyeParameters::DataView input, ::device::mojom::VREyeParametersPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_EXPORT StructTraits<::device::mojom::VRStageParameters::DataView,
                                         ::device::mojom::VRStageParametersPtr> {
  static bool IsNull(const ::device::mojom::VRStageParametersPtr& input) { return !input; }
  static void SetToNull(::device::mojom::VRStageParametersPtr* output) { output->reset(); }

  static const decltype(::device::mojom::VRStageParameters::standingTransform)& standingTransform(
      const ::device::mojom::VRStageParametersPtr& input) {
    return input->standingTransform;
  }

  static decltype(::device::mojom::VRStageParameters::sizeX) sizeX(
      const ::device::mojom::VRStageParametersPtr& input) {
    return input->sizeX;
  }

  static decltype(::device::mojom::VRStageParameters::sizeZ) sizeZ(
      const ::device::mojom::VRStageParametersPtr& input) {
    return input->sizeZ;
  }

  static bool Read(::device::mojom::VRStageParameters::DataView input, ::device::mojom::VRStageParametersPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_EXPORT StructTraits<::device::mojom::VRDisplayInfo::DataView,
                                         ::device::mojom::VRDisplayInfoPtr> {
  static bool IsNull(const ::device::mojom::VRDisplayInfoPtr& input) { return !input; }
  static void SetToNull(::device::mojom::VRDisplayInfoPtr* output) { output->reset(); }

  static decltype(::device::mojom::VRDisplayInfo::index) index(
      const ::device::mojom::VRDisplayInfoPtr& input) {
    return input->index;
  }

  static const decltype(::device::mojom::VRDisplayInfo::displayName)& displayName(
      const ::device::mojom::VRDisplayInfoPtr& input) {
    return input->displayName;
  }

  static const decltype(::device::mojom::VRDisplayInfo::capabilities)& capabilities(
      const ::device::mojom::VRDisplayInfoPtr& input) {
    return input->capabilities;
  }

  static const decltype(::device::mojom::VRDisplayInfo::stageParameters)& stageParameters(
      const ::device::mojom::VRDisplayInfoPtr& input) {
    return input->stageParameters;
  }

  static const decltype(::device::mojom::VRDisplayInfo::leftEye)& leftEye(
      const ::device::mojom::VRDisplayInfoPtr& input) {
    return input->leftEye;
  }

  static const decltype(::device::mojom::VRDisplayInfo::rightEye)& rightEye(
      const ::device::mojom::VRDisplayInfoPtr& input) {
    return input->rightEye;
  }

  static bool Read(::device::mojom::VRDisplayInfo::DataView input, ::device::mojom::VRDisplayInfoPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_EXPORT StructTraits<::device::mojom::VRRequestPresentOptions::DataView,
                                         ::device::mojom::VRRequestPresentOptionsPtr> {
  static bool IsNull(const ::device::mojom::VRRequestPresentOptionsPtr& input) { return !input; }
  static void SetToNull(::device::mojom::VRRequestPresentOptionsPtr* output) { output->reset(); }

  static decltype(::device::mojom::VRRequestPresentOptions::preserve_drawing_buffer) preserve_drawing_buffer(
      const ::device::mojom::VRRequestPresentOptionsPtr& input) {
    return input->preserve_drawing_buffer;
  }

  static bool Read(::device::mojom::VRRequestPresentOptions::DataView input, ::device::mojom::VRRequestPresentOptionsPtr* output);
};


template <>
struct DEVICE_VR_MOJO_BINDINGS_EXPORT StructTraits<::device::mojom::VRDisplayFrameTransportOptions::DataView,
                                         ::device::mojom::VRDisplayFrameTransportOptionsPtr> {
  static bool IsNull(const ::device::mojom::VRDisplayFrameTransportOptionsPtr& input) { return !input; }
  static void SetToNull(::device::mojom::VRDisplayFrameTransportOptionsPtr* output) { output->reset(); }

  static decltype(::device::mojom::VRDisplayFrameTransportOptions::transport_method) transport_method(
      const ::device::mojom::VRDisplayFrameTransportOptionsPtr& input) {
    return input->transport_method;
  }

  static decltype(::device::mojom::VRDisplayFrameTransportOptions::wait_for_transfer_notification) wait_for_transfer_notification(
      const ::device::mojom::VRDisplayFrameTransportOptionsPtr& input) {
    return input->wait_for_transfer_notification;
  }

  static decltype(::device::mojom::VRDisplayFrameTransportOptions::wait_for_render_notification) wait_for_render_notification(
      const ::device::mojom::VRDisplayFrameTransportOptionsPtr& input) {
    return input->wait_for_render_notification;
  }

  static decltype(::device::mojom::VRDisplayFrameTransportOptions::wait_for_gpu_fence) wait_for_gpu_fence(
      const ::device::mojom::VRDisplayFrameTransportOptionsPtr& input) {
    return input->wait_for_gpu_fence;
  }

  static bool Read(::device::mojom::VRDisplayFrameTransportOptions::DataView input, ::device::mojom::VRDisplayFrameTransportOptionsPtr* output);
};

}  // namespace mojo

#endif  // DEVICE_VR_VR_SERVICE_MOJOM_H_