// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_INTERFACES_REMOTING_MOJOM_SHARED_INTERNAL_H_
#define MEDIA_MOJO_INTERFACES_REMOTING_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "media/mojo/interfaces/remoting_common.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace media {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 65370803 value is based on sha256(salt + "RemoterFactory1").
constexpr uint32_t kRemoterFactory_Create_Name = 65370803;
class  RemoterFactory_Create_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemoterFactory_Create_Params_Data));
      new (data()) RemoterFactory_Create_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemoterFactory_Create_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemoterFactory_Create_Params_Data>(index_);
    }
    RemoterFactory_Create_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data source;
  mojo::internal::Handle_Data remoter;
  uint8_t padfinal_[4];

 private:
  RemoterFactory_Create_Params_Data();
  ~RemoterFactory_Create_Params_Data() = delete;
};
static_assert(sizeof(RemoterFactory_Create_Params_Data) == 24,
              "Bad sizeof(RemoterFactory_Create_Params_Data)");
// The 1742435665 value is based on sha256(salt + "RemotingDataStreamSender1").
constexpr uint32_t kRemotingDataStreamSender_SendFrame_Name = 1742435665;
class  RemotingDataStreamSender_SendFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingDataStreamSender_SendFrame_Params_Data));
      new (data()) RemotingDataStreamSender_SendFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingDataStreamSender_SendFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingDataStreamSender_SendFrame_Params_Data>(index_);
    }
    RemotingDataStreamSender_SendFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t frame_size;
  uint8_t padfinal_[4];

 private:
  RemotingDataStreamSender_SendFrame_Params_Data();
  ~RemotingDataStreamSender_SendFrame_Params_Data() = delete;
};
static_assert(sizeof(RemotingDataStreamSender_SendFrame_Params_Data) == 16,
              "Bad sizeof(RemotingDataStreamSender_SendFrame_Params_Data)");
// The 1644380655 value is based on sha256(salt + "RemotingDataStreamSender2").
constexpr uint32_t kRemotingDataStreamSender_CancelInFlightData_Name = 1644380655;
class  RemotingDataStreamSender_CancelInFlightData_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingDataStreamSender_CancelInFlightData_Params_Data));
      new (data()) RemotingDataStreamSender_CancelInFlightData_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingDataStreamSender_CancelInFlightData_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingDataStreamSender_CancelInFlightData_Params_Data>(index_);
    }
    RemotingDataStreamSender_CancelInFlightData_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  RemotingDataStreamSender_CancelInFlightData_Params_Data();
  ~RemotingDataStreamSender_CancelInFlightData_Params_Data() = delete;
};
static_assert(sizeof(RemotingDataStreamSender_CancelInFlightData_Params_Data) == 8,
              "Bad sizeof(RemotingDataStreamSender_CancelInFlightData_Params_Data)");
// The 416786832 value is based on sha256(salt + "Remoter1").
constexpr uint32_t kRemoter_Start_Name = 416786832;
class  Remoter_Start_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Remoter_Start_Params_Data));
      new (data()) Remoter_Start_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Remoter_Start_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Remoter_Start_Params_Data>(index_);
    }
    Remoter_Start_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Remoter_Start_Params_Data();
  ~Remoter_Start_Params_Data() = delete;
};
static_assert(sizeof(Remoter_Start_Params_Data) == 8,
              "Bad sizeof(Remoter_Start_Params_Data)");
// The 1464925160 value is based on sha256(salt + "Remoter2").
constexpr uint32_t kRemoter_StartDataStreams_Name = 1464925160;
class  Remoter_StartDataStreams_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Remoter_StartDataStreams_Params_Data));
      new (data()) Remoter_StartDataStreams_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Remoter_StartDataStreams_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Remoter_StartDataStreams_Params_Data>(index_);
    }
    Remoter_StartDataStreams_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data audio_pipe;
  mojo::internal::Handle_Data video_pipe;
  mojo::internal::Handle_Data audio_sender;
  mojo::internal::Handle_Data video_sender;

 private:
  Remoter_StartDataStreams_Params_Data();
  ~Remoter_StartDataStreams_Params_Data() = delete;
};
static_assert(sizeof(Remoter_StartDataStreams_Params_Data) == 24,
              "Bad sizeof(Remoter_StartDataStreams_Params_Data)");
// The 160488184 value is based on sha256(salt + "Remoter3").
constexpr uint32_t kRemoter_Stop_Name = 160488184;
class  Remoter_Stop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Remoter_Stop_Params_Data));
      new (data()) Remoter_Stop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Remoter_Stop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Remoter_Stop_Params_Data>(index_);
    }
    Remoter_Stop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t reason;
  uint8_t padfinal_[4];

 private:
  Remoter_Stop_Params_Data();
  ~Remoter_Stop_Params_Data() = delete;
};
static_assert(sizeof(Remoter_Stop_Params_Data) == 16,
              "Bad sizeof(Remoter_Stop_Params_Data)");
// The 1385181570 value is based on sha256(salt + "Remoter4").
constexpr uint32_t kRemoter_SendMessageToSink_Name = 1385181570;
class  Remoter_SendMessageToSink_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Remoter_SendMessageToSink_Params_Data));
      new (data()) Remoter_SendMessageToSink_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Remoter_SendMessageToSink_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Remoter_SendMessageToSink_Params_Data>(index_);
    }
    Remoter_SendMessageToSink_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> message;

 private:
  Remoter_SendMessageToSink_Params_Data();
  ~Remoter_SendMessageToSink_Params_Data() = delete;
};
static_assert(sizeof(Remoter_SendMessageToSink_Params_Data) == 16,
              "Bad sizeof(Remoter_SendMessageToSink_Params_Data)");
// The 493926889 value is based on sha256(salt + "Remoter5").
constexpr uint32_t kRemoter_EstimateTransmissionCapacity_Name = 493926889;
class  Remoter_EstimateTransmissionCapacity_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Remoter_EstimateTransmissionCapacity_Params_Data));
      new (data()) Remoter_EstimateTransmissionCapacity_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Remoter_EstimateTransmissionCapacity_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Remoter_EstimateTransmissionCapacity_Params_Data>(index_);
    }
    Remoter_EstimateTransmissionCapacity_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Remoter_EstimateTransmissionCapacity_Params_Data();
  ~Remoter_EstimateTransmissionCapacity_Params_Data() = delete;
};
static_assert(sizeof(Remoter_EstimateTransmissionCapacity_Params_Data) == 8,
              "Bad sizeof(Remoter_EstimateTransmissionCapacity_Params_Data)");
class  Remoter_EstimateTransmissionCapacity_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Remoter_EstimateTransmissionCapacity_ResponseParams_Data));
      new (data()) Remoter_EstimateTransmissionCapacity_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Remoter_EstimateTransmissionCapacity_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Remoter_EstimateTransmissionCapacity_ResponseParams_Data>(index_);
    }
    Remoter_EstimateTransmissionCapacity_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  double rate;

 private:
  Remoter_EstimateTransmissionCapacity_ResponseParams_Data();
  ~Remoter_EstimateTransmissionCapacity_ResponseParams_Data() = delete;
};
static_assert(sizeof(Remoter_EstimateTransmissionCapacity_ResponseParams_Data) == 16,
              "Bad sizeof(Remoter_EstimateTransmissionCapacity_ResponseParams_Data)");
// The 248897105 value is based on sha256(salt + "RemotingSource1").
constexpr uint32_t kRemotingSource_OnSinkAvailable_Name = 248897105;
class  RemotingSource_OnSinkAvailable_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingSource_OnSinkAvailable_Params_Data));
      new (data()) RemotingSource_OnSinkAvailable_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingSource_OnSinkAvailable_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingSource_OnSinkAvailable_Params_Data>(index_);
    }
    RemotingSource_OnSinkAvailable_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::media::mojom::internal::RemotingSinkMetadata_Data> metadata;

 private:
  RemotingSource_OnSinkAvailable_Params_Data();
  ~RemotingSource_OnSinkAvailable_Params_Data() = delete;
};
static_assert(sizeof(RemotingSource_OnSinkAvailable_Params_Data) == 16,
              "Bad sizeof(RemotingSource_OnSinkAvailable_Params_Data)");
// The 107244143 value is based on sha256(salt + "RemotingSource2").
constexpr uint32_t kRemotingSource_OnSinkGone_Name = 107244143;
class  RemotingSource_OnSinkGone_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingSource_OnSinkGone_Params_Data));
      new (data()) RemotingSource_OnSinkGone_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingSource_OnSinkGone_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingSource_OnSinkGone_Params_Data>(index_);
    }
    RemotingSource_OnSinkGone_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  RemotingSource_OnSinkGone_Params_Data();
  ~RemotingSource_OnSinkGone_Params_Data() = delete;
};
static_assert(sizeof(RemotingSource_OnSinkGone_Params_Data) == 8,
              "Bad sizeof(RemotingSource_OnSinkGone_Params_Data)");
// The 1645862073 value is based on sha256(salt + "RemotingSource3").
constexpr uint32_t kRemotingSource_OnStarted_Name = 1645862073;
class  RemotingSource_OnStarted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingSource_OnStarted_Params_Data));
      new (data()) RemotingSource_OnStarted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingSource_OnStarted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingSource_OnStarted_Params_Data>(index_);
    }
    RemotingSource_OnStarted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  RemotingSource_OnStarted_Params_Data();
  ~RemotingSource_OnStarted_Params_Data() = delete;
};
static_assert(sizeof(RemotingSource_OnStarted_Params_Data) == 8,
              "Bad sizeof(RemotingSource_OnStarted_Params_Data)");
// The 1861777717 value is based on sha256(salt + "RemotingSource4").
constexpr uint32_t kRemotingSource_OnStartFailed_Name = 1861777717;
class  RemotingSource_OnStartFailed_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingSource_OnStartFailed_Params_Data));
      new (data()) RemotingSource_OnStartFailed_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingSource_OnStartFailed_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingSource_OnStartFailed_Params_Data>(index_);
    }
    RemotingSource_OnStartFailed_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t reason;
  uint8_t padfinal_[4];

 private:
  RemotingSource_OnStartFailed_Params_Data();
  ~RemotingSource_OnStartFailed_Params_Data() = delete;
};
static_assert(sizeof(RemotingSource_OnStartFailed_Params_Data) == 16,
              "Bad sizeof(RemotingSource_OnStartFailed_Params_Data)");
// The 1632838380 value is based on sha256(salt + "RemotingSource5").
constexpr uint32_t kRemotingSource_OnMessageFromSink_Name = 1632838380;
class  RemotingSource_OnMessageFromSink_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingSource_OnMessageFromSink_Params_Data));
      new (data()) RemotingSource_OnMessageFromSink_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingSource_OnMessageFromSink_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingSource_OnMessageFromSink_Params_Data>(index_);
    }
    RemotingSource_OnMessageFromSink_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> message;

 private:
  RemotingSource_OnMessageFromSink_Params_Data();
  ~RemotingSource_OnMessageFromSink_Params_Data() = delete;
};
static_assert(sizeof(RemotingSource_OnMessageFromSink_Params_Data) == 16,
              "Bad sizeof(RemotingSource_OnMessageFromSink_Params_Data)");
// The 1348134847 value is based on sha256(salt + "RemotingSource6").
constexpr uint32_t kRemotingSource_OnStopped_Name = 1348134847;
class  RemotingSource_OnStopped_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingSource_OnStopped_Params_Data));
      new (data()) RemotingSource_OnStopped_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingSource_OnStopped_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingSource_OnStopped_Params_Data>(index_);
    }
    RemotingSource_OnStopped_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t reason;
  uint8_t padfinal_[4];

 private:
  RemotingSource_OnStopped_Params_Data();
  ~RemotingSource_OnStopped_Params_Data() = delete;
};
static_assert(sizeof(RemotingSource_OnStopped_Params_Data) == 16,
              "Bad sizeof(RemotingSource_OnStopped_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace media

#endif  // MEDIA_MOJO_INTERFACES_REMOTING_MOJOM_SHARED_INTERNAL_H_