// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_INTERFACES_VIDEO_DECODE_STATS_RECORDER_MOJOM_SHARED_H_
#define MEDIA_MOJO_INTERFACES_VIDEO_DECODE_STATS_RECORDER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "media/mojo/interfaces/video_decode_stats_recorder.mojom-shared-internal.h"
#include "media/mojo/interfaces/media_types.mojom-shared.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared.h"
#include "url/mojo/origin.mojom-shared.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace media {
namespace mojom {


}  // namespace mojom
}  // namespace media

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace media {
namespace mojom {
// Interface base classes. They are used for type safety check.
class VideoDecodeStatsRecorderInterfaceBase {};

using VideoDecodeStatsRecorderPtrDataView =
    mojo::InterfacePtrDataView<VideoDecodeStatsRecorderInterfaceBase>;
using VideoDecodeStatsRecorderRequestDataView =
    mojo::InterfaceRequestDataView<VideoDecodeStatsRecorderInterfaceBase>;
using VideoDecodeStatsRecorderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<VideoDecodeStatsRecorderInterfaceBase>;
using VideoDecodeStatsRecorderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<VideoDecodeStatsRecorderInterfaceBase>;
class VideoDecodeStatsRecorder_StartNewRecord_ParamsDataView {
 public:
  VideoDecodeStatsRecorder_StartNewRecord_ParamsDataView() {}

  VideoDecodeStatsRecorder_StartNewRecord_ParamsDataView(
      internal::VideoDecodeStatsRecorder_StartNewRecord_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadProfile(UserType* output) const {
    auto data_value = data_->profile;
    return mojo::internal::Deserialize<::media::mojom::VideoCodecProfile>(
        data_value, output);
  }

  ::media::mojom::VideoCodecProfile profile() const {
    return static_cast<::media::mojom::VideoCodecProfile>(data_->profile);
  }
  inline void GetVideoSizeDataView(
      ::gfx::mojom::SizeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadVideoSize(UserType* output) {
    auto* pointer = data_->video_size.Get();
    return mojo::internal::Deserialize<::gfx::mojom::SizeDataView>(
        pointer, output, context_);
  }
  int32_t frames_per_sec() const {
    return data_->frames_per_sec;
  }
 private:
  internal::VideoDecodeStatsRecorder_StartNewRecord_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class VideoDecodeStatsRecorder_UpdateRecord_ParamsDataView {
 public:
  VideoDecodeStatsRecorder_UpdateRecord_ParamsDataView() {}

  VideoDecodeStatsRecorder_UpdateRecord_ParamsDataView(
      internal::VideoDecodeStatsRecorder_UpdateRecord_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t frames_decoded() const {
    return data_->frames_decoded;
  }
  uint32_t frames_dropped() const {
    return data_->frames_dropped;
  }
  uint32_t frames_decoded_power_efficient() const {
    return data_->frames_decoded_power_efficient;
  }
 private:
  internal::VideoDecodeStatsRecorder_UpdateRecord_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace media

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace media {
namespace mojom {

inline void VideoDecodeStatsRecorder_StartNewRecord_ParamsDataView::GetVideoSizeDataView(
    ::gfx::mojom::SizeDataView* output) {
  auto pointer = data_->video_size.Get();
  *output = ::gfx::mojom::SizeDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace media

#endif  // MEDIA_MOJO_INTERFACES_VIDEO_DECODE_STATS_RECORDER_MOJOM_SHARED_H_
