// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "mojo/common/process_id.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
namespace mojo {
namespace common {
namespace mojom {
namespace blink {
ProcessId::ProcessId()
    : pid() {}

ProcessId::ProcessId(
    uint32_t pid_in)
    : pid(std::move(pid_in)) {}

ProcessId::~ProcessId() = default;
size_t ProcessId::Hash(size_t seed) const {
  seed = mojo::internal::WTFHash(seed, this->pid);
  return seed;
}

bool ProcessId::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace common
}  // namespace mojo

namespace mojo {


// static
bool StructTraits<::mojo::common::mojom::blink::ProcessId::DataView, ::mojo::common::mojom::blink::ProcessIdPtr>::Read(
    ::mojo::common::mojom::blink::ProcessId::DataView input,
    ::mojo::common::mojom::blink::ProcessIdPtr* output) {
  bool success = true;
  ::mojo::common::mojom::blink::ProcessIdPtr result(::mojo::common::mojom::blink::ProcessId::New());
  
      result->pid = input.pid();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif