// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MOJO_COMMON_THREAD_PRIORITY_MOJOM_SHARED_H_
#define MOJO_COMMON_THREAD_PRIORITY_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "mojo/common/thread_priority.mojom-shared-internal.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace mojo {
namespace common {
namespace mojom {


}  // namespace mojom
}  // namespace common
}  // namespace mojo

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace mojo {
namespace common {
namespace mojom {

enum class ThreadPriority : int32_t {
  BACKGROUND,
  NORMAL,
  DISPLAY,
  REALTIME_AUDIO,
};

inline std::ostream& operator<<(std::ostream& os, ThreadPriority value) {
  switch(value) {
    case ThreadPriority::BACKGROUND:
      return os << "ThreadPriority::BACKGROUND";
    case ThreadPriority::NORMAL:
      return os << "ThreadPriority::NORMAL";
    case ThreadPriority::DISPLAY:
      return os << "ThreadPriority::DISPLAY";
    case ThreadPriority::REALTIME_AUDIO:
      return os << "ThreadPriority::REALTIME_AUDIO";
    default:
      return os << "Unknown ThreadPriority value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(ThreadPriority value) {
  return internal::ThreadPriority_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


}  // namespace mojom
}  // namespace common
}  // namespace mojo

namespace std {

template <>
struct hash<::mojo::common::mojom::ThreadPriority>
    : public mojo::internal::EnumHashImpl<::mojo::common::mojom::ThreadPriority> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::mojo::common::mojom::ThreadPriority, ::mojo::common::mojom::ThreadPriority> {
  static ::mojo::common::mojom::ThreadPriority ToMojom(::mojo::common::mojom::ThreadPriority input) { return input; }
  static bool FromMojom(::mojo::common::mojom::ThreadPriority input, ::mojo::common::mojom::ThreadPriority* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::mojo::common::mojom::ThreadPriority, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::mojo::common::mojom::ThreadPriority, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::mojo::common::mojom::ThreadPriority>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace mojo {
namespace common {
namespace mojom {


}  // namespace mojom
}  // namespace common
}  // namespace mojo

#endif  // MOJO_COMMON_THREAD_PRIORITY_MOJOM_SHARED_H_
