// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "mojo/common/time.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
namespace mojo {
namespace common {
namespace mojom {
Time::Time()
    : internal_value() {}

Time::Time(
    int64_t internal_value_in)
    : internal_value(std::move(internal_value_in)) {}

Time::~Time() = default;

bool Time::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
TimeDelta::TimeDelta()
    : microseconds() {}

TimeDelta::TimeDelta(
    int64_t microseconds_in)
    : microseconds(std::move(microseconds_in)) {}

TimeDelta::~TimeDelta() = default;

bool TimeDelta::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
TimeTicks::TimeTicks()
    : internal_value() {}

TimeTicks::TimeTicks(
    int64_t internal_value_in)
    : internal_value(std::move(internal_value_in)) {}

TimeTicks::~TimeTicks() = default;

bool TimeTicks::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace common
}  // namespace mojo

namespace mojo {


// static
bool StructTraits<::mojo::common::mojom::Time::DataView, ::mojo::common::mojom::TimePtr>::Read(
    ::mojo::common::mojom::Time::DataView input,
    ::mojo::common::mojom::TimePtr* output) {
  bool success = true;
  ::mojo::common::mojom::TimePtr result(::mojo::common::mojom::Time::New());
  
      result->internal_value = input.internal_value();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojo::common::mojom::TimeDelta::DataView, ::mojo::common::mojom::TimeDeltaPtr>::Read(
    ::mojo::common::mojom::TimeDelta::DataView input,
    ::mojo::common::mojom::TimeDeltaPtr* output) {
  bool success = true;
  ::mojo::common::mojom::TimeDeltaPtr result(::mojo::common::mojom::TimeDelta::New());
  
      result->microseconds = input.microseconds();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojo::common::mojom::TimeTicks::DataView, ::mojo::common::mojom::TimeTicksPtr>::Read(
    ::mojo::common::mojom::TimeTicks::DataView input,
    ::mojo::common::mojom::TimeTicksPtr* output) {
  bool success = true;
  ::mojo::common::mojom::TimeTicksPtr result(::mojo::common::mojom::TimeTicks::New());
  
      result->internal_value = input.internal_value();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif