// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_INTERFACES_NFC_PROVIDER_MOJOM_SHARED_H_
#define SERVICES_DEVICE_PUBLIC_INTERFACES_NFC_PROVIDER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/device/public/interfaces/nfc_provider.mojom-shared-internal.h"
#include "services/device/public/interfaces/nfc.mojom-shared.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace device {
namespace mojom {


}  // namespace mojom
}  // namespace device

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace device {
namespace mojom {
// Interface base classes. They are used for type safety check.
class NFCProviderInterfaceBase {};

using NFCProviderPtrDataView =
    mojo::InterfacePtrDataView<NFCProviderInterfaceBase>;
using NFCProviderRequestDataView =
    mojo::InterfaceRequestDataView<NFCProviderInterfaceBase>;
using NFCProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NFCProviderInterfaceBase>;
using NFCProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NFCProviderInterfaceBase>;
class NFCProvider_GetNFCForHost_ParamsDataView {
 public:
  NFCProvider_GetNFCForHost_ParamsDataView() {}

  NFCProvider_GetNFCForHost_ParamsDataView(
      internal::NFCProvider_GetNFCForHost_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t host_id() const {
    return data_->host_id;
  }
  template <typename UserType>
  UserType TakeNfc() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::NFCRequestDataView>(
            &data_->nfc, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::NFCProvider_GetNFCForHost_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace device

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace device {
namespace mojom {




}  // namespace mojom
}  // namespace device

#endif  // SERVICES_DEVICE_PUBLIC_INTERFACES_NFC_PROVIDER_MOJOM_SHARED_H_
