// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_INTERFACES_DATA_PIPE_GETTER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_INTERFACES_DATA_PIPE_GETTER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 928824279 value is based on sha256(salt + "DataPipeGetter1").
constexpr uint32_t kDataPipeGetter_Read_Name = 928824279;
class  DataPipeGetter_Read_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DataPipeGetter_Read_Params_Data));
      new (data()) DataPipeGetter_Read_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DataPipeGetter_Read_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DataPipeGetter_Read_Params_Data>(index_);
    }
    DataPipeGetter_Read_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data pipe;
  uint8_t padfinal_[4];

 private:
  DataPipeGetter_Read_Params_Data();
  ~DataPipeGetter_Read_Params_Data() = delete;
};
static_assert(sizeof(DataPipeGetter_Read_Params_Data) == 16,
              "Bad sizeof(DataPipeGetter_Read_Params_Data)");
class  DataPipeGetter_Read_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DataPipeGetter_Read_ResponseParams_Data));
      new (data()) DataPipeGetter_Read_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DataPipeGetter_Read_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DataPipeGetter_Read_ResponseParams_Data>(index_);
    }
    DataPipeGetter_Read_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t pad0_[4];
  uint64_t size;

 private:
  DataPipeGetter_Read_ResponseParams_Data();
  ~DataPipeGetter_Read_ResponseParams_Data() = delete;
};
static_assert(sizeof(DataPipeGetter_Read_ResponseParams_Data) == 24,
              "Bad sizeof(DataPipeGetter_Read_ResponseParams_Data)");
// The 1753972846 value is based on sha256(salt + "DataPipeGetter2").
constexpr uint32_t kDataPipeGetter_Clone_Name = 1753972846;
class  DataPipeGetter_Clone_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DataPipeGetter_Clone_Params_Data));
      new (data()) DataPipeGetter_Clone_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DataPipeGetter_Clone_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DataPipeGetter_Clone_Params_Data>(index_);
    }
    DataPipeGetter_Clone_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  DataPipeGetter_Clone_Params_Data();
  ~DataPipeGetter_Clone_Params_Data() = delete;
};
static_assert(sizeof(DataPipeGetter_Clone_Params_Data) == 16,
              "Bad sizeof(DataPipeGetter_Clone_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_INTERFACES_DATA_PIPE_GETTER_MOJOM_SHARED_INTERNAL_H_