// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_INTERFACES_PROXY_CONFIG_MOJOM_BLINK_H_
#define SERVICES_NETWORK_PUBLIC_INTERFACES_PROXY_CONFIG_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_features.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/network/public/interfaces/proxy_config.mojom-shared.h"
#include "url/mojo/url.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/WebKit/Source/platform/wtf/HashFunctions.h"
#include "third_party/WebKit/Source/platform/wtf/Optional.h"
#include "third_party/WebKit/Source/platform/wtf/text/WTFString.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/WebKit/public/platform/WebCommon.h"


namespace WTF {
struct network_mojom_internal_ProxyRulesType_DataHashFn {
  static unsigned GetHash(const ::network::mojom::ProxyRulesType& value) {
    using utype = std::underlying_type<::network::mojom::ProxyRulesType>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::network::mojom::ProxyRulesType& left, const ::network::mojom::ProxyRulesType& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::network::mojom::ProxyRulesType> {
  using Hash = network_mojom_internal_ProxyRulesType_DataHashFn;
};

template <>
struct HashTraits<::network::mojom::ProxyRulesType>
    : public GenericHashTraits<::network::mojom::ProxyRulesType> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::network::mojom::ProxyRulesType& value) {
    return value == static_cast<::network::mojom::ProxyRulesType>(-1000000);
  }
  static void ConstructDeletedValue(::network::mojom::ProxyRulesType& slot, bool) {
    slot = static_cast<::network::mojom::ProxyRulesType>(-1000001);
  }
  static bool IsDeletedValue(const ::network::mojom::ProxyRulesType& value) {
    return value == static_cast<::network::mojom::ProxyRulesType>(-1000001);
  }
};
}  // namespace WTF


namespace WTF {
struct network_mojom_internal_ProxyConfigSource_DataHashFn {
  static unsigned GetHash(const ::network::mojom::ProxyConfigSource& value) {
    using utype = std::underlying_type<::network::mojom::ProxyConfigSource>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::network::mojom::ProxyConfigSource& left, const ::network::mojom::ProxyConfigSource& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::network::mojom::ProxyConfigSource> {
  using Hash = network_mojom_internal_ProxyConfigSource_DataHashFn;
};

template <>
struct HashTraits<::network::mojom::ProxyConfigSource>
    : public GenericHashTraits<::network::mojom::ProxyConfigSource> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::network::mojom::ProxyConfigSource& value) {
    return value == static_cast<::network::mojom::ProxyConfigSource>(-1000000);
  }
  static void ConstructDeletedValue(::network::mojom::ProxyConfigSource& slot, bool) {
    slot = static_cast<::network::mojom::ProxyConfigSource>(-1000001);
  }
  static bool IsDeletedValue(const ::network::mojom::ProxyConfigSource& value) {
    return value == static_cast<::network::mojom::ProxyConfigSource>(-1000001);
  }
};
}  // namespace WTF


namespace network {
namespace mojom {
namespace blink {
using ProxyRulesType = ProxyRulesType;  // Alias for definition in the parent namespace.
using ProxyConfigSource = ProxyConfigSource;  // Alias for definition in the parent namespace.
class ProxyConfigClient;
using ProxyConfigClientPtr = mojo::InterfacePtr<ProxyConfigClient>;
using ProxyConfigClientPtrInfo = mojo::InterfacePtrInfo<ProxyConfigClient>;
using ThreadSafeProxyConfigClientPtr =
    mojo::ThreadSafeInterfacePtr<ProxyConfigClient>;
using ProxyConfigClientRequest = mojo::InterfaceRequest<ProxyConfigClient>;
using ProxyConfigClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<ProxyConfigClient>;
using ThreadSafeProxyConfigClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<ProxyConfigClient>;
using ProxyConfigClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<ProxyConfigClient>;
using ProxyConfigClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<ProxyConfigClient>;

class ProxyConfigPollerClient;
using ProxyConfigPollerClientPtr = mojo::InterfacePtr<ProxyConfigPollerClient>;
using ProxyConfigPollerClientPtrInfo = mojo::InterfacePtrInfo<ProxyConfigPollerClient>;
using ThreadSafeProxyConfigPollerClientPtr =
    mojo::ThreadSafeInterfacePtr<ProxyConfigPollerClient>;
using ProxyConfigPollerClientRequest = mojo::InterfaceRequest<ProxyConfigPollerClient>;
using ProxyConfigPollerClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<ProxyConfigPollerClient>;
using ThreadSafeProxyConfigPollerClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<ProxyConfigPollerClient>;
using ProxyConfigPollerClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<ProxyConfigPollerClient>;
using ProxyConfigPollerClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<ProxyConfigPollerClient>;

class ProxyBypassRules;
using ProxyBypassRulesPtr = mojo::StructPtr<ProxyBypassRules>;

class ProxyList;
using ProxyListPtr = mojo::StructPtr<ProxyList>;

class ProxyRules;
using ProxyRulesPtr = mojo::StructPtr<ProxyRules>;

class ProxyConfig;
using ProxyConfigPtr = mojo::StructPtr<ProxyConfig>;


class ProxyConfigClientProxy;

template <typename ImplRefTraits>
class ProxyConfigClientStub;

class ProxyConfigClientRequestValidator;

class BLINK_PLATFORM_EXPORT ProxyConfigClient
    : public ProxyConfigClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = ProxyConfigClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = ProxyConfigClientStub<ImplRefTraits>;

  using RequestValidator_ = ProxyConfigClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnProxyConfigUpdatedMinVersion = 0,
  };
  virtual ~ProxyConfigClient() {}

  virtual void OnProxyConfigUpdated(ProxyConfigPtr proxy_config) = 0;
};
class BLINK_PLATFORM_EXPORT ProxyConfigClientInterceptorForTesting : public ProxyConfigClient {
  virtual ProxyConfigClient* GetForwardingInterface() = 0;
  void OnProxyConfigUpdated(ProxyConfigPtr proxy_config) override;
};
class BLINK_PLATFORM_EXPORT ProxyConfigClientAsyncWaiter {
 public:
  explicit ProxyConfigClientAsyncWaiter(ProxyConfigClient* proxy);
  ~ProxyConfigClientAsyncWaiter();

 private:
  ProxyConfigClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ProxyConfigClientAsyncWaiter);
};

class ProxyConfigPollerClientProxy;

template <typename ImplRefTraits>
class ProxyConfigPollerClientStub;

class ProxyConfigPollerClientRequestValidator;

class BLINK_PLATFORM_EXPORT ProxyConfigPollerClient
    : public ProxyConfigPollerClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = ProxyConfigPollerClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = ProxyConfigPollerClientStub<ImplRefTraits>;

  using RequestValidator_ = ProxyConfigPollerClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnLazyProxyConfigPollMinVersion = 0,
  };
  virtual ~ProxyConfigPollerClient() {}

  virtual void OnLazyProxyConfigPoll() = 0;
};
class BLINK_PLATFORM_EXPORT ProxyConfigPollerClientInterceptorForTesting : public ProxyConfigPollerClient {
  virtual ProxyConfigPollerClient* GetForwardingInterface() = 0;
  void OnLazyProxyConfigPoll() override;
};
class BLINK_PLATFORM_EXPORT ProxyConfigPollerClientAsyncWaiter {
 public:
  explicit ProxyConfigPollerClientAsyncWaiter(ProxyConfigPollerClient* proxy);
  ~ProxyConfigPollerClientAsyncWaiter();

 private:
  ProxyConfigPollerClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ProxyConfigPollerClientAsyncWaiter);
};

class BLINK_PLATFORM_EXPORT ProxyConfigClientProxy
    : public ProxyConfigClient {
 public:
  explicit ProxyConfigClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnProxyConfigUpdated(ProxyConfigPtr proxy_config) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class BLINK_PLATFORM_EXPORT ProxyConfigPollerClientProxy
    : public ProxyConfigPollerClient {
 public:
  explicit ProxyConfigPollerClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnLazyProxyConfigPoll() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_PLATFORM_EXPORT ProxyConfigClientStubDispatch {
 public:
  static bool Accept(ProxyConfigClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ProxyConfigClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ProxyConfigClient>>
class ProxyConfigClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ProxyConfigClientStub() {}
  ~ProxyConfigClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ProxyConfigClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ProxyConfigClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT ProxyConfigPollerClientStubDispatch {
 public:
  static bool Accept(ProxyConfigPollerClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      ProxyConfigPollerClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<ProxyConfigPollerClient>>
class ProxyConfigPollerClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  ProxyConfigPollerClientStub() {}
  ~ProxyConfigPollerClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ProxyConfigPollerClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return ProxyConfigPollerClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT ProxyConfigClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT ProxyConfigPollerClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class BLINK_PLATFORM_EXPORT ProxyBypassRules {
 public:
  using DataView = ProxyBypassRulesDataView;
  using Data_ = internal::ProxyBypassRules_Data;

  template <typename... Args>
  static ProxyBypassRulesPtr New(Args&&... args) {
    return ProxyBypassRulesPtr(
        WTF::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static ProxyBypassRulesPtr From(const U& u) {
    return mojo::TypeConverter<ProxyBypassRulesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ProxyBypassRules>::Convert(*this);
  }


  ProxyBypassRules();

  explicit ProxyBypassRules(
      const WTF::Vector<WTF::String>& rules);

  ~ProxyBypassRules();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ProxyBypassRulesPtr>
  ProxyBypassRulesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ProxyBypassRules>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ProxyBypassRules::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ProxyBypassRules::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ProxyBypassRules_UnserializedMessageContext<
            UserType, ProxyBypassRules::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ProxyBypassRules::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ProxyBypassRules::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ProxyBypassRules_UnserializedMessageContext<
            UserType, ProxyBypassRules::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ProxyBypassRules::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  WTF::Vector<WTF::String> rules;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};


class BLINK_PLATFORM_EXPORT ProxyList {
 public:
  using DataView = ProxyListDataView;
  using Data_ = internal::ProxyList_Data;

  template <typename... Args>
  static ProxyListPtr New(Args&&... args) {
    return ProxyListPtr(
        WTF::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static ProxyListPtr From(const U& u) {
    return mojo::TypeConverter<ProxyListPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ProxyList>::Convert(*this);
  }


  ProxyList();

  explicit ProxyList(
      const WTF::Vector<WTF::String>& proxies);

  ~ProxyList();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ProxyListPtr>
  ProxyListPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ProxyList>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ProxyList::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ProxyList::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ProxyList_UnserializedMessageContext<
            UserType, ProxyList::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ProxyList::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ProxyList::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ProxyList_UnserializedMessageContext<
            UserType, ProxyList::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ProxyList::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  WTF::Vector<WTF::String> proxies;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};


class BLINK_PLATFORM_EXPORT ProxyRules {
 public:
  using DataView = ProxyRulesDataView;
  using Data_ = internal::ProxyRules_Data;

  template <typename... Args>
  static ProxyRulesPtr New(Args&&... args) {
    return ProxyRulesPtr(
        WTF::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static ProxyRulesPtr From(const U& u) {
    return mojo::TypeConverter<ProxyRulesPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ProxyRules>::Convert(*this);
  }


  ProxyRules();

  ProxyRules(
      ProxyBypassRulesPtr bypass_rules,
      bool reverse_bypass,
      ProxyRulesType type,
      ProxyListPtr single_proxies,
      ProxyListPtr proxies_for_http,
      ProxyListPtr proxies_for_https,
      ProxyListPtr proxies_for_ftp,
      ProxyListPtr fallback_proxies);

  ~ProxyRules();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ProxyRulesPtr>
  ProxyRulesPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ProxyRules>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ProxyRules::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ProxyRules::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ProxyRules_UnserializedMessageContext<
            UserType, ProxyRules::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ProxyRules::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ProxyRules::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ProxyRules_UnserializedMessageContext<
            UserType, ProxyRules::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ProxyRules::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  ProxyBypassRulesPtr bypass_rules;
  bool reverse_bypass;
  ProxyRulesType type;
  ProxyListPtr single_proxies;
  ProxyListPtr proxies_for_http;
  ProxyListPtr proxies_for_https;
  ProxyListPtr proxies_for_ftp;
  ProxyListPtr fallback_proxies;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(ProxyRules);
};


class BLINK_PLATFORM_EXPORT ProxyConfig {
 public:
  using DataView = ProxyConfigDataView;
  using Data_ = internal::ProxyConfig_Data;

  template <typename... Args>
  static ProxyConfigPtr New(Args&&... args) {
    return ProxyConfigPtr(
        WTF::in_place,
        std::forward<Args>(args)...);
  }

  template <typename U>
  static ProxyConfigPtr From(const U& u) {
    return mojo::TypeConverter<ProxyConfigPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ProxyConfig>::Convert(*this);
  }


  ProxyConfig();

  ProxyConfig(
      bool auto_detect,
      const ::blink::KURL& pac_url,
      bool pac_mandatory,
      ProxyRulesPtr proxy_rules,
      ProxyConfigSource source,
      int32_t id);

  ~ProxyConfig();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ProxyConfigPtr>
  ProxyConfigPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, ProxyConfig>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ProxyConfig::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ProxyConfig::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ProxyConfig_UnserializedMessageContext<
            UserType, ProxyConfig::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<ProxyConfig::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return ProxyConfig::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ProxyConfig_UnserializedMessageContext<
            UserType, ProxyConfig::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ProxyConfig::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  bool auto_detect;
  ::blink::KURL pac_url;
  bool pac_mandatory;
  ProxyRulesPtr proxy_rules;
  ProxyConfigSource source;
  int32_t id;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(ProxyConfig);
};

template <typename StructPtrType>
ProxyBypassRulesPtr ProxyBypassRules::Clone() const {
  return New(
      mojo::Clone(rules)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ProxyBypassRules>::value>::type*>
bool ProxyBypassRules::Equals(const T& other) const {
  if (!mojo::Equals(this->rules, other.rules))
    return false;
  return true;
}
template <typename StructPtrType>
ProxyListPtr ProxyList::Clone() const {
  return New(
      mojo::Clone(proxies)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ProxyList>::value>::type*>
bool ProxyList::Equals(const T& other) const {
  if (!mojo::Equals(this->proxies, other.proxies))
    return false;
  return true;
}
template <typename StructPtrType>
ProxyRulesPtr ProxyRules::Clone() const {
  return New(
      mojo::Clone(bypass_rules),
      mojo::Clone(reverse_bypass),
      mojo::Clone(type),
      mojo::Clone(single_proxies),
      mojo::Clone(proxies_for_http),
      mojo::Clone(proxies_for_https),
      mojo::Clone(proxies_for_ftp),
      mojo::Clone(fallback_proxies)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ProxyRules>::value>::type*>
bool ProxyRules::Equals(const T& other) const {
  if (!mojo::Equals(this->bypass_rules, other.bypass_rules))
    return false;
  if (!mojo::Equals(this->reverse_bypass, other.reverse_bypass))
    return false;
  if (!mojo::Equals(this->type, other.type))
    return false;
  if (!mojo::Equals(this->single_proxies, other.single_proxies))
    return false;
  if (!mojo::Equals(this->proxies_for_http, other.proxies_for_http))
    return false;
  if (!mojo::Equals(this->proxies_for_https, other.proxies_for_https))
    return false;
  if (!mojo::Equals(this->proxies_for_ftp, other.proxies_for_ftp))
    return false;
  if (!mojo::Equals(this->fallback_proxies, other.fallback_proxies))
    return false;
  return true;
}
template <typename StructPtrType>
ProxyConfigPtr ProxyConfig::Clone() const {
  return New(
      mojo::Clone(auto_detect),
      mojo::Clone(pac_url),
      mojo::Clone(pac_mandatory),
      mojo::Clone(proxy_rules),
      mojo::Clone(source),
      mojo::Clone(id)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, ProxyConfig>::value>::type*>
bool ProxyConfig::Equals(const T& other) const {
  if (!mojo::Equals(this->auto_detect, other.auto_detect))
    return false;
  if (!mojo::Equals(this->pac_url, other.pac_url))
    return false;
  if (!mojo::Equals(this->pac_mandatory, other.pac_mandatory))
    return false;
  if (!mojo::Equals(this->proxy_rules, other.proxy_rules))
    return false;
  if (!mojo::Equals(this->source, other.source))
    return false;
  if (!mojo::Equals(this->id, other.id))
    return false;
  return true;
}


}  // namespace blink
}  // namespace mojom
}  // namespace network

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::network::mojom::blink::ProxyBypassRules::DataView,
                                         ::network::mojom::blink::ProxyBypassRulesPtr> {
  static bool IsNull(const ::network::mojom::blink::ProxyBypassRulesPtr& input) { return !input; }
  static void SetToNull(::network::mojom::blink::ProxyBypassRulesPtr* output) { output->reset(); }

  static const decltype(::network::mojom::blink::ProxyBypassRules::rules)& rules(
      const ::network::mojom::blink::ProxyBypassRulesPtr& input) {
    return input->rules;
  }

  static bool Read(::network::mojom::blink::ProxyBypassRules::DataView input, ::network::mojom::blink::ProxyBypassRulesPtr* output);
};


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::network::mojom::blink::ProxyList::DataView,
                                         ::network::mojom::blink::ProxyListPtr> {
  static bool IsNull(const ::network::mojom::blink::ProxyListPtr& input) { return !input; }
  static void SetToNull(::network::mojom::blink::ProxyListPtr* output) { output->reset(); }

  static const decltype(::network::mojom::blink::ProxyList::proxies)& proxies(
      const ::network::mojom::blink::ProxyListPtr& input) {
    return input->proxies;
  }

  static bool Read(::network::mojom::blink::ProxyList::DataView input, ::network::mojom::blink::ProxyListPtr* output);
};


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::network::mojom::blink::ProxyRules::DataView,
                                         ::network::mojom::blink::ProxyRulesPtr> {
  static bool IsNull(const ::network::mojom::blink::ProxyRulesPtr& input) { return !input; }
  static void SetToNull(::network::mojom::blink::ProxyRulesPtr* output) { output->reset(); }

  static const decltype(::network::mojom::blink::ProxyRules::bypass_rules)& bypass_rules(
      const ::network::mojom::blink::ProxyRulesPtr& input) {
    return input->bypass_rules;
  }

  static decltype(::network::mojom::blink::ProxyRules::reverse_bypass) reverse_bypass(
      const ::network::mojom::blink::ProxyRulesPtr& input) {
    return input->reverse_bypass;
  }

  static decltype(::network::mojom::blink::ProxyRules::type) type(
      const ::network::mojom::blink::ProxyRulesPtr& input) {
    return input->type;
  }

  static const decltype(::network::mojom::blink::ProxyRules::single_proxies)& single_proxies(
      const ::network::mojom::blink::ProxyRulesPtr& input) {
    return input->single_proxies;
  }

  static const decltype(::network::mojom::blink::ProxyRules::proxies_for_http)& proxies_for_http(
      const ::network::mojom::blink::ProxyRulesPtr& input) {
    return input->proxies_for_http;
  }

  static const decltype(::network::mojom::blink::ProxyRules::proxies_for_https)& proxies_for_https(
      const ::network::mojom::blink::ProxyRulesPtr& input) {
    return input->proxies_for_https;
  }

  static const decltype(::network::mojom::blink::ProxyRules::proxies_for_ftp)& proxies_for_ftp(
      const ::network::mojom::blink::ProxyRulesPtr& input) {
    return input->proxies_for_ftp;
  }

  static const decltype(::network::mojom::blink::ProxyRules::fallback_proxies)& fallback_proxies(
      const ::network::mojom::blink::ProxyRulesPtr& input) {
    return input->fallback_proxies;
  }

  static bool Read(::network::mojom::blink::ProxyRules::DataView input, ::network::mojom::blink::ProxyRulesPtr* output);
};


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::network::mojom::blink::ProxyConfig::DataView,
                                         ::network::mojom::blink::ProxyConfigPtr> {
  static bool IsNull(const ::network::mojom::blink::ProxyConfigPtr& input) { return !input; }
  static void SetToNull(::network::mojom::blink::ProxyConfigPtr* output) { output->reset(); }

  static decltype(::network::mojom::blink::ProxyConfig::auto_detect) auto_detect(
      const ::network::mojom::blink::ProxyConfigPtr& input) {
    return input->auto_detect;
  }

  static const decltype(::network::mojom::blink::ProxyConfig::pac_url)& pac_url(
      const ::network::mojom::blink::ProxyConfigPtr& input) {
    return input->pac_url;
  }

  static decltype(::network::mojom::blink::ProxyConfig::pac_mandatory) pac_mandatory(
      const ::network::mojom::blink::ProxyConfigPtr& input) {
    return input->pac_mandatory;
  }

  static const decltype(::network::mojom::blink::ProxyConfig::proxy_rules)& proxy_rules(
      const ::network::mojom::blink::ProxyConfigPtr& input) {
    return input->proxy_rules;
  }

  static decltype(::network::mojom::blink::ProxyConfig::source) source(
      const ::network::mojom::blink::ProxyConfigPtr& input) {
    return input->source;
  }

  static decltype(::network::mojom::blink::ProxyConfig::id) id(
      const ::network::mojom::blink::ProxyConfigPtr& input) {
    return input->id;
  }

  static bool Read(::network::mojom::blink::ProxyConfig::DataView input, ::network::mojom::blink::ProxyConfigPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_INTERFACES_PROXY_CONFIG_MOJOM_BLINK_H_