// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_COORDINATION_UNIT_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_COORDINATION_UNIT_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/time.mojom-shared-internal.h"
#include "services/resource_coordinator/public/interfaces/signals.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "services/resource_coordinator/public/interfaces/interfaces_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace resource_coordinator {
namespace mojom {
namespace internal {
class CoordinationUnitID_Data;

struct CoordinationUnitType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT CoordinationUnitID_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CoordinationUnitID_Data));
      new (data()) CoordinationUnitID_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CoordinationUnitID_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CoordinationUnitID_Data>(index_);
    }
    CoordinationUnitID_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t type;
  uint8_t pad0_[4];
  int64_t id;

 private:
  CoordinationUnitID_Data();
  ~CoordinationUnitID_Data() = delete;
};
static_assert(sizeof(CoordinationUnitID_Data) == 24,
              "Bad sizeof(CoordinationUnitID_Data)");
// Used by CoordinationUnitID::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct CoordinationUnitID_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  CoordinationUnitID_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~CoordinationUnitID_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    CoordinationUnitID_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    CoordinationUnitID_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
// The 2042057155 value is based on sha256(salt + "FrameCoordinationUnit1").
constexpr uint32_t kFrameCoordinationUnit_GetID_Name = 2042057155;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT FrameCoordinationUnit_GetID_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_GetID_Params_Data));
      new (data()) FrameCoordinationUnit_GetID_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_GetID_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_GetID_Params_Data>(index_);
    }
    FrameCoordinationUnit_GetID_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  FrameCoordinationUnit_GetID_Params_Data();
  ~FrameCoordinationUnit_GetID_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_GetID_Params_Data) == 8,
              "Bad sizeof(FrameCoordinationUnit_GetID_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT FrameCoordinationUnit_GetID_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_GetID_ResponseParams_Data));
      new (data()) FrameCoordinationUnit_GetID_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_GetID_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_GetID_ResponseParams_Data>(index_);
    }
    FrameCoordinationUnit_GetID_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> id;

 private:
  FrameCoordinationUnit_GetID_ResponseParams_Data();
  ~FrameCoordinationUnit_GetID_ResponseParams_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_GetID_ResponseParams_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_GetID_ResponseParams_Data)");
// The 213911242 value is based on sha256(salt + "FrameCoordinationUnit2").
constexpr uint32_t kFrameCoordinationUnit_AddBinding_Name = 213911242;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT FrameCoordinationUnit_AddBinding_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_AddBinding_Params_Data));
      new (data()) FrameCoordinationUnit_AddBinding_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_AddBinding_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_AddBinding_Params_Data>(index_);
    }
    FrameCoordinationUnit_AddBinding_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  FrameCoordinationUnit_AddBinding_Params_Data();
  ~FrameCoordinationUnit_AddBinding_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_AddBinding_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_AddBinding_Params_Data)");
// The 530232924 value is based on sha256(salt + "FrameCoordinationUnit3").
constexpr uint32_t kFrameCoordinationUnit_AddChildFrame_Name = 530232924;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT FrameCoordinationUnit_AddChildFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_AddChildFrame_Params_Data));
      new (data()) FrameCoordinationUnit_AddChildFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_AddChildFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_AddChildFrame_Params_Data>(index_);
    }
    FrameCoordinationUnit_AddChildFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  FrameCoordinationUnit_AddChildFrame_Params_Data();
  ~FrameCoordinationUnit_AddChildFrame_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_AddChildFrame_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_AddChildFrame_Params_Data)");
// The 410531658 value is based on sha256(salt + "FrameCoordinationUnit4").
constexpr uint32_t kFrameCoordinationUnit_RemoveChildFrame_Name = 410531658;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT FrameCoordinationUnit_RemoveChildFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_RemoveChildFrame_Params_Data));
      new (data()) FrameCoordinationUnit_RemoveChildFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_RemoveChildFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_RemoveChildFrame_Params_Data>(index_);
    }
    FrameCoordinationUnit_RemoveChildFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  FrameCoordinationUnit_RemoveChildFrame_Params_Data();
  ~FrameCoordinationUnit_RemoveChildFrame_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_RemoveChildFrame_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_RemoveChildFrame_Params_Data)");
// The 1222102502 value is based on sha256(salt + "FrameCoordinationUnit5").
constexpr uint32_t kFrameCoordinationUnit_SetAudibility_Name = 1222102502;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT FrameCoordinationUnit_SetAudibility_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_SetAudibility_Params_Data));
      new (data()) FrameCoordinationUnit_SetAudibility_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_SetAudibility_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_SetAudibility_Params_Data>(index_);
    }
    FrameCoordinationUnit_SetAudibility_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t audible : 1;
  uint8_t padfinal_[7];

 private:
  FrameCoordinationUnit_SetAudibility_Params_Data();
  ~FrameCoordinationUnit_SetAudibility_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_SetAudibility_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_SetAudibility_Params_Data)");
// The 15030629 value is based on sha256(salt + "FrameCoordinationUnit6").
constexpr uint32_t kFrameCoordinationUnit_SetNetworkAlmostIdle_Name = 15030629;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data));
      new (data()) FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data>(index_);
    }
    FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t idle : 1;
  uint8_t padfinal_[7];

 private:
  FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data();
  ~FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data) == 16,
              "Bad sizeof(FrameCoordinationUnit_SetNetworkAlmostIdle_Params_Data)");
// The 968029098 value is based on sha256(salt + "FrameCoordinationUnit7").
constexpr uint32_t kFrameCoordinationUnit_OnAlertFired_Name = 968029098;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT FrameCoordinationUnit_OnAlertFired_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_OnAlertFired_Params_Data));
      new (data()) FrameCoordinationUnit_OnAlertFired_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_OnAlertFired_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_OnAlertFired_Params_Data>(index_);
    }
    FrameCoordinationUnit_OnAlertFired_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  FrameCoordinationUnit_OnAlertFired_Params_Data();
  ~FrameCoordinationUnit_OnAlertFired_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_OnAlertFired_Params_Data) == 8,
              "Bad sizeof(FrameCoordinationUnit_OnAlertFired_Params_Data)");
// The 1872981509 value is based on sha256(salt + "FrameCoordinationUnit8").
constexpr uint32_t kFrameCoordinationUnit_OnNonPersistentNotificationCreated_Name = 1872981509;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data));
      new (data()) FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data>(index_);
    }
    FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data();
  ~FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data() = delete;
};
static_assert(sizeof(FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data) == 8,
              "Bad sizeof(FrameCoordinationUnit_OnNonPersistentNotificationCreated_Params_Data)");
// The 1546280832 value is based on sha256(salt + "PageCoordinationUnit1").
constexpr uint32_t kPageCoordinationUnit_GetID_Name = 1546280832;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_GetID_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_GetID_Params_Data));
      new (data()) PageCoordinationUnit_GetID_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_GetID_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_GetID_Params_Data>(index_);
    }
    PageCoordinationUnit_GetID_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PageCoordinationUnit_GetID_Params_Data();
  ~PageCoordinationUnit_GetID_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_GetID_Params_Data) == 8,
              "Bad sizeof(PageCoordinationUnit_GetID_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_GetID_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_GetID_ResponseParams_Data));
      new (data()) PageCoordinationUnit_GetID_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_GetID_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_GetID_ResponseParams_Data>(index_);
    }
    PageCoordinationUnit_GetID_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> id;

 private:
  PageCoordinationUnit_GetID_ResponseParams_Data();
  ~PageCoordinationUnit_GetID_ResponseParams_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_GetID_ResponseParams_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_GetID_ResponseParams_Data)");
// The 1569353481 value is based on sha256(salt + "PageCoordinationUnit2").
constexpr uint32_t kPageCoordinationUnit_AddBinding_Name = 1569353481;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_AddBinding_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_AddBinding_Params_Data));
      new (data()) PageCoordinationUnit_AddBinding_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_AddBinding_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_AddBinding_Params_Data>(index_);
    }
    PageCoordinationUnit_AddBinding_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  PageCoordinationUnit_AddBinding_Params_Data();
  ~PageCoordinationUnit_AddBinding_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_AddBinding_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_AddBinding_Params_Data)");
// The 2094838222 value is based on sha256(salt + "PageCoordinationUnit3").
constexpr uint32_t kPageCoordinationUnit_AddFrame_Name = 2094838222;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_AddFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_AddFrame_Params_Data));
      new (data()) PageCoordinationUnit_AddFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_AddFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_AddFrame_Params_Data>(index_);
    }
    PageCoordinationUnit_AddFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  PageCoordinationUnit_AddFrame_Params_Data();
  ~PageCoordinationUnit_AddFrame_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_AddFrame_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_AddFrame_Params_Data)");
// The 987967650 value is based on sha256(salt + "PageCoordinationUnit4").
constexpr uint32_t kPageCoordinationUnit_RemoveFrame_Name = 987967650;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_RemoveFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_RemoveFrame_Params_Data));
      new (data()) PageCoordinationUnit_RemoveFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_RemoveFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_RemoveFrame_Params_Data>(index_);
    }
    PageCoordinationUnit_RemoveFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  PageCoordinationUnit_RemoveFrame_Params_Data();
  ~PageCoordinationUnit_RemoveFrame_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_RemoveFrame_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_RemoveFrame_Params_Data)");
// The 1745454260 value is based on sha256(salt + "PageCoordinationUnit5").
constexpr uint32_t kPageCoordinationUnit_SetVisibility_Name = 1745454260;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_SetVisibility_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_SetVisibility_Params_Data));
      new (data()) PageCoordinationUnit_SetVisibility_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_SetVisibility_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_SetVisibility_Params_Data>(index_);
    }
    PageCoordinationUnit_SetVisibility_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t visible : 1;
  uint8_t padfinal_[7];

 private:
  PageCoordinationUnit_SetVisibility_Params_Data();
  ~PageCoordinationUnit_SetVisibility_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_SetVisibility_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_SetVisibility_Params_Data)");
// The 1726018928 value is based on sha256(salt + "PageCoordinationUnit6").
constexpr uint32_t kPageCoordinationUnit_SetUKMSourceId_Name = 1726018928;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_SetUKMSourceId_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_SetUKMSourceId_Params_Data));
      new (data()) PageCoordinationUnit_SetUKMSourceId_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_SetUKMSourceId_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_SetUKMSourceId_Params_Data>(index_);
    }
    PageCoordinationUnit_SetUKMSourceId_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t ukm_source_id;

 private:
  PageCoordinationUnit_SetUKMSourceId_Params_Data();
  ~PageCoordinationUnit_SetUKMSourceId_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_SetUKMSourceId_Params_Data) == 16,
              "Bad sizeof(PageCoordinationUnit_SetUKMSourceId_Params_Data)");
// The 242599175 value is based on sha256(salt + "PageCoordinationUnit7").
constexpr uint32_t kPageCoordinationUnit_OnFaviconUpdated_Name = 242599175;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_OnFaviconUpdated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_OnFaviconUpdated_Params_Data));
      new (data()) PageCoordinationUnit_OnFaviconUpdated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_OnFaviconUpdated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_OnFaviconUpdated_Params_Data>(index_);
    }
    PageCoordinationUnit_OnFaviconUpdated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PageCoordinationUnit_OnFaviconUpdated_Params_Data();
  ~PageCoordinationUnit_OnFaviconUpdated_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_OnFaviconUpdated_Params_Data) == 8,
              "Bad sizeof(PageCoordinationUnit_OnFaviconUpdated_Params_Data)");
// The 781153713 value is based on sha256(salt + "PageCoordinationUnit8").
constexpr uint32_t kPageCoordinationUnit_OnTitleUpdated_Name = 781153713;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_OnTitleUpdated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_OnTitleUpdated_Params_Data));
      new (data()) PageCoordinationUnit_OnTitleUpdated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_OnTitleUpdated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_OnTitleUpdated_Params_Data>(index_);
    }
    PageCoordinationUnit_OnTitleUpdated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PageCoordinationUnit_OnTitleUpdated_Params_Data();
  ~PageCoordinationUnit_OnTitleUpdated_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_OnTitleUpdated_Params_Data) == 8,
              "Bad sizeof(PageCoordinationUnit_OnTitleUpdated_Params_Data)");
// The 267564541 value is based on sha256(salt + "PageCoordinationUnit9").
constexpr uint32_t kPageCoordinationUnit_OnMainFrameNavigationCommitted_Name = 267564541;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data));
      new (data()) PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data>(index_);
    }
    PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data();
  ~PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data() = delete;
};
static_assert(sizeof(PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data) == 8,
              "Bad sizeof(PageCoordinationUnit_OnMainFrameNavigationCommitted_Params_Data)");
// The 1126021701 value is based on sha256(salt + "ProcessCoordinationUnit1").
constexpr uint32_t kProcessCoordinationUnit_GetID_Name = 1126021701;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_GetID_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_GetID_Params_Data));
      new (data()) ProcessCoordinationUnit_GetID_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_GetID_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_GetID_Params_Data>(index_);
    }
    ProcessCoordinationUnit_GetID_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProcessCoordinationUnit_GetID_Params_Data();
  ~ProcessCoordinationUnit_GetID_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_GetID_Params_Data) == 8,
              "Bad sizeof(ProcessCoordinationUnit_GetID_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_GetID_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_GetID_ResponseParams_Data));
      new (data()) ProcessCoordinationUnit_GetID_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_GetID_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_GetID_ResponseParams_Data>(index_);
    }
    ProcessCoordinationUnit_GetID_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> id;

 private:
  ProcessCoordinationUnit_GetID_ResponseParams_Data();
  ~ProcessCoordinationUnit_GetID_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_GetID_ResponseParams_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_GetID_ResponseParams_Data)");
// The 524548252 value is based on sha256(salt + "ProcessCoordinationUnit2").
constexpr uint32_t kProcessCoordinationUnit_AddBinding_Name = 524548252;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_AddBinding_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_AddBinding_Params_Data));
      new (data()) ProcessCoordinationUnit_AddBinding_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_AddBinding_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_AddBinding_Params_Data>(index_);
    }
    ProcessCoordinationUnit_AddBinding_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  ProcessCoordinationUnit_AddBinding_Params_Data();
  ~ProcessCoordinationUnit_AddBinding_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_AddBinding_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_AddBinding_Params_Data)");
// The 20978392 value is based on sha256(salt + "ProcessCoordinationUnit3").
constexpr uint32_t kProcessCoordinationUnit_AddFrame_Name = 20978392;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_AddFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_AddFrame_Params_Data));
      new (data()) ProcessCoordinationUnit_AddFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_AddFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_AddFrame_Params_Data>(index_);
    }
    ProcessCoordinationUnit_AddFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  ProcessCoordinationUnit_AddFrame_Params_Data();
  ~ProcessCoordinationUnit_AddFrame_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_AddFrame_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_AddFrame_Params_Data)");
// The 1712010360 value is based on sha256(salt + "ProcessCoordinationUnit4").
constexpr uint32_t kProcessCoordinationUnit_RemoveFrame_Name = 1712010360;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_RemoveFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_RemoveFrame_Params_Data));
      new (data()) ProcessCoordinationUnit_RemoveFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_RemoveFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_RemoveFrame_Params_Data>(index_);
    }
    ProcessCoordinationUnit_RemoveFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CoordinationUnitID_Data> cu_id;

 private:
  ProcessCoordinationUnit_RemoveFrame_Params_Data();
  ~ProcessCoordinationUnit_RemoveFrame_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_RemoveFrame_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_RemoveFrame_Params_Data)");
// The 1622428652 value is based on sha256(salt + "ProcessCoordinationUnit5").
constexpr uint32_t kProcessCoordinationUnit_SetCPUUsage_Name = 1622428652;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_SetCPUUsage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetCPUUsage_Params_Data));
      new (data()) ProcessCoordinationUnit_SetCPUUsage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetCPUUsage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetCPUUsage_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetCPUUsage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  double cpu_usage;

 private:
  ProcessCoordinationUnit_SetCPUUsage_Params_Data();
  ~ProcessCoordinationUnit_SetCPUUsage_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetCPUUsage_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetCPUUsage_Params_Data)");
// The 843388653 value is based on sha256(salt + "ProcessCoordinationUnit6").
constexpr uint32_t kProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Name = 843388653;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data));
      new (data()) ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::TimeDelta_Data> duration;

 private:
  ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data();
  ~ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetExpectedTaskQueueingDuration_Params_Data)");
// The 1732124569 value is based on sha256(salt + "ProcessCoordinationUnit7").
constexpr uint32_t kProcessCoordinationUnit_SetLaunchTime_Name = 1732124569;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_SetLaunchTime_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetLaunchTime_Params_Data));
      new (data()) ProcessCoordinationUnit_SetLaunchTime_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetLaunchTime_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetLaunchTime_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetLaunchTime_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::Time_Data> launch_time;

 private:
  ProcessCoordinationUnit_SetLaunchTime_Params_Data();
  ~ProcessCoordinationUnit_SetLaunchTime_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetLaunchTime_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetLaunchTime_Params_Data)");
// The 1710179362 value is based on sha256(salt + "ProcessCoordinationUnit8").
constexpr uint32_t kProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Name = 1710179362;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data));
      new (data()) ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t main_thread_task_load_is_low : 1;
  uint8_t padfinal_[7];

 private:
  ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data();
  ~ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetMainThreadTaskLoadIsLow_Params_Data)");
// The 1281422267 value is based on sha256(salt + "ProcessCoordinationUnit9").
constexpr uint32_t kProcessCoordinationUnit_SetPID_Name = 1281422267;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT ProcessCoordinationUnit_SetPID_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessCoordinationUnit_SetPID_Params_Data));
      new (data()) ProcessCoordinationUnit_SetPID_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessCoordinationUnit_SetPID_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessCoordinationUnit_SetPID_Params_Data>(index_);
    }
    ProcessCoordinationUnit_SetPID_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t pid;

 private:
  ProcessCoordinationUnit_SetPID_Params_Data();
  ~ProcessCoordinationUnit_SetPID_Params_Data() = delete;
};
static_assert(sizeof(ProcessCoordinationUnit_SetPID_Params_Data) == 16,
              "Bad sizeof(ProcessCoordinationUnit_SetPID_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_COORDINATION_UNIT_MOJOM_SHARED_INTERNAL_H_