// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TRACING_TRACING_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TRACING_TRACING_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/time.mojom-shared-internal.h"
#include "mojo/common/values.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "services/resource_coordinator/public/interfaces/interfaces_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace tracing {
namespace mojom {
namespace internal {

struct TraceDataType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
// The 1531960023 value is based on sha256(salt + "AgentRegistry1").
constexpr uint32_t kAgentRegistry_RegisterAgent_Name = 1531960023;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT AgentRegistry_RegisterAgent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AgentRegistry_RegisterAgent_Params_Data));
      new (data()) AgentRegistry_RegisterAgent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AgentRegistry_RegisterAgent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AgentRegistry_RegisterAgent_Params_Data>(index_);
    }
    AgentRegistry_RegisterAgent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data agent;
  mojo::internal::Pointer<mojo::internal::String_Data> label;
  int32_t type;
  uint8_t supports_explicit_clock_sync_ : 1;
  uint8_t padfinal_[3];

 private:
  AgentRegistry_RegisterAgent_Params_Data();
  ~AgentRegistry_RegisterAgent_Params_Data() = delete;
};
static_assert(sizeof(AgentRegistry_RegisterAgent_Params_Data) == 32,
              "Bad sizeof(AgentRegistry_RegisterAgent_Params_Data)");
// The 359362103 value is based on sha256(salt + "Agent1").
constexpr uint32_t kAgent_StartTracing_Name = 359362103;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Agent_StartTracing_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Agent_StartTracing_Params_Data));
      new (data()) Agent_StartTracing_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Agent_StartTracing_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Agent_StartTracing_Params_Data>(index_);
    }
    Agent_StartTracing_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> config;
  mojo::internal::Pointer<::mojo::common::mojom::internal::TimeTicks_Data> coordinator_time;

 private:
  Agent_StartTracing_Params_Data();
  ~Agent_StartTracing_Params_Data() = delete;
};
static_assert(sizeof(Agent_StartTracing_Params_Data) == 24,
              "Bad sizeof(Agent_StartTracing_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Agent_StartTracing_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Agent_StartTracing_ResponseParams_Data));
      new (data()) Agent_StartTracing_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Agent_StartTracing_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Agent_StartTracing_ResponseParams_Data>(index_);
    }
    Agent_StartTracing_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  Agent_StartTracing_ResponseParams_Data();
  ~Agent_StartTracing_ResponseParams_Data() = delete;
};
static_assert(sizeof(Agent_StartTracing_ResponseParams_Data) == 16,
              "Bad sizeof(Agent_StartTracing_ResponseParams_Data)");
// The 1556042454 value is based on sha256(salt + "Agent2").
constexpr uint32_t kAgent_StopAndFlush_Name = 1556042454;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Agent_StopAndFlush_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Agent_StopAndFlush_Params_Data));
      new (data()) Agent_StopAndFlush_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Agent_StopAndFlush_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Agent_StopAndFlush_Params_Data>(index_);
    }
    Agent_StopAndFlush_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data recorder;

 private:
  Agent_StopAndFlush_Params_Data();
  ~Agent_StopAndFlush_Params_Data() = delete;
};
static_assert(sizeof(Agent_StopAndFlush_Params_Data) == 16,
              "Bad sizeof(Agent_StopAndFlush_Params_Data)");
// The 456021557 value is based on sha256(salt + "Agent3").
constexpr uint32_t kAgent_RequestClockSyncMarker_Name = 456021557;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Agent_RequestClockSyncMarker_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Agent_RequestClockSyncMarker_Params_Data));
      new (data()) Agent_RequestClockSyncMarker_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Agent_RequestClockSyncMarker_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Agent_RequestClockSyncMarker_Params_Data>(index_);
    }
    Agent_RequestClockSyncMarker_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> sync_id;

 private:
  Agent_RequestClockSyncMarker_Params_Data();
  ~Agent_RequestClockSyncMarker_Params_Data() = delete;
};
static_assert(sizeof(Agent_RequestClockSyncMarker_Params_Data) == 16,
              "Bad sizeof(Agent_RequestClockSyncMarker_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Agent_RequestClockSyncMarker_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Agent_RequestClockSyncMarker_ResponseParams_Data));
      new (data()) Agent_RequestClockSyncMarker_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Agent_RequestClockSyncMarker_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Agent_RequestClockSyncMarker_ResponseParams_Data>(index_);
    }
    Agent_RequestClockSyncMarker_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::TimeTicks_Data> issue_ts;
  mojo::internal::Pointer<::mojo::common::mojom::internal::TimeTicks_Data> issue_end_ts;

 private:
  Agent_RequestClockSyncMarker_ResponseParams_Data();
  ~Agent_RequestClockSyncMarker_ResponseParams_Data() = delete;
};
static_assert(sizeof(Agent_RequestClockSyncMarker_ResponseParams_Data) == 24,
              "Bad sizeof(Agent_RequestClockSyncMarker_ResponseParams_Data)");
// The 348360725 value is based on sha256(salt + "Agent4").
constexpr uint32_t kAgent_RequestBufferStatus_Name = 348360725;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Agent_RequestBufferStatus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Agent_RequestBufferStatus_Params_Data));
      new (data()) Agent_RequestBufferStatus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Agent_RequestBufferStatus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Agent_RequestBufferStatus_Params_Data>(index_);
    }
    Agent_RequestBufferStatus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Agent_RequestBufferStatus_Params_Data();
  ~Agent_RequestBufferStatus_Params_Data() = delete;
};
static_assert(sizeof(Agent_RequestBufferStatus_Params_Data) == 8,
              "Bad sizeof(Agent_RequestBufferStatus_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Agent_RequestBufferStatus_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Agent_RequestBufferStatus_ResponseParams_Data));
      new (data()) Agent_RequestBufferStatus_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Agent_RequestBufferStatus_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Agent_RequestBufferStatus_ResponseParams_Data>(index_);
    }
    Agent_RequestBufferStatus_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t capacity;
  uint32_t count;

 private:
  Agent_RequestBufferStatus_ResponseParams_Data();
  ~Agent_RequestBufferStatus_ResponseParams_Data() = delete;
};
static_assert(sizeof(Agent_RequestBufferStatus_ResponseParams_Data) == 16,
              "Bad sizeof(Agent_RequestBufferStatus_ResponseParams_Data)");
// The 1622637841 value is based on sha256(salt + "Agent5").
constexpr uint32_t kAgent_GetCategories_Name = 1622637841;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Agent_GetCategories_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Agent_GetCategories_Params_Data));
      new (data()) Agent_GetCategories_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Agent_GetCategories_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Agent_GetCategories_Params_Data>(index_);
    }
    Agent_GetCategories_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Agent_GetCategories_Params_Data();
  ~Agent_GetCategories_Params_Data() = delete;
};
static_assert(sizeof(Agent_GetCategories_Params_Data) == 8,
              "Bad sizeof(Agent_GetCategories_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Agent_GetCategories_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Agent_GetCategories_ResponseParams_Data));
      new (data()) Agent_GetCategories_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Agent_GetCategories_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Agent_GetCategories_ResponseParams_Data>(index_);
    }
    Agent_GetCategories_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> categories;

 private:
  Agent_GetCategories_ResponseParams_Data();
  ~Agent_GetCategories_ResponseParams_Data() = delete;
};
static_assert(sizeof(Agent_GetCategories_ResponseParams_Data) == 16,
              "Bad sizeof(Agent_GetCategories_ResponseParams_Data)");
// The 366675734 value is based on sha256(salt + "Recorder1").
constexpr uint32_t kRecorder_AddChunk_Name = 366675734;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Recorder_AddChunk_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Recorder_AddChunk_Params_Data));
      new (data()) Recorder_AddChunk_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Recorder_AddChunk_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Recorder_AddChunk_Params_Data>(index_);
    }
    Recorder_AddChunk_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> chunk;

 private:
  Recorder_AddChunk_Params_Data();
  ~Recorder_AddChunk_Params_Data() = delete;
};
static_assert(sizeof(Recorder_AddChunk_Params_Data) == 16,
              "Bad sizeof(Recorder_AddChunk_Params_Data)");
// The 1460585933 value is based on sha256(salt + "Recorder2").
constexpr uint32_t kRecorder_AddMetadata_Name = 1460585933;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Recorder_AddMetadata_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Recorder_AddMetadata_Params_Data));
      new (data()) Recorder_AddMetadata_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Recorder_AddMetadata_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Recorder_AddMetadata_Params_Data>(index_);
    }
    Recorder_AddMetadata_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::DictionaryValue_Data> metadata;

 private:
  Recorder_AddMetadata_Params_Data();
  ~Recorder_AddMetadata_Params_Data() = delete;
};
static_assert(sizeof(Recorder_AddMetadata_Params_Data) == 16,
              "Bad sizeof(Recorder_AddMetadata_Params_Data)");
// The 1627877091 value is based on sha256(salt + "Coordinator1").
constexpr uint32_t kCoordinator_StartTracing_Name = 1627877091;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_StartTracing_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_StartTracing_Params_Data));
      new (data()) Coordinator_StartTracing_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_StartTracing_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_StartTracing_Params_Data>(index_);
    }
    Coordinator_StartTracing_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> config;

 private:
  Coordinator_StartTracing_Params_Data();
  ~Coordinator_StartTracing_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_StartTracing_Params_Data) == 16,
              "Bad sizeof(Coordinator_StartTracing_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_StartTracing_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_StartTracing_ResponseParams_Data));
      new (data()) Coordinator_StartTracing_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_StartTracing_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_StartTracing_ResponseParams_Data>(index_);
    }
    Coordinator_StartTracing_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  Coordinator_StartTracing_ResponseParams_Data();
  ~Coordinator_StartTracing_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_StartTracing_ResponseParams_Data) == 16,
              "Bad sizeof(Coordinator_StartTracing_ResponseParams_Data)");
// The 640121188 value is based on sha256(salt + "Coordinator2").
constexpr uint32_t kCoordinator_StopAndFlush_Name = 640121188;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_StopAndFlush_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_StopAndFlush_Params_Data));
      new (data()) Coordinator_StopAndFlush_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_StopAndFlush_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_StopAndFlush_Params_Data>(index_);
    }
    Coordinator_StopAndFlush_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data stream;
  uint8_t padfinal_[4];

 private:
  Coordinator_StopAndFlush_Params_Data();
  ~Coordinator_StopAndFlush_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_StopAndFlush_Params_Data) == 16,
              "Bad sizeof(Coordinator_StopAndFlush_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_StopAndFlush_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_StopAndFlush_ResponseParams_Data));
      new (data()) Coordinator_StopAndFlush_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_StopAndFlush_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_StopAndFlush_ResponseParams_Data>(index_);
    }
    Coordinator_StopAndFlush_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::DictionaryValue_Data> metadata;

 private:
  Coordinator_StopAndFlush_ResponseParams_Data();
  ~Coordinator_StopAndFlush_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_StopAndFlush_ResponseParams_Data) == 16,
              "Bad sizeof(Coordinator_StopAndFlush_ResponseParams_Data)");
// The 103154053 value is based on sha256(salt + "Coordinator3").
constexpr uint32_t kCoordinator_StopAndFlushAgent_Name = 103154053;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_StopAndFlushAgent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_StopAndFlushAgent_Params_Data));
      new (data()) Coordinator_StopAndFlushAgent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_StopAndFlushAgent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_StopAndFlushAgent_Params_Data>(index_);
    }
    Coordinator_StopAndFlushAgent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data stream;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> agent_label;

 private:
  Coordinator_StopAndFlushAgent_Params_Data();
  ~Coordinator_StopAndFlushAgent_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_StopAndFlushAgent_Params_Data) == 24,
              "Bad sizeof(Coordinator_StopAndFlushAgent_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_StopAndFlushAgent_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_StopAndFlushAgent_ResponseParams_Data));
      new (data()) Coordinator_StopAndFlushAgent_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_StopAndFlushAgent_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_StopAndFlushAgent_ResponseParams_Data>(index_);
    }
    Coordinator_StopAndFlushAgent_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::DictionaryValue_Data> metadata;

 private:
  Coordinator_StopAndFlushAgent_ResponseParams_Data();
  ~Coordinator_StopAndFlushAgent_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_StopAndFlushAgent_ResponseParams_Data) == 16,
              "Bad sizeof(Coordinator_StopAndFlushAgent_ResponseParams_Data)");
// The 1862817015 value is based on sha256(salt + "Coordinator4").
constexpr uint32_t kCoordinator_IsTracing_Name = 1862817015;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_IsTracing_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_IsTracing_Params_Data));
      new (data()) Coordinator_IsTracing_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_IsTracing_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_IsTracing_Params_Data>(index_);
    }
    Coordinator_IsTracing_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Coordinator_IsTracing_Params_Data();
  ~Coordinator_IsTracing_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_IsTracing_Params_Data) == 8,
              "Bad sizeof(Coordinator_IsTracing_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_IsTracing_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_IsTracing_ResponseParams_Data));
      new (data()) Coordinator_IsTracing_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_IsTracing_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_IsTracing_ResponseParams_Data>(index_);
    }
    Coordinator_IsTracing_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t is_tracing : 1;
  uint8_t padfinal_[7];

 private:
  Coordinator_IsTracing_ResponseParams_Data();
  ~Coordinator_IsTracing_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_IsTracing_ResponseParams_Data) == 16,
              "Bad sizeof(Coordinator_IsTracing_ResponseParams_Data)");
// The 1959167952 value is based on sha256(salt + "Coordinator5").
constexpr uint32_t kCoordinator_RequestBufferUsage_Name = 1959167952;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_RequestBufferUsage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_RequestBufferUsage_Params_Data));
      new (data()) Coordinator_RequestBufferUsage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_RequestBufferUsage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_RequestBufferUsage_Params_Data>(index_);
    }
    Coordinator_RequestBufferUsage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Coordinator_RequestBufferUsage_Params_Data();
  ~Coordinator_RequestBufferUsage_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_RequestBufferUsage_Params_Data) == 8,
              "Bad sizeof(Coordinator_RequestBufferUsage_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_RequestBufferUsage_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_RequestBufferUsage_ResponseParams_Data));
      new (data()) Coordinator_RequestBufferUsage_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_RequestBufferUsage_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_RequestBufferUsage_ResponseParams_Data>(index_);
    }
    Coordinator_RequestBufferUsage_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[3];
  float percent_full;
  uint32_t approximate_count;
  uint8_t padfinal_[4];

 private:
  Coordinator_RequestBufferUsage_ResponseParams_Data();
  ~Coordinator_RequestBufferUsage_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_RequestBufferUsage_ResponseParams_Data) == 24,
              "Bad sizeof(Coordinator_RequestBufferUsage_ResponseParams_Data)");
// The 694338403 value is based on sha256(salt + "Coordinator6").
constexpr uint32_t kCoordinator_GetCategories_Name = 694338403;
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_GetCategories_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_GetCategories_Params_Data));
      new (data()) Coordinator_GetCategories_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_GetCategories_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_GetCategories_Params_Data>(index_);
    }
    Coordinator_GetCategories_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  Coordinator_GetCategories_Params_Data();
  ~Coordinator_GetCategories_Params_Data() = delete;
};
static_assert(sizeof(Coordinator_GetCategories_Params_Data) == 8,
              "Bad sizeof(Coordinator_GetCategories_Params_Data)");
class RESOURCE_COORDINATOR_PUBLIC_INTERFACES_SHARED_EXPORT Coordinator_GetCategories_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Coordinator_GetCategories_ResponseParams_Data));
      new (data()) Coordinator_GetCategories_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Coordinator_GetCategories_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Coordinator_GetCategories_ResponseParams_Data>(index_);
    }
    Coordinator_GetCategories_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<mojo::internal::String_Data> categories;

 private:
  Coordinator_GetCategories_ResponseParams_Data();
  ~Coordinator_GetCategories_ResponseParams_Data() = delete;
};
static_assert(sizeof(Coordinator_GetCategories_ResponseParams_Data) == 24,
              "Bad sizeof(Coordinator_GetCategories_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace tracing

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_INTERFACES_TRACING_TRACING_MOJOM_SHARED_INTERNAL_H_