// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_SHAPE_DETECTION_PUBLIC_INTERFACES_BARCODEDETECTION_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_SHAPE_DETECTION_PUBLIC_INTERFACES_BARCODEDETECTION_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "skia/public/interfaces/bitmap.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace shape_detection {
namespace mojom {
namespace internal {
class BarcodeDetectionResult_Data;

#pragma pack(push, 1)
class  BarcodeDetectionResult_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BarcodeDetectionResult_Data));
      new (data()) BarcodeDetectionResult_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BarcodeDetectionResult_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BarcodeDetectionResult_Data>(index_);
    }
    BarcodeDetectionResult_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> raw_value;
  mojo::internal::Pointer<::gfx::mojom::internal::RectF_Data> bounding_box;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::gfx::mojom::internal::PointF_Data>>> corner_points;

 private:
  BarcodeDetectionResult_Data();
  ~BarcodeDetectionResult_Data() = delete;
};
static_assert(sizeof(BarcodeDetectionResult_Data) == 32,
              "Bad sizeof(BarcodeDetectionResult_Data)");
// Used by BarcodeDetectionResult::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct BarcodeDetectionResult_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  BarcodeDetectionResult_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~BarcodeDetectionResult_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    BarcodeDetectionResult_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    BarcodeDetectionResult_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
// The 392103216 value is based on sha256(salt + "BarcodeDetection1").
constexpr uint32_t kBarcodeDetection_Detect_Name = 392103216;
class  BarcodeDetection_Detect_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BarcodeDetection_Detect_Params_Data));
      new (data()) BarcodeDetection_Detect_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BarcodeDetection_Detect_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BarcodeDetection_Detect_Params_Data>(index_);
    }
    BarcodeDetection_Detect_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::skia::mojom::internal::Bitmap_Data> bitmap_data;

 private:
  BarcodeDetection_Detect_Params_Data();
  ~BarcodeDetection_Detect_Params_Data() = delete;
};
static_assert(sizeof(BarcodeDetection_Detect_Params_Data) == 16,
              "Bad sizeof(BarcodeDetection_Detect_Params_Data)");
class  BarcodeDetection_Detect_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BarcodeDetection_Detect_ResponseParams_Data));
      new (data()) BarcodeDetection_Detect_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BarcodeDetection_Detect_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BarcodeDetection_Detect_ResponseParams_Data>(index_);
    }
    BarcodeDetection_Detect_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::BarcodeDetectionResult_Data>>> results;

 private:
  BarcodeDetection_Detect_ResponseParams_Data();
  ~BarcodeDetection_Detect_ResponseParams_Data() = delete;
};
static_assert(sizeof(BarcodeDetection_Detect_ResponseParams_Data) == 16,
              "Bad sizeof(BarcodeDetection_Detect_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace shape_detection

#endif  // SERVICES_SHAPE_DETECTION_PUBLIC_INTERFACES_BARCODEDETECTION_MOJOM_SHARED_INTERNAL_H_