// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_UI_PUBLIC_INTERFACES_VIDEO_DETECTOR_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_UI_PUBLIC_INTERFACES_VIDEO_DETECTOR_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/viz/public/interfaces/compositing/video_detector_observer.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ui {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 402251326 value is based on sha256(salt + "VideoDetector1").
constexpr uint32_t kVideoDetector_AddObserver_Name = 402251326;
class  VideoDetector_AddObserver_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(VideoDetector_AddObserver_Params_Data));
      new (data()) VideoDetector_AddObserver_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    VideoDetector_AddObserver_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<VideoDetector_AddObserver_Params_Data>(index_);
    }
    VideoDetector_AddObserver_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data observer;

 private:
  VideoDetector_AddObserver_Params_Data();
  ~VideoDetector_AddObserver_Params_Data() = delete;
};
static_assert(sizeof(VideoDetector_AddObserver_Params_Data) == 16,
              "Bad sizeof(VideoDetector_AddObserver_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ui

#endif  // SERVICES_UI_PUBLIC_INTERFACES_VIDEO_DETECTOR_MOJOM_SHARED_INTERNAL_H_