// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_UI_PUBLIC_INTERFACES_WINDOW_MANAGER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_UI_PUBLIC_INTERFACES_WINDOW_MANAGER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "gpu/ipc/common/surface_handle.mojom-shared-internal.h"
#include "services/ui/public/interfaces/cursor/cursor.mojom-shared-internal.h"
#include "services/ui/public/interfaces/event_matcher.mojom-shared-internal.h"
#include "services/ui/public/interfaces/window_manager_constants.mojom-shared-internal.h"
#include "services/ui/public/interfaces/window_tree_constants.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/frame_sink_id.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/local_surface_id.mojom-shared-internal.h"
#include "skia/public/interfaces/bitmap.mojom-shared-internal.h"
#include "ui/base/mojo/ui_base_types.mojom-shared-internal.h"
#include "ui/display/mojo/display.mojom-shared-internal.h"
#include "ui/events/mojo/event.mojom-shared-internal.h"
#include "ui/events/mojo/event_constants.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/display/mojo/display.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ui {
namespace mojom {
namespace internal {
class WmAccelerator_Data;

#pragma pack(push, 1)
class  WmAccelerator_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WmAccelerator_Data));
      new (data()) WmAccelerator_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WmAccelerator_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WmAccelerator_Data>(index_);
    }
    WmAccelerator_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::ui::mojom::internal::EventMatcher_Data> event_matcher;

 private:
  WmAccelerator_Data();
  ~WmAccelerator_Data() = delete;
};
static_assert(sizeof(WmAccelerator_Data) == 24,
              "Bad sizeof(WmAccelerator_Data)");
// Used by WmAccelerator::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct WmAccelerator_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  WmAccelerator_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~WmAccelerator_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    WmAccelerator_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    WmAccelerator_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
// The 470471399 value is based on sha256(salt + "WindowManager1").
constexpr uint32_t kWindowManager_OnConnect_Name = 470471399;
class  WindowManager_OnConnect_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_OnConnect_Params_Data));
      new (data()) WindowManager_OnConnect_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_OnConnect_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_OnConnect_Params_Data>(index_);
    }
    WindowManager_OnConnect_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WindowManager_OnConnect_Params_Data();
  ~WindowManager_OnConnect_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_OnConnect_Params_Data) == 8,
              "Bad sizeof(WindowManager_OnConnect_Params_Data)");
// The 960079719 value is based on sha256(salt + "WindowManager2").
constexpr uint32_t kWindowManager_WmOnAcceleratedWidgetForDisplay_Name = 960079719;
class  WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data));
      new (data()) WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data>(index_);
    }
    WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;
  mojo::internal::Pointer<::gpu::mojom::internal::SurfaceHandle_Data> surface_handle;

 private:
  WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data();
  ~WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data) == 24,
              "Bad sizeof(WindowManager_WmOnAcceleratedWidgetForDisplay_Params_Data)");
// The 78493433 value is based on sha256(salt + "WindowManager3").
constexpr uint32_t kWindowManager_WmNewDisplayAdded_Name = 78493433;
class  WindowManager_WmNewDisplayAdded_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmNewDisplayAdded_Params_Data));
      new (data()) WindowManager_WmNewDisplayAdded_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmNewDisplayAdded_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmNewDisplayAdded_Params_Data>(index_);
    }
    WindowManager_WmNewDisplayAdded_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::display::mojom::internal::Display_Data> display;
  mojo::internal::Pointer<::ui::mojom::internal::WindowData_Data> root;
  uint8_t parent_drawn : 1;
  uint8_t pad2_[7];
  mojo::internal::Pointer<::viz::mojom::internal::LocalSurfaceId_Data> local_surface_id;

 private:
  WindowManager_WmNewDisplayAdded_Params_Data();
  ~WindowManager_WmNewDisplayAdded_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmNewDisplayAdded_Params_Data) == 40,
              "Bad sizeof(WindowManager_WmNewDisplayAdded_Params_Data)");
// The 2121457181 value is based on sha256(salt + "WindowManager4").
constexpr uint32_t kWindowManager_WmDisplayRemoved_Name = 2121457181;
class  WindowManager_WmDisplayRemoved_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmDisplayRemoved_Params_Data));
      new (data()) WindowManager_WmDisplayRemoved_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmDisplayRemoved_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmDisplayRemoved_Params_Data>(index_);
    }
    WindowManager_WmDisplayRemoved_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;

 private:
  WindowManager_WmDisplayRemoved_Params_Data();
  ~WindowManager_WmDisplayRemoved_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmDisplayRemoved_Params_Data) == 16,
              "Bad sizeof(WindowManager_WmDisplayRemoved_Params_Data)");
// The 2115362914 value is based on sha256(salt + "WindowManager5").
constexpr uint32_t kWindowManager_WmDisplayModified_Name = 2115362914;
class  WindowManager_WmDisplayModified_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmDisplayModified_Params_Data));
      new (data()) WindowManager_WmDisplayModified_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmDisplayModified_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmDisplayModified_Params_Data>(index_);
    }
    WindowManager_WmDisplayModified_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::display::mojom::internal::Display_Data> display;

 private:
  WindowManager_WmDisplayModified_Params_Data();
  ~WindowManager_WmDisplayModified_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmDisplayModified_Params_Data) == 16,
              "Bad sizeof(WindowManager_WmDisplayModified_Params_Data)");
// The 1791342558 value is based on sha256(salt + "WindowManager6").
constexpr uint32_t kWindowManager_WmSetBounds_Name = 1791342558;
class  WindowManager_WmSetBounds_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmSetBounds_Params_Data));
      new (data()) WindowManager_WmSetBounds_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmSetBounds_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmSetBounds_Params_Data>(index_);
    }
    WindowManager_WmSetBounds_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> bounds;

 private:
  WindowManager_WmSetBounds_Params_Data();
  ~WindowManager_WmSetBounds_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmSetBounds_Params_Data) == 24,
              "Bad sizeof(WindowManager_WmSetBounds_Params_Data)");
// The 371795673 value is based on sha256(salt + "WindowManager7").
constexpr uint32_t kWindowManager_WmSetProperty_Name = 371795673;
class  WindowManager_WmSetProperty_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmSetProperty_Params_Data));
      new (data()) WindowManager_WmSetProperty_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmSetProperty_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmSetProperty_Params_Data>(index_);
    }
    WindowManager_WmSetProperty_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;

 private:
  WindowManager_WmSetProperty_Params_Data();
  ~WindowManager_WmSetProperty_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmSetProperty_Params_Data) == 32,
              "Bad sizeof(WindowManager_WmSetProperty_Params_Data)");
// The 2002888024 value is based on sha256(salt + "WindowManager8").
constexpr uint32_t kWindowManager_WmSetModalType_Name = 2002888024;
class  WindowManager_WmSetModalType_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmSetModalType_Params_Data));
      new (data()) WindowManager_WmSetModalType_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmSetModalType_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmSetModalType_Params_Data>(index_);
    }
    WindowManager_WmSetModalType_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  int32_t type;

 private:
  WindowManager_WmSetModalType_Params_Data();
  ~WindowManager_WmSetModalType_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmSetModalType_Params_Data) == 16,
              "Bad sizeof(WindowManager_WmSetModalType_Params_Data)");
// The 1640682335 value is based on sha256(salt + "WindowManager9").
constexpr uint32_t kWindowManager_WmSetCanFocus_Name = 1640682335;
class  WindowManager_WmSetCanFocus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmSetCanFocus_Params_Data));
      new (data()) WindowManager_WmSetCanFocus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmSetCanFocus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmSetCanFocus_Params_Data>(index_);
    }
    WindowManager_WmSetCanFocus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t can_focus : 1;
  uint8_t padfinal_[3];

 private:
  WindowManager_WmSetCanFocus_Params_Data();
  ~WindowManager_WmSetCanFocus_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmSetCanFocus_Params_Data) == 16,
              "Bad sizeof(WindowManager_WmSetCanFocus_Params_Data)");
// The 1934859097 value is based on sha256(salt + "WindowManager10").
constexpr uint32_t kWindowManager_WmCreateTopLevelWindow_Name = 1934859097;
class  WindowManager_WmCreateTopLevelWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmCreateTopLevelWindow_Params_Data));
      new (data()) WindowManager_WmCreateTopLevelWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmCreateTopLevelWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmCreateTopLevelWindow_Params_Data>(index_);
    }
    WindowManager_WmCreateTopLevelWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::viz::mojom::internal::FrameSinkId_Data> frame_sink_id;
  mojo::internal::Pointer<mojo::internal::Map_Data<mojo::internal::Pointer<mojo::internal::String_Data>, mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>>>> properties;

 private:
  WindowManager_WmCreateTopLevelWindow_Params_Data();
  ~WindowManager_WmCreateTopLevelWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmCreateTopLevelWindow_Params_Data) == 32,
              "Bad sizeof(WindowManager_WmCreateTopLevelWindow_Params_Data)");
// The 570469038 value is based on sha256(salt + "WindowManager11").
constexpr uint32_t kWindowManager_WmClientJankinessChanged_Name = 570469038;
class  WindowManager_WmClientJankinessChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmClientJankinessChanged_Params_Data));
      new (data()) WindowManager_WmClientJankinessChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmClientJankinessChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmClientJankinessChanged_Params_Data>(index_);
    }
    WindowManager_WmClientJankinessChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint16_t client_id;
  uint8_t janky : 1;
  uint8_t padfinal_[5];

 private:
  WindowManager_WmClientJankinessChanged_Params_Data();
  ~WindowManager_WmClientJankinessChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmClientJankinessChanged_Params_Data) == 16,
              "Bad sizeof(WindowManager_WmClientJankinessChanged_Params_Data)");
// The 2141028304 value is based on sha256(salt + "WindowManager12").
constexpr uint32_t kWindowManager_WmBuildDragImage_Name = 2141028304;
class  WindowManager_WmBuildDragImage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmBuildDragImage_Params_Data));
      new (data()) WindowManager_WmBuildDragImage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmBuildDragImage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmBuildDragImage_Params_Data>(index_);
    }
    WindowManager_WmBuildDragImage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> screen_location;
  mojo::internal::Pointer<::skia::mojom::internal::Bitmap_Data> drag_image;
  mojo::internal::Pointer<::gfx::mojom::internal::Vector2d_Data> drag_image_offset;
  int32_t source;
  uint8_t padfinal_[4];

 private:
  WindowManager_WmBuildDragImage_Params_Data();
  ~WindowManager_WmBuildDragImage_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmBuildDragImage_Params_Data) == 40,
              "Bad sizeof(WindowManager_WmBuildDragImage_Params_Data)");
// The 512592647 value is based on sha256(salt + "WindowManager13").
constexpr uint32_t kWindowManager_WmMoveDragImage_Name = 512592647;
class  WindowManager_WmMoveDragImage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmMoveDragImage_Params_Data));
      new (data()) WindowManager_WmMoveDragImage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmMoveDragImage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmMoveDragImage_Params_Data>(index_);
    }
    WindowManager_WmMoveDragImage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> screen_location;

 private:
  WindowManager_WmMoveDragImage_Params_Data();
  ~WindowManager_WmMoveDragImage_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmMoveDragImage_Params_Data) == 16,
              "Bad sizeof(WindowManager_WmMoveDragImage_Params_Data)");
class  WindowManager_WmMoveDragImage_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmMoveDragImage_ResponseParams_Data));
      new (data()) WindowManager_WmMoveDragImage_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmMoveDragImage_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmMoveDragImage_ResponseParams_Data>(index_);
    }
    WindowManager_WmMoveDragImage_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WindowManager_WmMoveDragImage_ResponseParams_Data();
  ~WindowManager_WmMoveDragImage_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowManager_WmMoveDragImage_ResponseParams_Data) == 8,
              "Bad sizeof(WindowManager_WmMoveDragImage_ResponseParams_Data)");
// The 1042034016 value is based on sha256(salt + "WindowManager14").
constexpr uint32_t kWindowManager_WmDestroyDragImage_Name = 1042034016;
class  WindowManager_WmDestroyDragImage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmDestroyDragImage_Params_Data));
      new (data()) WindowManager_WmDestroyDragImage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmDestroyDragImage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmDestroyDragImage_Params_Data>(index_);
    }
    WindowManager_WmDestroyDragImage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WindowManager_WmDestroyDragImage_Params_Data();
  ~WindowManager_WmDestroyDragImage_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmDestroyDragImage_Params_Data) == 8,
              "Bad sizeof(WindowManager_WmDestroyDragImage_Params_Data)");
// The 2143085683 value is based on sha256(salt + "WindowManager15").
constexpr uint32_t kWindowManager_WmPerformMoveLoop_Name = 2143085683;
class  WindowManager_WmPerformMoveLoop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmPerformMoveLoop_Params_Data));
      new (data()) WindowManager_WmPerformMoveLoop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmPerformMoveLoop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmPerformMoveLoop_Params_Data>(index_);
    }
    WindowManager_WmPerformMoveLoop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  int32_t source;
  uint8_t pad2_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> cursor_location;

 private:
  WindowManager_WmPerformMoveLoop_Params_Data();
  ~WindowManager_WmPerformMoveLoop_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmPerformMoveLoop_Params_Data) == 32,
              "Bad sizeof(WindowManager_WmPerformMoveLoop_Params_Data)");
// The 2002078848 value is based on sha256(salt + "WindowManager16").
constexpr uint32_t kWindowManager_WmCancelMoveLoop_Name = 2002078848;
class  WindowManager_WmCancelMoveLoop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmCancelMoveLoop_Params_Data));
      new (data()) WindowManager_WmCancelMoveLoop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmCancelMoveLoop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmCancelMoveLoop_Params_Data>(index_);
    }
    WindowManager_WmCancelMoveLoop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint8_t padfinal_[4];

 private:
  WindowManager_WmCancelMoveLoop_Params_Data();
  ~WindowManager_WmCancelMoveLoop_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmCancelMoveLoop_Params_Data) == 16,
              "Bad sizeof(WindowManager_WmCancelMoveLoop_Params_Data)");
// The 400453048 value is based on sha256(salt + "WindowManager17").
constexpr uint32_t kWindowManager_WmDeactivateWindow_Name = 400453048;
class  WindowManager_WmDeactivateWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmDeactivateWindow_Params_Data));
      new (data()) WindowManager_WmDeactivateWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmDeactivateWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmDeactivateWindow_Params_Data>(index_);
    }
    WindowManager_WmDeactivateWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowManager_WmDeactivateWindow_Params_Data();
  ~WindowManager_WmDeactivateWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmDeactivateWindow_Params_Data) == 16,
              "Bad sizeof(WindowManager_WmDeactivateWindow_Params_Data)");
// The 1642673552 value is based on sha256(salt + "WindowManager18").
constexpr uint32_t kWindowManager_WmStackAbove_Name = 1642673552;
class  WindowManager_WmStackAbove_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmStackAbove_Params_Data));
      new (data()) WindowManager_WmStackAbove_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmStackAbove_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmStackAbove_Params_Data>(index_);
    }
    WindowManager_WmStackAbove_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t above_id;
  uint32_t below_id;
  uint8_t padfinal_[4];

 private:
  WindowManager_WmStackAbove_Params_Data();
  ~WindowManager_WmStackAbove_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmStackAbove_Params_Data) == 24,
              "Bad sizeof(WindowManager_WmStackAbove_Params_Data)");
// The 1685222501 value is based on sha256(salt + "WindowManager19").
constexpr uint32_t kWindowManager_WmStackAtTop_Name = 1685222501;
class  WindowManager_WmStackAtTop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmStackAtTop_Params_Data));
      new (data()) WindowManager_WmStackAtTop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmStackAtTop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmStackAtTop_Params_Data>(index_);
    }
    WindowManager_WmStackAtTop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;

 private:
  WindowManager_WmStackAtTop_Params_Data();
  ~WindowManager_WmStackAtTop_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmStackAtTop_Params_Data) == 16,
              "Bad sizeof(WindowManager_WmStackAtTop_Params_Data)");
// The 229789376 value is based on sha256(salt + "WindowManager20").
constexpr uint32_t kWindowManager_WmPerformWmAction_Name = 229789376;
class  WindowManager_WmPerformWmAction_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_WmPerformWmAction_Params_Data));
      new (data()) WindowManager_WmPerformWmAction_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_WmPerformWmAction_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_WmPerformWmAction_Params_Data>(index_);
    }
    WindowManager_WmPerformWmAction_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> action;

 private:
  WindowManager_WmPerformWmAction_Params_Data();
  ~WindowManager_WmPerformWmAction_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_WmPerformWmAction_Params_Data) == 24,
              "Bad sizeof(WindowManager_WmPerformWmAction_Params_Data)");
// The 565172329 value is based on sha256(salt + "WindowManager21").
constexpr uint32_t kWindowManager_OnAccelerator_Name = 565172329;
class  WindowManager_OnAccelerator_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_OnAccelerator_Params_Data));
      new (data()) WindowManager_OnAccelerator_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_OnAccelerator_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_OnAccelerator_Params_Data>(index_);
    }
    WindowManager_OnAccelerator_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t ack_id;
  uint32_t accelerator_id;
  mojo::internal::Pointer<::ui::mojom::internal::Event_Data> event;

 private:
  WindowManager_OnAccelerator_Params_Data();
  ~WindowManager_OnAccelerator_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_OnAccelerator_Params_Data) == 24,
              "Bad sizeof(WindowManager_OnAccelerator_Params_Data)");
// The 91217531 value is based on sha256(salt + "WindowManager22").
constexpr uint32_t kWindowManager_OnCursorTouchVisibleChanged_Name = 91217531;
class  WindowManager_OnCursorTouchVisibleChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_OnCursorTouchVisibleChanged_Params_Data));
      new (data()) WindowManager_OnCursorTouchVisibleChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_OnCursorTouchVisibleChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_OnCursorTouchVisibleChanged_Params_Data>(index_);
    }
    WindowManager_OnCursorTouchVisibleChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t enabled : 1;
  uint8_t padfinal_[7];

 private:
  WindowManager_OnCursorTouchVisibleChanged_Params_Data();
  ~WindowManager_OnCursorTouchVisibleChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_OnCursorTouchVisibleChanged_Params_Data) == 16,
              "Bad sizeof(WindowManager_OnCursorTouchVisibleChanged_Params_Data)");
// The 727115567 value is based on sha256(salt + "WindowManager23").
constexpr uint32_t kWindowManager_OnEventBlockedByModalWindow_Name = 727115567;
class  WindowManager_OnEventBlockedByModalWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManager_OnEventBlockedByModalWindow_Params_Data));
      new (data()) WindowManager_OnEventBlockedByModalWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManager_OnEventBlockedByModalWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManager_OnEventBlockedByModalWindow_Params_Data>(index_);
    }
    WindowManager_OnEventBlockedByModalWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowManager_OnEventBlockedByModalWindow_Params_Data();
  ~WindowManager_OnEventBlockedByModalWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowManager_OnEventBlockedByModalWindow_Params_Data) == 16,
              "Bad sizeof(WindowManager_OnEventBlockedByModalWindow_Params_Data)");
// The 1772872383 value is based on sha256(salt + "WindowManagerClient1").
constexpr uint32_t kWindowManagerClient_AddActivationParent_Name = 1772872383;
class  WindowManagerClient_AddActivationParent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_AddActivationParent_Params_Data));
      new (data()) WindowManagerClient_AddActivationParent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_AddActivationParent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_AddActivationParent_Params_Data>(index_);
    }
    WindowManagerClient_AddActivationParent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowManagerClient_AddActivationParent_Params_Data();
  ~WindowManagerClient_AddActivationParent_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_AddActivationParent_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_AddActivationParent_Params_Data)");
// The 165385815 value is based on sha256(salt + "WindowManagerClient2").
constexpr uint32_t kWindowManagerClient_RemoveActivationParent_Name = 165385815;
class  WindowManagerClient_RemoveActivationParent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_RemoveActivationParent_Params_Data));
      new (data()) WindowManagerClient_RemoveActivationParent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_RemoveActivationParent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_RemoveActivationParent_Params_Data>(index_);
    }
    WindowManagerClient_RemoveActivationParent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowManagerClient_RemoveActivationParent_Params_Data();
  ~WindowManagerClient_RemoveActivationParent_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_RemoveActivationParent_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_RemoveActivationParent_Params_Data)");
// The 252542845 value is based on sha256(salt + "WindowManagerClient3").
constexpr uint32_t kWindowManagerClient_SetExtendedHitRegionForChildren_Name = 252542845;
class  WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data));
      new (data()) WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data>(index_);
    }
    WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Insets_Data> mouse_insets;
  mojo::internal::Pointer<::gfx::mojom::internal::Insets_Data> touch_insets;

 private:
  WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data();
  ~WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data) == 32,
              "Bad sizeof(WindowManagerClient_SetExtendedHitRegionForChildren_Params_Data)");
// The 228902170 value is based on sha256(salt + "WindowManagerClient4").
constexpr uint32_t kWindowManagerClient_AddAccelerators_Name = 228902170;
class  WindowManagerClient_AddAccelerators_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_AddAccelerators_Params_Data));
      new (data()) WindowManagerClient_AddAccelerators_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_AddAccelerators_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_AddAccelerators_Params_Data>(index_);
    }
    WindowManagerClient_AddAccelerators_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::WmAccelerator_Data>>> accelerators;

 private:
  WindowManagerClient_AddAccelerators_Params_Data();
  ~WindowManagerClient_AddAccelerators_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_AddAccelerators_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_AddAccelerators_Params_Data)");
class  WindowManagerClient_AddAccelerators_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_AddAccelerators_ResponseParams_Data));
      new (data()) WindowManagerClient_AddAccelerators_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_AddAccelerators_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_AddAccelerators_ResponseParams_Data>(index_);
    }
    WindowManagerClient_AddAccelerators_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  WindowManagerClient_AddAccelerators_ResponseParams_Data();
  ~WindowManagerClient_AddAccelerators_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_AddAccelerators_ResponseParams_Data) == 16,
              "Bad sizeof(WindowManagerClient_AddAccelerators_ResponseParams_Data)");
// The 392208718 value is based on sha256(salt + "WindowManagerClient5").
constexpr uint32_t kWindowManagerClient_RemoveAccelerator_Name = 392208718;
class  WindowManagerClient_RemoveAccelerator_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_RemoveAccelerator_Params_Data));
      new (data()) WindowManagerClient_RemoveAccelerator_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_RemoveAccelerator_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_RemoveAccelerator_Params_Data>(index_);
    }
    WindowManagerClient_RemoveAccelerator_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t id;
  uint8_t padfinal_[4];

 private:
  WindowManagerClient_RemoveAccelerator_Params_Data();
  ~WindowManagerClient_RemoveAccelerator_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_RemoveAccelerator_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_RemoveAccelerator_Params_Data)");
// The 439585738 value is based on sha256(salt + "WindowManagerClient6").
constexpr uint32_t kWindowManagerClient_SetKeyEventsThatDontHideCursor_Name = 439585738;
class  WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data));
      new (data()) WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data>(index_);
    }
    WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::EventMatcher_Data>>> dont_hide_cursor_list;

 private:
  WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data();
  ~WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_SetKeyEventsThatDontHideCursor_Params_Data)");
// The 990011115 value is based on sha256(salt + "WindowManagerClient7").
constexpr uint32_t kWindowManagerClient_SetDisplayRoot_Name = 990011115;
class  WindowManagerClient_SetDisplayRoot_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SetDisplayRoot_Params_Data));
      new (data()) WindowManagerClient_SetDisplayRoot_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SetDisplayRoot_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SetDisplayRoot_Params_Data>(index_);
    }
    WindowManagerClient_SetDisplayRoot_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::display::mojom::internal::Display_Data> display;
  mojo::internal::Pointer<::ui::mojom::internal::WmViewportMetrics_Data> viewport_metrics;
  uint8_t is_primary_display : 1;
  uint8_t pad2_[3];
  uint32_t window_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::display::mojom::internal::Display_Data>>> mirrors;

 private:
  WindowManagerClient_SetDisplayRoot_Params_Data();
  ~WindowManagerClient_SetDisplayRoot_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SetDisplayRoot_Params_Data) == 40,
              "Bad sizeof(WindowManagerClient_SetDisplayRoot_Params_Data)");
class  WindowManagerClient_SetDisplayRoot_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SetDisplayRoot_ResponseParams_Data));
      new (data()) WindowManagerClient_SetDisplayRoot_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SetDisplayRoot_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SetDisplayRoot_ResponseParams_Data>(index_);
    }
    WindowManagerClient_SetDisplayRoot_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  WindowManagerClient_SetDisplayRoot_ResponseParams_Data();
  ~WindowManagerClient_SetDisplayRoot_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SetDisplayRoot_ResponseParams_Data) == 16,
              "Bad sizeof(WindowManagerClient_SetDisplayRoot_ResponseParams_Data)");
// The 643053426 value is based on sha256(salt + "WindowManagerClient8").
constexpr uint32_t kWindowManagerClient_SetDisplayConfiguration_Name = 643053426;
class  WindowManagerClient_SetDisplayConfiguration_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SetDisplayConfiguration_Params_Data));
      new (data()) WindowManagerClient_SetDisplayConfiguration_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SetDisplayConfiguration_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SetDisplayConfiguration_Params_Data>(index_);
    }
    WindowManagerClient_SetDisplayConfiguration_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::display::mojom::internal::Display_Data>>> displays;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::WmViewportMetrics_Data>>> viewport_metrics;
  int64_t primary_display_id;
  int64_t internal_display_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::display::mojom::internal::Display_Data>>> mirrors;

 private:
  WindowManagerClient_SetDisplayConfiguration_Params_Data();
  ~WindowManagerClient_SetDisplayConfiguration_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SetDisplayConfiguration_Params_Data) == 48,
              "Bad sizeof(WindowManagerClient_SetDisplayConfiguration_Params_Data)");
class  WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data));
      new (data()) WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data>(index_);
    }
    WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data();
  ~WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data) == 16,
              "Bad sizeof(WindowManagerClient_SetDisplayConfiguration_ResponseParams_Data)");
// The 2014899422 value is based on sha256(salt + "WindowManagerClient9").
constexpr uint32_t kWindowManagerClient_SwapDisplayRoots_Name = 2014899422;
class  WindowManagerClient_SwapDisplayRoots_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SwapDisplayRoots_Params_Data));
      new (data()) WindowManagerClient_SwapDisplayRoots_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SwapDisplayRoots_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SwapDisplayRoots_Params_Data>(index_);
    }
    WindowManagerClient_SwapDisplayRoots_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id1;
  int64_t display_id2;

 private:
  WindowManagerClient_SwapDisplayRoots_Params_Data();
  ~WindowManagerClient_SwapDisplayRoots_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SwapDisplayRoots_Params_Data) == 24,
              "Bad sizeof(WindowManagerClient_SwapDisplayRoots_Params_Data)");
class  WindowManagerClient_SwapDisplayRoots_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SwapDisplayRoots_ResponseParams_Data));
      new (data()) WindowManagerClient_SwapDisplayRoots_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SwapDisplayRoots_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SwapDisplayRoots_ResponseParams_Data>(index_);
    }
    WindowManagerClient_SwapDisplayRoots_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  WindowManagerClient_SwapDisplayRoots_ResponseParams_Data();
  ~WindowManagerClient_SwapDisplayRoots_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SwapDisplayRoots_ResponseParams_Data) == 16,
              "Bad sizeof(WindowManagerClient_SwapDisplayRoots_ResponseParams_Data)");
// The 589996719 value is based on sha256(salt + "WindowManagerClient10").
constexpr uint32_t kWindowManagerClient_SetBlockingContainers_Name = 589996719;
class  WindowManagerClient_SetBlockingContainers_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SetBlockingContainers_Params_Data));
      new (data()) WindowManagerClient_SetBlockingContainers_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SetBlockingContainers_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SetBlockingContainers_Params_Data>(index_);
    }
    WindowManagerClient_SetBlockingContainers_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::BlockingContainers_Data>>> blocking_containers;

 private:
  WindowManagerClient_SetBlockingContainers_Params_Data();
  ~WindowManagerClient_SetBlockingContainers_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SetBlockingContainers_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_SetBlockingContainers_Params_Data)");
class  WindowManagerClient_SetBlockingContainers_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_SetBlockingContainers_ResponseParams_Data));
      new (data()) WindowManagerClient_SetBlockingContainers_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_SetBlockingContainers_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_SetBlockingContainers_ResponseParams_Data>(index_);
    }
    WindowManagerClient_SetBlockingContainers_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  WindowManagerClient_SetBlockingContainers_ResponseParams_Data();
  ~WindowManagerClient_SetBlockingContainers_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_SetBlockingContainers_ResponseParams_Data) == 16,
              "Bad sizeof(WindowManagerClient_SetBlockingContainers_ResponseParams_Data)");
// The 108135931 value is based on sha256(salt + "WindowManagerClient11").
constexpr uint32_t kWindowManagerClient_WmResponse_Name = 108135931;
class  WindowManagerClient_WmResponse_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmResponse_Params_Data));
      new (data()) WindowManagerClient_WmResponse_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmResponse_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmResponse_Params_Data>(index_);
    }
    WindowManagerClient_WmResponse_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint8_t response : 1;
  uint8_t padfinal_[3];

 private:
  WindowManagerClient_WmResponse_Params_Data();
  ~WindowManagerClient_WmResponse_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmResponse_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_WmResponse_Params_Data)");
// The 1605639206 value is based on sha256(salt + "WindowManagerClient12").
constexpr uint32_t kWindowManagerClient_WmSetBoundsResponse_Name = 1605639206;
class  WindowManagerClient_WmSetBoundsResponse_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmSetBoundsResponse_Params_Data));
      new (data()) WindowManagerClient_WmSetBoundsResponse_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmSetBoundsResponse_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmSetBoundsResponse_Params_Data>(index_);
    }
    WindowManagerClient_WmSetBoundsResponse_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint8_t padfinal_[4];

 private:
  WindowManagerClient_WmSetBoundsResponse_Params_Data();
  ~WindowManagerClient_WmSetBoundsResponse_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmSetBoundsResponse_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_WmSetBoundsResponse_Params_Data)");
// The 769401342 value is based on sha256(salt + "WindowManagerClient13").
constexpr uint32_t kWindowManagerClient_WmRequestClose_Name = 769401342;
class  WindowManagerClient_WmRequestClose_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmRequestClose_Params_Data));
      new (data()) WindowManagerClient_WmRequestClose_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmRequestClose_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmRequestClose_Params_Data>(index_);
    }
    WindowManagerClient_WmRequestClose_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowManagerClient_WmRequestClose_Params_Data();
  ~WindowManagerClient_WmRequestClose_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmRequestClose_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_WmRequestClose_Params_Data)");
// The 2113974205 value is based on sha256(salt + "WindowManagerClient14").
constexpr uint32_t kWindowManagerClient_WmSetFrameDecorationValues_Name = 2113974205;
class  WindowManagerClient_WmSetFrameDecorationValues_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmSetFrameDecorationValues_Params_Data));
      new (data()) WindowManagerClient_WmSetFrameDecorationValues_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmSetFrameDecorationValues_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmSetFrameDecorationValues_Params_Data>(index_);
    }
    WindowManagerClient_WmSetFrameDecorationValues_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::ui::mojom::internal::FrameDecorationValues_Data> values;

 private:
  WindowManagerClient_WmSetFrameDecorationValues_Params_Data();
  ~WindowManagerClient_WmSetFrameDecorationValues_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmSetFrameDecorationValues_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_WmSetFrameDecorationValues_Params_Data)");
// The 454933345 value is based on sha256(salt + "WindowManagerClient15").
constexpr uint32_t kWindowManagerClient_WmSetNonClientCursor_Name = 454933345;
class  WindowManagerClient_WmSetNonClientCursor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmSetNonClientCursor_Params_Data));
      new (data()) WindowManagerClient_WmSetNonClientCursor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmSetNonClientCursor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmSetNonClientCursor_Params_Data>(index_);
    }
    WindowManagerClient_WmSetNonClientCursor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::ui::mojom::internal::CursorData_Data> cursor;

 private:
  WindowManagerClient_WmSetNonClientCursor_Params_Data();
  ~WindowManagerClient_WmSetNonClientCursor_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmSetNonClientCursor_Params_Data) == 24,
              "Bad sizeof(WindowManagerClient_WmSetNonClientCursor_Params_Data)");
// The 718535583 value is based on sha256(salt + "WindowManagerClient16").
constexpr uint32_t kWindowManagerClient_WmLockCursor_Name = 718535583;
class  WindowManagerClient_WmLockCursor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmLockCursor_Params_Data));
      new (data()) WindowManagerClient_WmLockCursor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmLockCursor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmLockCursor_Params_Data>(index_);
    }
    WindowManagerClient_WmLockCursor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WindowManagerClient_WmLockCursor_Params_Data();
  ~WindowManagerClient_WmLockCursor_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmLockCursor_Params_Data) == 8,
              "Bad sizeof(WindowManagerClient_WmLockCursor_Params_Data)");
// The 792721097 value is based on sha256(salt + "WindowManagerClient17").
constexpr uint32_t kWindowManagerClient_WmUnlockCursor_Name = 792721097;
class  WindowManagerClient_WmUnlockCursor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmUnlockCursor_Params_Data));
      new (data()) WindowManagerClient_WmUnlockCursor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmUnlockCursor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmUnlockCursor_Params_Data>(index_);
    }
    WindowManagerClient_WmUnlockCursor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WindowManagerClient_WmUnlockCursor_Params_Data();
  ~WindowManagerClient_WmUnlockCursor_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmUnlockCursor_Params_Data) == 8,
              "Bad sizeof(WindowManagerClient_WmUnlockCursor_Params_Data)");
// The 2115320347 value is based on sha256(salt + "WindowManagerClient18").
constexpr uint32_t kWindowManagerClient_WmSetCursorVisible_Name = 2115320347;
class  WindowManagerClient_WmSetCursorVisible_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmSetCursorVisible_Params_Data));
      new (data()) WindowManagerClient_WmSetCursorVisible_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmSetCursorVisible_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmSetCursorVisible_Params_Data>(index_);
    }
    WindowManagerClient_WmSetCursorVisible_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t visible : 1;
  uint8_t padfinal_[7];

 private:
  WindowManagerClient_WmSetCursorVisible_Params_Data();
  ~WindowManagerClient_WmSetCursorVisible_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmSetCursorVisible_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_WmSetCursorVisible_Params_Data)");
// The 1961097471 value is based on sha256(salt + "WindowManagerClient19").
constexpr uint32_t kWindowManagerClient_WmSetCursorSize_Name = 1961097471;
class  WindowManagerClient_WmSetCursorSize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmSetCursorSize_Params_Data));
      new (data()) WindowManagerClient_WmSetCursorSize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmSetCursorSize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmSetCursorSize_Params_Data>(index_);
    }
    WindowManagerClient_WmSetCursorSize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t cursor_size;
  uint8_t padfinal_[4];

 private:
  WindowManagerClient_WmSetCursorSize_Params_Data();
  ~WindowManagerClient_WmSetCursorSize_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmSetCursorSize_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_WmSetCursorSize_Params_Data)");
// The 1049606855 value is based on sha256(salt + "WindowManagerClient20").
constexpr uint32_t kWindowManagerClient_WmSetGlobalOverrideCursor_Name = 1049606855;
class  WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data));
      new (data()) WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data>(index_);
    }
    WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::ui::mojom::internal::CursorData_Data> cursor;

 private:
  WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data();
  ~WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_WmSetGlobalOverrideCursor_Params_Data)");
// The 992261428 value is based on sha256(salt + "WindowManagerClient21").
constexpr uint32_t kWindowManagerClient_WmMoveCursorToDisplayLocation_Name = 992261428;
class  WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data));
      new (data()) WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data>(index_);
    }
    WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> display_pixels;
  int64_t display_id;

 private:
  WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data();
  ~WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data) == 24,
              "Bad sizeof(WindowManagerClient_WmMoveCursorToDisplayLocation_Params_Data)");
// The 479006080 value is based on sha256(salt + "WindowManagerClient22").
constexpr uint32_t kWindowManagerClient_WmConfineCursorToBounds_Name = 479006080;
class  WindowManagerClient_WmConfineCursorToBounds_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmConfineCursorToBounds_Params_Data));
      new (data()) WindowManagerClient_WmConfineCursorToBounds_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmConfineCursorToBounds_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmConfineCursorToBounds_Params_Data>(index_);
    }
    WindowManagerClient_WmConfineCursorToBounds_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> bounds_in_pixels;
  int64_t display_id;

 private:
  WindowManagerClient_WmConfineCursorToBounds_Params_Data();
  ~WindowManagerClient_WmConfineCursorToBounds_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmConfineCursorToBounds_Params_Data) == 24,
              "Bad sizeof(WindowManagerClient_WmConfineCursorToBounds_Params_Data)");
// The 1777817488 value is based on sha256(salt + "WindowManagerClient23").
constexpr uint32_t kWindowManagerClient_WmSetCursorTouchVisible_Name = 1777817488;
class  WindowManagerClient_WmSetCursorTouchVisible_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_WmSetCursorTouchVisible_Params_Data));
      new (data()) WindowManagerClient_WmSetCursorTouchVisible_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_WmSetCursorTouchVisible_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_WmSetCursorTouchVisible_Params_Data>(index_);
    }
    WindowManagerClient_WmSetCursorTouchVisible_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t enabled : 1;
  uint8_t padfinal_[7];

 private:
  WindowManagerClient_WmSetCursorTouchVisible_Params_Data();
  ~WindowManagerClient_WmSetCursorTouchVisible_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_WmSetCursorTouchVisible_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_WmSetCursorTouchVisible_Params_Data)");
// The 2058281430 value is based on sha256(salt + "WindowManagerClient24").
constexpr uint32_t kWindowManagerClient_OnWmCreatedTopLevelWindow_Name = 2058281430;
class  WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data));
      new (data()) WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data>(index_);
    }
    WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;

 private:
  WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data();
  ~WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data) == 16,
              "Bad sizeof(WindowManagerClient_OnWmCreatedTopLevelWindow_Params_Data)");
// The 1874709949 value is based on sha256(salt + "WindowManagerClient25").
constexpr uint32_t kWindowManagerClient_OnAcceleratorAck_Name = 1874709949;
class  WindowManagerClient_OnAcceleratorAck_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowManagerClient_OnAcceleratorAck_Params_Data));
      new (data()) WindowManagerClient_OnAcceleratorAck_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowManagerClient_OnAcceleratorAck_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowManagerClient_OnAcceleratorAck_Params_Data>(index_);
    }
    WindowManagerClient_OnAcceleratorAck_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t ack_id;
  int32_t event_result;
  mojo::internal::Pointer<mojo::internal::Map_Data<mojo::internal::Pointer<mojo::internal::String_Data>, mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>>>> properties;

 private:
  WindowManagerClient_OnAcceleratorAck_Params_Data();
  ~WindowManagerClient_OnAcceleratorAck_Params_Data() = delete;
};
static_assert(sizeof(WindowManagerClient_OnAcceleratorAck_Params_Data) == 24,
              "Bad sizeof(WindowManagerClient_OnAcceleratorAck_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ui

#endif  // SERVICES_UI_PUBLIC_INTERFACES_WINDOW_MANAGER_MOJOM_SHARED_INTERNAL_H_