// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_UI_PUBLIC_INTERFACES_WINDOW_TREE_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_UI_PUBLIC_INTERFACES_WINDOW_TREE_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/unguessable_token.mojom-shared-internal.h"
#include "services/ui/public/interfaces/cursor/cursor.mojom-shared-internal.h"
#include "services/ui/public/interfaces/event_matcher.mojom-shared-internal.h"
#include "services/ui/public/interfaces/mus_constants.mojom-shared-internal.h"
#include "services/ui/public/interfaces/window_manager.mojom-shared-internal.h"
#include "services/ui/public/interfaces/window_manager_constants.mojom-shared-internal.h"
#include "services/ui/public/interfaces/window_tree_constants.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/compositor_frame_sink.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/frame_sink_id.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/local_surface_id.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/surface_info.mojom-shared-internal.h"
#include "skia/public/interfaces/bitmap.mojom-shared-internal.h"
#include "ui/base/mojo/ui_base_types.mojom-shared-internal.h"
#include "ui/events/mojo/event.mojom-shared-internal.h"
#include "ui/events/mojo/event_constants.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/gfx/mojo/transform.mojom-shared-internal.h"
#include "ui/platform_window/mojo/text_input_state.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ui {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 524243986 value is based on sha256(salt + "WindowTree1").
constexpr uint32_t kWindowTree_NewWindow_Name = 524243986;
class  WindowTree_NewWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_NewWindow_Params_Data));
      new (data()) WindowTree_NewWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_NewWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_NewWindow_Params_Data>(index_);
    }
    WindowTree_NewWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  mojo::internal::Pointer<mojo::internal::Map_Data<mojo::internal::Pointer<mojo::internal::String_Data>, mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>>>> properties;

 private:
  WindowTree_NewWindow_Params_Data();
  ~WindowTree_NewWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_NewWindow_Params_Data) == 24,
              "Bad sizeof(WindowTree_NewWindow_Params_Data)");
// The 1933318566 value is based on sha256(salt + "WindowTree2").
constexpr uint32_t kWindowTree_NewTopLevelWindow_Name = 1933318566;
class  WindowTree_NewTopLevelWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_NewTopLevelWindow_Params_Data));
      new (data()) WindowTree_NewTopLevelWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_NewTopLevelWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_NewTopLevelWindow_Params_Data>(index_);
    }
    WindowTree_NewTopLevelWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  mojo::internal::Pointer<mojo::internal::Map_Data<mojo::internal::Pointer<mojo::internal::String_Data>, mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>>>> properties;

 private:
  WindowTree_NewTopLevelWindow_Params_Data();
  ~WindowTree_NewTopLevelWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_NewTopLevelWindow_Params_Data) == 24,
              "Bad sizeof(WindowTree_NewTopLevelWindow_Params_Data)");
// The 1810210676 value is based on sha256(salt + "WindowTree3").
constexpr uint32_t kWindowTree_DeleteWindow_Name = 1810210676;
class  WindowTree_DeleteWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_DeleteWindow_Params_Data));
      new (data()) WindowTree_DeleteWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_DeleteWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_DeleteWindow_Params_Data>(index_);
    }
    WindowTree_DeleteWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;

 private:
  WindowTree_DeleteWindow_Params_Data();
  ~WindowTree_DeleteWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_DeleteWindow_Params_Data) == 16,
              "Bad sizeof(WindowTree_DeleteWindow_Params_Data)");
// The 404844402 value is based on sha256(salt + "WindowTree4").
constexpr uint32_t kWindowTree_SetCapture_Name = 404844402;
class  WindowTree_SetCapture_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetCapture_Params_Data));
      new (data()) WindowTree_SetCapture_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetCapture_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetCapture_Params_Data>(index_);
    }
    WindowTree_SetCapture_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;

 private:
  WindowTree_SetCapture_Params_Data();
  ~WindowTree_SetCapture_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetCapture_Params_Data) == 16,
              "Bad sizeof(WindowTree_SetCapture_Params_Data)");
// The 756091290 value is based on sha256(salt + "WindowTree5").
constexpr uint32_t kWindowTree_ReleaseCapture_Name = 756091290;
class  WindowTree_ReleaseCapture_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_ReleaseCapture_Params_Data));
      new (data()) WindowTree_ReleaseCapture_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_ReleaseCapture_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_ReleaseCapture_Params_Data>(index_);
    }
    WindowTree_ReleaseCapture_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;

 private:
  WindowTree_ReleaseCapture_Params_Data();
  ~WindowTree_ReleaseCapture_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_ReleaseCapture_Params_Data) == 16,
              "Bad sizeof(WindowTree_ReleaseCapture_Params_Data)");
// The 2046812377 value is based on sha256(salt + "WindowTree6").
constexpr uint32_t kWindowTree_StartPointerWatcher_Name = 2046812377;
class  WindowTree_StartPointerWatcher_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_StartPointerWatcher_Params_Data));
      new (data()) WindowTree_StartPointerWatcher_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_StartPointerWatcher_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_StartPointerWatcher_Params_Data>(index_);
    }
    WindowTree_StartPointerWatcher_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t want_moves : 1;
  uint8_t padfinal_[7];

 private:
  WindowTree_StartPointerWatcher_Params_Data();
  ~WindowTree_StartPointerWatcher_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_StartPointerWatcher_Params_Data) == 16,
              "Bad sizeof(WindowTree_StartPointerWatcher_Params_Data)");
// The 1477224244 value is based on sha256(salt + "WindowTree7").
constexpr uint32_t kWindowTree_StopPointerWatcher_Name = 1477224244;
class  WindowTree_StopPointerWatcher_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_StopPointerWatcher_Params_Data));
      new (data()) WindowTree_StopPointerWatcher_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_StopPointerWatcher_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_StopPointerWatcher_Params_Data>(index_);
    }
    WindowTree_StopPointerWatcher_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WindowTree_StopPointerWatcher_Params_Data();
  ~WindowTree_StopPointerWatcher_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_StopPointerWatcher_Params_Data) == 8,
              "Bad sizeof(WindowTree_StopPointerWatcher_Params_Data)");
// The 9622235 value is based on sha256(salt + "WindowTree8").
constexpr uint32_t kWindowTree_SetWindowBounds_Name = 9622235;
class  WindowTree_SetWindowBounds_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetWindowBounds_Params_Data));
      new (data()) WindowTree_SetWindowBounds_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetWindowBounds_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetWindowBounds_Params_Data>(index_);
    }
    WindowTree_SetWindowBounds_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> bounds;
  mojo::internal::Pointer<::viz::mojom::internal::LocalSurfaceId_Data> local_surface_id;

 private:
  WindowTree_SetWindowBounds_Params_Data();
  ~WindowTree_SetWindowBounds_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetWindowBounds_Params_Data) == 32,
              "Bad sizeof(WindowTree_SetWindowBounds_Params_Data)");
// The 60611070 value is based on sha256(salt + "WindowTree9").
constexpr uint32_t kWindowTree_SetWindowTransform_Name = 60611070;
class  WindowTree_SetWindowTransform_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetWindowTransform_Params_Data));
      new (data()) WindowTree_SetWindowTransform_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetWindowTransform_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetWindowTransform_Params_Data>(index_);
    }
    WindowTree_SetWindowTransform_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  mojo::internal::Pointer<::gfx::mojom::internal::Transform_Data> transform;

 private:
  WindowTree_SetWindowTransform_Params_Data();
  ~WindowTree_SetWindowTransform_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetWindowTransform_Params_Data) == 24,
              "Bad sizeof(WindowTree_SetWindowTransform_Params_Data)");
// The 1031607744 value is based on sha256(salt + "WindowTree10").
constexpr uint32_t kWindowTree_SetClientArea_Name = 1031607744;
class  WindowTree_SetClientArea_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetClientArea_Params_Data));
      new (data()) WindowTree_SetClientArea_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetClientArea_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetClientArea_Params_Data>(index_);
    }
    WindowTree_SetClientArea_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Insets_Data> insets;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data>>> additional_client_areas;

 private:
  WindowTree_SetClientArea_Params_Data();
  ~WindowTree_SetClientArea_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetClientArea_Params_Data) == 32,
              "Bad sizeof(WindowTree_SetClientArea_Params_Data)");
// The 934104982 value is based on sha256(salt + "WindowTree11").
constexpr uint32_t kWindowTree_SetHitTestMask_Name = 934104982;
class  WindowTree_SetHitTestMask_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetHitTestMask_Params_Data));
      new (data()) WindowTree_SetHitTestMask_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetHitTestMask_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetHitTestMask_Params_Data>(index_);
    }
    WindowTree_SetHitTestMask_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> mask;

 private:
  WindowTree_SetHitTestMask_Params_Data();
  ~WindowTree_SetHitTestMask_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetHitTestMask_Params_Data) == 24,
              "Bad sizeof(WindowTree_SetHitTestMask_Params_Data)");
// The 432049282 value is based on sha256(salt + "WindowTree12").
constexpr uint32_t kWindowTree_SetCanAcceptDrops_Name = 432049282;
class  WindowTree_SetCanAcceptDrops_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetCanAcceptDrops_Params_Data));
      new (data()) WindowTree_SetCanAcceptDrops_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetCanAcceptDrops_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetCanAcceptDrops_Params_Data>(index_);
    }
    WindowTree_SetCanAcceptDrops_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t accepts_drops : 1;
  uint8_t padfinal_[3];

 private:
  WindowTree_SetCanAcceptDrops_Params_Data();
  ~WindowTree_SetCanAcceptDrops_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetCanAcceptDrops_Params_Data) == 16,
              "Bad sizeof(WindowTree_SetCanAcceptDrops_Params_Data)");
// The 1210870615 value is based on sha256(salt + "WindowTree13").
constexpr uint32_t kWindowTree_SetWindowVisibility_Name = 1210870615;
class  WindowTree_SetWindowVisibility_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetWindowVisibility_Params_Data));
      new (data()) WindowTree_SetWindowVisibility_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetWindowVisibility_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetWindowVisibility_Params_Data>(index_);
    }
    WindowTree_SetWindowVisibility_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  uint8_t visible : 1;
  uint8_t padfinal_[7];

 private:
  WindowTree_SetWindowVisibility_Params_Data();
  ~WindowTree_SetWindowVisibility_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetWindowVisibility_Params_Data) == 24,
              "Bad sizeof(WindowTree_SetWindowVisibility_Params_Data)");
// The 873892186 value is based on sha256(salt + "WindowTree14").
constexpr uint32_t kWindowTree_SetWindowProperty_Name = 873892186;
class  WindowTree_SetWindowProperty_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetWindowProperty_Params_Data));
      new (data()) WindowTree_SetWindowProperty_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetWindowProperty_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetWindowProperty_Params_Data>(index_);
    }
    WindowTree_SetWindowProperty_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;

 private:
  WindowTree_SetWindowProperty_Params_Data();
  ~WindowTree_SetWindowProperty_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetWindowProperty_Params_Data) == 32,
              "Bad sizeof(WindowTree_SetWindowProperty_Params_Data)");
// The 930839124 value is based on sha256(salt + "WindowTree15").
constexpr uint32_t kWindowTree_SetWindowOpacity_Name = 930839124;
class  WindowTree_SetWindowOpacity_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetWindowOpacity_Params_Data));
      new (data()) WindowTree_SetWindowOpacity_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetWindowOpacity_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetWindowOpacity_Params_Data>(index_);
    }
    WindowTree_SetWindowOpacity_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  float opacity;
  uint8_t padfinal_[4];

 private:
  WindowTree_SetWindowOpacity_Params_Data();
  ~WindowTree_SetWindowOpacity_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetWindowOpacity_Params_Data) == 24,
              "Bad sizeof(WindowTree_SetWindowOpacity_Params_Data)");
// The 1615835832 value is based on sha256(salt + "WindowTree16").
constexpr uint32_t kWindowTree_AttachCompositorFrameSink_Name = 1615835832;
class  WindowTree_AttachCompositorFrameSink_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_AttachCompositorFrameSink_Params_Data));
      new (data()) WindowTree_AttachCompositorFrameSink_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_AttachCompositorFrameSink_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_AttachCompositorFrameSink_Params_Data>(index_);
    }
    WindowTree_AttachCompositorFrameSink_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  mojo::internal::Handle_Data compositor_frame_sink;
  mojo::internal::Interface_Data client;

 private:
  WindowTree_AttachCompositorFrameSink_Params_Data();
  ~WindowTree_AttachCompositorFrameSink_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_AttachCompositorFrameSink_Params_Data) == 24,
              "Bad sizeof(WindowTree_AttachCompositorFrameSink_Params_Data)");
// The 274057094 value is based on sha256(salt + "WindowTree17").
constexpr uint32_t kWindowTree_AddWindow_Name = 274057094;
class  WindowTree_AddWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_AddWindow_Params_Data));
      new (data()) WindowTree_AddWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_AddWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_AddWindow_Params_Data>(index_);
    }
    WindowTree_AddWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t parent;
  uint32_t child;
  uint8_t padfinal_[4];

 private:
  WindowTree_AddWindow_Params_Data();
  ~WindowTree_AddWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_AddWindow_Params_Data) == 24,
              "Bad sizeof(WindowTree_AddWindow_Params_Data)");
// The 1163290724 value is based on sha256(salt + "WindowTree18").
constexpr uint32_t kWindowTree_RemoveWindowFromParent_Name = 1163290724;
class  WindowTree_RemoveWindowFromParent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_RemoveWindowFromParent_Params_Data));
      new (data()) WindowTree_RemoveWindowFromParent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_RemoveWindowFromParent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_RemoveWindowFromParent_Params_Data>(index_);
    }
    WindowTree_RemoveWindowFromParent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;

 private:
  WindowTree_RemoveWindowFromParent_Params_Data();
  ~WindowTree_RemoveWindowFromParent_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_RemoveWindowFromParent_Params_Data) == 16,
              "Bad sizeof(WindowTree_RemoveWindowFromParent_Params_Data)");
// The 372903017 value is based on sha256(salt + "WindowTree19").
constexpr uint32_t kWindowTree_AddTransientWindow_Name = 372903017;
class  WindowTree_AddTransientWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_AddTransientWindow_Params_Data));
      new (data()) WindowTree_AddTransientWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_AddTransientWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_AddTransientWindow_Params_Data>(index_);
    }
    WindowTree_AddTransientWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  uint32_t transient_window_id;
  uint8_t padfinal_[4];

 private:
  WindowTree_AddTransientWindow_Params_Data();
  ~WindowTree_AddTransientWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_AddTransientWindow_Params_Data) == 24,
              "Bad sizeof(WindowTree_AddTransientWindow_Params_Data)");
// The 1013648436 value is based on sha256(salt + "WindowTree20").
constexpr uint32_t kWindowTree_RemoveTransientWindowFromParent_Name = 1013648436;
class  WindowTree_RemoveTransientWindowFromParent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_RemoveTransientWindowFromParent_Params_Data));
      new (data()) WindowTree_RemoveTransientWindowFromParent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_RemoveTransientWindowFromParent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_RemoveTransientWindowFromParent_Params_Data>(index_);
    }
    WindowTree_RemoveTransientWindowFromParent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t transient_window_id;

 private:
  WindowTree_RemoveTransientWindowFromParent_Params_Data();
  ~WindowTree_RemoveTransientWindowFromParent_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_RemoveTransientWindowFromParent_Params_Data) == 16,
              "Bad sizeof(WindowTree_RemoveTransientWindowFromParent_Params_Data)");
// The 1450975908 value is based on sha256(salt + "WindowTree21").
constexpr uint32_t kWindowTree_SetModalType_Name = 1450975908;
class  WindowTree_SetModalType_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetModalType_Params_Data));
      new (data()) WindowTree_SetModalType_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetModalType_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetModalType_Params_Data>(index_);
    }
    WindowTree_SetModalType_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  int32_t type;
  uint8_t padfinal_[4];

 private:
  WindowTree_SetModalType_Params_Data();
  ~WindowTree_SetModalType_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetModalType_Params_Data) == 24,
              "Bad sizeof(WindowTree_SetModalType_Params_Data)");
// The 655128180 value is based on sha256(salt + "WindowTree22").
constexpr uint32_t kWindowTree_SetChildModalParent_Name = 655128180;
class  WindowTree_SetChildModalParent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetChildModalParent_Params_Data));
      new (data()) WindowTree_SetChildModalParent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetChildModalParent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetChildModalParent_Params_Data>(index_);
    }
    WindowTree_SetChildModalParent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  uint32_t parent_window_id;
  uint8_t padfinal_[4];

 private:
  WindowTree_SetChildModalParent_Params_Data();
  ~WindowTree_SetChildModalParent_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetChildModalParent_Params_Data) == 24,
              "Bad sizeof(WindowTree_SetChildModalParent_Params_Data)");
// The 1033745476 value is based on sha256(salt + "WindowTree23").
constexpr uint32_t kWindowTree_ReorderWindow_Name = 1033745476;
class  WindowTree_ReorderWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_ReorderWindow_Params_Data));
      new (data()) WindowTree_ReorderWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_ReorderWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_ReorderWindow_Params_Data>(index_);
    }
    WindowTree_ReorderWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  uint32_t relative_window_id;
  int32_t direction;

 private:
  WindowTree_ReorderWindow_Params_Data();
  ~WindowTree_ReorderWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_ReorderWindow_Params_Data) == 24,
              "Bad sizeof(WindowTree_ReorderWindow_Params_Data)");
// The 1292785507 value is based on sha256(salt + "WindowTree24").
constexpr uint32_t kWindowTree_GetWindowTree_Name = 1292785507;
class  WindowTree_GetWindowTree_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_GetWindowTree_Params_Data));
      new (data()) WindowTree_GetWindowTree_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_GetWindowTree_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_GetWindowTree_Params_Data>(index_);
    }
    WindowTree_GetWindowTree_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowTree_GetWindowTree_Params_Data();
  ~WindowTree_GetWindowTree_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_GetWindowTree_Params_Data) == 16,
              "Bad sizeof(WindowTree_GetWindowTree_Params_Data)");
class  WindowTree_GetWindowTree_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_GetWindowTree_ResponseParams_Data));
      new (data()) WindowTree_GetWindowTree_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_GetWindowTree_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_GetWindowTree_ResponseParams_Data>(index_);
    }
    WindowTree_GetWindowTree_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::WindowData_Data>>> windows;

 private:
  WindowTree_GetWindowTree_ResponseParams_Data();
  ~WindowTree_GetWindowTree_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowTree_GetWindowTree_ResponseParams_Data) == 16,
              "Bad sizeof(WindowTree_GetWindowTree_ResponseParams_Data)");
// The 955349899 value is based on sha256(salt + "WindowTree25").
constexpr uint32_t kWindowTree_Embed_Name = 955349899;
class  WindowTree_Embed_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_Embed_Params_Data));
      new (data()) WindowTree_Embed_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_Embed_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_Embed_Params_Data>(index_);
    }
    WindowTree_Embed_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  mojo::internal::Interface_Data client;
  uint32_t embed_flags;

 private:
  WindowTree_Embed_Params_Data();
  ~WindowTree_Embed_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_Embed_Params_Data) == 24,
              "Bad sizeof(WindowTree_Embed_Params_Data)");
class  WindowTree_Embed_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_Embed_ResponseParams_Data));
      new (data()) WindowTree_Embed_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_Embed_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_Embed_ResponseParams_Data>(index_);
    }
    WindowTree_Embed_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  WindowTree_Embed_ResponseParams_Data();
  ~WindowTree_Embed_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowTree_Embed_ResponseParams_Data) == 16,
              "Bad sizeof(WindowTree_Embed_ResponseParams_Data)");
// The 327570549 value is based on sha256(salt + "WindowTree26").
constexpr uint32_t kWindowTree_ScheduleEmbed_Name = 327570549;
class  WindowTree_ScheduleEmbed_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_ScheduleEmbed_Params_Data));
      new (data()) WindowTree_ScheduleEmbed_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_ScheduleEmbed_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_ScheduleEmbed_Params_Data>(index_);
    }
    WindowTree_ScheduleEmbed_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data client;

 private:
  WindowTree_ScheduleEmbed_Params_Data();
  ~WindowTree_ScheduleEmbed_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_ScheduleEmbed_Params_Data) == 16,
              "Bad sizeof(WindowTree_ScheduleEmbed_Params_Data)");
class  WindowTree_ScheduleEmbed_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_ScheduleEmbed_ResponseParams_Data));
      new (data()) WindowTree_ScheduleEmbed_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_ScheduleEmbed_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_ScheduleEmbed_ResponseParams_Data>(index_);
    }
    WindowTree_ScheduleEmbed_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::UnguessableToken_Data> token;

 private:
  WindowTree_ScheduleEmbed_ResponseParams_Data();
  ~WindowTree_ScheduleEmbed_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowTree_ScheduleEmbed_ResponseParams_Data) == 16,
              "Bad sizeof(WindowTree_ScheduleEmbed_ResponseParams_Data)");
// The 749939136 value is based on sha256(salt + "WindowTree27").
constexpr uint32_t kWindowTree_EmbedUsingToken_Name = 749939136;
class  WindowTree_EmbedUsingToken_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_EmbedUsingToken_Params_Data));
      new (data()) WindowTree_EmbedUsingToken_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_EmbedUsingToken_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_EmbedUsingToken_Params_Data>(index_);
    }
    WindowTree_EmbedUsingToken_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint32_t embed_flags;
  mojo::internal::Pointer<::mojo::common::mojom::internal::UnguessableToken_Data> token;

 private:
  WindowTree_EmbedUsingToken_Params_Data();
  ~WindowTree_EmbedUsingToken_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_EmbedUsingToken_Params_Data) == 24,
              "Bad sizeof(WindowTree_EmbedUsingToken_Params_Data)");
class  WindowTree_EmbedUsingToken_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_EmbedUsingToken_ResponseParams_Data));
      new (data()) WindowTree_EmbedUsingToken_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_EmbedUsingToken_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_EmbedUsingToken_ResponseParams_Data>(index_);
    }
    WindowTree_EmbedUsingToken_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  WindowTree_EmbedUsingToken_ResponseParams_Data();
  ~WindowTree_EmbedUsingToken_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowTree_EmbedUsingToken_ResponseParams_Data) == 16,
              "Bad sizeof(WindowTree_EmbedUsingToken_ResponseParams_Data)");
// The 768118346 value is based on sha256(salt + "WindowTree28").
constexpr uint32_t kWindowTree_SetFocus_Name = 768118346;
class  WindowTree_SetFocus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetFocus_Params_Data));
      new (data()) WindowTree_SetFocus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetFocus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetFocus_Params_Data>(index_);
    }
    WindowTree_SetFocus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;

 private:
  WindowTree_SetFocus_Params_Data();
  ~WindowTree_SetFocus_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetFocus_Params_Data) == 16,
              "Bad sizeof(WindowTree_SetFocus_Params_Data)");
// The 1340908067 value is based on sha256(salt + "WindowTree29").
constexpr uint32_t kWindowTree_SetCanFocus_Name = 1340908067;
class  WindowTree_SetCanFocus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetCanFocus_Params_Data));
      new (data()) WindowTree_SetCanFocus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetCanFocus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetCanFocus_Params_Data>(index_);
    }
    WindowTree_SetCanFocus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t can_focus : 1;
  uint8_t padfinal_[3];

 private:
  WindowTree_SetCanFocus_Params_Data();
  ~WindowTree_SetCanFocus_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetCanFocus_Params_Data) == 16,
              "Bad sizeof(WindowTree_SetCanFocus_Params_Data)");
// The 1721652521 value is based on sha256(salt + "WindowTree30").
constexpr uint32_t kWindowTree_SetCursor_Name = 1721652521;
class  WindowTree_SetCursor_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetCursor_Params_Data));
      new (data()) WindowTree_SetCursor_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetCursor_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetCursor_Params_Data>(index_);
    }
    WindowTree_SetCursor_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  mojo::internal::Pointer<::ui::mojom::internal::CursorData_Data> cursor;

 private:
  WindowTree_SetCursor_Params_Data();
  ~WindowTree_SetCursor_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetCursor_Params_Data) == 24,
              "Bad sizeof(WindowTree_SetCursor_Params_Data)");
// The 421100091 value is based on sha256(salt + "WindowTree31").
constexpr uint32_t kWindowTree_SetWindowTextInputState_Name = 421100091;
class  WindowTree_SetWindowTextInputState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetWindowTextInputState_Params_Data));
      new (data()) WindowTree_SetWindowTextInputState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetWindowTextInputState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetWindowTextInputState_Params_Data>(index_);
    }
    WindowTree_SetWindowTextInputState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::ui::mojom::internal::TextInputState_Data> state;

 private:
  WindowTree_SetWindowTextInputState_Params_Data();
  ~WindowTree_SetWindowTextInputState_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetWindowTextInputState_Params_Data) == 24,
              "Bad sizeof(WindowTree_SetWindowTextInputState_Params_Data)");
// The 1172170090 value is based on sha256(salt + "WindowTree32").
constexpr uint32_t kWindowTree_SetImeVisibility_Name = 1172170090;
class  WindowTree_SetImeVisibility_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetImeVisibility_Params_Data));
      new (data()) WindowTree_SetImeVisibility_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetImeVisibility_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetImeVisibility_Params_Data>(index_);
    }
    WindowTree_SetImeVisibility_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t visible : 1;
  uint8_t pad1_[3];
  mojo::internal::Pointer<::ui::mojom::internal::TextInputState_Data> state;

 private:
  WindowTree_SetImeVisibility_Params_Data();
  ~WindowTree_SetImeVisibility_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetImeVisibility_Params_Data) == 24,
              "Bad sizeof(WindowTree_SetImeVisibility_Params_Data)");
// The 762187375 value is based on sha256(salt + "WindowTree33").
constexpr uint32_t kWindowTree_SetEventTargetingPolicy_Name = 762187375;
class  WindowTree_SetEventTargetingPolicy_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_SetEventTargetingPolicy_Params_Data));
      new (data()) WindowTree_SetEventTargetingPolicy_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_SetEventTargetingPolicy_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_SetEventTargetingPolicy_Params_Data>(index_);
    }
    WindowTree_SetEventTargetingPolicy_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  int32_t policy;

 private:
  WindowTree_SetEventTargetingPolicy_Params_Data();
  ~WindowTree_SetEventTargetingPolicy_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_SetEventTargetingPolicy_Params_Data) == 16,
              "Bad sizeof(WindowTree_SetEventTargetingPolicy_Params_Data)");
// The 191120465 value is based on sha256(salt + "WindowTree34").
constexpr uint32_t kWindowTree_OnWindowInputEventAck_Name = 191120465;
class  WindowTree_OnWindowInputEventAck_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_OnWindowInputEventAck_Params_Data));
      new (data()) WindowTree_OnWindowInputEventAck_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_OnWindowInputEventAck_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_OnWindowInputEventAck_Params_Data>(index_);
    }
    WindowTree_OnWindowInputEventAck_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t event_id;
  int32_t result;

 private:
  WindowTree_OnWindowInputEventAck_Params_Data();
  ~WindowTree_OnWindowInputEventAck_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_OnWindowInputEventAck_Params_Data) == 16,
              "Bad sizeof(WindowTree_OnWindowInputEventAck_Params_Data)");
// The 1930623290 value is based on sha256(salt + "WindowTree35").
constexpr uint32_t kWindowTree_DeactivateWindow_Name = 1930623290;
class  WindowTree_DeactivateWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_DeactivateWindow_Params_Data));
      new (data()) WindowTree_DeactivateWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_DeactivateWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_DeactivateWindow_Params_Data>(index_);
    }
    WindowTree_DeactivateWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowTree_DeactivateWindow_Params_Data();
  ~WindowTree_DeactivateWindow_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_DeactivateWindow_Params_Data) == 16,
              "Bad sizeof(WindowTree_DeactivateWindow_Params_Data)");
// The 1130357812 value is based on sha256(salt + "WindowTree36").
constexpr uint32_t kWindowTree_StackAbove_Name = 1130357812;
class  WindowTree_StackAbove_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_StackAbove_Params_Data));
      new (data()) WindowTree_StackAbove_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_StackAbove_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_StackAbove_Params_Data>(index_);
    }
    WindowTree_StackAbove_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t above_id;
  uint32_t below_id;
  uint8_t padfinal_[4];

 private:
  WindowTree_StackAbove_Params_Data();
  ~WindowTree_StackAbove_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_StackAbove_Params_Data) == 24,
              "Bad sizeof(WindowTree_StackAbove_Params_Data)");
// The 315720171 value is based on sha256(salt + "WindowTree37").
constexpr uint32_t kWindowTree_StackAtTop_Name = 315720171;
class  WindowTree_StackAtTop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_StackAtTop_Params_Data));
      new (data()) WindowTree_StackAtTop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_StackAtTop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_StackAtTop_Params_Data>(index_);
    }
    WindowTree_StackAtTop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;

 private:
  WindowTree_StackAtTop_Params_Data();
  ~WindowTree_StackAtTop_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_StackAtTop_Params_Data) == 16,
              "Bad sizeof(WindowTree_StackAtTop_Params_Data)");
// The 806664833 value is based on sha256(salt + "WindowTree38").
constexpr uint32_t kWindowTree_PerformWmAction_Name = 806664833;
class  WindowTree_PerformWmAction_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_PerformWmAction_Params_Data));
      new (data()) WindowTree_PerformWmAction_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_PerformWmAction_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_PerformWmAction_Params_Data>(index_);
    }
    WindowTree_PerformWmAction_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> action;

 private:
  WindowTree_PerformWmAction_Params_Data();
  ~WindowTree_PerformWmAction_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_PerformWmAction_Params_Data) == 24,
              "Bad sizeof(WindowTree_PerformWmAction_Params_Data)");
// The 370521312 value is based on sha256(salt + "WindowTree39").
constexpr uint32_t kWindowTree_GetWindowManagerClient_Name = 370521312;
class  WindowTree_GetWindowManagerClient_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_GetWindowManagerClient_Params_Data));
      new (data()) WindowTree_GetWindowManagerClient_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_GetWindowManagerClient_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_GetWindowManagerClient_Params_Data>(index_);
    }
    WindowTree_GetWindowManagerClient_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedEndpointHandle_Data internal;
  uint8_t padfinal_[4];

 private:
  WindowTree_GetWindowManagerClient_Params_Data();
  ~WindowTree_GetWindowManagerClient_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_GetWindowManagerClient_Params_Data) == 16,
              "Bad sizeof(WindowTree_GetWindowManagerClient_Params_Data)");
// The 1674634675 value is based on sha256(salt + "WindowTree40").
constexpr uint32_t kWindowTree_GetCursorLocationMemory_Name = 1674634675;
class  WindowTree_GetCursorLocationMemory_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_GetCursorLocationMemory_Params_Data));
      new (data()) WindowTree_GetCursorLocationMemory_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_GetCursorLocationMemory_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_GetCursorLocationMemory_Params_Data>(index_);
    }
    WindowTree_GetCursorLocationMemory_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WindowTree_GetCursorLocationMemory_Params_Data();
  ~WindowTree_GetCursorLocationMemory_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_GetCursorLocationMemory_Params_Data) == 8,
              "Bad sizeof(WindowTree_GetCursorLocationMemory_Params_Data)");
class  WindowTree_GetCursorLocationMemory_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_GetCursorLocationMemory_ResponseParams_Data));
      new (data()) WindowTree_GetCursorLocationMemory_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_GetCursorLocationMemory_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_GetCursorLocationMemory_ResponseParams_Data>(index_);
    }
    WindowTree_GetCursorLocationMemory_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data cursor_buffer;
  uint8_t padfinal_[4];

 private:
  WindowTree_GetCursorLocationMemory_ResponseParams_Data();
  ~WindowTree_GetCursorLocationMemory_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowTree_GetCursorLocationMemory_ResponseParams_Data) == 16,
              "Bad sizeof(WindowTree_GetCursorLocationMemory_ResponseParams_Data)");
// The 1539492878 value is based on sha256(salt + "WindowTree41").
constexpr uint32_t kWindowTree_PerformWindowMove_Name = 1539492878;
class  WindowTree_PerformWindowMove_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_PerformWindowMove_Params_Data));
      new (data()) WindowTree_PerformWindowMove_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_PerformWindowMove_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_PerformWindowMove_Params_Data>(index_);
    }
    WindowTree_PerformWindowMove_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t window_id;
  int32_t source;
  uint8_t pad2_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> cursor;

 private:
  WindowTree_PerformWindowMove_Params_Data();
  ~WindowTree_PerformWindowMove_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_PerformWindowMove_Params_Data) == 32,
              "Bad sizeof(WindowTree_PerformWindowMove_Params_Data)");
// The 1287978234 value is based on sha256(salt + "WindowTree42").
constexpr uint32_t kWindowTree_CancelWindowMove_Name = 1287978234;
class  WindowTree_CancelWindowMove_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_CancelWindowMove_Params_Data));
      new (data()) WindowTree_CancelWindowMove_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_CancelWindowMove_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_CancelWindowMove_Params_Data>(index_);
    }
    WindowTree_CancelWindowMove_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowTree_CancelWindowMove_Params_Data();
  ~WindowTree_CancelWindowMove_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_CancelWindowMove_Params_Data) == 16,
              "Bad sizeof(WindowTree_CancelWindowMove_Params_Data)");
// The 369080437 value is based on sha256(salt + "WindowTree43").
constexpr uint32_t kWindowTree_PerformDragDrop_Name = 369080437;
class  WindowTree_PerformDragDrop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_PerformDragDrop_Params_Data));
      new (data()) WindowTree_PerformDragDrop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_PerformDragDrop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_PerformDragDrop_Params_Data>(index_);
    }
    WindowTree_PerformDragDrop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint32_t source_window_id;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> screen_location;
  mojo::internal::Pointer<mojo::internal::Map_Data<mojo::internal::Pointer<mojo::internal::String_Data>, mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>>>> drag_data;
  mojo::internal::Pointer<::skia::mojom::internal::Bitmap_Data> drag_image;
  mojo::internal::Pointer<::gfx::mojom::internal::Vector2d_Data> drag_image_offset;
  uint32_t drag_operation;
  int32_t source;

 private:
  WindowTree_PerformDragDrop_Params_Data();
  ~WindowTree_PerformDragDrop_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_PerformDragDrop_Params_Data) == 56,
              "Bad sizeof(WindowTree_PerformDragDrop_Params_Data)");
// The 921886997 value is based on sha256(salt + "WindowTree44").
constexpr uint32_t kWindowTree_CancelDragDrop_Name = 921886997;
class  WindowTree_CancelDragDrop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTree_CancelDragDrop_Params_Data));
      new (data()) WindowTree_CancelDragDrop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTree_CancelDragDrop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTree_CancelDragDrop_Params_Data>(index_);
    }
    WindowTree_CancelDragDrop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowTree_CancelDragDrop_Params_Data();
  ~WindowTree_CancelDragDrop_Params_Data() = delete;
};
static_assert(sizeof(WindowTree_CancelDragDrop_Params_Data) == 16,
              "Bad sizeof(WindowTree_CancelDragDrop_Params_Data)");
// The 672989993 value is based on sha256(salt + "WindowTreeClient1").
constexpr uint32_t kWindowTreeClient_OnEmbed_Name = 672989993;
class  WindowTreeClient_OnEmbed_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnEmbed_Params_Data));
      new (data()) WindowTreeClient_OnEmbed_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnEmbed_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnEmbed_Params_Data>(index_);
    }
    WindowTreeClient_OnEmbed_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::ui::mojom::internal::WindowData_Data> root;
  mojo::internal::Interface_Data tree;
  int64_t display_id;
  uint32_t focused_window;
  uint8_t parent_drawn : 1;
  uint8_t pad4_[3];
  mojo::internal::Pointer<::viz::mojom::internal::LocalSurfaceId_Data> local_surface_id;

 private:
  WindowTreeClient_OnEmbed_Params_Data();
  ~WindowTreeClient_OnEmbed_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnEmbed_Params_Data) == 48,
              "Bad sizeof(WindowTreeClient_OnEmbed_Params_Data)");
// The 1514348731 value is based on sha256(salt + "WindowTreeClient2").
constexpr uint32_t kWindowTreeClient_OnEmbeddedAppDisconnected_Name = 1514348731;
class  WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data));
      new (data()) WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data>(index_);
    }
    WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data();
  ~WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnEmbeddedAppDisconnected_Params_Data)");
// The 2085482987 value is based on sha256(salt + "WindowTreeClient3").
constexpr uint32_t kWindowTreeClient_OnUnembed_Name = 2085482987;
class  WindowTreeClient_OnUnembed_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnUnembed_Params_Data));
      new (data()) WindowTreeClient_OnUnembed_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnUnembed_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnUnembed_Params_Data>(index_);
    }
    WindowTreeClient_OnUnembed_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnUnembed_Params_Data();
  ~WindowTreeClient_OnUnembed_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnUnembed_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnUnembed_Params_Data)");
// The 1138946770 value is based on sha256(salt + "WindowTreeClient4").
constexpr uint32_t kWindowTreeClient_OnCaptureChanged_Name = 1138946770;
class  WindowTreeClient_OnCaptureChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnCaptureChanged_Params_Data));
      new (data()) WindowTreeClient_OnCaptureChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnCaptureChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnCaptureChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnCaptureChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t new_capture;
  uint32_t old_capture;

 private:
  WindowTreeClient_OnCaptureChanged_Params_Data();
  ~WindowTreeClient_OnCaptureChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnCaptureChanged_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnCaptureChanged_Params_Data)");
// The 386936961 value is based on sha256(salt + "WindowTreeClient5").
constexpr uint32_t kWindowTreeClient_OnFrameSinkIdAllocated_Name = 386936961;
class  WindowTreeClient_OnFrameSinkIdAllocated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnFrameSinkIdAllocated_Params_Data));
      new (data()) WindowTreeClient_OnFrameSinkIdAllocated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnFrameSinkIdAllocated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnFrameSinkIdAllocated_Params_Data>(index_);
    }
    WindowTreeClient_OnFrameSinkIdAllocated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::viz::mojom::internal::FrameSinkId_Data> frame_sink_id;

 private:
  WindowTreeClient_OnFrameSinkIdAllocated_Params_Data();
  ~WindowTreeClient_OnFrameSinkIdAllocated_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnFrameSinkIdAllocated_Params_Data) == 24,
              "Bad sizeof(WindowTreeClient_OnFrameSinkIdAllocated_Params_Data)");
// The 1592717176 value is based on sha256(salt + "WindowTreeClient6").
constexpr uint32_t kWindowTreeClient_OnTopLevelCreated_Name = 1592717176;
class  WindowTreeClient_OnTopLevelCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnTopLevelCreated_Params_Data));
      new (data()) WindowTreeClient_OnTopLevelCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnTopLevelCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnTopLevelCreated_Params_Data>(index_);
    }
    WindowTreeClient_OnTopLevelCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint8_t parent_drawn : 1;
  uint8_t pad1_[3];
  mojo::internal::Pointer<::ui::mojom::internal::WindowData_Data> data;
  int64_t display_id;
  mojo::internal::Pointer<::viz::mojom::internal::LocalSurfaceId_Data> local_surface_id;

 private:
  WindowTreeClient_OnTopLevelCreated_Params_Data();
  ~WindowTreeClient_OnTopLevelCreated_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnTopLevelCreated_Params_Data) == 40,
              "Bad sizeof(WindowTreeClient_OnTopLevelCreated_Params_Data)");
// The 851760517 value is based on sha256(salt + "WindowTreeClient7").
constexpr uint32_t kWindowTreeClient_OnWindowBoundsChanged_Name = 851760517;
class  WindowTreeClient_OnWindowBoundsChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowBoundsChanged_Params_Data));
      new (data()) WindowTreeClient_OnWindowBoundsChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowBoundsChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowBoundsChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowBoundsChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> old_bounds;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> new_bounds;
  mojo::internal::Pointer<::viz::mojom::internal::LocalSurfaceId_Data> local_surface_id;

 private:
  WindowTreeClient_OnWindowBoundsChanged_Params_Data();
  ~WindowTreeClient_OnWindowBoundsChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowBoundsChanged_Params_Data) == 40,
              "Bad sizeof(WindowTreeClient_OnWindowBoundsChanged_Params_Data)");
// The 1019925173 value is based on sha256(salt + "WindowTreeClient8").
constexpr uint32_t kWindowTreeClient_OnWindowTransformChanged_Name = 1019925173;
class  WindowTreeClient_OnWindowTransformChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowTransformChanged_Params_Data));
      new (data()) WindowTreeClient_OnWindowTransformChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowTransformChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowTransformChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowTransformChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Transform_Data> old_transform;
  mojo::internal::Pointer<::gfx::mojom::internal::Transform_Data> new_transform;

 private:
  WindowTreeClient_OnWindowTransformChanged_Params_Data();
  ~WindowTreeClient_OnWindowTransformChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowTransformChanged_Params_Data) == 32,
              "Bad sizeof(WindowTreeClient_OnWindowTransformChanged_Params_Data)");
// The 189713243 value is based on sha256(salt + "WindowTreeClient9").
constexpr uint32_t kWindowTreeClient_OnClientAreaChanged_Name = 189713243;
class  WindowTreeClient_OnClientAreaChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnClientAreaChanged_Params_Data));
      new (data()) WindowTreeClient_OnClientAreaChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnClientAreaChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnClientAreaChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnClientAreaChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gfx::mojom::internal::Insets_Data> new_client_area;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data>>> new_additional_client_areas;

 private:
  WindowTreeClient_OnClientAreaChanged_Params_Data();
  ~WindowTreeClient_OnClientAreaChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnClientAreaChanged_Params_Data) == 32,
              "Bad sizeof(WindowTreeClient_OnClientAreaChanged_Params_Data)");
// The 1774949982 value is based on sha256(salt + "WindowTreeClient10").
constexpr uint32_t kWindowTreeClient_OnTransientWindowAdded_Name = 1774949982;
class  WindowTreeClient_OnTransientWindowAdded_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnTransientWindowAdded_Params_Data));
      new (data()) WindowTreeClient_OnTransientWindowAdded_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnTransientWindowAdded_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnTransientWindowAdded_Params_Data>(index_);
    }
    WindowTreeClient_OnTransientWindowAdded_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint32_t transient_window_id;

 private:
  WindowTreeClient_OnTransientWindowAdded_Params_Data();
  ~WindowTreeClient_OnTransientWindowAdded_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnTransientWindowAdded_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnTransientWindowAdded_Params_Data)");
// The 822939468 value is based on sha256(salt + "WindowTreeClient11").
constexpr uint32_t kWindowTreeClient_OnTransientWindowRemoved_Name = 822939468;
class  WindowTreeClient_OnTransientWindowRemoved_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnTransientWindowRemoved_Params_Data));
      new (data()) WindowTreeClient_OnTransientWindowRemoved_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnTransientWindowRemoved_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnTransientWindowRemoved_Params_Data>(index_);
    }
    WindowTreeClient_OnTransientWindowRemoved_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint32_t transient_window_id;

 private:
  WindowTreeClient_OnTransientWindowRemoved_Params_Data();
  ~WindowTreeClient_OnTransientWindowRemoved_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnTransientWindowRemoved_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnTransientWindowRemoved_Params_Data)");
// The 571954113 value is based on sha256(salt + "WindowTreeClient12").
constexpr uint32_t kWindowTreeClient_OnWindowHierarchyChanged_Name = 571954113;
class  WindowTreeClient_OnWindowHierarchyChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowHierarchyChanged_Params_Data));
      new (data()) WindowTreeClient_OnWindowHierarchyChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowHierarchyChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowHierarchyChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowHierarchyChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint32_t old_parent;
  uint32_t new_parent;
  uint8_t pad2_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::mojom::internal::WindowData_Data>>> windows;

 private:
  WindowTreeClient_OnWindowHierarchyChanged_Params_Data();
  ~WindowTreeClient_OnWindowHierarchyChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowHierarchyChanged_Params_Data) == 32,
              "Bad sizeof(WindowTreeClient_OnWindowHierarchyChanged_Params_Data)");
// The 785979138 value is based on sha256(salt + "WindowTreeClient13").
constexpr uint32_t kWindowTreeClient_OnWindowReordered_Name = 785979138;
class  WindowTreeClient_OnWindowReordered_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowReordered_Params_Data));
      new (data()) WindowTreeClient_OnWindowReordered_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowReordered_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowReordered_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowReordered_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint32_t relative_window_id;
  int32_t direction;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnWindowReordered_Params_Data();
  ~WindowTreeClient_OnWindowReordered_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowReordered_Params_Data) == 24,
              "Bad sizeof(WindowTreeClient_OnWindowReordered_Params_Data)");
// The 1559065586 value is based on sha256(salt + "WindowTreeClient14").
constexpr uint32_t kWindowTreeClient_OnWindowDeleted_Name = 1559065586;
class  WindowTreeClient_OnWindowDeleted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowDeleted_Params_Data));
      new (data()) WindowTreeClient_OnWindowDeleted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowDeleted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowDeleted_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowDeleted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnWindowDeleted_Params_Data();
  ~WindowTreeClient_OnWindowDeleted_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowDeleted_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnWindowDeleted_Params_Data)");
// The 1270535538 value is based on sha256(salt + "WindowTreeClient15").
constexpr uint32_t kWindowTreeClient_OnWindowVisibilityChanged_Name = 1270535538;
class  WindowTreeClient_OnWindowVisibilityChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowVisibilityChanged_Params_Data));
      new (data()) WindowTreeClient_OnWindowVisibilityChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowVisibilityChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowVisibilityChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowVisibilityChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t visible : 1;
  uint8_t padfinal_[3];

 private:
  WindowTreeClient_OnWindowVisibilityChanged_Params_Data();
  ~WindowTreeClient_OnWindowVisibilityChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowVisibilityChanged_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnWindowVisibilityChanged_Params_Data)");
// The 300981865 value is based on sha256(salt + "WindowTreeClient16").
constexpr uint32_t kWindowTreeClient_OnWindowOpacityChanged_Name = 300981865;
class  WindowTreeClient_OnWindowOpacityChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowOpacityChanged_Params_Data));
      new (data()) WindowTreeClient_OnWindowOpacityChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowOpacityChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowOpacityChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowOpacityChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  float old_opacity;
  float new_opacity;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnWindowOpacityChanged_Params_Data();
  ~WindowTreeClient_OnWindowOpacityChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowOpacityChanged_Params_Data) == 24,
              "Bad sizeof(WindowTreeClient_OnWindowOpacityChanged_Params_Data)");
// The 1089651863 value is based on sha256(salt + "WindowTreeClient17").
constexpr uint32_t kWindowTreeClient_OnWindowParentDrawnStateChanged_Name = 1089651863;
class  WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data));
      new (data()) WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t drawn : 1;
  uint8_t padfinal_[3];

 private:
  WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data();
  ~WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnWindowParentDrawnStateChanged_Params_Data)");
// The 882164898 value is based on sha256(salt + "WindowTreeClient18").
constexpr uint32_t kWindowTreeClient_OnWindowSharedPropertyChanged_Name = 882164898;
class  WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data));
      new (data()) WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> new_data;

 private:
  WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data();
  ~WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data) == 32,
              "Bad sizeof(WindowTreeClient_OnWindowSharedPropertyChanged_Params_Data)");
// The 1819928811 value is based on sha256(salt + "WindowTreeClient19").
constexpr uint32_t kWindowTreeClient_OnWindowInputEvent_Name = 1819928811;
class  WindowTreeClient_OnWindowInputEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowInputEvent_Params_Data));
      new (data()) WindowTreeClient_OnWindowInputEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowInputEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowInputEvent_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowInputEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t event_id;
  uint32_t window;
  int64_t display_id;
  uint32_t display_root_window;
  uint8_t matches_pointer_watcher : 1;
  uint8_t pad4_[3];
  mojo::internal::Pointer<::gfx::mojom::internal::PointF_Data> event_location_in_screen_pixel_layout;
  mojo::internal::Pointer<::ui::mojom::internal::Event_Data> event;

 private:
  WindowTreeClient_OnWindowInputEvent_Params_Data();
  ~WindowTreeClient_OnWindowInputEvent_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowInputEvent_Params_Data) == 48,
              "Bad sizeof(WindowTreeClient_OnWindowInputEvent_Params_Data)");
// The 1653583753 value is based on sha256(salt + "WindowTreeClient20").
constexpr uint32_t kWindowTreeClient_OnPointerEventObserved_Name = 1653583753;
class  WindowTreeClient_OnPointerEventObserved_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnPointerEventObserved_Params_Data));
      new (data()) WindowTreeClient_OnPointerEventObserved_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnPointerEventObserved_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnPointerEventObserved_Params_Data>(index_);
    }
    WindowTreeClient_OnPointerEventObserved_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::ui::mojom::internal::Event_Data> event;
  uint32_t window_id;
  uint8_t pad1_[4];
  int64_t display_id;

 private:
  WindowTreeClient_OnPointerEventObserved_Params_Data();
  ~WindowTreeClient_OnPointerEventObserved_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnPointerEventObserved_Params_Data) == 32,
              "Bad sizeof(WindowTreeClient_OnPointerEventObserved_Params_Data)");
// The 950126897 value is based on sha256(salt + "WindowTreeClient21").
constexpr uint32_t kWindowTreeClient_OnWindowFocused_Name = 950126897;
class  WindowTreeClient_OnWindowFocused_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowFocused_Params_Data));
      new (data()) WindowTreeClient_OnWindowFocused_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowFocused_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowFocused_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowFocused_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t focused_window_id;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnWindowFocused_Params_Data();
  ~WindowTreeClient_OnWindowFocused_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowFocused_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnWindowFocused_Params_Data)");
// The 1923153371 value is based on sha256(salt + "WindowTreeClient22").
constexpr uint32_t kWindowTreeClient_OnWindowCursorChanged_Name = 1923153371;
class  WindowTreeClient_OnWindowCursorChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowCursorChanged_Params_Data));
      new (data()) WindowTreeClient_OnWindowCursorChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowCursorChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowCursorChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowCursorChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::ui::mojom::internal::CursorData_Data> cursor;

 private:
  WindowTreeClient_OnWindowCursorChanged_Params_Data();
  ~WindowTreeClient_OnWindowCursorChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowCursorChanged_Params_Data) == 24,
              "Bad sizeof(WindowTreeClient_OnWindowCursorChanged_Params_Data)");
// The 567419007 value is based on sha256(salt + "WindowTreeClient23").
constexpr uint32_t kWindowTreeClient_OnWindowSurfaceChanged_Name = 567419007;
class  WindowTreeClient_OnWindowSurfaceChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnWindowSurfaceChanged_Params_Data));
      new (data()) WindowTreeClient_OnWindowSurfaceChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnWindowSurfaceChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnWindowSurfaceChanged_Params_Data>(index_);
    }
    WindowTreeClient_OnWindowSurfaceChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::viz::mojom::internal::SurfaceInfo_Data> surface_info;

 private:
  WindowTreeClient_OnWindowSurfaceChanged_Params_Data();
  ~WindowTreeClient_OnWindowSurfaceChanged_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnWindowSurfaceChanged_Params_Data) == 24,
              "Bad sizeof(WindowTreeClient_OnWindowSurfaceChanged_Params_Data)");
// The 969908616 value is based on sha256(salt + "WindowTreeClient24").
constexpr uint32_t kWindowTreeClient_OnDragDropStart_Name = 969908616;
class  WindowTreeClient_OnDragDropStart_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnDragDropStart_Params_Data));
      new (data()) WindowTreeClient_OnDragDropStart_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnDragDropStart_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnDragDropStart_Params_Data>(index_);
    }
    WindowTreeClient_OnDragDropStart_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Map_Data<mojo::internal::Pointer<mojo::internal::String_Data>, mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>>>> drag_data;

 private:
  WindowTreeClient_OnDragDropStart_Params_Data();
  ~WindowTreeClient_OnDragDropStart_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnDragDropStart_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnDragDropStart_Params_Data)");
// The 318063502 value is based on sha256(salt + "WindowTreeClient25").
constexpr uint32_t kWindowTreeClient_OnDragEnter_Name = 318063502;
class  WindowTreeClient_OnDragEnter_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnDragEnter_Params_Data));
      new (data()) WindowTreeClient_OnDragEnter_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnDragEnter_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnDragEnter_Params_Data>(index_);
    }
    WindowTreeClient_OnDragEnter_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint32_t key_state;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> screen_position;
  uint32_t effect_bitmask;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnDragEnter_Params_Data();
  ~WindowTreeClient_OnDragEnter_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnDragEnter_Params_Data) == 32,
              "Bad sizeof(WindowTreeClient_OnDragEnter_Params_Data)");
class  WindowTreeClient_OnDragEnter_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnDragEnter_ResponseParams_Data));
      new (data()) WindowTreeClient_OnDragEnter_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnDragEnter_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnDragEnter_ResponseParams_Data>(index_);
    }
    WindowTreeClient_OnDragEnter_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t supported_op_bitmask;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnDragEnter_ResponseParams_Data();
  ~WindowTreeClient_OnDragEnter_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnDragEnter_ResponseParams_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnDragEnter_ResponseParams_Data)");
// The 1633680805 value is based on sha256(salt + "WindowTreeClient26").
constexpr uint32_t kWindowTreeClient_OnDragOver_Name = 1633680805;
class  WindowTreeClient_OnDragOver_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnDragOver_Params_Data));
      new (data()) WindowTreeClient_OnDragOver_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnDragOver_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnDragOver_Params_Data>(index_);
    }
    WindowTreeClient_OnDragOver_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint32_t key_state;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> screen_position;
  uint32_t effect_bitmask;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnDragOver_Params_Data();
  ~WindowTreeClient_OnDragOver_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnDragOver_Params_Data) == 32,
              "Bad sizeof(WindowTreeClient_OnDragOver_Params_Data)");
class  WindowTreeClient_OnDragOver_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnDragOver_ResponseParams_Data));
      new (data()) WindowTreeClient_OnDragOver_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnDragOver_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnDragOver_ResponseParams_Data>(index_);
    }
    WindowTreeClient_OnDragOver_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t supported_op_bitmask;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnDragOver_ResponseParams_Data();
  ~WindowTreeClient_OnDragOver_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnDragOver_ResponseParams_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnDragOver_ResponseParams_Data)");
// The 1022159930 value is based on sha256(salt + "WindowTreeClient27").
constexpr uint32_t kWindowTreeClient_OnDragLeave_Name = 1022159930;
class  WindowTreeClient_OnDragLeave_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnDragLeave_Params_Data));
      new (data()) WindowTreeClient_OnDragLeave_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnDragLeave_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnDragLeave_Params_Data>(index_);
    }
    WindowTreeClient_OnDragLeave_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnDragLeave_Params_Data();
  ~WindowTreeClient_OnDragLeave_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnDragLeave_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnDragLeave_Params_Data)");
// The 1173986197 value is based on sha256(salt + "WindowTreeClient28").
constexpr uint32_t kWindowTreeClient_OnCompleteDrop_Name = 1173986197;
class  WindowTreeClient_OnCompleteDrop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnCompleteDrop_Params_Data));
      new (data()) WindowTreeClient_OnCompleteDrop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnCompleteDrop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnCompleteDrop_Params_Data>(index_);
    }
    WindowTreeClient_OnCompleteDrop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint32_t key_state;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> screen_position;
  uint32_t effect_bitmask;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnCompleteDrop_Params_Data();
  ~WindowTreeClient_OnCompleteDrop_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnCompleteDrop_Params_Data) == 32,
              "Bad sizeof(WindowTreeClient_OnCompleteDrop_Params_Data)");
class  WindowTreeClient_OnCompleteDrop_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnCompleteDrop_ResponseParams_Data));
      new (data()) WindowTreeClient_OnCompleteDrop_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnCompleteDrop_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnCompleteDrop_ResponseParams_Data>(index_);
    }
    WindowTreeClient_OnCompleteDrop_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t action_taken;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnCompleteDrop_ResponseParams_Data();
  ~WindowTreeClient_OnCompleteDrop_ResponseParams_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnCompleteDrop_ResponseParams_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnCompleteDrop_ResponseParams_Data)");
// The 1368051841 value is based on sha256(salt + "WindowTreeClient29").
constexpr uint32_t kWindowTreeClient_OnPerformDragDropCompleted_Name = 1368051841;
class  WindowTreeClient_OnPerformDragDropCompleted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnPerformDragDropCompleted_Params_Data));
      new (data()) WindowTreeClient_OnPerformDragDropCompleted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnPerformDragDropCompleted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnPerformDragDropCompleted_Params_Data>(index_);
    }
    WindowTreeClient_OnPerformDragDropCompleted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window;
  uint8_t success : 1;
  uint8_t pad1_[3];
  uint32_t action_taken;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_OnPerformDragDropCompleted_Params_Data();
  ~WindowTreeClient_OnPerformDragDropCompleted_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnPerformDragDropCompleted_Params_Data) == 24,
              "Bad sizeof(WindowTreeClient_OnPerformDragDropCompleted_Params_Data)");
// The 1336040959 value is based on sha256(salt + "WindowTreeClient30").
constexpr uint32_t kWindowTreeClient_OnDragDropDone_Name = 1336040959;
class  WindowTreeClient_OnDragDropDone_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnDragDropDone_Params_Data));
      new (data()) WindowTreeClient_OnDragDropDone_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnDragDropDone_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnDragDropDone_Params_Data>(index_);
    }
    WindowTreeClient_OnDragDropDone_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WindowTreeClient_OnDragDropDone_Params_Data();
  ~WindowTreeClient_OnDragDropDone_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnDragDropDone_Params_Data) == 8,
              "Bad sizeof(WindowTreeClient_OnDragDropDone_Params_Data)");
// The 888731328 value is based on sha256(salt + "WindowTreeClient31").
constexpr uint32_t kWindowTreeClient_OnChangeCompleted_Name = 888731328;
class  WindowTreeClient_OnChangeCompleted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_OnChangeCompleted_Params_Data));
      new (data()) WindowTreeClient_OnChangeCompleted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_OnChangeCompleted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_OnChangeCompleted_Params_Data>(index_);
    }
    WindowTreeClient_OnChangeCompleted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t change_id;
  uint8_t success : 1;
  uint8_t padfinal_[3];

 private:
  WindowTreeClient_OnChangeCompleted_Params_Data();
  ~WindowTreeClient_OnChangeCompleted_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_OnChangeCompleted_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_OnChangeCompleted_Params_Data)");
// The 1958549983 value is based on sha256(salt + "WindowTreeClient32").
constexpr uint32_t kWindowTreeClient_RequestClose_Name = 1958549983;
class  WindowTreeClient_RequestClose_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_RequestClose_Params_Data));
      new (data()) WindowTreeClient_RequestClose_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_RequestClose_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_RequestClose_Params_Data>(index_);
    }
    WindowTreeClient_RequestClose_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t window_id;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_RequestClose_Params_Data();
  ~WindowTreeClient_RequestClose_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_RequestClose_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_RequestClose_Params_Data)");
// The 1580930337 value is based on sha256(salt + "WindowTreeClient33").
constexpr uint32_t kWindowTreeClient_GetWindowManager_Name = 1580930337;
class  WindowTreeClient_GetWindowManager_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeClient_GetWindowManager_Params_Data));
      new (data()) WindowTreeClient_GetWindowManager_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeClient_GetWindowManager_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeClient_GetWindowManager_Params_Data>(index_);
    }
    WindowTreeClient_GetWindowManager_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedEndpointHandle_Data internal;
  uint8_t padfinal_[4];

 private:
  WindowTreeClient_GetWindowManager_Params_Data();
  ~WindowTreeClient_GetWindowManager_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeClient_GetWindowManager_Params_Data) == 16,
              "Bad sizeof(WindowTreeClient_GetWindowManager_Params_Data)");
// The 1707511575 value is based on sha256(salt + "WindowTreeFactory1").
constexpr uint32_t kWindowTreeFactory_CreateWindowTree_Name = 1707511575;
class  WindowTreeFactory_CreateWindowTree_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WindowTreeFactory_CreateWindowTree_Params_Data));
      new (data()) WindowTreeFactory_CreateWindowTree_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WindowTreeFactory_CreateWindowTree_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WindowTreeFactory_CreateWindowTree_Params_Data>(index_);
    }
    WindowTreeFactory_CreateWindowTree_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data tree_request;
  mojo::internal::Interface_Data client;
  uint8_t padfinal_[4];

 private:
  WindowTreeFactory_CreateWindowTree_Params_Data();
  ~WindowTreeFactory_CreateWindowTree_Params_Data() = delete;
};
static_assert(sizeof(WindowTreeFactory_CreateWindowTree_Params_Data) == 24,
              "Bad sizeof(WindowTreeFactory_CreateWindowTree_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ui

#endif  // SERVICES_UI_PUBLIC_INTERFACES_WINDOW_TREE_MOJOM_SHARED_INTERNAL_H_