// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_INTERFACES_DEVICE_FACTORY_PROVIDER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_INTERFACES_DEVICE_FACTORY_PROVIDER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/video_capture/public/interfaces/device_factory.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace video_capture {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1669325880 value is based on sha256(salt + "DeviceFactoryProvider1").
constexpr uint32_t kDeviceFactoryProvider_ConnectToDeviceFactory_Name = 1669325880;
class  DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data));
      new (data()) DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data>(index_);
    }
    DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data();
  ~DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data() = delete;
};
static_assert(sizeof(DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data) == 16,
              "Bad sizeof(DeviceFactoryProvider_ConnectToDeviceFactory_Params_Data)");
// The 896481218 value is based on sha256(salt + "DeviceFactoryProvider2").
constexpr uint32_t kDeviceFactoryProvider_SetShutdownDelayInSeconds_Name = 896481218;
class  DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data));
      new (data()) DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data>(index_);
    }
    DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  float seconds;
  uint8_t padfinal_[4];

 private:
  DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data();
  ~DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data() = delete;
};
static_assert(sizeof(DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data) == 16,
              "Bad sizeof(DeviceFactoryProvider_SetShutdownDelayInSeconds_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_INTERFACES_DEVICE_FACTORY_PROVIDER_MOJOM_SHARED_INTERNAL_H_