// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PRIVILEGED_INTERFACES_GL_GPU_HOST_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIZ_PRIVILEGED_INTERFACES_GL_GPU_HOST_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "gpu/ipc/common/gpu_feature_info.mojom-shared-internal.h"
#include "gpu/ipc/common/gpu_info.mojom-shared-internal.h"
#include "gpu/ipc/common/surface_handle.mojom-shared-internal.h"
#include "services/viz/privileged/interfaces/gl/context_lost_reason.mojom-shared-internal.h"
#include "url/mojo/url.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace viz {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1167760970 value is based on sha256(salt + "GpuHost1").
constexpr uint32_t kGpuHost_DidInitialize_Name = 1167760970;
class  GpuHost_DidInitialize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_DidInitialize_Params_Data));
      new (data()) GpuHost_DidInitialize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_DidInitialize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_DidInitialize_Params_Data>(index_);
    }
    GpuHost_DidInitialize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gpu::mojom::internal::GpuInfo_Data> gpu_info;
  mojo::internal::Pointer<::gpu::mojom::internal::GpuFeatureInfo_Data> gpu_feature_info;

 private:
  GpuHost_DidInitialize_Params_Data();
  ~GpuHost_DidInitialize_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_DidInitialize_Params_Data) == 24,
              "Bad sizeof(GpuHost_DidInitialize_Params_Data)");
// The 171921136 value is based on sha256(salt + "GpuHost2").
constexpr uint32_t kGpuHost_DidFailInitialize_Name = 171921136;
class  GpuHost_DidFailInitialize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_DidFailInitialize_Params_Data));
      new (data()) GpuHost_DidFailInitialize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_DidFailInitialize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_DidFailInitialize_Params_Data>(index_);
    }
    GpuHost_DidFailInitialize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuHost_DidFailInitialize_Params_Data();
  ~GpuHost_DidFailInitialize_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_DidFailInitialize_Params_Data) == 8,
              "Bad sizeof(GpuHost_DidFailInitialize_Params_Data)");
// The 144517509 value is based on sha256(salt + "GpuHost3").
constexpr uint32_t kGpuHost_DidCreateContextSuccessfully_Name = 144517509;
class  GpuHost_DidCreateContextSuccessfully_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_DidCreateContextSuccessfully_Params_Data));
      new (data()) GpuHost_DidCreateContextSuccessfully_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_DidCreateContextSuccessfully_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_DidCreateContextSuccessfully_Params_Data>(index_);
    }
    GpuHost_DidCreateContextSuccessfully_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  GpuHost_DidCreateContextSuccessfully_Params_Data();
  ~GpuHost_DidCreateContextSuccessfully_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_DidCreateContextSuccessfully_Params_Data) == 8,
              "Bad sizeof(GpuHost_DidCreateContextSuccessfully_Params_Data)");
// The 2006205803 value is based on sha256(salt + "GpuHost4").
constexpr uint32_t kGpuHost_DidCreateOffscreenContext_Name = 2006205803;
class  GpuHost_DidCreateOffscreenContext_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_DidCreateOffscreenContext_Params_Data));
      new (data()) GpuHost_DidCreateOffscreenContext_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_DidCreateOffscreenContext_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_DidCreateOffscreenContext_Params_Data>(index_);
    }
    GpuHost_DidCreateOffscreenContext_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  GpuHost_DidCreateOffscreenContext_Params_Data();
  ~GpuHost_DidCreateOffscreenContext_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_DidCreateOffscreenContext_Params_Data) == 16,
              "Bad sizeof(GpuHost_DidCreateOffscreenContext_Params_Data)");
// The 162815509 value is based on sha256(salt + "GpuHost5").
constexpr uint32_t kGpuHost_DidDestroyOffscreenContext_Name = 162815509;
class  GpuHost_DidDestroyOffscreenContext_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_DidDestroyOffscreenContext_Params_Data));
      new (data()) GpuHost_DidDestroyOffscreenContext_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_DidDestroyOffscreenContext_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_DidDestroyOffscreenContext_Params_Data>(index_);
    }
    GpuHost_DidDestroyOffscreenContext_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  GpuHost_DidDestroyOffscreenContext_Params_Data();
  ~GpuHost_DidDestroyOffscreenContext_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_DidDestroyOffscreenContext_Params_Data) == 16,
              "Bad sizeof(GpuHost_DidDestroyOffscreenContext_Params_Data)");
// The 1962606691 value is based on sha256(salt + "GpuHost6").
constexpr uint32_t kGpuHost_DidDestroyChannel_Name = 1962606691;
class  GpuHost_DidDestroyChannel_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_DidDestroyChannel_Params_Data));
      new (data()) GpuHost_DidDestroyChannel_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_DidDestroyChannel_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_DidDestroyChannel_Params_Data>(index_);
    }
    GpuHost_DidDestroyChannel_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t client_id;
  uint8_t padfinal_[4];

 private:
  GpuHost_DidDestroyChannel_Params_Data();
  ~GpuHost_DidDestroyChannel_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_DidDestroyChannel_Params_Data) == 16,
              "Bad sizeof(GpuHost_DidDestroyChannel_Params_Data)");
// The 1225595653 value is based on sha256(salt + "GpuHost7").
constexpr uint32_t kGpuHost_DidLoseContext_Name = 1225595653;
class  GpuHost_DidLoseContext_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_DidLoseContext_Params_Data));
      new (data()) GpuHost_DidLoseContext_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_DidLoseContext_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_DidLoseContext_Params_Data>(index_);
    }
    GpuHost_DidLoseContext_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t offscreen : 1;
  uint8_t pad0_[3];
  int32_t reason;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> active_url;

 private:
  GpuHost_DidLoseContext_Params_Data();
  ~GpuHost_DidLoseContext_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_DidLoseContext_Params_Data) == 24,
              "Bad sizeof(GpuHost_DidLoseContext_Params_Data)");
// The 1731435374 value is based on sha256(salt + "GpuHost8").
constexpr uint32_t kGpuHost_SetChildSurface_Name = 1731435374;
class  GpuHost_SetChildSurface_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_SetChildSurface_Params_Data));
      new (data()) GpuHost_SetChildSurface_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_SetChildSurface_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_SetChildSurface_Params_Data>(index_);
    }
    GpuHost_SetChildSurface_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gpu::mojom::internal::SurfaceHandle_Data> parent;
  mojo::internal::Pointer<::gpu::mojom::internal::SurfaceHandle_Data> child;

 private:
  GpuHost_SetChildSurface_Params_Data();
  ~GpuHost_SetChildSurface_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_SetChildSurface_Params_Data) == 24,
              "Bad sizeof(GpuHost_SetChildSurface_Params_Data)");
// The 1296965093 value is based on sha256(salt + "GpuHost9").
constexpr uint32_t kGpuHost_StoreShaderToDisk_Name = 1296965093;
class  GpuHost_StoreShaderToDisk_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_StoreShaderToDisk_Params_Data));
      new (data()) GpuHost_StoreShaderToDisk_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_StoreShaderToDisk_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_StoreShaderToDisk_Params_Data>(index_);
    }
    GpuHost_StoreShaderToDisk_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t client_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> key;
  mojo::internal::Pointer<mojo::internal::String_Data> shader;

 private:
  GpuHost_StoreShaderToDisk_Params_Data();
  ~GpuHost_StoreShaderToDisk_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_StoreShaderToDisk_Params_Data) == 32,
              "Bad sizeof(GpuHost_StoreShaderToDisk_Params_Data)");
// The 393088679 value is based on sha256(salt + "GpuHost10").
constexpr uint32_t kGpuHost_RecordLogMessage_Name = 393088679;
class  GpuHost_RecordLogMessage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(GpuHost_RecordLogMessage_Params_Data));
      new (data()) GpuHost_RecordLogMessage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    GpuHost_RecordLogMessage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<GpuHost_RecordLogMessage_Params_Data>(index_);
    }
    GpuHost_RecordLogMessage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t severity;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> header;
  mojo::internal::Pointer<mojo::internal::String_Data> message;

 private:
  GpuHost_RecordLogMessage_Params_Data();
  ~GpuHost_RecordLogMessage_Params_Data() = delete;
};
static_assert(sizeof(GpuHost_RecordLogMessage_Params_Data) == 32,
              "Bad sizeof(GpuHost_RecordLogMessage_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PRIVILEGED_INTERFACES_GL_GPU_HOST_MOJOM_SHARED_INTERNAL_H_