// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_COMPOSITOR_FRAME_SINK_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_COMPOSITOR_FRAME_SINK_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/time.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/begin_frame_args.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/compositor_frame.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/local_surface_id.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/returned_resource.mojom-shared-internal.h"
#include "services/viz/public/interfaces/hit_test/hit_test_region_list.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace viz {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1017742228 value is based on sha256(salt + "CompositorFrameSink1").
constexpr uint32_t kCompositorFrameSink_SetNeedsBeginFrame_Name = 1017742228;
class  CompositorFrameSink_SetNeedsBeginFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSink_SetNeedsBeginFrame_Params_Data));
      new (data()) CompositorFrameSink_SetNeedsBeginFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSink_SetNeedsBeginFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSink_SetNeedsBeginFrame_Params_Data>(index_);
    }
    CompositorFrameSink_SetNeedsBeginFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t needs_begin_frame : 1;
  uint8_t padfinal_[7];

 private:
  CompositorFrameSink_SetNeedsBeginFrame_Params_Data();
  ~CompositorFrameSink_SetNeedsBeginFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSink_SetNeedsBeginFrame_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSink_SetNeedsBeginFrame_Params_Data)");
// The 1233996261 value is based on sha256(salt + "CompositorFrameSink2").
constexpr uint32_t kCompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Name = 1233996261;
class  CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data));
      new (data()) CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data>(index_);
    }
    CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data();
  ~CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data) == 8,
              "Bad sizeof(CompositorFrameSink_SetWantsAnimateOnlyBeginFrames_Params_Data)");
// The 441678040 value is based on sha256(salt + "CompositorFrameSink3").
constexpr uint32_t kCompositorFrameSink_SubmitCompositorFrame_Name = 441678040;
class  CompositorFrameSink_SubmitCompositorFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSink_SubmitCompositorFrame_Params_Data));
      new (data()) CompositorFrameSink_SubmitCompositorFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSink_SubmitCompositorFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSink_SubmitCompositorFrame_Params_Data>(index_);
    }
    CompositorFrameSink_SubmitCompositorFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::LocalSurfaceId_Data> local_surface_id;
  mojo::internal::Pointer<::viz::mojom::internal::CompositorFrame_Data> frame;
  mojo::internal::Pointer<::viz::mojom::internal::HitTestRegionList_Data> hit_test_region_list;
  uint64_t submit_time;

 private:
  CompositorFrameSink_SubmitCompositorFrame_Params_Data();
  ~CompositorFrameSink_SubmitCompositorFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSink_SubmitCompositorFrame_Params_Data) == 40,
              "Bad sizeof(CompositorFrameSink_SubmitCompositorFrame_Params_Data)");
// The 329618962 value is based on sha256(salt + "CompositorFrameSink4").
constexpr uint32_t kCompositorFrameSink_DidNotProduceFrame_Name = 329618962;
class  CompositorFrameSink_DidNotProduceFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSink_DidNotProduceFrame_Params_Data));
      new (data()) CompositorFrameSink_DidNotProduceFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSink_DidNotProduceFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSink_DidNotProduceFrame_Params_Data>(index_);
    }
    CompositorFrameSink_DidNotProduceFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::BeginFrameAck_Data> ack;

 private:
  CompositorFrameSink_DidNotProduceFrame_Params_Data();
  ~CompositorFrameSink_DidNotProduceFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSink_DidNotProduceFrame_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSink_DidNotProduceFrame_Params_Data)");
// The 1404581249 value is based on sha256(salt + "CompositorFrameSinkClient1").
constexpr uint32_t kCompositorFrameSinkClient_DidReceiveCompositorFrameAck_Name = 1404581249;
class  CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data));
      new (data()) CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data>(index_);
    }
    CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::viz::mojom::internal::ReturnedResource_Data>>> resources;

 private:
  CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data();
  ~CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkClient_DidReceiveCompositorFrameAck_Params_Data)");
// The 842172489 value is based on sha256(salt + "CompositorFrameSinkClient2").
constexpr uint32_t kCompositorFrameSinkClient_DidPresentCompositorFrame_Name = 842172489;
class  CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data));
      new (data()) CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data>(index_);
    }
    CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t presentation_token;
  uint32_t flags;
  mojo::internal::Pointer<::mojo::common::mojom::internal::TimeTicks_Data> time;
  mojo::internal::Pointer<::mojo::common::mojom::internal::TimeDelta_Data> refresh;

 private:
  CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data();
  ~CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data) == 32,
              "Bad sizeof(CompositorFrameSinkClient_DidPresentCompositorFrame_Params_Data)");
// The 1713183645 value is based on sha256(salt + "CompositorFrameSinkClient3").
constexpr uint32_t kCompositorFrameSinkClient_DidDiscardCompositorFrame_Name = 1713183645;
class  CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data));
      new (data()) CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data>(index_);
    }
    CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t presentation_token;
  uint8_t padfinal_[4];

 private:
  CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data();
  ~CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkClient_DidDiscardCompositorFrame_Params_Data)");
// The 21844706 value is based on sha256(salt + "CompositorFrameSinkClient4").
constexpr uint32_t kCompositorFrameSinkClient_OnBeginFrame_Name = 21844706;
class  CompositorFrameSinkClient_OnBeginFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSinkClient_OnBeginFrame_Params_Data));
      new (data()) CompositorFrameSinkClient_OnBeginFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSinkClient_OnBeginFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSinkClient_OnBeginFrame_Params_Data>(index_);
    }
    CompositorFrameSinkClient_OnBeginFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::BeginFrameArgs_Data> args;

 private:
  CompositorFrameSinkClient_OnBeginFrame_Params_Data();
  ~CompositorFrameSinkClient_OnBeginFrame_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_OnBeginFrame_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkClient_OnBeginFrame_Params_Data)");
// The 2089347345 value is based on sha256(salt + "CompositorFrameSinkClient5").
constexpr uint32_t kCompositorFrameSinkClient_OnBeginFramePausedChanged_Name = 2089347345;
class  CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data));
      new (data()) CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data>(index_);
    }
    CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t paused : 1;
  uint8_t padfinal_[7];

 private:
  CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data();
  ~CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkClient_OnBeginFramePausedChanged_Params_Data)");
// The 1440793264 value is based on sha256(salt + "CompositorFrameSinkClient6").
constexpr uint32_t kCompositorFrameSinkClient_ReclaimResources_Name = 1440793264;
class  CompositorFrameSinkClient_ReclaimResources_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(CompositorFrameSinkClient_ReclaimResources_Params_Data));
      new (data()) CompositorFrameSinkClient_ReclaimResources_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    CompositorFrameSinkClient_ReclaimResources_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<CompositorFrameSinkClient_ReclaimResources_Params_Data>(index_);
    }
    CompositorFrameSinkClient_ReclaimResources_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::viz::mojom::internal::ReturnedResource_Data>>> resources;

 private:
  CompositorFrameSinkClient_ReclaimResources_Params_Data();
  ~CompositorFrameSinkClient_ReclaimResources_Params_Data() = delete;
};
static_assert(sizeof(CompositorFrameSinkClient_ReclaimResources_Params_Data) == 16,
              "Bad sizeof(CompositorFrameSinkClient_ReclaimResources_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_COMPOSITOR_FRAME_SINK_MOJOM_SHARED_INTERNAL_H_