// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_RENDER_PASS_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_RENDER_PASS_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/viz/public/interfaces/compositing/filter_operations.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/quads.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/gfx/mojo/color_space.mojom-shared-internal.h"
#include "ui/gfx/mojo/transform.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace viz {
namespace mojom {
namespace internal {
class RenderPass_Data;

#pragma pack(push, 1)
class  RenderPass_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RenderPass_Data));
      new (data()) RenderPass_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RenderPass_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RenderPass_Data>(index_);
    }
    RenderPass_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t id;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> output_rect;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> damage_rect;
  mojo::internal::Pointer<::gfx::mojom::internal::Transform_Data> transform_to_root_target;
  mojo::internal::Pointer<::viz::mojom::internal::FilterOperations_Data> filters;
  mojo::internal::Pointer<::viz::mojom::internal::FilterOperations_Data> background_filters;
  mojo::internal::Pointer<::gfx::mojom::internal::ColorSpace_Data> color_space;
  uint8_t has_transparent_background : 1;
  uint8_t cache_render_pass : 1;
  uint8_t has_damage_from_contributing_content : 1;
  uint8_t generate_mipmap : 1;
  uint8_t pad10_[7];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::viz::mojom::internal::DrawQuad_Data>>> quad_list;

 private:
  RenderPass_Data();
  ~RenderPass_Data() = delete;
};
static_assert(sizeof(RenderPass_Data) == 80,
              "Bad sizeof(RenderPass_Data)");
// Used by RenderPass::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct RenderPass_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  RenderPass_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~RenderPass_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    RenderPass_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    RenderPass_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_RENDER_PASS_MOJOM_SHARED_INTERNAL_H_