// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/viz/public/interfaces/compositing/shared_bitmap_allocation_notifier.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
namespace viz {
namespace mojom {
namespace blink {
const char SharedBitmapAllocationNotifier::Name_[] = "viz::mojom::SharedBitmapAllocationNotifier";

SharedBitmapAllocationNotifierProxy::SharedBitmapAllocationNotifierProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void SharedBitmapAllocationNotifierProxy::DidAllocateSharedBitmap(
    mojo::ScopedSharedBufferHandle in_buffer, ::gpu::mojom::blink::MailboxPtr in_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "viz::mojom::SharedBitmapAllocationNotifier::DidAllocateSharedBitmap");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::viz::mojom::internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<mojo::ScopedSharedBufferHandle>(
      in_buffer, &params->buffer, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->buffer),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid buffer in SharedBitmapAllocationNotifier.DidAllocateSharedBitmap request");
  typename decltype(params->id)::BaseType::BufferWriter
      id_writer;
  mojo::internal::Serialize<::gpu::mojom::MailboxDataView>(
      in_id, buffer, &id_writer, &serialization_context);
  params->id.Set(
      id_writer.is_null() ? nullptr : id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null id in SharedBitmapAllocationNotifier.DidAllocateSharedBitmap request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void SharedBitmapAllocationNotifierProxy::DidDeleteSharedBitmap(
    ::gpu::mojom::blink::MailboxPtr in_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "viz::mojom::SharedBitmapAllocationNotifier::DidDeleteSharedBitmap");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::viz::mojom::internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->id)::BaseType::BufferWriter
      id_writer;
  mojo::internal::Serialize<::gpu::mojom::MailboxDataView>(
      in_id, buffer, &id_writer, &serialization_context);
  params->id.Set(
      id_writer.is_null() ? nullptr : id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null id in SharedBitmapAllocationNotifier.DidDeleteSharedBitmap request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool SharedBitmapAllocationNotifierStubDispatch::Accept(
    SharedBitmapAllocationNotifier* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)viz::mojom::SharedBitmapAllocationNotifier::DidAllocateSharedBitmap",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data* params =
          reinterpret_cast<internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      mojo::ScopedSharedBufferHandle p_buffer{};
      ::gpu::mojom::blink::MailboxPtr p_id{};
      SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_ParamsDataView input_data_view(params, &serialization_context);
      
      p_buffer = input_data_view.TakeBuffer();
      if (!input_data_view.ReadId(&p_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "SharedBitmapAllocationNotifier::DidAllocateSharedBitmap deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DidAllocateSharedBitmap(
std::move(p_buffer), 
std::move(p_id));
      return true;
    }
    case internal::kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)viz::mojom::SharedBitmapAllocationNotifier::DidDeleteSharedBitmap",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data* params =
          reinterpret_cast<internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::gpu::mojom::blink::MailboxPtr p_id{};
      SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadId(&p_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "SharedBitmapAllocationNotifier::DidDeleteSharedBitmap deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DidDeleteSharedBitmap(
std::move(p_id));
      return true;
    }
  }
  return false;
}

// static
bool SharedBitmapAllocationNotifierStubDispatch::AcceptWithResponder(
    SharedBitmapAllocationNotifier* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)viz::mojom::SharedBitmapAllocationNotifier::DidAllocateSharedBitmap",
               "message", message->name());
#endif
      break;
    }
    case internal::kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)viz::mojom::SharedBitmapAllocationNotifier::DidDeleteSharedBitmap",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool SharedBitmapAllocationNotifierRequestValidator::Accept(mojo::Message* message) {
  if (mojo::internal::IsUnserializedOrControlMessage(message))
    return true;

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "SharedBitmapAllocationNotifier RequestValidator");

  switch (message->header()->name) {
    case internal::kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void SharedBitmapAllocationNotifierInterceptorForTesting::DidAllocateSharedBitmap(mojo::ScopedSharedBufferHandle buffer, ::gpu::mojom::blink::MailboxPtr id) {
  GetForwardingInterface()->DidAllocateSharedBitmap(std::move(buffer), std::move(id));
}
void SharedBitmapAllocationNotifierInterceptorForTesting::DidDeleteSharedBitmap(::gpu::mojom::blink::MailboxPtr id) {
  GetForwardingInterface()->DidDeleteSharedBitmap(std::move(id));
}
SharedBitmapAllocationNotifierAsyncWaiter::SharedBitmapAllocationNotifierAsyncWaiter(
    SharedBitmapAllocationNotifier* proxy) : proxy_(proxy) {}

SharedBitmapAllocationNotifierAsyncWaiter::~SharedBitmapAllocationNotifierAsyncWaiter() = default;


}  // namespace blink
}  // namespace mojom
}  // namespace viz

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif