// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_SHARED_BITMAP_ALLOCATION_NOTIFIER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_SHARED_BITMAP_ALLOCATION_NOTIFIER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "gpu/ipc/common/mailbox.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace viz {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 103519943 value is based on sha256(salt + "SharedBitmapAllocationNotifier1").
constexpr uint32_t kSharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Name = 103519943;
class  SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data));
      new (data()) SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data>(index_);
    }
    SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data buffer;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::gpu::mojom::internal::Mailbox_Data> id;

 private:
  SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data();
  ~SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data() = delete;
};
static_assert(sizeof(SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data) == 24,
              "Bad sizeof(SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data)");
// The 1174014589 value is based on sha256(salt + "SharedBitmapAllocationNotifier2").
constexpr uint32_t kSharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Name = 1174014589;
class  SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data));
      new (data()) SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data>(index_);
    }
    SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gpu::mojom::internal::Mailbox_Data> id;

 private:
  SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data();
  ~SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data() = delete;
};
static_assert(sizeof(SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data) == 16,
              "Bad sizeof(SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_SHARED_BITMAP_ALLOCATION_NOTIFIER_MOJOM_SHARED_INTERNAL_H_