// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_SHARED_BITMAP_ALLOCATION_NOTIFIER_MOJOM_SHARED_H_
#define SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_SHARED_BITMAP_ALLOCATION_NOTIFIER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/viz/public/interfaces/compositing/shared_bitmap_allocation_notifier.mojom-shared-internal.h"
#include "gpu/ipc/common/mailbox.mojom-shared.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace viz {
namespace mojom {


}  // namespace mojom
}  // namespace viz

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace viz {
namespace mojom {
// Interface base classes. They are used for type safety check.
class SharedBitmapAllocationNotifierInterfaceBase {};

using SharedBitmapAllocationNotifierPtrDataView =
    mojo::InterfacePtrDataView<SharedBitmapAllocationNotifierInterfaceBase>;
using SharedBitmapAllocationNotifierRequestDataView =
    mojo::InterfaceRequestDataView<SharedBitmapAllocationNotifierInterfaceBase>;
using SharedBitmapAllocationNotifierAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<SharedBitmapAllocationNotifierInterfaceBase>;
using SharedBitmapAllocationNotifierAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<SharedBitmapAllocationNotifierInterfaceBase>;
class SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_ParamsDataView {
 public:
  SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_ParamsDataView() {}

  SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_ParamsDataView(
      internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  mojo::ScopedSharedBufferHandle TakeBuffer() {
    mojo::ScopedSharedBufferHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedSharedBufferHandle>(
            &data_->buffer, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetIdDataView(
      ::gpu::mojom::MailboxDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::gpu::mojom::MailboxDataView>(
        pointer, output, context_);
  }
 private:
  internal::SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_ParamsDataView {
 public:
  SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_ParamsDataView() {}

  SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_ParamsDataView(
      internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      ::gpu::mojom::MailboxDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadId(UserType* output) {
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<::gpu::mojom::MailboxDataView>(
        pointer, output, context_);
  }
 private:
  internal::SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace viz

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace viz {
namespace mojom {

inline void SharedBitmapAllocationNotifier_DidAllocateSharedBitmap_ParamsDataView::GetIdDataView(
    ::gpu::mojom::MailboxDataView* output) {
  auto pointer = data_->id.Get();
  *output = ::gpu::mojom::MailboxDataView(pointer, context_);
}


inline void SharedBitmapAllocationNotifier_DidDeleteSharedBitmap_ParamsDataView::GetIdDataView(
    ::gpu::mojom::MailboxDataView* output) {
  auto pointer = data_->id.Get();
  *output = ::gpu::mojom::MailboxDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_SHARED_BITMAP_ALLOCATION_NOTIFIER_MOJOM_SHARED_H_
