// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/viz/public/interfaces/compositing/surface_sequence.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "services/viz/public/cpp/compositing/frame_sink_id_struct_traits.h"
namespace viz {
namespace mojom {
namespace blink {
SurfaceSequence::SurfaceSequence()
    : frame_sink_id(),
      sequence() {}

SurfaceSequence::SurfaceSequence(
    const viz::FrameSinkId& frame_sink_id_in,
    uint32_t sequence_in)
    : frame_sink_id(std::move(frame_sink_id_in)),
      sequence(std::move(sequence_in)) {}

SurfaceSequence::~SurfaceSequence() = default;

bool SurfaceSequence::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace viz

namespace mojo {


// static
bool StructTraits<::viz::mojom::blink::SurfaceSequence::DataView, ::viz::mojom::blink::SurfaceSequencePtr>::Read(
    ::viz::mojom::blink::SurfaceSequence::DataView input,
    ::viz::mojom::blink::SurfaceSequencePtr* output) {
  bool success = true;
  ::viz::mojom::blink::SurfaceSequencePtr result(::viz::mojom::blink::SurfaceSequence::New());
  
      if (!input.ReadFrameSinkId(&result->frame_sink_id))
        success = false;
      result->sequence = input.sequence();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif