// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_VIDEO_DETECTOR_OBSERVER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_VIDEO_DETECTOR_OBSERVER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace viz {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 658530869 value is based on sha256(salt + "VideoDetectorObserver1").
constexpr uint32_t kVideoDetectorObserver_OnVideoActivityStarted_Name = 658530869;
class  VideoDetectorObserver_OnVideoActivityStarted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(VideoDetectorObserver_OnVideoActivityStarted_Params_Data));
      new (data()) VideoDetectorObserver_OnVideoActivityStarted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    VideoDetectorObserver_OnVideoActivityStarted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<VideoDetectorObserver_OnVideoActivityStarted_Params_Data>(index_);
    }
    VideoDetectorObserver_OnVideoActivityStarted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  VideoDetectorObserver_OnVideoActivityStarted_Params_Data();
  ~VideoDetectorObserver_OnVideoActivityStarted_Params_Data() = delete;
};
static_assert(sizeof(VideoDetectorObserver_OnVideoActivityStarted_Params_Data) == 8,
              "Bad sizeof(VideoDetectorObserver_OnVideoActivityStarted_Params_Data)");
// The 1544008542 value is based on sha256(salt + "VideoDetectorObserver2").
constexpr uint32_t kVideoDetectorObserver_OnVideoActivityEnded_Name = 1544008542;
class  VideoDetectorObserver_OnVideoActivityEnded_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(VideoDetectorObserver_OnVideoActivityEnded_Params_Data));
      new (data()) VideoDetectorObserver_OnVideoActivityEnded_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    VideoDetectorObserver_OnVideoActivityEnded_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<VideoDetectorObserver_OnVideoActivityEnded_Params_Data>(index_);
    }
    VideoDetectorObserver_OnVideoActivityEnded_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  VideoDetectorObserver_OnVideoActivityEnded_Params_Data();
  ~VideoDetectorObserver_OnVideoActivityEnded_Params_Data() = delete;
};
static_assert(sizeof(VideoDetectorObserver_OnVideoActivityEnded_Params_Data) == 8,
              "Bad sizeof(VideoDetectorObserver_OnVideoActivityEnded_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PUBLIC_INTERFACES_COMPOSITING_VIDEO_DETECTOR_OBSERVER_MOJOM_SHARED_INTERNAL_H_