// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_COMMON_BLOB_BLOB_URL_STORE_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_COMMON_BLOB_BLOB_URL_STORE_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "third_party/WebKit/common/blob/blob.mojom-shared-internal.h"
#include "url/mojo/url.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "third_party/WebKit/common/mojo_platform_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1555172068 value is based on sha256(salt + "BlobURLStore1").
constexpr uint32_t kBlobURLStore_Register_Name = 1555172068;
class MOJOM_SHARED_BLINK_COMMON_EXPORT BlobURLStore_Register_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BlobURLStore_Register_Params_Data));
      new (data()) BlobURLStore_Register_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BlobURLStore_Register_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BlobURLStore_Register_Params_Data>(index_);
    }
    BlobURLStore_Register_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data blob;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  BlobURLStore_Register_Params_Data();
  ~BlobURLStore_Register_Params_Data() = delete;
};
static_assert(sizeof(BlobURLStore_Register_Params_Data) == 24,
              "Bad sizeof(BlobURLStore_Register_Params_Data)");
class MOJOM_SHARED_BLINK_COMMON_EXPORT BlobURLStore_Register_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BlobURLStore_Register_ResponseParams_Data));
      new (data()) BlobURLStore_Register_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BlobURLStore_Register_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BlobURLStore_Register_ResponseParams_Data>(index_);
    }
    BlobURLStore_Register_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BlobURLStore_Register_ResponseParams_Data();
  ~BlobURLStore_Register_ResponseParams_Data() = delete;
};
static_assert(sizeof(BlobURLStore_Register_ResponseParams_Data) == 8,
              "Bad sizeof(BlobURLStore_Register_ResponseParams_Data)");
// The 1766988851 value is based on sha256(salt + "BlobURLStore2").
constexpr uint32_t kBlobURLStore_Revoke_Name = 1766988851;
class MOJOM_SHARED_BLINK_COMMON_EXPORT BlobURLStore_Revoke_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BlobURLStore_Revoke_Params_Data));
      new (data()) BlobURLStore_Revoke_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BlobURLStore_Revoke_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BlobURLStore_Revoke_Params_Data>(index_);
    }
    BlobURLStore_Revoke_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  BlobURLStore_Revoke_Params_Data();
  ~BlobURLStore_Revoke_Params_Data() = delete;
};
static_assert(sizeof(BlobURLStore_Revoke_Params_Data) == 16,
              "Bad sizeof(BlobURLStore_Revoke_Params_Data)");
// The 96220020 value is based on sha256(salt + "BlobURLStore3").
constexpr uint32_t kBlobURLStore_Resolve_Name = 96220020;
class MOJOM_SHARED_BLINK_COMMON_EXPORT BlobURLStore_Resolve_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BlobURLStore_Resolve_Params_Data));
      new (data()) BlobURLStore_Resolve_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BlobURLStore_Resolve_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BlobURLStore_Resolve_Params_Data>(index_);
    }
    BlobURLStore_Resolve_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  BlobURLStore_Resolve_Params_Data();
  ~BlobURLStore_Resolve_Params_Data() = delete;
};
static_assert(sizeof(BlobURLStore_Resolve_Params_Data) == 16,
              "Bad sizeof(BlobURLStore_Resolve_Params_Data)");
class MOJOM_SHARED_BLINK_COMMON_EXPORT BlobURLStore_Resolve_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BlobURLStore_Resolve_ResponseParams_Data));
      new (data()) BlobURLStore_Resolve_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BlobURLStore_Resolve_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BlobURLStore_Resolve_ResponseParams_Data>(index_);
    }
    BlobURLStore_Resolve_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data blob;

 private:
  BlobURLStore_Resolve_ResponseParams_Data();
  ~BlobURLStore_Resolve_ResponseParams_Data() = delete;
};
static_assert(sizeof(BlobURLStore_Resolve_ResponseParams_Data) == 16,
              "Bad sizeof(BlobURLStore_Resolve_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_COMMON_BLOB_BLOB_URL_STORE_MOJOM_SHARED_INTERNAL_H_