// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_COMMON_BLOB_BLOB_URL_STORE_MOJOM_SHARED_H_
#define THIRD_PARTY_WEBKIT_COMMON_BLOB_BLOB_URL_STORE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/WebKit/common/blob/blob_url_store.mojom-shared-internal.h"
#include "third_party/WebKit/common/blob/blob.mojom-shared.h"
#include "url/mojo/url.mojom-shared.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/WebKit/common/mojo_platform_bindings_shared_export.h"


namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class BlobURLStoreInterfaceBase {};

using BlobURLStorePtrDataView =
    mojo::InterfacePtrDataView<BlobURLStoreInterfaceBase>;
using BlobURLStoreRequestDataView =
    mojo::InterfaceRequestDataView<BlobURLStoreInterfaceBase>;
using BlobURLStoreAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<BlobURLStoreInterfaceBase>;
using BlobURLStoreAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<BlobURLStoreInterfaceBase>;
class BlobURLStore_Register_ParamsDataView {
 public:
  BlobURLStore_Register_ParamsDataView() {}

  BlobURLStore_Register_ParamsDataView(
      internal::BlobURLStore_Register_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeBlob() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::BlobPtrDataView>(
            &data_->blob, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::BlobURLStore_Register_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class BlobURLStore_Register_ResponseParamsDataView {
 public:
  BlobURLStore_Register_ResponseParamsDataView() {}

  BlobURLStore_Register_ResponseParamsDataView(
      internal::BlobURLStore_Register_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::BlobURLStore_Register_ResponseParams_Data* data_ = nullptr;
};

class BlobURLStore_Revoke_ParamsDataView {
 public:
  BlobURLStore_Revoke_ParamsDataView() {}

  BlobURLStore_Revoke_ParamsDataView(
      internal::BlobURLStore_Revoke_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::BlobURLStore_Revoke_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class BlobURLStore_Resolve_ParamsDataView {
 public:
  BlobURLStore_Resolve_ParamsDataView() {}

  BlobURLStore_Resolve_ParamsDataView(
      internal::BlobURLStore_Resolve_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::BlobURLStore_Resolve_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class BlobURLStore_Resolve_ResponseParamsDataView {
 public:
  BlobURLStore_Resolve_ResponseParamsDataView() {}

  BlobURLStore_Resolve_ResponseParamsDataView(
      internal::BlobURLStore_Resolve_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeBlob() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::BlobPtrDataView>(
            &data_->blob, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::BlobURLStore_Resolve_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace blink {
namespace mojom {

inline void BlobURLStore_Register_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}




inline void BlobURLStore_Revoke_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void BlobURLStore_Resolve_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_COMMON_BLOB_BLOB_URL_STORE_MOJOM_SHARED_H_
