// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_COMMON_SERVICE_WORKER_SERVICE_WORKER_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_COMMON_SERVICE_WORKER_SERVICE_WORKER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "third_party/WebKit/common/service_worker/service_worker_error_type.mojom-shared-internal.h"
#include "third_party/WebKit/common/service_worker/service_worker_client.mojom-shared-internal.h"
#include "url/mojo/url.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "third_party/WebKit/common/mojo_platform_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1053419763 value is based on sha256(salt + "ServiceWorkerHost1").
constexpr uint32_t kServiceWorkerHost_SetCachedMetadata_Name = 1053419763;
class MOJOM_SHARED_BLINK_COMMON_EXPORT ServiceWorkerHost_SetCachedMetadata_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_SetCachedMetadata_Params_Data));
      new (data()) ServiceWorkerHost_SetCachedMetadata_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_SetCachedMetadata_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_SetCachedMetadata_Params_Data>(index_);
    }
    ServiceWorkerHost_SetCachedMetadata_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> data;

 private:
  ServiceWorkerHost_SetCachedMetadata_Params_Data();
  ~ServiceWorkerHost_SetCachedMetadata_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_SetCachedMetadata_Params_Data) == 24,
              "Bad sizeof(ServiceWorkerHost_SetCachedMetadata_Params_Data)");
// The 315906415 value is based on sha256(salt + "ServiceWorkerHost2").
constexpr uint32_t kServiceWorkerHost_ClearCachedMetadata_Name = 315906415;
class MOJOM_SHARED_BLINK_COMMON_EXPORT ServiceWorkerHost_ClearCachedMetadata_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_ClearCachedMetadata_Params_Data));
      new (data()) ServiceWorkerHost_ClearCachedMetadata_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_ClearCachedMetadata_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_ClearCachedMetadata_Params_Data>(index_);
    }
    ServiceWorkerHost_ClearCachedMetadata_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  ServiceWorkerHost_ClearCachedMetadata_Params_Data();
  ~ServiceWorkerHost_ClearCachedMetadata_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_ClearCachedMetadata_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_ClearCachedMetadata_Params_Data)");
// The 592321884 value is based on sha256(salt + "ServiceWorkerHost3").
constexpr uint32_t kServiceWorkerHost_GetClients_Name = 592321884;
class MOJOM_SHARED_BLINK_COMMON_EXPORT ServiceWorkerHost_GetClients_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_GetClients_Params_Data));
      new (data()) ServiceWorkerHost_GetClients_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_GetClients_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_GetClients_Params_Data>(index_);
    }
    ServiceWorkerHost_GetClients_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientQueryOptions_Data> options;

 private:
  ServiceWorkerHost_GetClients_Params_Data();
  ~ServiceWorkerHost_GetClients_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_GetClients_Params_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_GetClients_Params_Data)");
class MOJOM_SHARED_BLINK_COMMON_EXPORT ServiceWorkerHost_GetClients_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_GetClients_ResponseParams_Data));
      new (data()) ServiceWorkerHost_GetClients_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_GetClients_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_GetClients_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_GetClients_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::blink::mojom::internal::ServiceWorkerClientInfo_Data>>> clients;

 private:
  ServiceWorkerHost_GetClients_ResponseParams_Data();
  ~ServiceWorkerHost_GetClients_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_GetClients_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceWorkerHost_GetClients_ResponseParams_Data)");
// The 881554474 value is based on sha256(salt + "ServiceWorkerHost4").
constexpr uint32_t kServiceWorkerHost_ClaimClients_Name = 881554474;
class MOJOM_SHARED_BLINK_COMMON_EXPORT ServiceWorkerHost_ClaimClients_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_ClaimClients_Params_Data));
      new (data()) ServiceWorkerHost_ClaimClients_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_ClaimClients_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_ClaimClients_Params_Data>(index_);
    }
    ServiceWorkerHost_ClaimClients_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceWorkerHost_ClaimClients_Params_Data();
  ~ServiceWorkerHost_ClaimClients_Params_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_ClaimClients_Params_Data) == 8,
              "Bad sizeof(ServiceWorkerHost_ClaimClients_Params_Data)");
class MOJOM_SHARED_BLINK_COMMON_EXPORT ServiceWorkerHost_ClaimClients_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceWorkerHost_ClaimClients_ResponseParams_Data));
      new (data()) ServiceWorkerHost_ClaimClients_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceWorkerHost_ClaimClients_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceWorkerHost_ClaimClients_ResponseParams_Data>(index_);
    }
    ServiceWorkerHost_ClaimClients_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> error_msg;

 private:
  ServiceWorkerHost_ClaimClients_ResponseParams_Data();
  ~ServiceWorkerHost_ClaimClients_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceWorkerHost_ClaimClients_ResponseParams_Data) == 24,
              "Bad sizeof(ServiceWorkerHost_ClaimClients_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_COMMON_SERVICE_WORKER_SERVICE_WORKER_MOJOM_SHARED_INTERNAL_H_