// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_INPUT_HOST_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_INPUT_HOST_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "third_party/WebKit/public/android_mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class SpellCheckSuggestion_Data;
class TextSuggestion_Data;

#pragma pack(push, 1)
class MOJOM_SHARED_CONTENT_EXPORT SpellCheckSuggestion_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SpellCheckSuggestion_Data));
      new (data()) SpellCheckSuggestion_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SpellCheckSuggestion_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SpellCheckSuggestion_Data>(index_);
    }
    SpellCheckSuggestion_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> suggestion;

 private:
  SpellCheckSuggestion_Data();
  ~SpellCheckSuggestion_Data() = delete;
};
static_assert(sizeof(SpellCheckSuggestion_Data) == 16,
              "Bad sizeof(SpellCheckSuggestion_Data)");
// Used by SpellCheckSuggestion::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct SpellCheckSuggestion_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  SpellCheckSuggestion_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~SpellCheckSuggestion_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    SpellCheckSuggestion_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    SpellCheckSuggestion_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class MOJOM_SHARED_CONTENT_EXPORT TextSuggestion_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TextSuggestion_Data));
      new (data()) TextSuggestion_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TextSuggestion_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TextSuggestion_Data>(index_);
    }
    TextSuggestion_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t marker_tag;
  int32_t suggestion_index;
  mojo::internal::Pointer<mojo::internal::String_Data> prefix;
  mojo::internal::Pointer<mojo::internal::String_Data> suggestion;
  mojo::internal::Pointer<mojo::internal::String_Data> suffix;

 private:
  TextSuggestion_Data();
  ~TextSuggestion_Data() = delete;
};
static_assert(sizeof(TextSuggestion_Data) == 40,
              "Bad sizeof(TextSuggestion_Data)");
// Used by TextSuggestion::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct TextSuggestion_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  TextSuggestion_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~TextSuggestion_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    TextSuggestion_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    TextSuggestion_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
// The 858184809 value is based on sha256(salt + "TextSuggestionHost1").
constexpr uint32_t kTextSuggestionHost_StartSuggestionMenuTimer_Name = 858184809;
class MOJOM_SHARED_CONTENT_EXPORT TextSuggestionHost_StartSuggestionMenuTimer_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TextSuggestionHost_StartSuggestionMenuTimer_Params_Data));
      new (data()) TextSuggestionHost_StartSuggestionMenuTimer_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TextSuggestionHost_StartSuggestionMenuTimer_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TextSuggestionHost_StartSuggestionMenuTimer_Params_Data>(index_);
    }
    TextSuggestionHost_StartSuggestionMenuTimer_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  TextSuggestionHost_StartSuggestionMenuTimer_Params_Data();
  ~TextSuggestionHost_StartSuggestionMenuTimer_Params_Data() = delete;
};
static_assert(sizeof(TextSuggestionHost_StartSuggestionMenuTimer_Params_Data) == 8,
              "Bad sizeof(TextSuggestionHost_StartSuggestionMenuTimer_Params_Data)");
// The 1226953460 value is based on sha256(salt + "TextSuggestionHost2").
constexpr uint32_t kTextSuggestionHost_ShowSpellCheckSuggestionMenu_Name = 1226953460;
class MOJOM_SHARED_CONTENT_EXPORT TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data));
      new (data()) TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data>(index_);
    }
    TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  double caret_x;
  double caret_y;
  mojo::internal::Pointer<mojo::internal::String_Data> marked_text;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SpellCheckSuggestion_Data>>> suggestions;

 private:
  TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data();
  ~TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data() = delete;
};
static_assert(sizeof(TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data) == 40,
              "Bad sizeof(TextSuggestionHost_ShowSpellCheckSuggestionMenu_Params_Data)");
// The 1211512650 value is based on sha256(salt + "TextSuggestionHost3").
constexpr uint32_t kTextSuggestionHost_ShowTextSuggestionMenu_Name = 1211512650;
class MOJOM_SHARED_CONTENT_EXPORT TextSuggestionHost_ShowTextSuggestionMenu_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TextSuggestionHost_ShowTextSuggestionMenu_Params_Data));
      new (data()) TextSuggestionHost_ShowTextSuggestionMenu_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TextSuggestionHost_ShowTextSuggestionMenu_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TextSuggestionHost_ShowTextSuggestionMenu_Params_Data>(index_);
    }
    TextSuggestionHost_ShowTextSuggestionMenu_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  double caret_x;
  double caret_y;
  mojo::internal::Pointer<mojo::internal::String_Data> marked_text;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::TextSuggestion_Data>>> suggestions;

 private:
  TextSuggestionHost_ShowTextSuggestionMenu_Params_Data();
  ~TextSuggestionHost_ShowTextSuggestionMenu_Params_Data() = delete;
};
static_assert(sizeof(TextSuggestionHost_ShowTextSuggestionMenu_Params_Data) == 40,
              "Bad sizeof(TextSuggestionHost_ShowTextSuggestionMenu_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_INPUT_HOST_MOJOM_SHARED_INTERNAL_H_