// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_BROADCASTCHANNEL_BROADCAST_CHANNEL_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_BROADCASTCHANNEL_BROADCAST_CHANNEL_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "third_party/WebKit/common/message_port/message_port.mojom-shared-internal.h"
#include "url/mojo/origin.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "third_party/WebKit/public/core_mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1145014146 value is based on sha256(salt + "BroadcastChannelClient1").
constexpr uint32_t kBroadcastChannelClient_OnMessage_Name = 1145014146;
class MOJOM_SHARED_CONTENT_EXPORT BroadcastChannelClient_OnMessage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BroadcastChannelClient_OnMessage_Params_Data));
      new (data()) BroadcastChannelClient_OnMessage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BroadcastChannelClient_OnMessage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BroadcastChannelClient_OnMessage_Params_Data>(index_);
    }
    BroadcastChannelClient_OnMessage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::CloneableMessage_Data> message;

 private:
  BroadcastChannelClient_OnMessage_Params_Data();
  ~BroadcastChannelClient_OnMessage_Params_Data() = delete;
};
static_assert(sizeof(BroadcastChannelClient_OnMessage_Params_Data) == 16,
              "Bad sizeof(BroadcastChannelClient_OnMessage_Params_Data)");
// The 891472423 value is based on sha256(salt + "BroadcastChannelProvider1").
constexpr uint32_t kBroadcastChannelProvider_ConnectToChannel_Name = 891472423;
class MOJOM_SHARED_CONTENT_EXPORT BroadcastChannelProvider_ConnectToChannel_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BroadcastChannelProvider_ConnectToChannel_Params_Data));
      new (data()) BroadcastChannelProvider_ConnectToChannel_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BroadcastChannelProvider_ConnectToChannel_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BroadcastChannelProvider_ConnectToChannel_Params_Data>(index_);
    }
    BroadcastChannelProvider_ConnectToChannel_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Origin_Data> origin;
  mojo::internal::Pointer<mojo::internal::String_Data> name;
  mojo::internal::AssociatedInterface_Data receiver;
  mojo::internal::AssociatedEndpointHandle_Data sender;
  uint8_t padfinal_[4];

 private:
  BroadcastChannelProvider_ConnectToChannel_Params_Data();
  ~BroadcastChannelProvider_ConnectToChannel_Params_Data() = delete;
};
static_assert(sizeof(BroadcastChannelProvider_ConnectToChannel_Params_Data) == 40,
              "Bad sizeof(BroadcastChannelProvider_ConnectToChannel_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_BROADCASTCHANNEL_BROADCAST_CHANNEL_MOJOM_SHARED_INTERNAL_H_