// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_INSTALLEDAPP_INSTALLED_APP_PROVIDER_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_INSTALLEDAPP_INSTALLED_APP_PROVIDER_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "third_party/WebKit/public/platform/modules/installedapp/related_application.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "third_party/WebKit/public/android_mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 1939009939 value is based on sha256(salt + "InstalledAppProvider1").
constexpr uint32_t kInstalledAppProvider_FilterInstalledApps_Name = 1939009939;
class MOJOM_SHARED_CONTENT_EXPORT InstalledAppProvider_FilterInstalledApps_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InstalledAppProvider_FilterInstalledApps_Params_Data));
      new (data()) InstalledAppProvider_FilterInstalledApps_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InstalledAppProvider_FilterInstalledApps_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InstalledAppProvider_FilterInstalledApps_Params_Data>(index_);
    }
    InstalledAppProvider_FilterInstalledApps_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::blink::mojom::internal::RelatedApplication_Data>>> related_apps;

 private:
  InstalledAppProvider_FilterInstalledApps_Params_Data();
  ~InstalledAppProvider_FilterInstalledApps_Params_Data() = delete;
};
static_assert(sizeof(InstalledAppProvider_FilterInstalledApps_Params_Data) == 16,
              "Bad sizeof(InstalledAppProvider_FilterInstalledApps_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT InstalledAppProvider_FilterInstalledApps_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(InstalledAppProvider_FilterInstalledApps_ResponseParams_Data));
      new (data()) InstalledAppProvider_FilterInstalledApps_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    InstalledAppProvider_FilterInstalledApps_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<InstalledAppProvider_FilterInstalledApps_ResponseParams_Data>(index_);
    }
    InstalledAppProvider_FilterInstalledApps_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::blink::mojom::internal::RelatedApplication_Data>>> installedApps;

 private:
  InstalledAppProvider_FilterInstalledApps_ResponseParams_Data();
  ~InstalledAppProvider_FilterInstalledApps_ResponseParams_Data() = delete;
};
static_assert(sizeof(InstalledAppProvider_FilterInstalledApps_ResponseParams_Data) == 16,
              "Bad sizeof(InstalledAppProvider_FilterInstalledApps_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_INSTALLEDAPP_INSTALLED_APP_PROVIDER_MOJOM_SHARED_INTERNAL_H_