// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_KEYBOARD_LOCK_KEYBOARD_LOCK_MOJOM_SHARED_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_KEYBOARD_LOCK_KEYBOARD_LOCK_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/WebKit/public/platform/modules/keyboard_lock/keyboard_lock.mojom-shared-internal.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"


namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {

enum class KeyboardLockRequestResult : int32_t {
  SUCCESS = 0,
};

inline std::ostream& operator<<(std::ostream& os, KeyboardLockRequestResult value) {
  switch(value) {
    case KeyboardLockRequestResult::SUCCESS:
      return os << "KeyboardLockRequestResult::SUCCESS";
    default:
      return os << "Unknown KeyboardLockRequestResult value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(KeyboardLockRequestResult value) {
  return internal::KeyboardLockRequestResult_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class KeyboardLockServiceInterfaceBase {};

using KeyboardLockServicePtrDataView =
    mojo::InterfacePtrDataView<KeyboardLockServiceInterfaceBase>;
using KeyboardLockServiceRequestDataView =
    mojo::InterfaceRequestDataView<KeyboardLockServiceInterfaceBase>;
using KeyboardLockServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<KeyboardLockServiceInterfaceBase>;
using KeyboardLockServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<KeyboardLockServiceInterfaceBase>;
class KeyboardLockService_RequestKeyboardLock_ParamsDataView {
 public:
  KeyboardLockService_RequestKeyboardLock_ParamsDataView() {}

  KeyboardLockService_RequestKeyboardLock_ParamsDataView(
      internal::KeyboardLockService_RequestKeyboardLock_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetKeyCodesDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKeyCodes(UserType* output) {
    auto* pointer = data_->key_codes.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
 private:
  internal::KeyboardLockService_RequestKeyboardLock_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class KeyboardLockService_RequestKeyboardLock_ResponseParamsDataView {
 public:
  KeyboardLockService_RequestKeyboardLock_ResponseParamsDataView() {}

  KeyboardLockService_RequestKeyboardLock_ResponseParamsDataView(
      internal::KeyboardLockService_RequestKeyboardLock_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) const {
    auto data_value = data_->result;
    return mojo::internal::Deserialize<::blink::mojom::KeyboardLockRequestResult>(
        data_value, output);
  }

  KeyboardLockRequestResult result() const {
    return static_cast<KeyboardLockRequestResult>(data_->result);
  }
 private:
  internal::KeyboardLockService_RequestKeyboardLock_ResponseParams_Data* data_ = nullptr;
};

class KeyboardLockService_CancelKeyboardLock_ParamsDataView {
 public:
  KeyboardLockService_CancelKeyboardLock_ParamsDataView() {}

  KeyboardLockService_CancelKeyboardLock_ParamsDataView(
      internal::KeyboardLockService_CancelKeyboardLock_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::KeyboardLockService_CancelKeyboardLock_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::KeyboardLockRequestResult>
    : public mojo::internal::EnumHashImpl<::blink::mojom::KeyboardLockRequestResult> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::blink::mojom::KeyboardLockRequestResult, ::blink::mojom::KeyboardLockRequestResult> {
  static ::blink::mojom::KeyboardLockRequestResult ToMojom(::blink::mojom::KeyboardLockRequestResult input) { return input; }
  static bool FromMojom(::blink::mojom::KeyboardLockRequestResult input, ::blink::mojom::KeyboardLockRequestResult* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::KeyboardLockRequestResult, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::KeyboardLockRequestResult, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::KeyboardLockRequestResult>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void KeyboardLockService_RequestKeyboardLock_ParamsDataView::GetKeyCodesDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->key_codes.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}







}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_KEYBOARD_LOCK_KEYBOARD_LOCK_MOJOM_SHARED_H_
