// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_NOTIFICATIONS_NOTIFICATION_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_NOTIFICATIONS_NOTIFICATION_SERVICE_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/string16.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/modules/notifications/notification.mojom-shared-internal.h"
#include "third_party/WebKit/public/platform/modules/permissions/permission_status.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 53791207 value is based on sha256(salt + "NotificationService1").
constexpr uint32_t kNotificationService_GetPermissionStatus_Name = 53791207;
class MOJOM_SHARED_CONTENT_EXPORT NotificationService_GetPermissionStatus_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NotificationService_GetPermissionStatus_Params_Data));
      new (data()) NotificationService_GetPermissionStatus_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NotificationService_GetPermissionStatus_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NotificationService_GetPermissionStatus_Params_Data>(index_);
    }
    NotificationService_GetPermissionStatus_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NotificationService_GetPermissionStatus_Params_Data();
  ~NotificationService_GetPermissionStatus_Params_Data() = delete;
};
static_assert(sizeof(NotificationService_GetPermissionStatus_Params_Data) == 8,
              "Bad sizeof(NotificationService_GetPermissionStatus_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT NotificationService_GetPermissionStatus_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NotificationService_GetPermissionStatus_ResponseParams_Data));
      new (data()) NotificationService_GetPermissionStatus_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NotificationService_GetPermissionStatus_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NotificationService_GetPermissionStatus_ResponseParams_Data>(index_);
    }
    NotificationService_GetPermissionStatus_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t status;
  uint8_t padfinal_[4];

 private:
  NotificationService_GetPermissionStatus_ResponseParams_Data();
  ~NotificationService_GetPermissionStatus_ResponseParams_Data() = delete;
};
static_assert(sizeof(NotificationService_GetPermissionStatus_ResponseParams_Data) == 16,
              "Bad sizeof(NotificationService_GetPermissionStatus_ResponseParams_Data)");
// The 517743529 value is based on sha256(salt + "NotificationService2").
constexpr uint32_t kNotificationService_DisplayNonPersistentNotification_Name = 517743529;
class MOJOM_SHARED_CONTENT_EXPORT NotificationService_DisplayNonPersistentNotification_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NotificationService_DisplayNonPersistentNotification_Params_Data));
      new (data()) NotificationService_DisplayNonPersistentNotification_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NotificationService_DisplayNonPersistentNotification_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NotificationService_DisplayNonPersistentNotification_Params_Data>(index_);
    }
    NotificationService_DisplayNonPersistentNotification_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::blink::mojom::internal::NotificationData_Data> notification_data;

 private:
  NotificationService_DisplayNonPersistentNotification_Params_Data();
  ~NotificationService_DisplayNonPersistentNotification_Params_Data() = delete;
};
static_assert(sizeof(NotificationService_DisplayNonPersistentNotification_Params_Data) == 16,
              "Bad sizeof(NotificationService_DisplayNonPersistentNotification_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_NOTIFICATIONS_NOTIFICATION_SERVICE_MOJOM_SHARED_INTERNAL_H_