// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_BLINK_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_features.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/control_message_proxy.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/WebKit/public/platform/modules/offscreencanvas/offscreen_canvas_surface.mojom-shared.h"
#include "services/viz/public/interfaces/compositing/compositor_frame_sink.mojom-blink.h"
#include "services/viz/public/interfaces/compositing/frame_sink_id.mojom-blink.h"
#include "services/viz/public/interfaces/compositing/surface_id.mojom-blink.h"
#include "services/viz/public/interfaces/compositing/surface_info.mojom-blink.h"
#include "services/viz/public/interfaces/compositing/surface_sequence.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/WebKit/Source/platform/wtf/HashFunctions.h"
#include "third_party/WebKit/Source/platform/wtf/Optional.h"
#include "third_party/WebKit/Source/platform/wtf/text/WTFString.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/WebKit/public/platform/WebCommon.h"


namespace blink {
namespace mojom {
namespace blink {
class OffscreenCanvasSurface;
using OffscreenCanvasSurfacePtr = mojo::InterfacePtr<OffscreenCanvasSurface>;
using OffscreenCanvasSurfacePtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasSurface>;
using ThreadSafeOffscreenCanvasSurfacePtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceRequest = mojo::InterfaceRequest<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasSurface>;
using ThreadSafeOffscreenCanvasSurfaceAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasSurface>;
using OffscreenCanvasSurfaceAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasSurface>;

class OffscreenCanvasSurfaceClient;
using OffscreenCanvasSurfaceClientPtr = mojo::InterfacePtr<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientPtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasSurfaceClient>;
using ThreadSafeOffscreenCanvasSurfaceClientPtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientRequest = mojo::InterfaceRequest<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasSurfaceClient>;
using ThreadSafeOffscreenCanvasSurfaceClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasSurfaceClient>;
using OffscreenCanvasSurfaceClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasSurfaceClient>;

class OffscreenCanvasProvider;
using OffscreenCanvasProviderPtr = mojo::InterfacePtr<OffscreenCanvasProvider>;
using OffscreenCanvasProviderPtrInfo = mojo::InterfacePtrInfo<OffscreenCanvasProvider>;
using ThreadSafeOffscreenCanvasProviderPtr =
    mojo::ThreadSafeInterfacePtr<OffscreenCanvasProvider>;
using OffscreenCanvasProviderRequest = mojo::InterfaceRequest<OffscreenCanvasProvider>;
using OffscreenCanvasProviderAssociatedPtr =
    mojo::AssociatedInterfacePtr<OffscreenCanvasProvider>;
using ThreadSafeOffscreenCanvasProviderAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<OffscreenCanvasProvider>;
using OffscreenCanvasProviderAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<OffscreenCanvasProvider>;
using OffscreenCanvasProviderAssociatedRequest =
    mojo::AssociatedInterfaceRequest<OffscreenCanvasProvider>;


class OffscreenCanvasSurfaceProxy;

template <typename ImplRefTraits>
class OffscreenCanvasSurfaceStub;

class OffscreenCanvasSurfaceRequestValidator;

class BLINK_PLATFORM_EXPORT OffscreenCanvasSurface
    : public OffscreenCanvasSurfaceInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = OffscreenCanvasSurfaceProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasSurfaceStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasSurfaceRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kRequireMinVersion = 0,
    kSatisfyMinVersion = 0,
  };
  virtual ~OffscreenCanvasSurface() {}

  virtual void Require(const viz::SurfaceId& surface_id, const viz::SurfaceSequence& sequence) = 0;

  virtual void Satisfy(const viz::SurfaceSequence& sequence) = 0;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceInterceptorForTesting : public OffscreenCanvasSurface {
  virtual OffscreenCanvasSurface* GetForwardingInterface() = 0;
  void Require(const viz::SurfaceId& surface_id, const viz::SurfaceSequence& sequence) override;
  void Satisfy(const viz::SurfaceSequence& sequence) override;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceAsyncWaiter {
 public:
  explicit OffscreenCanvasSurfaceAsyncWaiter(OffscreenCanvasSurface* proxy);
  ~OffscreenCanvasSurfaceAsyncWaiter();

 private:
  OffscreenCanvasSurface* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(OffscreenCanvasSurfaceAsyncWaiter);
};

class OffscreenCanvasSurfaceClientProxy;

template <typename ImplRefTraits>
class OffscreenCanvasSurfaceClientStub;

class OffscreenCanvasSurfaceClientRequestValidator;

class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceClient
    : public OffscreenCanvasSurfaceClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = OffscreenCanvasSurfaceClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasSurfaceClientStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasSurfaceClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnFirstSurfaceActivationMinVersion = 0,
  };
  virtual ~OffscreenCanvasSurfaceClient() {}

  virtual void OnFirstSurfaceActivation(const viz::SurfaceInfo& surface_info) = 0;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceClientInterceptorForTesting : public OffscreenCanvasSurfaceClient {
  virtual OffscreenCanvasSurfaceClient* GetForwardingInterface() = 0;
  void OnFirstSurfaceActivation(const viz::SurfaceInfo& surface_info) override;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceClientAsyncWaiter {
 public:
  explicit OffscreenCanvasSurfaceClientAsyncWaiter(OffscreenCanvasSurfaceClient* proxy);
  ~OffscreenCanvasSurfaceClientAsyncWaiter();

 private:
  OffscreenCanvasSurfaceClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(OffscreenCanvasSurfaceClientAsyncWaiter);
};

class OffscreenCanvasProviderProxy;

template <typename ImplRefTraits>
class OffscreenCanvasProviderStub;

class OffscreenCanvasProviderRequestValidator;

class BLINK_PLATFORM_EXPORT OffscreenCanvasProvider
    : public OffscreenCanvasProviderInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = OffscreenCanvasProviderProxy;

  template <typename ImplRefTraits>
  using Stub_ = OffscreenCanvasProviderStub<ImplRefTraits>;

  using RequestValidator_ = OffscreenCanvasProviderRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreateOffscreenCanvasSurfaceMinVersion = 0,
    kCreateCompositorFrameSinkMinVersion = 0,
  };
  virtual ~OffscreenCanvasProvider() {}

  virtual void CreateOffscreenCanvasSurface(const viz::FrameSinkId& parent_frame_sink_id, const viz::FrameSinkId& frame_sink_id, OffscreenCanvasSurfaceClientPtr client, OffscreenCanvasSurfaceRequest surface) = 0;

  virtual void CreateCompositorFrameSink(const viz::FrameSinkId& frame_sink_id, ::viz::mojom::blink::CompositorFrameSinkClientPtr client, ::viz::mojom::blink::CompositorFrameSinkRequest sink) = 0;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasProviderInterceptorForTesting : public OffscreenCanvasProvider {
  virtual OffscreenCanvasProvider* GetForwardingInterface() = 0;
  void CreateOffscreenCanvasSurface(const viz::FrameSinkId& parent_frame_sink_id, const viz::FrameSinkId& frame_sink_id, OffscreenCanvasSurfaceClientPtr client, OffscreenCanvasSurfaceRequest surface) override;
  void CreateCompositorFrameSink(const viz::FrameSinkId& frame_sink_id, ::viz::mojom::blink::CompositorFrameSinkClientPtr client, ::viz::mojom::blink::CompositorFrameSinkRequest sink) override;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasProviderAsyncWaiter {
 public:
  explicit OffscreenCanvasProviderAsyncWaiter(OffscreenCanvasProvider* proxy);
  ~OffscreenCanvasProviderAsyncWaiter();

 private:
  OffscreenCanvasProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(OffscreenCanvasProviderAsyncWaiter);
};

class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceProxy
    : public OffscreenCanvasSurface {
 public:
  explicit OffscreenCanvasSurfaceProxy(mojo::MessageReceiverWithResponder* receiver);
  void Require(const viz::SurfaceId& surface_id, const viz::SurfaceSequence& sequence) final;
  void Satisfy(const viz::SurfaceSequence& sequence) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceClientProxy
    : public OffscreenCanvasSurfaceClient {
 public:
  explicit OffscreenCanvasSurfaceClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnFirstSurfaceActivation(const viz::SurfaceInfo& surface_info) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class BLINK_PLATFORM_EXPORT OffscreenCanvasProviderProxy
    : public OffscreenCanvasProvider {
 public:
  explicit OffscreenCanvasProviderProxy(mojo::MessageReceiverWithResponder* receiver);
  void CreateOffscreenCanvasSurface(const viz::FrameSinkId& parent_frame_sink_id, const viz::FrameSinkId& frame_sink_id, OffscreenCanvasSurfaceClientPtr client, OffscreenCanvasSurfaceRequest surface) final;
  void CreateCompositorFrameSink(const viz::FrameSinkId& frame_sink_id, ::viz::mojom::blink::CompositorFrameSinkClientPtr client, ::viz::mojom::blink::CompositorFrameSinkRequest sink) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceStubDispatch {
 public:
  static bool Accept(OffscreenCanvasSurface* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OffscreenCanvasSurface* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasSurface>>
class OffscreenCanvasSurfaceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasSurfaceStub() {}
  ~OffscreenCanvasSurfaceStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceClientStubDispatch {
 public:
  static bool Accept(OffscreenCanvasSurfaceClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OffscreenCanvasSurfaceClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasSurfaceClient>>
class OffscreenCanvasSurfaceClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasSurfaceClientStub() {}
  ~OffscreenCanvasSurfaceClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasSurfaceClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasProviderStubDispatch {
 public:
  static bool Accept(OffscreenCanvasProvider* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OffscreenCanvasProvider* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OffscreenCanvasProvider>>
class OffscreenCanvasProviderStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OffscreenCanvasProviderStub() {}
  ~OffscreenCanvasProviderStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasProviderStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OffscreenCanvasProviderStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasSurfaceClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT OffscreenCanvasProviderRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_BLINK_H_