// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/viz/public/interfaces/compositing/compositor_frame_sink.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/frame_sink_id.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/surface_id.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/surface_info.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/surface_sequence.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "third_party/WebKit/public/offscreen_canvas_mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 189554297 value is based on sha256(salt + "OffscreenCanvasSurface1").
constexpr uint32_t kOffscreenCanvasSurface_Require_Name = 189554297;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasSurface_Require_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OffscreenCanvasSurface_Require_Params_Data));
      new (data()) OffscreenCanvasSurface_Require_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OffscreenCanvasSurface_Require_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OffscreenCanvasSurface_Require_Params_Data>(index_);
    }
    OffscreenCanvasSurface_Require_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::SurfaceId_Data> surface_id;
  mojo::internal::Pointer<::viz::mojom::internal::SurfaceSequence_Data> sequence;

 private:
  OffscreenCanvasSurface_Require_Params_Data();
  ~OffscreenCanvasSurface_Require_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasSurface_Require_Params_Data) == 24,
              "Bad sizeof(OffscreenCanvasSurface_Require_Params_Data)");
// The 195994876 value is based on sha256(salt + "OffscreenCanvasSurface2").
constexpr uint32_t kOffscreenCanvasSurface_Satisfy_Name = 195994876;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasSurface_Satisfy_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OffscreenCanvasSurface_Satisfy_Params_Data));
      new (data()) OffscreenCanvasSurface_Satisfy_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OffscreenCanvasSurface_Satisfy_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OffscreenCanvasSurface_Satisfy_Params_Data>(index_);
    }
    OffscreenCanvasSurface_Satisfy_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::SurfaceSequence_Data> sequence;

 private:
  OffscreenCanvasSurface_Satisfy_Params_Data();
  ~OffscreenCanvasSurface_Satisfy_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasSurface_Satisfy_Params_Data) == 16,
              "Bad sizeof(OffscreenCanvasSurface_Satisfy_Params_Data)");
// The 4681817 value is based on sha256(salt + "OffscreenCanvasSurfaceClient1").
constexpr uint32_t kOffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Name = 4681817;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data));
      new (data()) OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data>(index_);
    }
    OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::SurfaceInfo_Data> surface_info;

 private:
  OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data();
  ~OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data) == 16,
              "Bad sizeof(OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data)");
// The 1864352395 value is based on sha256(salt + "OffscreenCanvasProvider1").
constexpr uint32_t kOffscreenCanvasProvider_CreateOffscreenCanvasSurface_Name = 1864352395;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data));
      new (data()) OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data>(index_);
    }
    OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::FrameSinkId_Data> parent_frame_sink_id;
  mojo::internal::Pointer<::viz::mojom::internal::FrameSinkId_Data> frame_sink_id;
  mojo::internal::Interface_Data client;
  mojo::internal::Handle_Data surface;
  uint8_t padfinal_[4];

 private:
  OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data();
  ~OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data) == 40,
              "Bad sizeof(OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data)");
// The 299440491 value is based on sha256(salt + "OffscreenCanvasProvider2").
constexpr uint32_t kOffscreenCanvasProvider_CreateCompositorFrameSink_Name = 299440491;
class MOJOM_SHARED_CONTENT_EXPORT OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data));
      new (data()) OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data>(index_);
    }
    OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::FrameSinkId_Data> frame_sink_id;
  mojo::internal::Interface_Data client;
  mojo::internal::Handle_Data sink;
  uint8_t padfinal_[4];

 private:
  OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data();
  ~OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data() = delete;
};
static_assert(sizeof(OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data) == 32,
              "Bad sizeof(OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_SHARED_INTERNAL_H_