// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_SHARED_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/WebKit/public/platform/modules/offscreencanvas/offscreen_canvas_surface.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/compositor_frame_sink.mojom-shared.h"
#include "services/viz/public/interfaces/compositing/frame_sink_id.mojom-shared.h"
#include "services/viz/public/interfaces/compositing/surface_id.mojom-shared.h"
#include "services/viz/public/interfaces/compositing/surface_info.mojom-shared.h"
#include "services/viz/public/interfaces/compositing/surface_sequence.mojom-shared.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/WebKit/public/offscreen_canvas_mojo_bindings_shared_export.h"


namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class OffscreenCanvasSurfaceInterfaceBase {};

using OffscreenCanvasSurfacePtrDataView =
    mojo::InterfacePtrDataView<OffscreenCanvasSurfaceInterfaceBase>;
using OffscreenCanvasSurfaceRequestDataView =
    mojo::InterfaceRequestDataView<OffscreenCanvasSurfaceInterfaceBase>;
using OffscreenCanvasSurfaceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<OffscreenCanvasSurfaceInterfaceBase>;
using OffscreenCanvasSurfaceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<OffscreenCanvasSurfaceInterfaceBase>;
class OffscreenCanvasSurfaceClientInterfaceBase {};

using OffscreenCanvasSurfaceClientPtrDataView =
    mojo::InterfacePtrDataView<OffscreenCanvasSurfaceClientInterfaceBase>;
using OffscreenCanvasSurfaceClientRequestDataView =
    mojo::InterfaceRequestDataView<OffscreenCanvasSurfaceClientInterfaceBase>;
using OffscreenCanvasSurfaceClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<OffscreenCanvasSurfaceClientInterfaceBase>;
using OffscreenCanvasSurfaceClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<OffscreenCanvasSurfaceClientInterfaceBase>;
class OffscreenCanvasProviderInterfaceBase {};

using OffscreenCanvasProviderPtrDataView =
    mojo::InterfacePtrDataView<OffscreenCanvasProviderInterfaceBase>;
using OffscreenCanvasProviderRequestDataView =
    mojo::InterfaceRequestDataView<OffscreenCanvasProviderInterfaceBase>;
using OffscreenCanvasProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<OffscreenCanvasProviderInterfaceBase>;
using OffscreenCanvasProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<OffscreenCanvasProviderInterfaceBase>;
class OffscreenCanvasSurface_Require_ParamsDataView {
 public:
  OffscreenCanvasSurface_Require_ParamsDataView() {}

  OffscreenCanvasSurface_Require_ParamsDataView(
      internal::OffscreenCanvasSurface_Require_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSurfaceIdDataView(
      ::viz::mojom::SurfaceIdDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSurfaceId(UserType* output) {
    auto* pointer = data_->surface_id.Get();
    return mojo::internal::Deserialize<::viz::mojom::SurfaceIdDataView>(
        pointer, output, context_);
  }
  inline void GetSequenceDataView(
      ::viz::mojom::SurfaceSequenceDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSequence(UserType* output) {
    auto* pointer = data_->sequence.Get();
    return mojo::internal::Deserialize<::viz::mojom::SurfaceSequenceDataView>(
        pointer, output, context_);
  }
 private:
  internal::OffscreenCanvasSurface_Require_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class OffscreenCanvasSurface_Satisfy_ParamsDataView {
 public:
  OffscreenCanvasSurface_Satisfy_ParamsDataView() {}

  OffscreenCanvasSurface_Satisfy_ParamsDataView(
      internal::OffscreenCanvasSurface_Satisfy_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSequenceDataView(
      ::viz::mojom::SurfaceSequenceDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSequence(UserType* output) {
    auto* pointer = data_->sequence.Get();
    return mojo::internal::Deserialize<::viz::mojom::SurfaceSequenceDataView>(
        pointer, output, context_);
  }
 private:
  internal::OffscreenCanvasSurface_Satisfy_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_ParamsDataView {
 public:
  OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_ParamsDataView() {}

  OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_ParamsDataView(
      internal::OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSurfaceInfoDataView(
      ::viz::mojom::SurfaceInfoDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSurfaceInfo(UserType* output) {
    auto* pointer = data_->surface_info.Get();
    return mojo::internal::Deserialize<::viz::mojom::SurfaceInfoDataView>(
        pointer, output, context_);
  }
 private:
  internal::OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class OffscreenCanvasProvider_CreateOffscreenCanvasSurface_ParamsDataView {
 public:
  OffscreenCanvasProvider_CreateOffscreenCanvasSurface_ParamsDataView() {}

  OffscreenCanvasProvider_CreateOffscreenCanvasSurface_ParamsDataView(
      internal::OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetParentFrameSinkIdDataView(
      ::viz::mojom::FrameSinkIdDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadParentFrameSinkId(UserType* output) {
    auto* pointer = data_->parent_frame_sink_id.Get();
    return mojo::internal::Deserialize<::viz::mojom::FrameSinkIdDataView>(
        pointer, output, context_);
  }
  inline void GetFrameSinkIdDataView(
      ::viz::mojom::FrameSinkIdDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFrameSinkId(UserType* output) {
    auto* pointer = data_->frame_sink_id.Get();
    return mojo::internal::Deserialize<::viz::mojom::FrameSinkIdDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::OffscreenCanvasSurfaceClientPtrDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeSurface() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::OffscreenCanvasSurfaceRequestDataView>(
            &data_->surface, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::OffscreenCanvasProvider_CreateOffscreenCanvasSurface_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class OffscreenCanvasProvider_CreateCompositorFrameSink_ParamsDataView {
 public:
  OffscreenCanvasProvider_CreateCompositorFrameSink_ParamsDataView() {}

  OffscreenCanvasProvider_CreateCompositorFrameSink_ParamsDataView(
      internal::OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFrameSinkIdDataView(
      ::viz::mojom::FrameSinkIdDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFrameSinkId(UserType* output) {
    auto* pointer = data_->frame_sink_id.Get();
    return mojo::internal::Deserialize<::viz::mojom::FrameSinkIdDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::viz::mojom::CompositorFrameSinkClientPtrDataView>(
            &data_->client, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeSink() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::viz::mojom::CompositorFrameSinkRequestDataView>(
            &data_->sink, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::OffscreenCanvasProvider_CreateCompositorFrameSink_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace blink {
namespace mojom {

inline void OffscreenCanvasSurface_Require_ParamsDataView::GetSurfaceIdDataView(
    ::viz::mojom::SurfaceIdDataView* output) {
  auto pointer = data_->surface_id.Get();
  *output = ::viz::mojom::SurfaceIdDataView(pointer, context_);
}
inline void OffscreenCanvasSurface_Require_ParamsDataView::GetSequenceDataView(
    ::viz::mojom::SurfaceSequenceDataView* output) {
  auto pointer = data_->sequence.Get();
  *output = ::viz::mojom::SurfaceSequenceDataView(pointer, context_);
}


inline void OffscreenCanvasSurface_Satisfy_ParamsDataView::GetSequenceDataView(
    ::viz::mojom::SurfaceSequenceDataView* output) {
  auto pointer = data_->sequence.Get();
  *output = ::viz::mojom::SurfaceSequenceDataView(pointer, context_);
}


inline void OffscreenCanvasSurfaceClient_OnFirstSurfaceActivation_ParamsDataView::GetSurfaceInfoDataView(
    ::viz::mojom::SurfaceInfoDataView* output) {
  auto pointer = data_->surface_info.Get();
  *output = ::viz::mojom::SurfaceInfoDataView(pointer, context_);
}


inline void OffscreenCanvasProvider_CreateOffscreenCanvasSurface_ParamsDataView::GetParentFrameSinkIdDataView(
    ::viz::mojom::FrameSinkIdDataView* output) {
  auto pointer = data_->parent_frame_sink_id.Get();
  *output = ::viz::mojom::FrameSinkIdDataView(pointer, context_);
}
inline void OffscreenCanvasProvider_CreateOffscreenCanvasSurface_ParamsDataView::GetFrameSinkIdDataView(
    ::viz::mojom::FrameSinkIdDataView* output) {
  auto pointer = data_->frame_sink_id.Get();
  *output = ::viz::mojom::FrameSinkIdDataView(pointer, context_);
}


inline void OffscreenCanvasProvider_CreateCompositorFrameSink_ParamsDataView::GetFrameSinkIdDataView(
    ::viz::mojom::FrameSinkIdDataView* output) {
  auto pointer = data_->frame_sink_id.Get();
  *output = ::viz::mojom::FrameSinkIdDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_PLATFORM_MODULES_OFFSCREENCANVAS_OFFSCREEN_CANVAS_SURFACE_MOJOM_SHARED_H_
