// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_WEB_DEVTOOLS_AGENT_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_WEB_DEVTOOLS_AGENT_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class DevToolsMessageChunk_Data;

#pragma pack(push, 1)
class MOJOM_SHARED_CONTENT_EXPORT DevToolsMessageChunk_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsMessageChunk_Data));
      new (data()) DevToolsMessageChunk_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsMessageChunk_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsMessageChunk_Data>(index_);
    }
    DevToolsMessageChunk_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t is_first : 1;
  uint8_t is_last : 1;
  uint8_t pad1_[3];
  int32_t call_id;
  mojo::internal::Pointer<mojo::internal::String_Data> data;
  mojo::internal::Pointer<mojo::internal::String_Data> post_state;

 private:
  DevToolsMessageChunk_Data();
  ~DevToolsMessageChunk_Data() = delete;
};
static_assert(sizeof(DevToolsMessageChunk_Data) == 32,
              "Bad sizeof(DevToolsMessageChunk_Data)");
// Used by DevToolsMessageChunk::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct DevToolsMessageChunk_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  DevToolsMessageChunk_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~DevToolsMessageChunk_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    DevToolsMessageChunk_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    DevToolsMessageChunk_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
// The 1525526819 value is based on sha256(salt + "DevToolsAgent1").
constexpr uint32_t kDevToolsAgent_AttachDevToolsSession_Name = 1525526819;
class MOJOM_SHARED_CONTENT_EXPORT DevToolsAgent_AttachDevToolsSession_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsAgent_AttachDevToolsSession_Params_Data));
      new (data()) DevToolsAgent_AttachDevToolsSession_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsAgent_AttachDevToolsSession_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsAgent_AttachDevToolsSession_Params_Data>(index_);
    }
    DevToolsAgent_AttachDevToolsSession_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data host;
  mojo::internal::AssociatedEndpointHandle_Data session;
  mojo::internal::Handle_Data io_session;
  mojo::internal::Pointer<mojo::internal::String_Data> reattach_state;

 private:
  DevToolsAgent_AttachDevToolsSession_Params_Data();
  ~DevToolsAgent_AttachDevToolsSession_Params_Data() = delete;
};
static_assert(sizeof(DevToolsAgent_AttachDevToolsSession_Params_Data) == 32,
              "Bad sizeof(DevToolsAgent_AttachDevToolsSession_Params_Data)");
// The 1738601930 value is based on sha256(salt + "DevToolsSession1").
constexpr uint32_t kDevToolsSession_DispatchProtocolMessage_Name = 1738601930;
class MOJOM_SHARED_CONTENT_EXPORT DevToolsSession_DispatchProtocolMessage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsSession_DispatchProtocolMessage_Params_Data));
      new (data()) DevToolsSession_DispatchProtocolMessage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsSession_DispatchProtocolMessage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsSession_DispatchProtocolMessage_Params_Data>(index_);
    }
    DevToolsSession_DispatchProtocolMessage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t call_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<mojo::internal::String_Data> method;
  mojo::internal::Pointer<mojo::internal::String_Data> message;

 private:
  DevToolsSession_DispatchProtocolMessage_Params_Data();
  ~DevToolsSession_DispatchProtocolMessage_Params_Data() = delete;
};
static_assert(sizeof(DevToolsSession_DispatchProtocolMessage_Params_Data) == 32,
              "Bad sizeof(DevToolsSession_DispatchProtocolMessage_Params_Data)");
// The 1360245523 value is based on sha256(salt + "DevToolsSession2").
constexpr uint32_t kDevToolsSession_InspectElement_Name = 1360245523;
class MOJOM_SHARED_CONTENT_EXPORT DevToolsSession_InspectElement_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsSession_InspectElement_Params_Data));
      new (data()) DevToolsSession_InspectElement_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsSession_InspectElement_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsSession_InspectElement_Params_Data>(index_);
    }
    DevToolsSession_InspectElement_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> point;

 private:
  DevToolsSession_InspectElement_Params_Data();
  ~DevToolsSession_InspectElement_Params_Data() = delete;
};
static_assert(sizeof(DevToolsSession_InspectElement_Params_Data) == 16,
              "Bad sizeof(DevToolsSession_InspectElement_Params_Data)");
// The 1069150529 value is based on sha256(salt + "DevToolsSessionHost1").
constexpr uint32_t kDevToolsSessionHost_DispatchProtocolMessage_Name = 1069150529;
class MOJOM_SHARED_CONTENT_EXPORT DevToolsSessionHost_DispatchProtocolMessage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DevToolsSessionHost_DispatchProtocolMessage_Params_Data));
      new (data()) DevToolsSessionHost_DispatchProtocolMessage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DevToolsSessionHost_DispatchProtocolMessage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DevToolsSessionHost_DispatchProtocolMessage_Params_Data>(index_);
    }
    DevToolsSessionHost_DispatchProtocolMessage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::DevToolsMessageChunk_Data> chunk;

 private:
  DevToolsSessionHost_DispatchProtocolMessage_Params_Data();
  ~DevToolsSessionHost_DispatchProtocolMessage_Params_Data() = delete;
};
static_assert(sizeof(DevToolsSessionHost_DispatchProtocolMessage_Params_Data) == 16,
              "Bad sizeof(DevToolsSessionHost_DispatchProtocolMessage_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_WEB_DEVTOOLS_AGENT_MOJOM_SHARED_INTERNAL_H_