// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_WEB_DEVTOOLS_AGENT_MOJOM_SHARED_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_WEB_DEVTOOLS_AGENT_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/WebKit/public/web/devtools_agent.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared.h"


#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"


namespace blink {
namespace mojom {
class DevToolsMessageChunkDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::DevToolsMessageChunkDataView> {
  using Data = ::blink::mojom::internal::DevToolsMessageChunk_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {
// Interface base classes. They are used for type safety check.
class DevToolsAgentInterfaceBase {};

using DevToolsAgentPtrDataView =
    mojo::InterfacePtrDataView<DevToolsAgentInterfaceBase>;
using DevToolsAgentRequestDataView =
    mojo::InterfaceRequestDataView<DevToolsAgentInterfaceBase>;
using DevToolsAgentAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DevToolsAgentInterfaceBase>;
using DevToolsAgentAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DevToolsAgentInterfaceBase>;
class DevToolsSessionInterfaceBase {};

using DevToolsSessionPtrDataView =
    mojo::InterfacePtrDataView<DevToolsSessionInterfaceBase>;
using DevToolsSessionRequestDataView =
    mojo::InterfaceRequestDataView<DevToolsSessionInterfaceBase>;
using DevToolsSessionAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DevToolsSessionInterfaceBase>;
using DevToolsSessionAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DevToolsSessionInterfaceBase>;
class DevToolsSessionHostInterfaceBase {};

using DevToolsSessionHostPtrDataView =
    mojo::InterfacePtrDataView<DevToolsSessionHostInterfaceBase>;
using DevToolsSessionHostRequestDataView =
    mojo::InterfaceRequestDataView<DevToolsSessionHostInterfaceBase>;
using DevToolsSessionHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DevToolsSessionHostInterfaceBase>;
using DevToolsSessionHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DevToolsSessionHostInterfaceBase>;
class DevToolsMessageChunkDataView {
 public:
  DevToolsMessageChunkDataView() {}

  DevToolsMessageChunkDataView(
      internal::DevToolsMessageChunk_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool is_first() const {
    return data_->is_first;
  }
  bool is_last() const {
    return data_->is_last;
  }
  inline void GetDataDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  int32_t call_id() const {
    return data_->call_id;
  }
  inline void GetPostStateDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPostState(UserType* output) {
    auto* pointer = data_->post_state.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsMessageChunk_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsAgent_AttachDevToolsSession_ParamsDataView {
 public:
  DevToolsAgent_AttachDevToolsSession_ParamsDataView() {}

  DevToolsAgent_AttachDevToolsSession_ParamsDataView(
      internal::DevToolsAgent_AttachDevToolsSession_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeHost() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::DevToolsSessionHostAssociatedPtrInfoDataView>(
            &data_->host, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeSession() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::DevToolsSessionAssociatedRequestDataView>(
            &data_->session, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeIoSession() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::DevToolsSessionRequestDataView>(
            &data_->io_session, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetReattachStateDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadReattachState(UserType* output) {
    auto* pointer = data_->reattach_state.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsAgent_AttachDevToolsSession_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsSession_DispatchProtocolMessage_ParamsDataView {
 public:
  DevToolsSession_DispatchProtocolMessage_ParamsDataView() {}

  DevToolsSession_DispatchProtocolMessage_ParamsDataView(
      internal::DevToolsSession_DispatchProtocolMessage_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t call_id() const {
    return data_->call_id;
  }
  inline void GetMethodDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMethod(UserType* output) {
    auto* pointer = data_->method.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetMessageDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMessage(UserType* output) {
    auto* pointer = data_->message.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsSession_DispatchProtocolMessage_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsSession_InspectElement_ParamsDataView {
 public:
  DevToolsSession_InspectElement_ParamsDataView() {}

  DevToolsSession_InspectElement_ParamsDataView(
      internal::DevToolsSession_InspectElement_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPointDataView(
      ::gfx::mojom::PointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPoint(UserType* output) {
    auto* pointer = data_->point.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsSession_InspectElement_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DevToolsSessionHost_DispatchProtocolMessage_ParamsDataView {
 public:
  DevToolsSessionHost_DispatchProtocolMessage_ParamsDataView() {}

  DevToolsSessionHost_DispatchProtocolMessage_ParamsDataView(
      internal::DevToolsSessionHost_DispatchProtocolMessage_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetChunkDataView(
      DevToolsMessageChunkDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadChunk(UserType* output) {
    auto* pointer = data_->chunk.Get();
    return mojo::internal::Deserialize<::blink::mojom::DevToolsMessageChunkDataView>(
        pointer, output, context_);
  }
 private:
  internal::DevToolsSessionHost_DispatchProtocolMessage_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::DevToolsMessageChunkDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::DevToolsMessageChunkDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::blink::mojom::internal::DevToolsMessageChunk_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    (*output)->is_first = CallWithContext(Traits::is_first, input, custom_context);
    (*output)->is_last = CallWithContext(Traits::is_last, input, custom_context);
    decltype(CallWithContext(Traits::data, input, custom_context)) in_data = CallWithContext(Traits::data, input, custom_context);
    typename decltype((*output)->data)::BaseType::BufferWriter
        data_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_data, buffer, &data_writer, context);
    (*output)->data.Set(
        data_writer.is_null() ? nullptr : data_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->data.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null data in DevToolsMessageChunk struct");
    (*output)->call_id = CallWithContext(Traits::call_id, input, custom_context);
    decltype(CallWithContext(Traits::post_state, input, custom_context)) in_post_state = CallWithContext(Traits::post_state, input, custom_context);
    typename decltype((*output)->post_state)::BaseType::BufferWriter
        post_state_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_post_state, buffer, &post_state_writer, context);
    (*output)->post_state.Set(
        post_state_writer.is_null() ? nullptr : post_state_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->post_state.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null post_state in DevToolsMessageChunk struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::blink::mojom::internal::DevToolsMessageChunk_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::DevToolsMessageChunkDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void DevToolsMessageChunkDataView::GetDataDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->data.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void DevToolsMessageChunkDataView::GetPostStateDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->post_state.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void DevToolsAgent_AttachDevToolsSession_ParamsDataView::GetReattachStateDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->reattach_state.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void DevToolsSession_DispatchProtocolMessage_ParamsDataView::GetMethodDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->method.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void DevToolsSession_DispatchProtocolMessage_ParamsDataView::GetMessageDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->message.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void DevToolsSession_InspectElement_ParamsDataView::GetPointDataView(
    ::gfx::mojom::PointDataView* output) {
  auto pointer = data_->point.Get();
  *output = ::gfx::mojom::PointDataView(pointer, context_);
}


inline void DevToolsSessionHost_DispatchProtocolMessage_ParamsDataView::GetChunkDataView(
    DevToolsMessageChunkDataView* output) {
  auto pointer = data_->chunk.Get();
  *output = DevToolsMessageChunkDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_WEB_DEVTOOLS_AGENT_MOJOM_SHARED_H_
