// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_WEBKIT_PUBLIC_WEB_WORKER_CONTENT_SETTINGS_PROXY_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_WEBKIT_PUBLIC_WEB_WORKER_CONTENT_SETTINGS_PROXY_MOJOM_SHARED_INTERNAL_H_

#include <stdint.h>

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/common/string16.mojom-shared-internal.h"
#include "url/mojo/origin.mojom-shared-internal.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "third_party/WebKit/public/mojo_bindings_shared_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
// The 116311631 value is based on sha256(salt + "WorkerContentSettingsProxy1").
constexpr uint32_t kWorkerContentSettingsProxy_AllowIndexedDB_Name = 116311631;
class MOJOM_SHARED_CONTENT_EXPORT WorkerContentSettingsProxy_AllowIndexedDB_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WorkerContentSettingsProxy_AllowIndexedDB_Params_Data));
      new (data()) WorkerContentSettingsProxy_AllowIndexedDB_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WorkerContentSettingsProxy_AllowIndexedDB_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WorkerContentSettingsProxy_AllowIndexedDB_Params_Data>(index_);
    }
    WorkerContentSettingsProxy_AllowIndexedDB_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo::common::mojom::internal::String16_Data> name;

 private:
  WorkerContentSettingsProxy_AllowIndexedDB_Params_Data();
  ~WorkerContentSettingsProxy_AllowIndexedDB_Params_Data() = delete;
};
static_assert(sizeof(WorkerContentSettingsProxy_AllowIndexedDB_Params_Data) == 16,
              "Bad sizeof(WorkerContentSettingsProxy_AllowIndexedDB_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data));
      new (data()) WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data>(index_);
    }
    WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t result : 1;
  uint8_t padfinal_[7];

 private:
  WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data();
  ~WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data() = delete;
};
static_assert(sizeof(WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data) == 16,
              "Bad sizeof(WorkerContentSettingsProxy_AllowIndexedDB_ResponseParams_Data)");
// The 1211851054 value is based on sha256(salt + "WorkerContentSettingsProxy2").
constexpr uint32_t kWorkerContentSettingsProxy_RequestFileSystemAccessSync_Name = 1211851054;
class MOJOM_SHARED_CONTENT_EXPORT WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data));
      new (data()) WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data>(index_);
    }
    WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data();
  ~WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data() = delete;
};
static_assert(sizeof(WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data) == 8,
              "Bad sizeof(WorkerContentSettingsProxy_RequestFileSystemAccessSync_Params_Data)");
class MOJOM_SHARED_CONTENT_EXPORT WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data));
      new (data()) WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data>(index_);
    }
    WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t result : 1;
  uint8_t padfinal_[7];

 private:
  WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data();
  ~WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data() = delete;
};
static_assert(sizeof(WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data) == 16,
              "Bad sizeof(WorkerContentSettingsProxy_RequestFileSystemAccessSync_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_WEBKIT_PUBLIC_WEB_WORKER_CONTENT_SETTINGS_PROXY_MOJOM_SHARED_INTERNAL_H_