// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "ui/gfx/mojo/ca_layer_params.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
namespace gfx {
namespace mojom {
CALayerParams::CALayerParams()
    : is_empty(),
      ca_context_id(),
      io_surface_mach_port(),
      pixel_size(),
      scale_factor() {}

CALayerParams::CALayerParams(
    bool is_empty_in,
    uint32_t ca_context_id_in,
    mojo::ScopedHandle io_surface_mach_port_in,
    const gfx::Size& pixel_size_in,
    float scale_factor_in)
    : is_empty(std::move(is_empty_in)),
      ca_context_id(std::move(ca_context_id_in)),
      io_surface_mach_port(std::move(io_surface_mach_port_in)),
      pixel_size(std::move(pixel_size_in)),
      scale_factor(std::move(scale_factor_in)) {}

CALayerParams::~CALayerParams() = default;

bool CALayerParams::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace gfx

namespace mojo {


// static
bool StructTraits<::gfx::mojom::CALayerParams::DataView, ::gfx::mojom::CALayerParamsPtr>::Read(
    ::gfx::mojom::CALayerParams::DataView input,
    ::gfx::mojom::CALayerParamsPtr* output) {
  bool success = true;
  ::gfx::mojom::CALayerParamsPtr result(::gfx::mojom::CALayerParams::New());
  
      result->is_empty = input.is_empty();
      result->ca_context_id = input.ca_context_id();
      result->io_surface_mach_port = input.TakeIoSurfaceMachPort();
      if (!input.ReadPixelSize(&result->pixel_size))
        success = false;
      result->scale_factor = input.scale_factor();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif